import type { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
export declare const addItemUniDriverFactory: (base: UniDriver, body: UniDriver) => {
    /**
     * Gets AddItem text
     * @return {Promise<string>}
     */
    getText: () => Promise<string>;
    /**
     * Checks whether AddItem text exist
     * @returns {Promise<boolean>}
     */
    textExists: () => Promise<boolean>;
    /**
     * Gets tooltip text
     * @return {Promise<string | null>}
     */
    getTooltipContent: () => Promise<string | null>;
    /**
     * Gets AddItem subtitle
     * @return {Promise<string>}
     */
    getSubtitle: () => Promise<string>;
    /**
     * Checks whether AddItem is focused
     * @returns {Promise<boolean>}
     */
    isFocused: () => Promise<boolean>;
    /**
     * Sets focus on the element
     * @returns {Promise<void>}
     */
    focus: () => Promise<void>;
    /**
     * Removes focus on the element
     * @returns {Promise<void>}
     */
    blur: () => Promise<void>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
    click: () => Promise<void>;
};
export type AddItemUniDriver = ReturnType<typeof addItemUniDriverFactory>;
//# sourceMappingURL=AddItem.uni.driver.d.ts.map