import * as React from 'react';
import { InjectedFocusableProps } from '../../common/Focusable';
export type ContentType = 'text' | 'placeholder' | 'image';
export interface AvatarCoreProps {
    /** Hook for testing purposes. */
    'data-hook'?: string;
    /** Css class name to be applied to the root element */
    className?: string;
    /** The name of the avatar user. Text initials will be generated from the name. And it will be used as default value for html `title` and `aria-label` attributes. */
    name?: string;
    /** Text to render as content. */
    text?: string;
    /** A node with a placeholder to be rendered as content. Will be displayed if no `text`, `name` or `imgProps` are provided. */
    placeholder?: React.ReactElement;
    /** Props for an <img> tag to be rendered as content. */
    imgProps?: React.ImgHTMLAttributes<HTMLImageElement> & {
        ['data-hook']?: string;
    };
    /** Limit the number of letters in the generated initials (from name). May be 1 2 or 3 only. */
    initialsLimit?: 1 | 2 | 3;
    /** HTML aria-label attribute value. To be applied on the root element */
    ariaLabel?: string;
    /** HTML title attribute value. To be applied on the root element */
    title?: string;
    /** onClick event callback. */
    onClick?(): void;
}
declare const _default: React.ComponentType<InjectedFocusableProps<AvatarCoreProps, HTMLDivElement>>;
export default _default;
//# sourceMappingURL=AvatarCore.d.ts.map