export default BarChart;
declare class BarChart extends React.PureComponent<any, any, any> {
    static displayName: string;
    static defaultProps: {
        items: never[];
    };
    static propTypes: {
        /** Applied as data-hook HTML attribute that can be used to create driver in testing */
        dataHook: PropTypes.Requireable<string>;
        /**
         * Array of items
         *  * `value` - This prop is used for sorting bars. Displayed as big text on a bar, when there is no caption prop.
         *  * `label` -  Displayed as big text on a bar.
         *  * `labelShort` - Is shown instead of a `label` when there is not enough space.
         *  * `description` - short label under the bar.
         *  * `descriptionInfo` - long description.
         */
        items: PropTypes.Requireable<(PropTypes.InferProps<{
            value: PropTypes.Validator<number>;
            label: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            labelShort: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            description: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            descriptionInfo: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        }> | null | undefined)[]>;
        /** Used to calculate space for bars inside a widget. Should be specified if the actual total is different from the sum of values of all items */
        total: PropTypes.Requireable<number>;
        /** Callback called every time when descriptionInfo tooltip is shown*/
        onDescriptionInfoShown: PropTypes.Requireable<(...args: any[]) => any>;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    MIN_BAR_WIDTH: number;
    state: {
        width: number;
    };
    componentDidMount(): void;
    _getCalculatedTotal(): any;
    _renderValue: ({ descriptionInfo, value, label, labelShort, showText }: {
        descriptionInfo: any;
        value: any;
        label: any;
        labelShort: any;
        showText: any;
    }) => React.JSX.Element;
    _renderItem: ({ value, label, labelShort, description, descriptionInfo }: {
        value: any;
        label: any;
        labelShort: any;
        description: any;
        descriptionInfo: any;
    }, key: any) => React.JSX.Element;
    render(): React.JSX.Element;
    node: HTMLDivElement | null | undefined;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=BarChart.d.ts.map