import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { InjectedFocusableProps } from '../common/Focusable';
import { CheckboxProps } from '.';
/** a simple WixStyle checkbox */
export declare class Checkbox extends PureComponent<InjectedFocusableProps<CheckboxProps, HTMLDivElement>> {
    static displayName: string;
    static propTypes: {
        dataHook: PropTypes.Requireable<string>;
        checked: PropTypes.Requireable<boolean>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        disabled: PropTypes.Requireable<boolean>;
        hasError: PropTypes.Requireable<boolean>;
        id: PropTypes.Requireable<string>;
        indeterminate: PropTypes.Requireable<boolean>;
        errorMessage: PropTypes.Requireable<string>;
        selectionArea: PropTypes.Requireable<"none" | "always" | "hover">;
        vAlign: PropTypes.Requireable<"top" | "center">;
        size: PropTypes.Requireable<"small" | "medium">;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        className: PropTypes.Requireable<string>;
        selectionAreaSkin: PropTypes.Requireable<"filled" | "outlined">;
        selectionAreaPadding: PropTypes.Requireable<string>;
        tooltipContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        maxLines: PropTypes.Requireable<number>;
    };
    static defaultProps: CheckboxProps;
    _id: string;
    checkboxRef: React.RefObject<HTMLDivElement>;
    inputRef: React.RefObject<HTMLInputElement>;
    focus: () => void;
    _handleKeyDown: (event: React.KeyboardEvent<HTMLDivElement>) => void;
    _getDataAttributes: () => {
        "data-check-type": "checked" | "unchecked" | "indeterminate";
        "data-has-error": boolean | undefined;
        "data-disabled": boolean | undefined;
    };
    render(): React.JSX.Element;
}
declare const _default: React.ComponentType<InjectedFocusableProps<CheckboxProps, HTMLDivElement>>;
export default _default;
//# sourceMappingURL=Checkbox.d.ts.map