import * as React from 'react';
export interface CircularProgressBarCoreProps {
    /** represent the progress state in percentages (0 - no progress, 100 - progress completed) */
    value?: number | string;
    /** should be true if had failure during the progress */
    error?: boolean;
    /** label to display when an error happens */
    errorLabel?: string;
    /** when set to true, an indication of the progress state will be presented along side the progress bar */
    showProgressIndication?: boolean;
    /** an indication icon (any react component) that will be presented when 'error' and 'showProgressIndication' are set to true */
    errorIcon?: React.JSX.Element;
    /** an indication icon (any react component) that will be presented when 'showProgressIndication' are set to true and 'value' is 100 */
    successIcon?: React.JSX.Element;
    /** custom text to display. will replace the progress indication if provided */
    label?: string;
    /** Placement of the label in the progress bar */
    labelPlacement?: 'center' | 'bottom';
    /** circle size in pixels */
    size?: number | string;
    /** hook for testing purposes */
    'data-hook'?: string;
    /** Skin of the bar */
    'data-skin'?: 'standard' | 'premium' | 'success';
    className?: string;
}
export declare const convertToPercentageString: (value: number) => string;
export declare const CircularProgressBarCore: React.FunctionComponent<CircularProgressBarCoreProps>;
//# sourceMappingURL=CircularProgressBarCore.d.ts.map