export default ColorPicker;
/**
 * Color Picker
 *
 * Under the hood uses color manipulation library [https://github.com/Qix-/color](https://github.com/Qix-/color).
 * Value for this component can be given in `string` or `object` format.
 * The callbacks always respond with color `object` format.
 */
declare class ColorPicker extends React.PureComponent<any, any, any> {
    constructor(props: any);
    state: {
        current: color;
        previous: color;
    };
    render(): React.JSX.Element;
    _renderChildren: () => any;
    UNSAFE_componentWillReceiveProps(props: any): void;
    /**
     * sets the selected color
     * @param {object} color - An object that contains data for the selected color, model, and valpha.
     */
    change: (_color: any) => void;
    /**
     * confirms the selected color
     */
    confirm: () => void;
    /**
     * cancels the selected color
     */
    cancel: () => void;
}
declare namespace ColorPicker {
    let displayName: string;
    namespace propTypes {
        let dataHook: PropTypes.Requireable<string>;
        let value: PropTypes.Validator<NonNullable<NonNullable<string | object | null | undefined>>>;
        let showHistory: PropTypes.Requireable<boolean>;
        let showConverter: PropTypes.Requireable<boolean>;
        let showInput: PropTypes.Requireable<boolean>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let onCancel: PropTypes.Requireable<(...args: any[]) => any>;
        let onConfirm: PropTypes.Requireable<(...args: any[]) => any>;
        let onAdd: PropTypes.Requireable<(...args: any[]) => any>;
        let children: PropTypes.Requireable<NonNullable<((...args: any[]) => any) | PropTypes.ReactNodeLike>>;
        let addTooltipContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let allowEmpty: PropTypes.Requireable<boolean>;
        let emptyPlaceholder: PropTypes.Requireable<string>;
    }
    namespace defaultProps {
        let showHistory_1: boolean;
        export { showHistory_1 as showHistory };
        let showConverter_1: boolean;
        export { showConverter_1 as showConverter };
        let showInput_1: boolean;
        export { showInput_1 as showInput };
        let allowEmpty_1: boolean;
        export { allowEmpty_1 as allowEmpty };
        export function onChange_1(): void;
        export { onChange_1 as onChange };
        export function onCancel_1(): void;
        export { onCancel_1 as onCancel };
        export function onConfirm_1(): void;
        export { onConfirm_1 as onConfirm };
    }
}
import React from 'react';
import color from 'color';
import PropTypes from 'prop-types';
//# sourceMappingURL=ColorPicker.d.ts.map