import { baseUniDriverFactory } from '../test-utils/utils/unidriver';
import { tooltipDriverFactory } from '../Tooltip/Tooltip.uni.driver';
export const dragHandleUniDriverFactory = (base, body) => {
    const getButton = () => base.$('[data-hook="drag-handle-button"]');
    const getTooltipDriver = () => tooltipDriverFactory(base, body);
    return {
        ...baseUniDriverFactory(base),
        getButton,
        click: () => getButton().click(),
        hover: () => getButton().hover(),
        getTooltipDriver,
        isTooltipEnabled: () => getTooltipDriver().tooltipExists(),
        getTooltipContent: () => getTooltipDriver().getTooltipText(),
        getDisabled: async () => {
            const value = await getButton().attr('data-disabled');
            return value === 'true';
        },
    };
};
//# sourceMappingURL=DragHandle.uni.driver.js.map