export default Dropdown;
declare class Dropdown extends InputWithOptions<import("../InputWithOptions").ManualInputFnSignature, ((option: import("..").DropdownLayoutValueOption, sameOptionWasPicked: boolean) => void) | undefined, import("../InputWithOptions").InputWithOptionsProps<import("../InputWithOptions").ManualInputFnSignature, ((option: import("..").DropdownLayoutValueOption, sameOptionWasPicked: boolean) => void) | undefined>> {
    static isOptionsEqual(optionsA: any, optionsB: any): boolean;
    /**
     * Updates the value by the selectedId.
     * If selectedId is not found in options, then value is NOT changed.
     */
    static getNextState(props: any, selectedId: any): {
        value: any;
        selectedId: any;
    };
    constructor(props: any);
    state: {
        value: any;
        selectedId: any;
    };
    isSelectedIdControlled(): boolean;
    getSelectedId(): any;
    _onInputClicked(event: any): void;
    UNSAFE_componentWillReceiveProps(nextProps: any): void;
    inputClasses(): any;
    dropdownAdditionalProps(): {
        selectedId: any;
        value: any;
        tabIndex: number;
        withArrow: boolean;
    };
    inputAdditionalProps(): {
        disableEditing: boolean;
        value: any;
    };
    _onSelect(option: any): void;
    _onChange(event: any): void;
}
declare namespace Dropdown {
    namespace propTypes {
        let initialSelectedId: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let ariaControls: PropTypes.Requireable<string>;
        let ariaDescribedby: PropTypes.Requireable<string>;
        let ariaLabel: PropTypes.Requireable<string>;
        let autoFocus: PropTypes.Requireable<boolean>;
        let border: PropTypes.Requireable<string>;
        let className: PropTypes.Requireable<string>;
        let clearButton: PropTypes.Requireable<boolean>;
        let closeOnSelect: PropTypes.Requireable<boolean>;
        let dataHook: PropTypes.Requireable<string>;
        let disabled: PropTypes.Requireable<boolean>;
        let dropdownWidth: PropTypes.Requireable<string>;
        let fixedFooter: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let fixedHeader: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let focusOnOption: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let focusOnSelectedOption: PropTypes.Requireable<boolean>;
        let forceFocus: PropTypes.Requireable<boolean>;
        let forceHover: PropTypes.Requireable<boolean>;
        let hasMore: PropTypes.Requireable<boolean>;
        let hideStatusSuffix: PropTypes.Requireable<boolean>;
        let id: PropTypes.Requireable<string>;
        let infiniteScroll: PropTypes.Requireable<boolean>;
        let loadMore: PropTypes.Requireable<(...args: any[]) => any>;
        let markedOption: PropTypes.Requireable<NonNullable<string | number | boolean | null | undefined>>;
        let maxHeightPixels: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let menuArrow: PropTypes.Requireable<boolean>;
        let minWidthPixels: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let name: PropTypes.Requireable<string>;
        let native: PropTypes.Requireable<boolean>;
        let noLeftBorderRadius: PropTypes.Requireable<boolean>;
        let noRightBorderRadius: PropTypes.Requireable<boolean>;
        let onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        let onClear: PropTypes.Requireable<(...args: any[]) => any>;
        let onClose: PropTypes.Requireable<(...args: any[]) => any>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let onCompositionChange: PropTypes.Requireable<(...args: any[]) => any>;
        let onEnterPressed: PropTypes.Requireable<(...args: any[]) => any>;
        let onEscapePressed: PropTypes.Requireable<(...args: any[]) => any>;
        let onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        let onInputClicked: PropTypes.Requireable<(...args: any[]) => any>;
        let onKeyDown: PropTypes.Requireable<(...args: any[]) => any>;
        let onKeyUp: PropTypes.Requireable<(...args: any[]) => any>;
        let onManuallyInput: PropTypes.Requireable<(...args: any[]) => any>;
        let onMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
        let onMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
        let onOptionMarked: PropTypes.Requireable<(...args: any[]) => any>;
        let onOptionsHide: PropTypes.Requireable<(...args: any[]) => any>;
        let onOptionsShow: PropTypes.Requireable<(...args: any[]) => any>;
        let onSelect: PropTypes.Requireable<(...args: any[]) => any>;
        let options: PropTypes.Requireable<any[]>;
        let overflow: PropTypes.Requireable<string>;
        let placeholder: PropTypes.Requireable<string>;
        let popoverProps: PropTypes.Requireable<PropTypes.InferProps<{
            appendTo: PropTypes.Requireable<string>;
            maxWidth: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
            minWidth: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
            flip: PropTypes.Requireable<boolean>;
            fixed: PropTypes.Requireable<boolean>;
            placement: PropTypes.Requireable<string>;
            dynamicWidth: PropTypes.Requireable<boolean>;
        }>>;
        let prefix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let readOnly: PropTypes.Requireable<boolean>;
        let selectedId: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let showOptionsIfEmptyInput: PropTypes.Requireable<boolean>;
        let size: PropTypes.Requireable<string>;
        let status: PropTypes.Requireable<string>;
        let statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let tabIndex: PropTypes.Requireable<number>;
        let textOverflow: PropTypes.Requireable<string>;
        let tooltipPlacement: PropTypes.Requireable<string>;
        let valueParser: PropTypes.Requireable<(...args: any[]) => any>;
    }
    let defaultProps: any;
    let displayName: string;
}
import InputWithOptions from '../InputWithOptions';
import PropTypes from 'prop-types';
//# sourceMappingURL=Dropdown.d.ts.map