import React from 'react';
import Text from '../../../Text';
import { st, classes } from './Label.st.css';
const Label = ({ labelSize, label, 'aria-hidden': ariaHidden, hasInlineElements, ...rest }) => {
    const weight = labelSize === 'tiny' ? 'normal' : undefined;
    return (React.createElement(Text, { "aria-hidden": ariaHidden, className: st(classes.root, {
            hasInlineElements,
            labelSize,
        }), size: labelSize, weight: weight, secondary: true, style: { display: 'block' }, ...rest }, label));
};
export default Label;
//# sourceMappingURL=Label.js.map