export namespace GoogleAddressInputHandler {
    let geocode: string;
    let places: string;
}
export default GoogleAddressInput;
/**
 * Address input box (using Google Maps)
 */
declare class GoogleAddressInput extends React.Component<any, any, any> {
    static getGoogleFooter: () => React.JSX.Element;
    constructor(props: any);
    state: {
        suggestions: never[];
        value: any;
    };
    autoCompleteRequestId: number;
    geocodeRequestId: number;
    client: any;
    onChange(e: any): void;
    onBlur(): void;
    onFocus(): void;
    onSet(value: any): void;
    onManuallyInput(inputValue: any): void;
    UNSAFE_componentWillReceiveProps(nextProps: any): void;
    render(): React.JSX.Element;
    autocomplete: InputWithOptions<import("../InputWithOptions").ManualInputFnSignature, ((option: import("..").DropdownLayoutValueOption, sameOptionWasPicked: boolean) => void) | undefined, import("../InputWithOptions").InputWithOptionsProps<import("../InputWithOptions").ManualInputFnSignature, ((option: import("..").DropdownLayoutValueOption, sameOptionWasPicked: boolean) => void) | undefined>> | null | undefined;
    focus(): void;
    select(): void;
    timer: NodeJS.Timeout | undefined;
    componentWillUnmount(): void;
    _getSuggestions(value: any, skipSetState: any): Promise<any>;
}
declare namespace GoogleAddressInput {
    let displayName: string;
    namespace defaultProps {
        export let magnifyingGlass: boolean;
        export let autoSelect: boolean;
        export let footerOptions: {};
        export let clearSuggestionsOnBlur: boolean;
        export let fallbackToManual: boolean;
        export let poweredByGoogle: boolean;
        import handler = GoogleAddressInputHandler.geocode;
        export { handler };
    }
    namespace propTypes {
        export let placeholder: PropTypes.Requireable<string>;
        export let valuePrefix: PropTypes.Requireable<string>;
        export let countryCode: PropTypes.Requireable<string>;
        export let value: PropTypes.Requireable<string>;
        export let types: PropTypes.Requireable<any[]>;
        export let filterTypes: PropTypes.Requireable<any[]>;
        export let placeDetailsFields: PropTypes.Requireable<any[]>;
        export let status: PropTypes.Requireable<string>;
        export let statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        export let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        export let onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        export let onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        export let onKeyDown: PropTypes.Requireable<(...args: any[]) => any>;
        export let onSet: PropTypes.Requireable<(...args: any[]) => any>;
        export let Client: PropTypes.Validator<(...args: any[]) => any>;
        let magnifyingGlass_1: PropTypes.Requireable<boolean>;
        export { magnifyingGlass_1 as magnifyingGlass };
        export let readOnly: PropTypes.Requireable<boolean>;
        let autoSelect_1: PropTypes.Requireable<boolean>;
        export { autoSelect_1 as autoSelect };
        export let footer: PropTypes.Requireable<any>;
        let footerOptions_1: PropTypes.Requireable<object>;
        export { footerOptions_1 as footerOptions };
        let clearSuggestionsOnBlur_1: PropTypes.Requireable<boolean>;
        export { clearSuggestionsOnBlur_1 as clearSuggestionsOnBlur };
        let fallbackToManual_1: PropTypes.Requireable<boolean>;
        export { fallbackToManual_1 as fallbackToManual };
        let poweredByGoogle_1: PropTypes.Requireable<boolean>;
        export { poweredByGoogle_1 as poweredByGoogle };
        let handler_1: PropTypes.Requireable<string>;
        export { handler_1 as handler };
    }
}
import React from 'react';
import InputWithOptions from '../InputWithOptions';
import PropTypes from 'prop-types';
//# sourceMappingURL=GoogleAddressInput.d.ts.map