import * as React from 'react';
import { ProgressBarAriaKeys } from './DataHooks';
export interface LinearProgressBarProps {
    /** represent the progress state in percentages (min || 0 - no progress, max || 100 - progress completed) */
    value?: number | string;
    /** should be true if had failure during the progress */
    error?: boolean;
    /** when set to true, an indication of the progress state will be presented along side the progress bar */
    showProgressIndication?: boolean;
    /** an indication icon (any react component) that will be presented when 'error' and 'showProgressIndication' are set to true */
    errorIcon?: React.JSX.Element;
    /** an indication icon (any react component) that will be presented when 'showProgressIndication' are set to true and 'value' is equal or bigger than 'max' */
    successIcon?: React.JSX.Element;
    /** minimum value for progress bar, default value: 0 */
    min?: number;
    /** maximum value for progress bar, default value: 100 */
    max?: number;
    /** Number of decimal points to keep when normalizing value */
    precision?: number;
    /** A prefix node for the progress bar */
    prefixIndication?: React.ReactNode;
    /** A custom text for the progress bar indication. */
    customSuffixIndicationText?: string;
    /** onClick on the component */
    onClick?: React.MouseEventHandler<HTMLElement>;
    /** aria-label - Accessibility */
    'aria-label'?: string;
    /** Applied as data-hook HTML attribute that can be used to create driver in testing */
    'data-hook'?: string;
    /** add aria-hidden to prefix/suffix */
    'aria-hide-affixes'?: boolean;
    role?: string;
    className?: string;
}
export interface LinearProgressBarPropsWithAria extends LinearProgressBarProps {
    [ProgressBarAriaKeys.valuetext]?: string;
}
declare const LinearProgressBarCore: React.FunctionComponent<LinearProgressBarPropsWithAria>;
export default LinearProgressBarCore;
//# sourceMappingURL=LinearProgressBarCore.d.ts.map