import { BaseUniDriver } from '@wix/wix-ui-test-utils/base-driver';
import { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
export interface LinearProgressBarCoreUniDriver extends BaseUniDriver {
    /** Get the width of the foreground bar (the progress) */
    getWidth(): Promise<string>;
    /** Returns Promise<boolean> that indicates if the success icon exists */
    isSuccessIconDisplayed(): Promise<boolean>;
    /** Returns Promise<boolean> that indicates if the error icon exists */
    isErrorIconDisplayed(): Promise<boolean>;
    /** Returns Promise<boolean> that indicates if the progress percentages text exists */
    isPercentagesProgressDisplayed(): Promise<boolean>;
    /** Returns Promise<boolean> that indicates if the prefix indication exists */
    hasPrefixIndication(): Promise<boolean>;
    /** Returns Promise<boolean> that indicates if the custom suffix indication exists */
    hasSuffixIndication(): Promise<boolean>;
    /** Get the suffix indication's text */
    getSuffixIndicationText(): Promise<string>;
    /** Get the prefix indication aria-hidden value */
    hasPrefixAriaHidden(): Promise<boolean>;
    /** Get the progress indication aria-hidden value */
    hasProgressIndicatorAriaHidden(): Promise<boolean>;
    /** Get the progress percentages value */
    getValue(): Promise<string | null>;
    /** Get the progress numeric value */
    getNumericValue(): Promise<number>;
    /** Returns true if has progress completed (value is 100) */
    isCompleted(): Promise<boolean>;
    /** Returns true if has error */
    hasError(): Promise<boolean>;
    /** Returns min value prop */
    getMinValue(): Promise<number>;
    /** Returns max value prop */
    getMaxValue(): Promise<number>;
    /** Returns aria-valuenow prop */
    getAriaValueNow(): Promise<number>;
    /** Returns aria-valuemin prop */
    getAriaValueMin(): Promise<number>;
    /** Returns aria-valuemax prop */
    getAriaValueMax(): Promise<number>;
    /** Returns aria-label prop */
    getAriaLabel(): Promise<string>;
    /** Returns role html attribute */
    getRoleAttribute(): Promise<string>;
    /** Returns aria-valuetext prop */
    getAriaValueText(): Promise<string>;
}
export declare const linearProgressBarUniDriverFactory: (base: UniDriver) => LinearProgressBarCoreUniDriver;
//# sourceMappingURL=LinearProgressBarCore.uni.driver.d.ts.map