export namespace TYPES {
    let WHITESPACE: string;
    let DIVIDER: string;
    let TITLE: string;
    let SUBHEADER: string;
}
export default ListItemSection;
export function listItemSectionBuilder({ id, className, dataHook, type, title, suffix, ellipsis, }: {
    id: any;
    className: any;
    dataHook: any;
    type: any;
    title: any;
    suffix: any;
    ellipsis: any;
}): {
    id: any;
    overrideOptionStyle: boolean;
    disabled: boolean;
    value: (props: any) => React.JSX.Element;
};
/** ListItemSection description */
declare class ListItemSection extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Applied as data-hook HTML attribute that can be used in the tests */
        dataHook: PropTypes.Requireable<string>;
        /** A css class to be applied to the component's root element */
        className: PropTypes.Requireable<string>;
        /** A list item section can be
         *  * `title` - Acts as a title for following list items.
         *  * `subheader` - Acts as separator between list items for differentiation.
         *  * `whitespace` - Adds some padding between list items.
         *  * `divider` - Same as whitespace, but with a line.
         */
        type: PropTypes.Requireable<string>;
        /** Text of the list item */
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Suffix node. Renders TextButton for a string otherwise the node itself.*/
        suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** If true, long text won't break into more than one line and will be terminated with an ellipsis */
        ellipsis: PropTypes.Requireable<boolean>;
        /** A callback function called when suffix is clicked */
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
    };
    static defaultProps: {
        type: string;
        ellipsis: boolean;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    state: {};
    render(): React.JSX.Element;
    _renderDivisionElements: (children: any) => React.JSX.Element;
    _renderSuffix: () => React.JSX.Element;
    _renderTitle: () => React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=ListItemSection.d.ts.map