// @ts-expect-error
import { testkit as inputTestkit } from '../Input/Input.uni.driver';
import { tickerDriverFactory } from '../Input/Ticker/Ticker.uni.driver';
import { dataHooks } from './constants';
export const numberInputDriverFactory = (base, body) => {
    const getTickerDriver = () => tickerDriverFactory(base.$(`[data-hook="${dataHooks.numberInputTicker}"]`));
    return {
        ...inputTestkit(base, body),
        /** Click on ticker up */
        clickOnIncrement: () => getTickerDriver().clickUp(),
        /** Click on ticker down */
        clickOnDecrement: () => getTickerDriver().clickDown(),
        /** Check if ticker down is disabled */
        isDownDisabled: () => getTickerDriver().isDownDisabled(),
        /** Check if ticker up is disabled */
        isUpDisabled: () => getTickerDriver().isUpDisabled(),
    };
};
//# sourceMappingURL=NumberInput.uni.driver.js.map