import React from 'react';
import { PopoverProps } from '../Popover.types';
interface PopoverState {
    isMounted: boolean;
    shown: boolean;
}
/**
 * Popover
 */
export declare class PopoverCore extends React.Component<PopoverProps, PopoverState> {
    static displayName: string;
    static defaultProps: {
        flip: boolean;
        fixed: boolean;
        zIndex: number;
        shown: boolean;
        placement: string;
        excludeClass: string;
    };
    static contextType: React.Context<{
        newColorsBranding: boolean;
        newBrandingClass: string;
    }>;
    static Element: React.FunctionComponent<import("./utils/utils").ElementProps>;
    static Content: React.FunctionComponent<import("./utils/utils").ElementProps>;
    targetRef: Element | undefined;
    portalNode: HTMLElement | null;
    portalClasses: string;
    appendToNode: HTMLElement | null;
    clickOutsideRef: any;
    popoverContentRef: React.RefObject<HTMLDivElement>;
    clickOutsideClass: string;
    contentHook: string;
    popperScheduleUpdate: undefined | (() => void);
    _hideTimeout: any;
    _showTimeout: any;
    constructor(props: PopoverProps);
    _handleClickOutside: (event: any) => void;
    _onKeyDown: (e: any) => void;
    focus(): void;
    getPopperContentStructure(childrenObject: any): any;
    applyStylesToPortaledNode(): void;
    wrapWithAnimations(popper: any): any;
    renderPopperContent(childrenObject: any): any;
    renderArrow(arrowProps: any, moveArrowTo: any, placement: any, customArrow: any): any;
    componentDidMount(): void;
    /**
     * Checks to see if the focused element is outside the Popover content
     */
    _onDocumentKeyUp: (e: any) => void;
    _setBlurByKeyboardListener(): void;
    _removeBlurListener(): void;
    initAppendToNode(): void;
    hidePopover(): void;
    showPopover(): void;
    componentWillUnmount(): void;
    updatePosition(): void;
    componentDidUpdate(prevProps: any): void;
    render(): React.JSX.Element;
}
export {};
//# sourceMappingURL=PopoverCore.d.ts.map