export default class SelectableAccordionItem extends React.PureComponent<any, any, any> {
    static propTypes: {
        /** A title of the item */
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** An optional second row of the header */
        subtitle: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** A content of the item */
        content: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** A type can be ether radio, checkbox, or toggle, which will effect the way an accordion item is selected */
        type: PropTypes.Requireable<string>;
        /** A flag that indicates a open state */
        open: PropTypes.Requireable<boolean>;
        /** An index of the item in the items list */
        idx: PropTypes.Requireable<number>;
        /** A callback which is invoked every time the selection of the item is changed */
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        /** Extra space on top and bottom of selectable accordion item */
        verticalPadding: PropTypes.Requireable<string>;
        /** Is item disabled */
        disabled: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        type: string;
        onChange: () => void;
    };
    static displayName: string;
    constructor(props: any);
    constructor(props: any, context: any);
    state: {
        hovered: boolean;
    };
    _onChange: (event: any) => void;
    _onMouseEnter: () => void;
    _onMouseLeave: () => void;
    _renderSelector(): React.JSX.Element;
    _renderTitle(): any;
    _renderContent(): any;
    _renderSubtitle(): any;
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=Item.d.ts.map