import React from 'react';
import PropTypes from 'prop-types';
import { st, classes } from './Field.st.css';
const Field = ({ noPadding = false, divider = 'auto', children, }) => {
    return (React.createElement("div", { className: st(classes.root, {
            padded: !noPadding,
            divider: String(divider),
        }) }, children));
};
Field.displayName = 'Field';
Field.propTypes = {
    noPadding: PropTypes.bool,
    divider: PropTypes.oneOf([PropTypes.bool, 'auto']),
    children: PropTypes.node,
};
export default Field;
//# sourceMappingURL=Field.js.map