import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { HeaderProps } from './Header.types';
import { SidePanelProps } from '../SidePanel.types';
declare class Header extends PureComponent<HeaderProps> {
    static displayName: string;
    static propTypes: {
        className: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        subtitle: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        infoTooltipContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        infoTooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        showDivider: PropTypes.Requireable<boolean>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        maxLines: PropTypes.Requireable<number>;
        ellipsis: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        showDivider: boolean;
    };
    renderStringTitle(): React.JSX.Element;
    renderSubtitle(): number | true | Iterable<React.ReactNode> | React.JSX.Element | null;
    renderTitle(onCloseButtonClick?: SidePanelProps['onCloseButtonClick'], onHelpButtonClick?: SidePanelProps['onHelpButtonClick']): React.JSX.Element;
    renderButtons(onCloseButtonClick?: SidePanelProps['onCloseButtonClick'], onHelpButtonClick?: SidePanelProps['onHelpButtonClick']): React.JSX.Element;
    render(): React.JSX.Element;
}
export default Header;
//# sourceMappingURL=Header.d.ts.map