import { baseUniDriverFactory, findByHook, } from '../../test-utils/utils/unidriver';
import { sectionHeaderDriverFactory } from '../../SectionHeader/SectionHeader.uni.driver';
import { dataHooks } from '../constants';
export const sidePanelSectionDriverFactory = (base) => {
    const getHeader = () => sectionHeaderDriverFactory(findByHook(base, dataHooks.sidePanelSectionHeader));
    return {
        ...baseUniDriverFactory(base),
        /** Returns title value */
        getTitle: async () => {
            const stringTitle = await base.attr('data-title');
            const nodeTitle = (await getHeader().exists())
                ? await getHeader().getTitle()
                : undefined;
            return stringTitle || nodeTitle;
        },
        /** Returns titleVisible value */
        getTitleVisible: async () => getHeader().exists(),
        /** Returns ariaLabel value */
        getAriaLabel: async () => (await base.get('div[role="group"]')).attr('aria-label'),
    };
};
//# sourceMappingURL=Section.uni.driver.js.map