import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import Header from './Header';
import Content from './Content';
import Footer from './Footer';
import Divider from './Divider';
import { SidePanelProps } from './SidePanel.types';
declare class SidePanel extends PureComponent<SidePanelProps> {
    static displayName: string;
    static Header: typeof Header;
    static Content: typeof Content;
    static Footer: typeof Footer;
    static Divider: typeof Divider;
    static Section: {
        ({ title, titleVisible, suffix, children, ariaLabel, dataHook, as, "aria-describedby": ariaDescribedBy, id, }: import("./Section").SectionProps): React.JSX.Element;
        displayName: string;
        propTypes: {
            title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            titleVisible: PropTypes.Requireable<boolean>;
            suffix: PropTypes.Requireable<PropTypes.ReactElementLike>;
            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            ariaLabel: PropTypes.Requireable<string>;
            dataHook: PropTypes.Requireable<string>;
            as: PropTypes.Requireable<string>;
            id: PropTypes.Requireable<string>;
            'aria-describedby': PropTypes.Requireable<string>;
        };
    };
    static Field: {
        ({ noPadding, divider, children, }: import("./Field").FieldProps): React.JSX.Element;
        displayName: string;
        propTypes: {
            noPadding: PropTypes.Requireable<boolean>;
            divider: PropTypes.Requireable<string | PropTypes.Requireable<boolean>>;
            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        };
    };
    static propTypes: {
        className: PropTypes.Requireable<string>;
        dataHook: PropTypes.Requireable<string>;
        onCloseButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        onHelpButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        width: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        height: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        maxHeight: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        skin: PropTypes.Requireable<string>;
        draggable: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        width: string;
        height: string;
    };
    render(): React.JSX.Element;
}
export default SidePanel;
//# sourceMappingURL=SidePanel.d.ts.map