import React from 'react';
import Tooltip from '../../Tooltip';
import IconButton from '../../IconButton';
import { ChevronRightSmall, ChevronLeftSmall } from '@wix/wix-ui-icons-common';
import { dataHooks } from '../constants';
import { st, classes } from './ToggleButton.st.css';
export const ToggleButton = ({ minimized, minimizeToggleTooltip, onMinimizeToggleClick, skin, }) => (React.createElement(Tooltip, { className: st(classes.root, { skin }), size: "small", placement: "right-start", moveBy: { x: 6, y: -3 }, disabled: !minimizeToggleTooltip, content: minimizeToggleTooltip, 
    // @ts-expect-error
    style: { left: 'calc(100% - 12px)' } },
    React.createElement(IconButton, { size: "tiny", onClick: onMinimizeToggleClick, dataHook: dataHooks.minimizeButton, className: st(classes.iconButton, { skin }) }, minimized ? React.createElement(ChevronRightSmall, null) : React.createElement(ChevronLeftSmall, null))));
//# sourceMappingURL=ToggleButton.js.map