/**
 * Returns a identity-memoized value. The memoization is based on deep equality.
 *
 * @example
 * ```
 * const value = useMemoizedIdentity({ foo: 'bar', baz: { qux: 'quux' } });
 * value === useMemoizedIdentity({ foo: 'bar', baz: { qux: 'quux' } }); // true
 * ```
 */
export declare const useMemoizedIdentity: <T>(value: T) => T;
//# sourceMappingURL=useMemoizedIdentity.d.ts.map