export default SocialPreview;
/**
 * A displayer for a social post
 */
declare class SocialPreview extends React.Component<any, any, any> {
    static displayName: string;
    static propTypes: {
        dataHook: PropTypes.Requireable<string>;
        /** A social post link title */
        title: PropTypes.Requireable<string>;
        /** A social post link description */
        description: PropTypes.Requireable<string>;
        /** A url representation of the social post link */
        previewUrl: PropTypes.Requireable<string>;
        /** A slot to render a media item, most common will be the ImageViewer component */
        media: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Changes the style of the preview */
        skin: PropTypes.Requireable<string>;
        /** Specifies the size of the preview. Size small works only in combination with twitter skin */
        size: PropTypes.Requireable<string>;
    };
    static defaultProps: {
        skin: string;
        size: string;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    _isTwitter(): boolean;
    _isTwitterSmall(): boolean;
    _renderTitle(): React.JSX.Element;
    _renderDescription(): React.JSX.Element;
    _renderUrlText(): React.JSX.Element;
    _renderUrl(): any;
    _renderMedia(): any;
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=SocialPreview.d.ts.map