export default Stepper;
/** Stepper */
declare class Stepper extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Hook for testing purposes. */
        dataHook: PropTypes.Requireable<string>;
        /** Event triggered on step click: `onClick(stepIndex)` */
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** Index of the active step. */
        activeStep: PropTypes.Validator<number>;
        /**
         * An array of steps, where each step is an object with the following properties:
         * - `text` - step title text (required).
         * - `type` - step type (`completed`, `disabled`, `error` or default `normal`).
         */
        steps: PropTypes.Validator<(PropTypes.InferProps<{
            text: PropTypes.Validator<string>;
            type: PropTypes.Requireable<string>;
        }> | null | undefined)[]>;
        /** Style type. */
        type: PropTypes.Requireable<string>;
        /**
         * Fit mode for steps. In `stretched` mode the component will grow to fill parent
         * container width.
         */
        fit: PropTypes.Requireable<string>;
    };
    static defaultProps: {
        steps: never[];
        type: string;
        fit: string;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    _getActiveStepType: () => any;
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=Stepper.d.ts.map