import { Simulate } from 'react-dom/test-utils';
import type { TooltipSize } from './Tooltip.types';
export declare const tooltipLegacyDriverFactory: ({ element, eventTrigger, }: {
    element: Element | undefined;
    eventTrigger: typeof Simulate;
}) => {
    /** returns true if trigger element exists on the DOM */
    exists: () => Promise<boolean>;
    /** returns true if tooltip element exists on the DOM */
    tooltipExists: () => Promise<boolean>;
    /** mouse over the target element */
    mouseEnter: () => Promise<void | undefined>;
    /** mouse leaves the target element */
    mouseLeave: () => Promise<void | undefined>;
    /** clicks outside the tooltip target */
    clickOutside: () => Promise<void>;
    /** returns tooltips content value in string */
    getTooltipText: () => string | null | undefined;
    /**
     * Checks whether tooltip has a given size
     * @param {boolean} sizeName The tooltip size
     * @return {Promise<boolean>}
     */
    hasSize: (sizeName: TooltipSize) => boolean;
};
//# sourceMappingURL=Tooltip.driver.d.ts.map