import { Collapse, Expand } from '../Transition.types';
export declare const expandDefault: Expand;
export declare const collapseDefault: Collapse;
export declare const expectedOneWayValuesByDirection: {
    topToBottom: {
        entering: {
            bottom: string;
        };
        entered: {
            bottom: string;
        };
        exiting: {
            bottom: string;
        };
        exited: {
            bottom: string;
        };
    };
    bottomToTop: {
        entering: {
            bottom: string;
        };
        entered: {
            bottom: string;
        };
        exiting: {
            bottom: string;
        };
        exited: {
            bottom: string;
        };
    };
    leftToRight: {
        entering: {
            left: string;
        };
        entered: {
            left: string;
        };
        exiting: {
            left: string;
        };
        exited: {
            left: string;
        };
    };
    rightToLeft: {
        entering: {
            left: string;
        };
        entered: {
            left: string;
        };
        exiting: {
            left: string;
        };
        exited: {
            left: string;
        };
    };
};
export declare const expectedVerticalValuesWithReversedDirections: {
    bottomToTopTopToBottom: {
        entering: {
            bottom: string;
        };
        entered: {
            bottom: string;
        };
        exiting: {
            bottom: string;
        };
        exited: {
            bottom: string;
        };
    };
    topToBottomBottomToTop: {
        entering: {
            bottom: string;
        };
        entered: {
            bottom: string;
        };
        exiting: {
            bottom: string;
        };
        exited: {
            bottom: string;
        };
    };
};
export declare const differentVerticalDirections: {
    expand: Expand;
    collapse: Collapse;
    type: string;
}[];
export declare const expectedHorizontalValuesWithReversedDirections: {
    leftToRightRightToLeft: {
        entering: {
            left: string;
        };
        entered: {
            left: string;
        };
        exiting: {
            left: string;
        };
        exited: {
            left: string;
        };
    };
    rightToLeftLeftToRight: {
        entering: {
            left: string;
        };
        entered: {
            left: string;
        };
        exiting: {
            left: string;
        };
        exited: {
            left: string;
        };
    };
};
export declare const differentHorizontalDirections: {
    expand: Expand;
    collapse: Collapse;
    type: string;
}[];
export declare const expectedValuesWithDifferentDirections: {
    bottomToTopLeftToRight: {
        entering: {
            bottom: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exiting: {
            left: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
    bottomToTopRightToLeft: {
        exiting: {
            left: string;
            height: string;
            width: string;
        };
        entering: {
            bottom: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
    topToBottomLeftToRight: {
        entering: {
            bottom: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exiting: {
            left: string;
            height: string;
            width: string;
        };
    };
    topToBottomRightToLeft: {
        entering: {
            bottom: string;
            height: string;
            width: string;
        };
        exiting: {
            left: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
    leftToRightBottomToTop: {
        entering: {
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exiting: {
            bottom: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
    leftToRightTopToBottom: {
        exiting: {
            bottom: string;
            height: string;
            width: string;
        };
        entering: {
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
    rightToLeftbottomToTop: {
        entering: {
            left: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        exiting: {
            bottom: string;
            height: string;
            width: string;
        };
    };
    rightToLefttopToBottom: {
        entering: {
            left: string;
            height: string;
            width: string;
        };
        exiting: {
            bottom: string;
            height: string;
            width: string;
        };
        exited: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
        entered: {
            bottom: string;
            left: string;
            height: string;
            width: string;
        };
    };
};
export declare const differentDirections: {
    expand: Expand;
    collapse: Collapse;
    type: string;
}[];
//# sourceMappingURL=utils.mocks.d.ts.map