export default Ellipsis;
declare class Ellipsis extends React.PureComponent<any, any, any> {
    static propTypes: any;
    static defaultProps: {
        ellipsis: boolean;
        appendTo: string;
        flip: boolean;
        fixed: boolean;
        placement: string;
        zIndex: any;
        enterDelay: number;
        exitDelay: number;
        showTooltip: boolean;
    };
    static getDerivedStateFromProps(props: any, state: any): {
        textRendered: boolean;
        prevRender: any;
        prevEllipsis: any;
        prevMaxLines: any;
    } | null;
    constructor(props: any);
    state: {
        isActive: boolean;
        textContent: null;
        textRendered: boolean;
    };
    ref: React.RefObject<any>;
    /**
     * Once text component has rendered,
     * Update text content and tooltip active state
     * @private
     */
    private _onTextRendered;
    /**
     * An ellipsis is considered active when either the text's scroll width/height is wider than it's container or itself.
     * @private
     */
    private _updateIsActive;
    _getTextContent: () => any;
    _checkShouldBeActive: () => any;
    _isOverflowingHorizontally: () => any;
    _isOverflowingVertically: () => any;
    /**
     * A callback for resizing the window, must be debounced in order to improve performance.
     * @private
     */
    private _debouncedUpdate;
    componentDidMount(): void;
    _renderText(): React.JSX.Element;
    render(): React.JSX.Element;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
}
import React from 'react';
//# sourceMappingURL=Ellipsis.d.ts.map