export default usePlacesAutocomplete;
/** A hook for fetching place predictions based on input value */
declare function usePlacesAutocomplete({ client, debounceMs, debounceFn, onError, }: {
    client: any;
    debounceMs?: number | undefined;
    debounceFn?: {
        <T extends (...args: any) => any>(func: T, wait: number | undefined, options: import("lodash").DebounceSettingsLeading): import("lodash").DebouncedFuncLeading<T>;
        <T extends (...args: any) => any>(func: T, wait?: number, options?: import("lodash").DebounceSettings): import("lodash").DebouncedFunc<T>;
    } | undefined;
    onError: any;
}): {
    /** array of prediction results */
    predictions: never[];
    /** whether fetch request is ongoing */
    loading: boolean;
    /** (value: string, requestOptions?: RequestOptions) => void
     * fetches predictions for given value from client (debounced)
     * and sets results to prediction state.
     *
     * Can also receive requestOptions,
     * which are client specific options to pass to the request */
    updatePredictions: import("lodash").DebouncedFunc<(...args: any[]) => void>;
    /** function that clears predictions array and sets loading state to false */
    clearPredictions: () => void;
};
//# sourceMappingURL=usePlacesAutocomplete.d.ts.map