import React from 'react';
import PropTypes from 'prop-types';
import { AnnouncementModalLayoutProps } from './AnnouncementModalLayout.types';
/** A layout for announcement modals, to be used inside a &lt;Modal /&gt; */
declare const AnnouncementModalLayout: {
    ({ theme, actionsSize, ...propsWithoutDefaults }: AnnouncementModalLayoutProps): React.JSX.Element;
    displayName: string;
    propTypes: {
        className: PropTypes.Requireable<string>;
        dataHook: PropTypes.Requireable<string>;
        onCloseButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        onHelpButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        theme: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        subtitle: PropTypes.Requireable<string>;
        content: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        actionsSize: PropTypes.Requireable<string>;
        primaryButtonText: PropTypes.Requireable<string>;
        primaryButtonOnClick: PropTypes.Requireable<(...args: any[]) => any>;
        primaryButtonProps: PropTypes.Requireable<PropTypes.InferProps<{
            as: PropTypes.Requireable<NonNullable<string | object | null | undefined>>;
            className: PropTypes.Requireable<string>;
            skin: PropTypes.Requireable<string>;
            priority: PropTypes.Requireable<string>;
            size: PropTypes.Requireable<string>;
            onClick: PropTypes.Requireable<(...args: any[]) => any>;
            fullWidth: PropTypes.Requireable<boolean>;
            suffixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            prefixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            disabled: PropTypes.Requireable<boolean>;
            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            ellipsis: PropTypes.Requireable<boolean>;
            showTooltip: PropTypes.Requireable<boolean>;
            tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        }>>;
        secondaryButtonText: PropTypes.Requireable<string>;
        secondaryButtonOnClick: PropTypes.Requireable<(...args: any[]) => any>;
        secondaryButtonProps: PropTypes.Requireable<PropTypes.InferProps<{
            as: PropTypes.Requireable<NonNullable<string | object | null | undefined>>;
            className: PropTypes.Requireable<string>;
            skin: PropTypes.Requireable<string>;
            priority: PropTypes.Requireable<string>;
            size: PropTypes.Requireable<string>;
            onClick: PropTypes.Requireable<(...args: any[]) => any>;
            fullWidth: PropTypes.Requireable<boolean>;
            suffixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            prefixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            disabled: PropTypes.Requireable<boolean>;
            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            ellipsis: PropTypes.Requireable<boolean>;
            showTooltip: PropTypes.Requireable<boolean>;
            tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        }>>;
        sideActions: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        footnote: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        illustration: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        linkText: PropTypes.Requireable<string>;
        linkOnClick: PropTypes.Requireable<(...args: any[]) => any>;
    };
};
export default AnnouncementModalLayout;
//# sourceMappingURL=AnnouncementModalLayout.d.ts.map