"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _AnnouncementModalLayoutSt = require("./AnnouncementModalLayout.st.css");
var _TextButton = _interopRequireDefault(require("../TextButton"));
var _constants = require("./constants");
var _BaseModalLayout = _interopRequireDefault(require("../BaseModalLayout"));
var _Button = _interopRequireDefault(require("../Button"));
var _context = require("../WixStyleReactProvider/context");
var _excluded = ["theme", "actionsSize"],
  _excluded2 = ["className", "children"],
  _excluded3 = ["dataHook"],
  _excluded4 = ["dataHook"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/AnnouncementModalLayout/AnnouncementModalLayout.tsx";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/** A layout for announcement modals, to be used inside a &lt;Modal /&gt; */
var AnnouncementModalLayout = _ref => {
  var {
      theme = 'standard',
      actionsSize = 'medium'
    } = _ref,
    propsWithoutDefaults = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var _theme$actionsSize$pr = _objectSpread({
      theme,
      actionsSize
    }, propsWithoutDefaults),
    {
      className,
      children
    } = _theme$actionsSize$pr,
    restProps = (0, _objectWithoutProperties2.default)(_theme$actionsSize$pr, _excluded2);
  return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 25,
      columnNumber: 5
    }
  }, _ref2 => {
    var {
      newColorsBranding
    } = _ref2;
    return (
      /*#__PURE__*/
      // @ts-ignore
      _react.default.createElement(_BaseModalLayout.default, (0, _extends2.default)({
        className: (0, _AnnouncementModalLayoutSt.st)(_AnnouncementModalLayoutSt.classes.announcementModalLayout, className)
      }, restProps, {
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 28,
          columnNumber: 9
        }
      }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Illustration, {
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 32,
          columnNumber: 11
        }
      }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Header, {
        titleSize: newColorsBranding ? 'extraLarge' : 'large',
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 33,
          columnNumber: 11
        }
      }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Content, {
        hideTopScrollDivider: true,
        hideBottomScrollDivider: true,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 37,
          columnNumber: 11
        }
      }, children), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Footer, {
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 40,
          columnNumber: 11
        }
      }), /*#__PURE__*/_react.default.createElement(Link, (0, _extends2.default)({}, restProps, {
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 41,
          columnNumber: 11
        }
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: _AnnouncementModalLayoutSt.classes.bottomSpacing,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 42,
          columnNumber: 11
        }
      }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Footnote, {
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 43,
          columnNumber: 11
        }
      }))
    );
  });
};
var Link = _ref3 => {
  var {
    linkText,
    linkOnClick,
    theme
  } = _ref3;
  return (linkText || linkOnClick) && /*#__PURE__*/_react.default.createElement("div", {
    className: _AnnouncementModalLayoutSt.classes.link,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 56,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(_TextButton.default, {
    size: "small",
    weight: "normal",
    dataHook: _constants.dataHooks.link,
    onClick: linkOnClick,
    skin: theme,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 7
    }
  }, linkText)) || null;
};
AnnouncementModalLayout.displayName = 'AnnouncementModalLayout';
AnnouncementModalLayout.propTypes = {
  className: _propTypes.default.string,
  dataHook: _propTypes.default.string,
  onCloseButtonClick: _propTypes.default.func,
  onHelpButtonClick: _propTypes.default.func,
  theme: _propTypes.default.oneOf(['standard', 'premium']),
  title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  subtitle: _propTypes.default.string,
  content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  actionsSize: _Button.default.propTypes.size,
  primaryButtonText: _propTypes.default.string,
  primaryButtonOnClick: _propTypes.default.func,
  primaryButtonProps: (() => {
    var _Button$propTypes = _Button.default.propTypes,
      {
        dataHook
      } = _Button$propTypes,
      buttonProps = (0, _objectWithoutProperties2.default)(_Button$propTypes, _excluded3);
    return _propTypes.default.shape(buttonProps);
  })(),
  secondaryButtonText: _propTypes.default.string,
  secondaryButtonOnClick: _propTypes.default.func,
  secondaryButtonProps: (() => {
    var _Button$propTypes2 = _Button.default.propTypes,
      {
        dataHook
      } = _Button$propTypes2,
      buttonProps = (0, _objectWithoutProperties2.default)(_Button$propTypes2, _excluded4);
    return _propTypes.default.shape(buttonProps);
  })(),
  sideActions: _propTypes.default.node,
  footnote: _propTypes.default.node,
  illustration: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  linkText: _propTypes.default.string,
  linkOnClick: _propTypes.default.func
};
var _default = exports.default = AnnouncementModalLayout;
//# sourceMappingURL=AnnouncementModalLayout.js.map