"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.audioPlayerDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _IconButtonUni = require("../IconButton/IconButton.uni.driver");
var _HeadingUni = require("../Heading/Heading.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * Note: Testing AudioPlayer is not possible in JSdom due to the web audio API.
 */
var audioPlayerDriverFactory = (base, body) => {
  var playPauseButtonDriver = (0, _IconButtonUni.iconButtonDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.audioPlayerPlayPause));
  var timeIndicatorDriver = (0, _HeadingUni.headingUniDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.audioTimeIndicator));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Clicks on play/pause button
     * @return {Promise<void>}
     */
    clickOnPlayPauseButton: () => playPauseButtonDriver.click(),
    /**
     * Gets time indicator text
     * @return {Promise<string>}
     */
    timeIndicatorText: () => timeIndicatorDriver.getText()
  });
};
exports.audioPlayerDriverFactory = audioPlayerDriverFactory;
//# sourceMappingURL=AudioPlayer.uni.driver.js.map