"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _Badge = _interopRequireDefault(require("../Badge/Badge.driver"));
var DATA_ATTR = _interopRequireWildcard(require("./DataAttr"));
var _DropdownLayout = _interopRequireDefault(require("../DropdownLayout/DropdownLayout.driver"));
var _Popover = require("../Popover/Popover.driver");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var badgeSelectDriverFactory = _ref => {
  var {
    element,
    eventTrigger
  } = _ref;
  var popoverDriver = (0, _Popover.popoverLegacyDriverFactory)({
    element,
    eventTrigger
  });
  var badgeDriver = (0, _Badge.default)({
    element: element.querySelector("[data-hook=\"".concat(DATA_ATTR.DATA_BADGE, "\"]")),
    eventTrigger
  });
  return {
    /** Returns 'true' whether the element exists */
    exists: () => !!element,
    /** Gets badge text */
    text: badgeDriver.text,
    /** Click on an option */
    clickAtOption: index => {
      if (!popoverDriver.isContentElementExists()) {
        badgeDriver.click();
      }

      // Since the popover may be closed, we need to create the DropdownLayout driver every time
      var dropdownLayoutDriver = (0, _DropdownLayout.default)({
        element: popoverDriver.getContentElement().querySelector("[data-hook=\"".concat(DATA_ATTR.DATA_DROPDOWN, "\"]"))
      });
      if (dropdownLayoutDriver.exists()) {
        dropdownLayoutDriver.clickAtOption(index);
      }
    }
  };
};
var _default = exports.default = badgeSelectDriverFactory;
//# sourceMappingURL=BadgeSelect.driver.js.map