export default BaseModalLayout;
/** Private component to be used by all public modals. Represents the common internals of all modals */
declare class BaseModalLayout extends React.PureComponent<any, any, any> {
    static Header: React.FunctionComponent<import("./LayoutBlocks").HeaderProps> & {
        Title: React.FunctionComponent<{
            children?: React.ReactNode;
        }>;
    };
    static Content: React.FunctionComponent<import("./LayoutBlocks").ContentProps>;
    static Footer: React.FunctionComponent<import("./LayoutBlocks").FooterProps>;
    static Footnote: React.FunctionComponent<import("./LayoutBlocks").FootnoteProps>;
    static Illustration: React.FunctionComponent<import("./LayoutBlocks").IllustrationProps>;
    constructor(props: any);
    constructor(props: any, context: any);
    render(): React.JSX.Element;
}
declare namespace BaseModalLayout {
    namespace propTypes {
        let className: PropTypes.Requireable<string>;
        let dataHook: PropTypes.Requireable<string>;
        let onCloseButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        let onHelpButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        let theme: PropTypes.Requireable<string>;
    }
    namespace defaultProps {
        let theme_1: string;
        export { theme_1 as theme };
    }
    let displayName: string;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=BaseModalLayout.d.ts.map