"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _Ellipsis = _interopRequireDefault(require("../common/Ellipsis"));
var _TooltipCommon = require("../common/PropTypes/TooltipCommon");
var _generateDataAttr = require("../utils/generateDataAttr");
var _ButtonSt = require("./Button.st.css");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _WixStyleReactDefaultsOverrideProvider = require("../WixStyleReactDefaultsOverrideProvider");
var _context = require("../WixStyleReactProvider/context");
var _deprecationLog = _interopRequireDefault(require("../utils/deprecationLog"));
var _ButtonCore = _interopRequireDefault(require("./ButtonCore"));
var _excluded = ["skin", "priority", "size", "className", "fullWidth", "children", "dataHook", "ellipsis", "showTooltip", "tooltipProps"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Button/Button.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
class Button extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.button = /*#__PURE__*/_react.default.createRef();
    /**
     * Sets focus on the element
     */
    this.focus = () => {
      this.button.current && this.button.current.focus();
    };
    if (props.skin === 'inverted') {
      (0, _deprecationLog.default)('<Button/> - skin="inverted" is deprecated and will be removed in next major version, please use skin="standard" and priority="secondary" instead');
    }
  }
  render() {
    var {
      button: buttonPropsDefaults
    } = this.context;
    var _this$props = this.props,
      {
        skin = 'standard',
        priority = 'primary',
        size = buttonPropsDefaults.size,
        className,
        fullWidth,
        children,
        dataHook,
        ellipsis,
        showTooltip,
        tooltipProps = {}
      } = _this$props,
      rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
    return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 91,
        columnNumber: 7
      }
    }, _ref => {
      var {
        newColorsBranding
      } = _ref;
      return /*#__PURE__*/_react.default.createElement(_Ellipsis.default, (0, _extends2.default)({
        ellipsis: ellipsis,
        showTooltip: showTooltip
      }, tooltipProps, {
        render: _ref2 => {
          var {
            ref,
            ellipsisClasses
          } = _ref2;
          return /*#__PURE__*/_react.default.createElement(_ButtonCore.default, (0, _extends2.default)({}, rest, (0, _generateDataAttr.generateDataAttr)(_objectSpread(_objectSpread({}, this.props), {}, {
            size
          }), ['skin', 'size', 'priority']), {
            ref: this.button,
            className: (0, _ButtonSt.st)(_ButtonSt.classes.root, {
              fluid: !!fullWidth,
              skin,
              priority,
              size,
              ellipsis: !!ellipsis,
              newColorsBranding
            }, className),
            "data-hook": dataHook,
            contentClassName: ellipsisClasses(),
            contentRef: ref,
            __self: this,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 98,
              columnNumber: 15
            }
          }), children);
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 93,
          columnNumber: 11
        }
      }));
    });
  }
}
Button.contextType = _WixStyleReactDefaultsOverrideProvider.WixStyleReactDefaultsOverrideContext;
Button.displayName = 'Button';
Button.propTypes = {
  as: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object, _propTypes.default.string]),
  className: _propTypes.default.string,
  skin: _propTypes.default.oneOf(['standard', 'inverted', 'destructive', 'premium', 'dark', 'light', 'transparent', 'premium-light', 'ai']),
  priority: _propTypes.default.oneOf(['primary', 'secondary']),
  size: _propTypes.default.oneOf(['tiny', 'small', 'medium', 'large']),
  onClick: _propTypes.default.func,
  fullWidth: _propTypes.default.bool,
  suffixIcon: _propTypes.default.element,
  prefixIcon: _propTypes.default.element,
  disabled: _propTypes.default.bool,
  children: _propTypes.default.node,
  dataHook: _propTypes.default.string,
  ellipsis: _propTypes.default.bool,
  showTooltip: _propTypes.default.bool,
  tooltipProps: _propTypes.default.shape(_TooltipCommon.TooltipCommonProps)
};
var _default = exports.default = Button;
//# sourceMappingURL=Button.js.map