"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.buttonDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _ButtonCoreUni = require("./ButtonCore/ButtonCore.uni.driver");
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var buttonDriverFactory = base => {
  var buttonCoreDriver = (0, _ButtonCoreUni.buttonCoreDriverFactory)(base);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    // Gets button text
    getButtonTextContent: buttonCoreDriver.getButtonTextContent,
    // Checks whether button is focused
    isFocused: buttonCoreDriver.isFocused,
    // Checks whether button is disabled
    isButtonDisabled: buttonCoreDriver.isButtonDisabled,
    // Checks whether button has a given skin
    hasSkin: function () {
      var _hasSkin = (0, _asyncToGenerator2.default)(function* (skinName) {
        return (yield base.attr("data-skin")) === skinName;
      });
      function hasSkin(_x) {
        return _hasSkin.apply(this, arguments);
      }
      return hasSkin;
    }(),
    /**
     * Checks whether button has an icon prefix
     * @return {Promise<boolean>}
     */
    isPrefixIconExists: buttonCoreDriver.isPrefixIconExists,
    // Checks whether button has an icon suffix
    isSuffixIconExists: buttonCoreDriver.isSuffixIconExists
  });
};
exports.buttonDriverFactory = buttonDriverFactory;
//# sourceMappingURL=Button.uni.driver.js.map