import * as React from 'react';
export interface ButtonProps extends React.ButtonHTMLAttributes<HTMLButtonElement> {
    /** an element type to render as (string or function).  */
    as?: string | React.ComponentType<any>;
    children?: React.ReactNode;
    /** URL of the page that link goes to */
    href?: string;
    /** accepts prefix icon */
    prefixIcon?: React.ReactElement;
    /** accepts suffix icon  */
    suffixIcon?: React.ReactElement;
    /** apply disabled styles */
    disabled?: boolean;
    /** class name to be added to the content span */
    contentClassName?: string;
    /** React ref to be attached to the content span */
    contentRef?: React.RefObject<HTMLSpanElement>;
    focusableOnFocus?(): void;
    focusableOnBlur?(): void;
}
declare const _default: React.ComponentType<import("../../common/Focusable").InjectedFocusableProps<ButtonProps, HTMLElement>>;
export default _default;
//# sourceMappingURL=ButtonCore.d.ts.map