"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Focusable = require("../../common/Focusable");
var _ButtonCoreSt = require("./ButtonCore.st.css");
var _constants = require("./constants");
var _utils = require("./utils");
var _excluded = ["as", "suffixIcon", "prefixIcon", "children", "disabled", "focusableOnFocus", "focusableOnBlur", "href", "contentClassName", "contentRef"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Button/ButtonCore/ButtonCore.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var _addAffix = (Affix, styleClass, dataHook) => Affix && /*#__PURE__*/React.cloneElement(Affix, {
  className: (0, _classnames.default)(_ButtonCoreSt.classes[styleClass], Affix.props.className),
  'data-hook': Affix.props['data-hook'] || Affix.props.dataHook || dataHook
});

/**
 * ButtonCore
 */
class ButtonCore extends React.Component {
  constructor() {
    super(...arguments);
    this.innerComponentRef = /*#__PURE__*/React.createRef();
  }
  focus() {
    if (this.innerComponentRef && this.innerComponentRef.focus) {
      this.innerComponentRef.focus();
    }
  }
  render() {
    var _this$props = this.props,
      {
        as: Component,
        suffixIcon,
        prefixIcon,
        children,
        disabled,
        focusableOnFocus,
        focusableOnBlur,
        href,
        contentClassName,
        contentRef
      } = _this$props,
      rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
    var htmlTabIndex = disabled ? -1 : rest.tabIndex || 0;
    var htmlHref = disabled ? undefined : href;
    var reference = (0, _utils.isStatelessComponent)(Component) && typeof Component !== 'string' ? undefined : ref => this.innerComponentRef = ref;
    if (!Component) {
      return null;
    }
    return /*#__PURE__*/React.createElement(Component, (0, _extends2.default)({
      "data-hook": _constants.dataHooks.button
    }, rest, {
      onFocus: focusableOnFocus,
      onBlur: focusableOnBlur,
      disabled: href ? undefined : disabled,
      href: htmlHref,
      ref: reference,
      tabIndex: htmlTabIndex,
      "aria-disabled": disabled,
      className: (0, _ButtonCoreSt.st)(_ButtonCoreSt.classes.root, {
        disabled
      }, this.props.className),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 87,
        columnNumber: 7
      }
    }), prefixIcon && _addAffix(prefixIcon, 'prefix', _constants.dataHooks.prefixIcon), /*#__PURE__*/React.createElement("span", {
      className: (0, _ButtonCoreSt.st)(_ButtonCoreSt.classes.content, contentClassName),
      ref: contentRef,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 100,
        columnNumber: 9
      }
    }, children), suffixIcon && _addAffix(suffixIcon, 'suffix', _constants.dataHooks.suffixIcon));
  }
}
ButtonCore.defaultProps = {
  as: 'button',
  type: 'button'
};
ButtonCore.displayName = 'ButtonCore';
var _default = exports.default = (0, _Focusable.withFocusable)(ButtonCore);
//# sourceMappingURL=ButtonCore.js.map