export default CalendarPanelFooter;
declare class CalendarPanelFooter extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Applies a data-hook HTML attribute that can be used in the tests */
        dataHook: PropTypes.Requireable<string>;
        /** Defines primary (submit) action label */
        primaryActionLabel: PropTypes.Validator<string>;
        /** Defines secondary (cancel) action label */
        secondaryActionLabel: PropTypes.Validator<string>;
        /** Specifies whether primary action is disabled */
        primaryActionDisabled: PropTypes.Validator<boolean>;
        /** Defines a callback function which is called every time primary button is clicked */
        primaryActionOnClick: PropTypes.Validator<(...args: any[]) => any>;
        /** Defines a callback function which is called every time secondary button is clicked */
        secondaryActionOnClick: PropTypes.Validator<(...args: any[]) => any>;
        /** Defines an active date or a date range selection */
        selectedDays: PropTypes.Requireable<NonNullable<string | Date | PropTypes.InferProps<{
            from: PropTypes.Requireable<NonNullable<string | Date | null | undefined>>;
            to: PropTypes.Requireable<NonNullable<string | Date | null | undefined>>;
        }> | null | undefined>>;
        /** Formats date into a string for displaying the current selected days. Receives a Date instance (not undefined). */
        dateToString: PropTypes.Validator<(...args: any[]) => any>;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=CalendarPanelFooter.d.ts.map