"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Content = _interopRequireDefault(require("./Content"));
var _Header = _interopRequireDefault(require("./Header"));
var _Subheader = _interopRequireDefault(require("./Subheader"));
var _Divider = _interopRequireDefault(require("./Divider"));
var _CardSt = require("./Card.st.css");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Card/Card.js";
var Card = _ref => {
  var {
    stretchVertically = false,
    showShadow = false,
    hideOverflow,
    className,
    children,
    controls,
    dataHook
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _CardSt.st)(_CardSt.classes.card, {
      stretchVertically,
      hideOverflow,
      showShadow
    }, className),
    "data-hook": dataHook,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 18,
      columnNumber: 3
    }
  }, controls && /*#__PURE__*/_react.default.createElement("div", {
    className: _CardSt.classes.controls,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 26,
      columnNumber: 18
    }
  }, controls), children);
};
Card.displayName = 'Card';
Card.propTypes = {
  /** Contains elements inside the card `<Card.Header/>`, `<Card.Subeader/>`, `<Card.Content/>` or `<Card.Divider/>` */
  children: _propTypes.default.node,
  /** Applies a CSS class to the component’s root element */
  className: _propTypes.default.string,
  /** Contains elements that control the component (usually a <CloseButton/>) */
  controls: _propTypes.default.node,
  /** Makes a card stretch vertically to max height in a layout or container */
  stretchVertically: _propTypes.default.bool,
  /** Applies a drop shadow effect */
  showShadow: _propTypes.default.bool,
  /** Hides a portion of card content that overflows its dimensions */
  hideOverflow: _propTypes.default.bool,
  /** Applies a data-hook HTML attribute to be used in the tests */
  dataHook: _propTypes.default.string
};
Card.Content = _Content.default;
Card.Header = _Header.default;
Card.Divider = _Divider.default;
Card.Subheader = _Subheader.default;
var _default = exports.default = Card;
//# sourceMappingURL=Card.js.map