"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _HeaderSt = require("./Header.st.css");
var _Heading = _interopRequireDefault(require("../../Heading"));
var _Text = _interopRequireDefault(require("../../Text"));
var _hooks = require("./hooks");
var _StringUtils = require("../../utils/StringUtils");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Card/Header/Header.js";
class Header extends _react.default.PureComponent {
  render() {
    var {
      dataHook,
      title,
      subtitle,
      suffix,
      className
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      "data-hook": dataHook,
      className: (0, _HeaderSt.st)(_HeaderSt.classes.root, {}, className),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 33,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: _HeaderSt.classes.titleWrapper,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 34,
        columnNumber: 9
      }
    }, (0, _StringUtils.isString)(title) ? /*#__PURE__*/_react.default.createElement(_Heading.default, {
      dataHook: _hooks.DataHooks.title,
      size: "medium",
      children: title,
      className: _HeaderSt.classes.title,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 36,
        columnNumber: 13
      }
    }) : /*#__PURE__*/_react.default.createElement("span", {
      "data-hook": _hooks.DataHooks.title,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 43,
        columnNumber: 13
      }
    }, title), subtitle && (0, _StringUtils.isString)(subtitle) ? /*#__PURE__*/_react.default.createElement(_Text.default, {
      dataHook: _hooks.DataHooks.subtitle,
      children: subtitle,
      secondary: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 47,
        columnNumber: 13
      }
    }) : /*#__PURE__*/_react.default.createElement("span", {
      "data-hook": _hooks.DataHooks.subtitle,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 13
      }
    }, subtitle)), suffix && /*#__PURE__*/_react.default.createElement("div", {
      "data-hook": _hooks.DataHooks.suffix,
      className: _HeaderSt.classes.suffix,
      children: suffix,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 11
      }
    }));
  }
}
Header.displayName = 'Card.Header';
Header.propTypes = {
  /** Applies a data-hook HTML attribute to be used in the tests */
  dataHook: _propTypes.default.string,
  /** Sets card title text value. Title can also be overridden to any other component. */
  title: _propTypes.default.node.isRequired,
  /** Sets card subtitle text value. Subtitle can also be overridden to any other component. */
  subtitle: _propTypes.default.node,
  /** Adds an empty container on the right side of a header. Used to store action buttons or other components. */
  suffix: _propTypes.default.node,
  /** Specifies a CSS class name to be appended to the component’s root element. */
  className: _propTypes.default.string
};
var _default = exports.default = Header;
//# sourceMappingURL=Header.js.map