"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.cardFolderTabsDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _TextUni = require("../Text/Text.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var cardFolderTabsDriverFactory = base => {
  var getButtonById = id => (0, _unidriver.findByHook)(base, _constants.dataHooks.tabButton(id));
  var getTabTextById = id => (0, _TextUni.textUniDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.tabText(id)));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether tab is disabled by id
     * @param {string} tabId
     * @return {Promise<boolean>}
     */
    isTabDisabledById: function () {
      var _isTabDisabledById = (0, _asyncToGenerator2.default)(function* (tabId) {
        return (yield getButtonById(tabId).attr('disabled')) !== null;
      });
      function isTabDisabledById(_x) {
        return _isTabDisabledById.apply(this, arguments);
      }
      return isTabDisabledById;
    }(),
    /**
     * Selects tab by tab by id
     * @param {string} tabId
     * @return {Promise<void>}
     */
    selectTabById: function () {
      var _selectTabById = (0, _asyncToGenerator2.default)(function* (tabId) {
        return (yield getButtonById(tabId)).click();
      });
      function selectTabById(_x2) {
        return _selectTabById.apply(this, arguments);
      }
      return selectTabById;
    }(),
    /**
     * Return tab text size
     * @return {Promise<string>}
     */
    getSize: tabId => getTabTextById(tabId).getSize()
  });
};
exports.cardFolderTabsDriverFactory = cardFolderTabsDriverFactory;
//# sourceMappingURL=CardFolderTabs.uni.driver.js.map