"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _MediaOverlayUni = require("../MediaOverlay/MediaOverlay.uni.driver");
var _constants = require("./constants");
var _DragHandleUni = require("../DragHandle/DragHandle.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var byHook = (base, dataHook) => base.$("[data-hook=\"".concat(dataHook, "\"]"));
var _getTitle = base => byHook(base, _constants.DataHook.Title);
var _getBadge = base => byHook(base, _constants.DataHook.Badge);
var _getSettingsMenu = base => byHook(base, _constants.DataHook.SettingsMenu);
var _getSubtitle = base => byHook(base, _constants.DataHook.Subtitle);
var getContainer = base => byHook(base, _constants.DataHook.Container);
var getFooter = base => byHook(base, _constants.DataHook.footer);
var getOverlayDriver = base => {
  var hoverComponent = byHook(base, _constants.DataHook.HoverComponent);
  return (0, _MediaOverlayUni.mediaOverlayDriverFactory)(hoverComponent);
};
var _hover = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2.default)(function* (base) {
    return getContainer(base).hover();
  });
  return function hover(_x) {
    return _ref.apply(this, arguments);
  };
}();
var getPrimaryAction = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2.default)(function* (base) {
    yield _hover(base);
    return byHook(base, _constants.DataHook.PrimaryAction);
  });
  return function getPrimaryAction(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
var getSecondaryAction = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2.default)(function* (base) {
    yield _hover(base);
    return byHook(base, _constants.DataHook.SecondaryAction);
  });
  return function getSecondaryAction(_x3) {
    return _ref3.apply(this, arguments);
  };
}();
var cardGalleryItemDriverFactory = (base, body) => {
  var getDragHandle = () => (0, _DragHandleUni.dragHandleUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.DataHook.dragHandle, "\"]")), body);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Gets the cards title.
     * @returns {Promise<string | null>}
     */
    getTitle: function () {
      var _getTitle2 = (0, _asyncToGenerator2.default)(function* () {
        var title = _getTitle(base);
        return (yield title.exists()) ? title.text() : null;
      });
      function getTitle() {
        return _getTitle2.apply(this, arguments);
      }
      return getTitle;
    }(),
    /**
     * Gets the badge node element.
     * @returns {Promise<any>}
     */
    getBadge: function () {
      var _getBadge2 = (0, _asyncToGenerator2.default)(function* () {
        var badge = _getBadge(base);
        return (yield badge.exists()) ? badge._prop('firstChild') : null;
      });
      function getBadge() {
        return _getBadge2.apply(this, arguments);
      }
      return getBadge;
    }(),
    /**
     * Gets the cards subtitle.
     * @returns {Promise<string | null>}
     */
    getSubtitle: function () {
      var _getSubtitle2 = (0, _asyncToGenerator2.default)(function* () {
        var subtitle = _getSubtitle(base);
        return (yield subtitle.exists()) ? subtitle.text() : null;
      });
      function getSubtitle() {
        return _getSubtitle2.apply(this, arguments);
      }
      return getSubtitle;
    }(),
    /**
     * Gets the background image URL.
     * @returns {Promise<string | null>}
     */
    getBackgroundImageUrl: function () {
      var _getBackgroundImageUrl = (0, _asyncToGenerator2.default)(function* () {
        return yield getOverlayDriver(base).getMediaUrl();
      });
      function getBackgroundImageUrl() {
        return _getBackgroundImageUrl.apply(this, arguments);
      }
      return getBackgroundImageUrl;
    }(),
    /**
     * Clicks on the primary action.
     * @returns {Promise<void>}
     */
    click: function () {
      var _click = (0, _asyncToGenerator2.default)(function* () {
        return (yield getPrimaryAction(base)).click();
      });
      function click() {
        return _click.apply(this, arguments);
      }
      return click;
    }(),
    /**
     * Clicks on the footer.
     * @returns {Promise<void>}
     */
    clickFooter: function () {
      var _clickFooter = (0, _asyncToGenerator2.default)(function* () {
        return (yield getFooter(base)).click();
      });
      function clickFooter() {
        return _clickFooter.apply(this, arguments);
      }
      return clickFooter;
    }(),
    /**
     * Gets the primary action label.
     * @returns {Promise<string>}
     */
    getPrimaryActionLabel: function () {
      var _getPrimaryActionLabel = (0, _asyncToGenerator2.default)(function* () {
        return (yield getPrimaryAction(base)).text();
      });
      function getPrimaryActionLabel() {
        return _getPrimaryActionLabel.apply(this, arguments);
      }
      return getPrimaryActionLabel;
    }(),
    /**
     * Checks whether the primary action is clickable.
     * @returns {Promise<boolean>}
     */
    isPrimaryActionDisabled: function () {
      var _isPrimaryActionDisabled = (0, _asyncToGenerator2.default)(function* () {
        return (yield getPrimaryAction(base))._prop('disabled');
      });
      function isPrimaryActionDisabled() {
        return _isPrimaryActionDisabled.apply(this, arguments);
      }
      return isPrimaryActionDisabled;
    }(),
    /**
     * Clicks on the primary action button.
     * @returns {Promise<void>}
     */
    clickOnPrimaryAction: function () {
      var _clickOnPrimaryAction = (0, _asyncToGenerator2.default)(function* () {
        return (yield getPrimaryAction(base)).click();
      });
      function clickOnPrimaryAction() {
        return _clickOnPrimaryAction.apply(this, arguments);
      }
      return clickOnPrimaryAction;
    }(),
    /**
     * Gets the secondary action label.
     * @returns {Promise<string>}
     */
    getSecondaryActionLabel: function () {
      var _getSecondaryActionLabel = (0, _asyncToGenerator2.default)(function* () {
        return (yield getSecondaryAction(base)).text();
      });
      function getSecondaryActionLabel() {
        return _getSecondaryActionLabel.apply(this, arguments);
      }
      return getSecondaryActionLabel;
    }(),
    /**
     * Clicks on the secondary action.
     * @returns {Promise<void>}
     */
    clickOnSecondaryAction: function () {
      var _clickOnSecondaryAction = (0, _asyncToGenerator2.default)(function* () {
        return (yield getSecondaryAction(base)).click();
      });
      function clickOnSecondaryAction() {
        return _clickOnSecondaryAction.apply(this, arguments);
      }
      return clickOnSecondaryAction;
    }(),
    /**
     * Gets the the settingsMenu node.
     * @returns {Promise<node>}
     */
    getSettingsMenu: function () {
      var _getSettingsMenu2 = (0, _asyncToGenerator2.default)(function* () {
        yield _hover(base);
        var settingsMenu = _getSettingsMenu(base);
        return (yield settingsMenu.exists()) ? settingsMenu._prop('firstChild') : null;
      });
      function getSettingsMenu() {
        return _getSettingsMenu2.apply(this, arguments);
      }
      return getSettingsMenu;
    }(),
    /**
     * Gets the background image element.
     * @returns {Promise<any>}
     */
    getBackgroundImageNode: function () {
      var _getBackgroundImageNode = (0, _asyncToGenerator2.default)(function* () {
        return getOverlayDriver(base).getMediaNode();
      });
      function getBackgroundImageNode() {
        return _getBackgroundImageNode.apply(this, arguments);
      }
      return getBackgroundImageNode;
    }(),
    /**
     * Hovers the component.
     * @returns {Promise<void>}
     */
    hover: function () {
      var _hover2 = (0, _asyncToGenerator2.default)(function* () {
        return _hover(base);
      });
      function hover() {
        return _hover2.apply(this, arguments);
      }
      return hover;
    }(),
    /**
     * Indicates drag handle exists
     */
    dragHandleExists: () => getDragHandle().exists(),
    clickDragHandle: () => getDragHandle().click(),
    hoverDragHandle: () => getDragHandle().hover(),
    isDragHandleTooltipEnabled: () => getDragHandle().isTooltipEnabled(),
    getDragHandleTooltipContent: () => getDragHandle().getTooltipContent()
  });
};
var _default = exports.default = cardGalleryItemDriverFactory;
//# sourceMappingURL=CardGalleryItem.uni.driver.js.map