"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.carouselDriverFactory = void 0;
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var carouselDriverFactory = _ref => {
  var {
    element
  } = _ref;
  // It turns out that react-slick duplicates the children, so we ditch the cloned nodes
  var withoutClonedNodes = function withoutClonedNodes() {
    var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    return ".slick-slide:not(.slick-cloned) ".concat(selector);
  };
  return {
    exists: () => !!element,
    isLoading: () => {
      var loader = element.querySelector('[data-hook="loader"]');
      return !!loader;
    },
    getChildren: () => element.querySelectorAll(withoutClonedNodes()),
    getImages: () => {
      // Converting the result from NodeList to a real array
      return [...element.querySelectorAll(withoutClonedNodes('[data-hook="carousel-img"]'))].map(img => img.src);
    },
    clickPrevious: () => {
      var prevButton = element.querySelector('[data-hook="prev-button"]');
      _testUtils.default.Simulate.click(prevButton);
    },
    clickNext: () => {
      var nextButton = element.querySelector('[data-hook="next-button"]');
      _testUtils.default.Simulate.click(nextButton);
    }
  };
};
exports.carouselDriverFactory = carouselDriverFactory;
//# sourceMappingURL=Carousel.driver.js.map