"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var _IconButtonUni = require("../IconButton/IconButton.uni.driver");
var _utils = require("../test-utils/utils");
var _Carousel = require("./Carousel.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _default = _ref => {
  var {
    element
  } = _ref;
  var arrowButtonDriver = direction => (0, _IconButtonUni.iconButtonDriverFactory)({
    wrapper: element,
    dataHook: "".concat(direction, "-button")
  });
  return _objectSpread(_objectSpread({}, (0, _Carousel.carouselDriverFactory)({
    element
  })), {}, {
    hasClass: className => (0, _utils.isClassExists)(element, className),
    getCurrentImageIndex: () => {
      var currentSlide = element.querySelector('[aria-hidden="false"]');
      return Number(currentSlide.dataset.index);
    },
    isPrevButtonDisabled: () => arrowButtonDriver('prev').isButtonDisabled(),
    isNextButtonDisabled: () => arrowButtonDriver('next').isButtonDisabled(),
    loadImages: () => {
      element.querySelectorAll('[data-hook="carousel-img"]').forEach(img => _testUtils.default.Simulate.load(img));
    },
    mouseOver: () => {
      var imageContainer = element.querySelector('.slick-current');
      _testUtils.default.Simulate.mouseOver(imageContainer);
    },
    mouseOut: () => {
      var imageContainer = element.querySelector('.slick-current');
      _testUtils.default.Simulate.mouseOut(imageContainer);
    },
    clickPageNavigationDot: index => {
      var pageNavigator = element.querySelector("[data-hook=\"page-navigation-".concat(index, "\"]"));
      _testUtils.default.Simulate.click(pageNavigator);
    },
    isPageNavigationDotExists: () => !!element.querySelector("[data-hook^=\"page-navigation-\"]"),
    getChildText: child => child.textContent
  });
};
exports.default = _default;
//# sourceMappingURL=Carousel.private.driver.js.map