"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.carouselUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
// It turns out that react-slick duplicates the children, so we ditch the cloned nodes
var withoutClonedNodes = function withoutClonedNodes() {
  var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return ".slick-slide:not(.slick-cloned) ".concat(selector);
};
var carouselUniDriverFactory = base => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether the carousel is loading
     * @return {Promise<boolean>}
     */
    isLoading: function () {
      var _isLoading = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.$$('[data-hook="loader"]').count()) > 0;
      });
      function isLoading() {
        return _isLoading.apply(this, arguments);
      }
      return isLoading;
    }(),
    /**
     * Gets children list elements
     * @return {UniDriverList}
     */
    getChildren: () => base.$$(withoutClonedNodes()).map(child => child),
    /**
     * Get a list of the carousel images
     * @return {Promise<Array<string | null>>}
     */
    getImages: () => base.$$(withoutClonedNodes('[data-hook="carousel-img"]')).map(img => img.attr('src')),
    /**
     * Click on the previous item button
     * @return {Promise<void>}
     */
    clickPrevious: () => base.$('[data-hook="prev-button"]').click(),
    /**
     * Click on the next item button
     * @return {Promise<void>}
     */
    clickNext: () => base.$('[data-hook="next-button"]').click()
  });
};
exports.carouselUniDriverFactory = carouselUniDriverFactory;
//# sourceMappingURL=Carousel.uni.driver.js.map