"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.carouselWIPDriverFactory = void 0;
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var _constants = require("./constants");
var carouselWIPDriverFactory = _ref => {
  var {
    element
  } = _ref;
  return {
    exists: () => !!element,
    isLoading: () => {
      var loader = element.querySelector("[data-hook=\"".concat(_constants.DATA_HOOKS.loader, "\"]"));
      return !!loader;
    },
    getChildren: () => element.querySelectorAll("[data-hook=\"".concat(_constants.DATA_HOOKS.child, "\"]")),
    getImages: () => {
      return [...element.querySelectorAll("[data-hook=\"".concat(_constants.DATA_HOOKS.carouselImage, "\"]"))].map(img => img.src);
    },
    clickPrevious: () => {
      var prevButton = element.querySelector("[data-hook=\"".concat(_constants.DATA_HOOKS.prevButton, "\"]"));
      _testUtils.default.Simulate.click(prevButton);
    },
    clickNext: () => {
      var nextButton = element.querySelector("[data-hook=\"".concat(_constants.DATA_HOOKS.nextButton, "\"]"));
      _testUtils.default.Simulate.click(nextButton);
    }
  };
};
exports.carouselWIPDriverFactory = carouselWIPDriverFactory;
//# sourceMappingURL=CarouselWIP.driver.js.map