"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.carouselWIPUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var carouselWIPUniDriverFactory = base => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether the carousel is loading
     * @return {Promise<boolean>}
     */
    isLoading: function () {
      var _isLoading = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.$$("[data-hook=\"".concat(_constants.DATA_HOOKS.loader, "\"]")).count()) > 0;
      });
      function isLoading() {
        return _isLoading.apply(this, arguments);
      }
      return isLoading;
    }(),
    /**
     * Gets children list elements
     * @return {UniDriverList}
     */
    getChildren: () => base.$$("[data-hook=\"".concat(_constants.DATA_HOOKS.child, "\"]")).map(child => child),
    /**
     * Get a list of the carousel images
     * @return {Promise<Array<string | null>>}
     */
    getImages: () => base.$$("[data-hook=\"".concat(_constants.DATA_HOOKS.carouselImage, "\"]")).map(img => img.attr('src')),
    /**
     * Click on the previous item button
     * @return {Promise<void>}
     */
    clickPrevious: () => base.$("[data-hook=\"".concat(_constants.DATA_HOOKS.prevButton, "\"]")).click(),
    /**
     * Click on the next item button
     * @return {Promise<void>}
     */
    clickNext: () => base.$("[data-hook=\"".concat(_constants.DATA_HOOKS.nextButton, "\"]")).click()
  });
};
exports.carouselWIPUniDriverFactory = carouselWIPUniDriverFactory;
//# sourceMappingURL=CarouselWIP.uni.driver.js.map