"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.checkToggleDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _TooltipUni = require("../Tooltip/Tooltip.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var checkToggleDriverFactory = (base, body) => {
  var getTooltipDriver = () => (0, _TooltipUni.tooltipDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.tooltip), body);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    // Checks whether CheckToggle is checked
    isChecked: () => (0, _unidriver.findByHook)(base, _constants.dataHooks.toggle)._prop('checked'),
    // Clicks on the element
    click: function () {
      var _click = (0, _asyncToGenerator2.default)(function* () {
        var input = yield (0, _unidriver.findByHook)(base, _constants.dataHooks.toggle);

        // eslint-disable-next-line no-restricted-properties
        var isDisabled = yield input._prop('disabled');

        // In order to simulate a real user event, we need to check if the input is disabled before clicking.
        if (!isDisabled) yield input.click();
      });
      function click() {
        return _click.apply(this, arguments);
      }
      return click;
    }(),
    //  Gets the tooltip content, throws an error if content is not provided.
    getTooltipContent: function () {
      var _getTooltipContent = (0, _asyncToGenerator2.default)(function* () {
        var tooltipDriver = getTooltipDriver();
        if (yield tooltipDriver.exists()) {
          yield tooltipDriver.mouseEnter();
          var text = yield tooltipDriver.getTooltipText();
          if (typeof text === 'string') {
            return text;
          }
        }
        throw new Error("Message was not provided");
      });
      function getTooltipContent() {
        return _getTooltipContent.apply(this, arguments);
      }
      return getTooltipContent;
    }()
  });
};
exports.checkToggleDriverFactory = checkToggleDriverFactory;
//# sourceMappingURL=CheckToggle.uni.driver.js.map