"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _Tooltip = require("../Tooltip/Tooltip.driver");
var _Text = _interopRequireDefault(require("../Text/Text.driver"));
var _constants = require("./constants");
var DATA_ATTR = _interopRequireWildcard(require("./DataAttr"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var checkboxDriverFactory = _ref => {
  var {
    element,
    eventTrigger
  } = _ref;
  var byHook = hook => element.querySelector("[data-hook*=\"".concat(hook, "\"]"));
  var input = () => element.querySelector('input');
  var checkbox = () => element.querySelector(_constants.dataHooks.box);
  var isChecked = () => input().checked;
  var labelText = () => element.querySelector("[data-hook=\"".concat(_constants.dataHooks.children, "\"]"));
  var labelTextDriver = () => (0, _Text.default)({
    element: labelText()
  });
  var getTooltipDriver = () => (0, _Tooltip.tooltipLegacyDriverFactory)({
    element: byHook(_constants.dataHooks.boxTooltip),
    eventTrigger
  });
  return {
    exists: () => !!element,
    click: () => eventTrigger.change(input(), {
      target: {
        checked: !isChecked()
      }
    }),
    /** Trigger focus on the element */
    focus: () => eventTrigger.focus(checkbox()),
    /** Checks whether the checkbox is focused */
    isFocused: () => element === document.activeElement,
    /** trigger blur on the element */
    blur: () => eventTrigger.blur(checkbox()),
    isChecked,
    isDisabled: () => element.getAttribute(DATA_ATTR.DATA_DISABLED) === 'true',
    isIndeterminate: () => element.getAttribute(DATA_ATTR.DATA_CHECK_TYPE) === DATA_ATTR.CHECK_TYPES.INDETERMINATE,
    isTooltipEnabled: () => !!getTooltipDriver().getTooltipText(),
    hasError: () => element.getAttribute(DATA_ATTR.DATA_HAS_ERROR) === 'true',
    getTooltipContent: () => getTooltipDriver().getTooltipText(),
    getLabel: () => labelTextDriver().getText(),
    getLabelSize: () => labelTextDriver().getSize()
  };
};
var _default = exports.default = checkboxDriverFactory;
//# sourceMappingURL=Checkbox.driver.js.map