"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.circularProgressBarDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _TooltipUni = require("../Tooltip/Tooltip.uni.driver");
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _CircularProgressBarCoreUni = require("./CircularProgressBarCore/CircularProgressBarCore.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var circularProgressBarDriverFactory = (base, body) => {
  var tooltip = base.$("[data-hook=\"".concat(_constants.dataHooks.tooltip, "\"]"));
  var createTooltipDriver = () => (0, _TooltipUni.tooltipDriverFactory)(tooltip, body);
  var coreProgressBarDriver = (0, _CircularProgressBarCoreUni.circularProgressBarCoreUniDriverFactory)(base);
  var errorIcon = base => base.$("[data-hook=".concat(_constants.dataHooks.errorIcon, "]"));
  var successIcon = base => base.$("[data-hook=".concat(_constants.dataHooks.successIcon, "]"));
  var progressBar = base => base.$("[data-hook=".concat(_constants.dataHooks.circularProgressBar, "]"));
  var getTooltip = () => createTooltipDriver();
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether the success icon is displayed
     * @returns {Promise<boolean>}
     * */
    isSuccessIconDisplayed: coreProgressBarDriver.isSuccessIconDisplayed,
    /**
     * Checks whether the error icon is displayed
     * @returns {Promise<boolean>}
     * */
    isErrorIconDisplayed: coreProgressBarDriver.isErrorIconDisplayed,
    /**
     * Checks whether the label text is displayed
     * @returns {Promise<boolean>}
     * */
    isLabelDisplayed: coreProgressBarDriver.isLabelDisplayed,
    /**
     * Gets the text content displayed
     * @returns {Promise<string>}
     */
    getLabelTextContent: coreProgressBarDriver.getLabelTextContent,
    /**
     * Checks whether the progress percentages are displayed
     * @returns {Promise<boolean>}
     */
    isPercentagesProgressDisplayed: coreProgressBarDriver.isPercentagesProgressDisplayed,
    /**
     * Gets the progress percentages value
     * @returns {Promise<string>}
     */
    getValue: coreProgressBarDriver.getValue,
    /**
     * Checks whether the progress completed (value is 100)
     * @returns {Promise<boolean>}
     */
    isCompleted: coreProgressBarDriver.isCompleted,
    /**
     * Checks whether an error occurred
     * @returns {Promise<boolean>}
     */
    hasError: coreProgressBarDriver.hasError,
    /**
     * Checks whether error icon is shown
     * @returns {Promise<boolean>}
     * */
    isErrorIconShown: () => errorIcon(base).exists(),
    /**
     * Checks whether success icon is shown
     * @returns {Promise<boolean>}
     * */
    isSuccessIconShown: () => successIcon(base).exists(),
    /**
     * Gets size.
     * @returns {Promise<string>}
     * */
    getSize: () => progressBar(base).attr('data-size'),
    /**
     * Gets the tooltip error message
     * @returns {Promise<string>}
     * */
    getTooltipErrorMessage: () => getTooltip().getTooltipText(),
    /**
     * Checks whether progress bar has a given skin
     * @param {string} skinName The progress bar skin
     * @return {Promise<boolean>}
     */
    hasSkin: function () {
      var _hasSkin = (0, _asyncToGenerator2.default)(function* (skinName) {
        return (yield progressBar(base).attr("data-skin")) === skinName;
      });
      function hasSkin(_x) {
        return _hasSkin.apply(this, arguments);
      }
      return hasSkin;
    }()
  });
};
exports.circularProgressBarDriverFactory = circularProgressBarDriverFactory;
//# sourceMappingURL=CircularProgressBar.uni.driver.js.map