import { BaseUniDriver } from '@wix/wix-ui-test-utils/base-driver';
import { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
export interface CircularProgressBarCoreUniDriver extends BaseUniDriver {
    /** Returns boolean that indicates if the success icon exists */
    isSuccessIconDisplayed(): Promise<boolean>;
    /** Returns boolean that indicates if the error icon exists */
    isErrorIconDisplayed(): Promise<boolean>;
    /** Returns boolean that indicates if the progress percentages text exists */
    isPercentagesProgressDisplayed(): Promise<boolean>;
    /** Returns boolean that indicates if the label text exists */
    isLabelDisplayed(): Promise<boolean>;
    /** Get the text content displayed */
    getLabelTextContent(): Promise<string>;
    /** Get the progress percentages value */
    getValue(): Promise<string | null>;
    /** Returns true if has progress completed (value is 100) */
    isCompleted(): Promise<boolean>;
    /** Returns true if has error */
    hasError(): Promise<boolean>;
    getAttribute(name: string): Promise<string | null>;
    /** Returns true if single element with given data-hook rendered*/
    isSingleElementRendered(dataHook: string): Promise<boolean>;
}
export declare const circularProgressBarCoreUniDriverFactory: (base: UniDriver) => CircularProgressBarCoreUniDriver;
//# sourceMappingURL=CircularProgressBarCore.uni.driver.d.ts.map