"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.getElementHeight = exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Toggle = _interopRequireDefault(require("../Transition/Toggle"));
var _constants = require("../Transition/constants");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Collapse/Collapse.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
// Returns the height of element including vertical margin
var getElementHeight = wrapper => element => {
  var offsetTop = wrapper ? element.getBoundingClientRect().y - wrapper.getBoundingClientRect().y : 0;
  var marginBottom = parseInt(window.getComputedStyle(element).getPropertyValue('margin-bottom') || 0, 10);
  return element.scrollHeight + offsetTop + marginBottom;
};

/** `<Collapse/>` component is used for hideable content.
 *
 * Easily create accordions or within `<Card/>` to collapse its `<Card.Content/>`.
 */
exports.getElementHeight = getElementHeight;
var Collapse = _ref => {
  var {
    children,
    open = true,
    dataHook,
    mountOnEnter = true,
    unmountOnExit = true,
    onExpandAnimationEnd,
    onCollapseAnimationEnd
  } = _ref;
  var wrapperRef = (0, _react.useRef)();
  return /*#__PURE__*/_react.default.createElement("div", {
    "data-hook": dataHook,
    "data-open": open,
    ref: wrapperRef,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 34,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(_Toggle.default, {
    timeout: _constants.timingMap['medium01'],
    show: open,
    unmountOnExit: unmountOnExit,
    mountOnEnter: mountOnEnter,
    onStart: onExpandAnimationEnd,
    onEnd: onCollapseAnimationEnd,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 35,
      columnNumber: 7
    }
  }, children));
};
Collapse.displayName = 'Collapse';
Collapse.propTypes = {
  /**
   * any node to be rendered inside
   */
  children: _propTypes.default.node,
  /**
   * determinants whether the element is collapsed.
   */
  open: _propTypes.default.bool,
  /**
   * string based data hook for testing
   */
  dataHook: _propTypes.default.string,
  /**
   * lazy-mounting of component. If false, will be mounted immediately. It true, will be mounted with first enter.
   */
  mountOnEnter: _propTypes.default.bool,
  /**
   * unmount component after it finishes exiting. If false, will stay mounted after exit.
   */
  unmountOnExit: _propTypes.default.bool,
  /**
   * callback for expand animation end
   */
  onExpandAnimationEnd: _propTypes.default.func,
  /**
   * callback for collapse animation end
   */
  onCollapseAnimationEnd: _propTypes.default.func
};
var _default = exports.default = Collapse;
//# sourceMappingURL=Collapse.js.map