"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = exports.colorPickerUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _TabsUni = require("../Tabs/Tabs.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var colorPickerUniDriverFactory = base => {
  var getConverterDriver = () => (0, _TabsUni.tabsUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.DataHooks.converter, "\"]")));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Clicks the confirm button
     * @returns {Promise<Void>}
     * */
    confirm: function () {
      var _confirm = (0, _asyncToGenerator2.default)(function* () {
        return base.$("[data-hook=\"".concat(_constants.DataHooks.confirmButton, "\"]")).click();
      });
      function confirm() {
        return _confirm.apply(this, arguments);
      }
      return confirm;
    }(),
    /**
     * Clicks the cancel button
     * @returns {Promise<Void>}
     * */
    cancel: function () {
      var _cancel = (0, _asyncToGenerator2.default)(function* () {
        return base.$("[data-hook=\"".concat(_constants.DataHooks.cancelButton, "\"]")).click();
      });
      function cancel() {
        return _cancel.apply(this, arguments);
      }
      return cancel;
    }(),
    /**
     * Clicks the previous color selection
     * @returns {Promise<Void>}
     */
    clickOnPreviousColor: function () {
      var _clickOnPreviousColor = (0, _asyncToGenerator2.default)(function* () {
        return base.$("[data-hook=\"".concat(_constants.DataHooks.historyPrevious, "\"]")).click();
      });
      function clickOnPreviousColor() {
        return _clickOnPreviousColor.apply(this, arguments);
      }
      return clickOnPreviousColor;
    }(),
    /**
     * Checks whether the history panel exists
     * @returns {Promise<boolean>}
     */
    historyPanelExists: function () {
      var _historyPanelExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$("[data-hook=\"".concat(_constants.DataHooks.history, "\"]")).exists();
      });
      function historyPanelExists() {
        return _historyPanelExists.apply(this, arguments);
      }
      return historyPanelExists;
    }(),
    /**
     * Gets the current selected color
     * @returns {Promise<string>}
     */
    historyCurrentColor: function () {
      var _historyCurrentColor = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.$("[data-hook=\"".concat(_constants.DataHooks.historyCurrent, "\"]"))._prop('style')).background;
      });
      function historyCurrentColor() {
        return _historyCurrentColor.apply(this, arguments);
      }
      return historyCurrentColor;
    }(),
    /**
     * Gets the previous color selected
     * @returns {Promise<string>}
     */
    historyPreviousColor: function () {
      var _historyPreviousColor = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.$("[data-hook=\"".concat(_constants.DataHooks.historyPrevious, "\"]"))._prop('style')).background;
      });
      function historyPreviousColor() {
        return _historyPreviousColor.apply(this, arguments);
      }
      return historyPreviousColor;
    }(),
    /**
     * Clicks the add new color button
     * @returns {Promise<Void>}
     */
    clickAddColor: function () {
      var _clickAddColor = (0, _asyncToGenerator2.default)(function* () {
        return base.$("[data-hook=".concat(_constants.DataHooks.addColor, "]")).click();
      });
      function clickAddColor() {
        return _clickAddColor.apply(this, arguments);
      }
      return clickAddColor;
    }(),
    /**
     * Clicks on RGB tab
     * @returns {Promise<Void>}
     */
    selectRgbTab: function () {
      var _selectRgbTab = (0, _asyncToGenerator2.default)(function* () {
        return getConverterDriver().clickTabAt(1);
      });
      function selectRgbTab() {
        return _selectRgbTab.apply(this, arguments);
      }
      return selectRgbTab;
    }(),
    /**
     * Clicks on HSB tab
     * @returns {Promise<Void>}
     */
    selectHsbTab: function () {
      var _selectHsbTab = (0, _asyncToGenerator2.default)(function* () {
        return getConverterDriver().clickTabAt(2);
      });
      function selectHsbTab() {
        return _selectHsbTab.apply(this, arguments);
      }
      return selectHsbTab;
    }()
  });
};
exports.colorPickerUniDriverFactory = colorPickerUniDriverFactory;
var _default = exports.default = colorPickerUniDriverFactory;
//# sourceMappingURL=ColorPicker.uni.driver.js.map