import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { CounterBadgeProps, CounterBadgeSize } from './CounterBadge.types';
type DefaultProps = Required<Pick<CounterBadgeProps, 'skin' | 'size' | 'truncate' | 'showShadow'>>;
type Props = CounterBadgeProps & DefaultProps;
/** CounterBadge */
declare class CounterBadge extends PureComponent<Props> {
    static displayName: string;
    static contextType: React.Context<{}>;
    static propTypes: {
        dataHook: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        locale: PropTypes.Requireable<"th" | "tr" | "ms" | "id" | "no" | "en" | "en-US" | "en-GB" | "en-AU" | "en-CA" | "ar" | "bg" | "ca" | "zh" | "zh-TW" | "zh-HK" | "zh-MO" | "cs" | "da" | "nl" | "fi" | "fr" | "fr-CA" | "fr-CH" | "fr-BE" | "de" | "de-CH" | "de-AT" | "el" | "he" | "hi" | "hu" | "it" | "ja" | "ko" | "lt" | "nb" | "nn" | "pl" | "pt-BR" | "pt" | "ro" | "ru" | "sk" | "sl" | "es" | "es-419" | "es-AR" | "es-MX" | "es-US" | "sv" | "tl" | "uk" | "vi">;
        skin: PropTypes.Requireable<string>;
        size: PropTypes.Requireable<string>;
        showShadow: PropTypes.Requireable<boolean>;
        truncate: PropTypes.Requireable<boolean>;
    };
    static defaultProps: DefaultProps;
    _renderNumberContent: (n: number, truncate: boolean) => string | React.JSX.Element;
    _renderCounterBadgeContent: (size: CounterBadgeSize, content: React.ReactNode) => React.JSX.Element;
    _getLocale(): any;
    render(): React.JSX.Element;
}
export default CounterBadge;
//# sourceMappingURL=CounterBadge.d.ts.map