"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _CustomModalLayoutSt = require("./CustomModalLayout.st.css");
var _BaseModalLayout = _interopRequireDefault(require("../BaseModalLayout"));
var _Button = _interopRequireDefault(require("../Button"));
var _TooltipCommon = require("../common/PropTypes/TooltipCommon");
var _context = require("../WixStyleReactProvider/context");
var _excluded = ["theme", "actionsSize", "removeContentPadding", "showHeaderDivider", "showFooterDivider", "overflowY", "style"],
  _excluded2 = ["children", "width", "height", "maxHeight", "className"],
  _excluded3 = ["dataHook"],
  _excluded4 = ["dataHook"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/CustomModalLayout/CustomModalLayout.js";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/** CustomModalLayout */
var CustomModalLayout = _ref => {
  var {
      // default props
      theme = 'standard',
      actionsSize = 'small',
      removeContentPadding = false,
      showHeaderDivider = 'auto',
      showFooterDivider = 'auto',
      overflowY = 'auto',
      style = {}
    } = _ref,
    propsWithNoDefaults = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var _theme$actionsSize$pr = _objectSpread({
      // default props
      theme,
      actionsSize
    }, propsWithNoDefaults),
    {
      children,
      width,
      height,
      maxHeight,
      className
    } = _theme$actionsSize$pr,
    restProps = (0, _objectWithoutProperties2.default)(_theme$actionsSize$pr, _excluded2);
  return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 28,
      columnNumber: 5
    }
  }, _ref2 => {
    var {
      newColorsBranding
    } = _ref2;
    return /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default, (0, _extends2.default)({}, restProps, {
      className: (0, _CustomModalLayoutSt.st)(_CustomModalLayoutSt.classes.root, {
        removeContentPadding,
        showHeaderDivider: showHeaderDivider === true,
        showFooterDivider: showFooterDivider === true,
        newColorsBranding
      }, className),
      style: _objectSpread(_objectSpread({}, style), {}, {
        width: width !== undefined ? width : style.width,
        height: height !== undefined ? height : style.height,
        maxHeight: maxHeight !== undefined ? maxHeight : style.maxHeight
      }),
      "data-contentpadding": !removeContentPadding,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 30,
        columnNumber: 9
      }
    }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Header, {
      showHeaderDivider: showHeaderDivider === true,
      titleSize: "medium",
      titleTag: "h2",
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 11
      }
    }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Content, {
      overflowY: overflowY,
      hideTopScrollDivider: showHeaderDivider !== 'auto',
      hideBottomScrollDivider: showFooterDivider !== 'auto',
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 55,
        columnNumber: 11
      }
    }, children), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Footer, {
      showFooterDivider: showFooterDivider === true,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 62,
        columnNumber: 11
      }
    }), /*#__PURE__*/_react.default.createElement(_BaseModalLayout.default.Footnote, {
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 65,
        columnNumber: 11
      }
    }));
  });
};
CustomModalLayout.Title = _BaseModalLayout.default.Header.Title;
CustomModalLayout.displayName = 'CustomModalLayout';
CustomModalLayout.propTypes = {
  /** ...BaseModalLayout.propTypes, */
  /** Applies a CSS class to the component’s root element */
  className: _propTypes.default.string,
  /** Applies a data-hook HTML attribute to be used in the tests */
  dataHook: _propTypes.default.string,
  /** Defines a call-back function after user clicks on the close button */
  onCloseButtonClick: _propTypes.default.func,
  /** Defines a call-back function after user clicks on the help button */
  onHelpButtonClick: _propTypes.default.func,
  /** Sets the appearance of modal (i.e., changes the skin of primary and secondary action buttons) */
  theme: _propTypes.default.oneOf(['standard', 'premium', 'destructive']),
  /** ...Header.propTypes, */
  /** Sets text title for the modal; can be used in conjunction with other components */
  title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  /** Sets text subtitle for the modal; can be used in conjunction with other components */
  subtitle: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  /** ...Content.propTypes, */
  /** Contains all modal’s content in its middle area. `<CustomModalLayout/>` children are passed as `content`, too.*/
  content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  /** ...Footer.propTypes, */
  /** Sets the size of action buttons */
  actionsSize: _Button.default.propTypes.size,
  /** Sets text label or other content (e.g., <Loader/>) for the primary button */
  primaryButtonText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  /** Defines a call-back function after user clicks on the primary button */
  primaryButtonOnClick: _propTypes.default.func,
  /** Passes on any `<Button/>` properties on the primary button */
  primaryButtonProps: (() => {
    var _Button$propTypes = _Button.default.propTypes,
      {
        dataHook
      } = _Button$propTypes,
      buttonProps = (0, _objectWithoutProperties2.default)(_Button$propTypes, _excluded3);
    return _propTypes.default.shape(buttonProps);
  })(),
  /** Passes on any `<Tooltip/>` properties on the primary button tooltip */
  primaryButtonTooltipProps: _propTypes.default.shape(_objectSpread({
    content: _propTypes.default.string
  }, _TooltipCommon.TooltipCommonProps)),
  /** Sets text label for the secondary button */
  secondaryButtonText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  /** Defines a call-back function after user clicks on the secondary button */
  secondaryButtonOnClick: _propTypes.default.func,
  /** Passes on any `<Button/>` properties on the secondary button */
  secondaryButtonProps: (() => {
    var _Button$propTypes2 = _Button.default.propTypes,
      {
        dataHook
      } = _Button$propTypes2,
      buttonProps = (0, _objectWithoutProperties2.default)(_Button$propTypes2, _excluded4);
    return _propTypes.default.shape(buttonProps);
  })(),
  /** Contains a checkbox or other components at the start of the footer */
  sideActions: _propTypes.default.node,
  /** ...Footnote.propTypes, */
  /** Renders supplementary text or other components at the bottom of the modal */
  footnote: _propTypes.default.node,
  /** CustomModalLayout */
  /** Removes 30 px left and right padding from the content area */
  removeContentPadding: _propTypes.default.bool,
  /** Fixes the width of component; if content area is wider than `width`, it scrolls horizontally */
  width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  /** Fixes the height of component */
  height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  /** Sets the maximum height of component; if content area is longer than maxHeight, it scrolls vertically */
  maxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  /** Controls visibility of a header divider. When set to `auto`, it is shown only when scroll position is greater than 0. When set to `true`, it is always visible, and when set to `false`, it is always hidden. */
  showHeaderDivider: _propTypes.default.oneOf(['auto', true, false]),
  /** Controls visibility of a footer divider. When set to `auto`, it is shown up until content is scrolled to the very bottom. When set to `true`, it is always visible, and when set to `false`, it is always hidden.*/
  showFooterDivider: _propTypes.default.oneOf(['auto', true, false]),
  /** Determines what happens when content overflows component vertically */
  overflowY: _propTypes.default.string
};
var _default = exports.default = CustomModalLayout;
//# sourceMappingURL=CustomModalLayout.js.map