"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _Input = _interopRequireDefault(require("../Input/Input.driver"));
var _Calendar = _interopRequireDefault(require("../Calendar/Calendar.driver"));
var _Popover = require("../Popover/Popover.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var datePickerDriverFactory = _ref => {
  var {
    element,
    eventTrigger
  } = _ref;
  var popoverElement = element.querySelector("[data-hook=".concat(_constants.dataHooks.datePickerPopover, "]"));
  var popoverContent = () => (0, _Popover.popoverLegacyDriverFactory)({
    element: popoverElement
  }).getContentElement();
  var calendarTestkit = () => (0, _Calendar.default)({
    element: popoverContent()
  });
  var calendarDriver = _objectSpread({}, Object.keys((0, _Calendar.default)({
    element
  })).reduce((prev, current) => _objectSpread(_objectSpread({}, prev), {}, {
    [current]: args => {
      if (current === 'isVisible') {
        return (0, _Popover.popoverLegacyDriverFactory)({
          element: popoverElement
        }).isContentElementExists();
      }
      if (current === 'mouseClickOutside') {
        return (0, _Popover.popoverLegacyDriverFactory)({
          element: popoverElement
        }).clickOutside();
      }
      return calendarTestkit()[current](args);
    }
  }), {}));
  var popoverDriver = (0, _Popover.popoverLegacyDriverFactory)({
    element: popoverElement
  });

  // here we have a dirty hack for getting input element directly
  // this is not the best wayt to do it, but knowing that we exposed
  // input datahook - we cannot change this for now.
  var inputElement = (0, _Popover.popoverLegacyDriverFactory)({
    element: popoverElement
  }).getTargetElement().querySelector('[data-size]');
  var inputDriver = (0, _Input.default)({
    element: inputElement,
    eventTrigger
  });
  var driver = {
    exists: () => !!element,
    open: () => {
      inputDriver.click();
      inputDriver.trigger('keyDown', {
        key: 'ArrowUp',
        keyCode: 38
      });
    },
    getWidth: () => element.style.width,
    clickOutside: () => popoverDriver.clickOutside()
  };
  return {
    exists: driver.exists,
    driver,
    inputDriver,
    calendarDriver
  };
};
var _default = exports.default = datePickerDriverFactory;
//# sourceMappingURL=DatePicker.driver.js.map