"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.datePickerUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _CalendarUniDriver = require("../Calendar/Calendar.uni.driver.js");
var _InputUniDriver = require("../Input/Input.uni.driver.js");
var _PopoverUni = require("../Popover/Popover.uni.driver");
var _constants = require("./constants");
var datePickerUniDriverFactory = (base, body) => {
  var calendarDriver = (0, _CalendarUniDriver.calendarUniDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.datePickerCalendar), body);
  var inputDriver = (0, _InputUniDriver.testkit)((0, _unidriver.findByHook)(base, _constants.dataHooks.datePickerInput), body);
  var popoverDriver = (0, _PopoverUni.popoverUniDriverFactory)((0, _unidriver.findByHook)(base, _constants.dataHooks.datePickerPopover), body);
  var driver = {
    exists: () => (0, _unidriver.baseUniDriverFactory)(base).exists(),
    open: function () {
      var _open = (0, _asyncToGenerator2.default)(function* () {
        yield inputDriver.click();
        yield inputDriver.trigger('keyDown', {
          key: 'ArrowUp',
          keyCode: 38
        });
      });
      function open() {
        return _open.apply(this, arguments);
      }
      return open;
    }(),
    getWidth: () => base._prop('style').then(style => style.width),
    clickOutside: () => popoverDriver.clickOutside(),
    focusCalendar: () => inputDriver.trigger('keyDown', {
      key: 'ArrowUp',
      keyCode: 38
    })
  };
  // TODO: needs to be fixed, autodocs doesn't generate the docs below.
  return {
    /**
     * Input Unidriver methods
     */
    inputDriver,
    /**
     * Calender Unidriver methods
     */
    calendarDriver,
    /**
     * Checks whether the component found with the given data hook.
     * @returns {Promise<boolean>}
     */
    exists: driver.exists,
    /**
     * Contains 'exists', 'open' and 'getWidth' methods
     */
    driver
  };
};
exports.datePickerUniDriverFactory = datePickerUniDriverFactory;
//# sourceMappingURL=DatePicker.uni.driver.js.map