"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.DragHandle = DragHandle;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _DragHandleSt = require("./DragHandle.st.css");
var _react = _interopRequireDefault(require("react"));
var _system = require("@wix/wix-ui-icons-common/system");
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _excluded = ["dataHook", "domRef", "dragging", "disabled", "aria-label", "aria-describedby", "tooltipContent", "tooltipProps", "dragHandleSize"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/DragHandle/DragHandle.tsx";
function DragHandle(props) {
  var {
      dataHook,
      domRef,
      dragging,
      disabled,
      'aria-label': ariaLabel,
      'aria-describedby': ariaDescribedBy,
      tooltipContent,
      tooltipProps,
      dragHandleSize
    } = props,
    rest = (0, _objectWithoutProperties2.default)(props, _excluded);
  var dragHandleIcon = dragHandleSize === 'small' ? /*#__PURE__*/_react.default.createElement(_system.DragAndDropSmall, {
    "data-hook": "dnd",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 46,
      columnNumber: 7
    }
  }) : /*#__PURE__*/_react.default.createElement(_system.DragAndDropLarge, {
    "data-hook": "dnd",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 48,
      columnNumber: 7
    }
  });
  return /*#__PURE__*/_react.default.createElement(_Tooltip.default, (0, _extends2.default)({
    dataHook: dataHook,
    disabled: !tooltipContent,
    content: tooltipContent,
    appendTo: "window"
  }, tooltipProps, {
    "aria-describedby": tooltipContent ? undefined : ariaDescribedBy,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    "data-hook": "drag-handle-button",
    "data-disabled": !!disabled,
    "aria-label": tooltipContent || ariaLabel,
    "aria-describedby": ariaDescribedBy,
    ref: domRef
  }, rest, {
    role: "button",
    className: (0, _DragHandleSt.st)(_DragHandleSt.classes.root, {
      disabled,
      dragging
    }),
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 60,
      columnNumber: 7
    }
  }), dragHandleIcon));
}
//# sourceMappingURL=DragHandle.js.map