"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.dropdownBasePrivateDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _DropdownBaseUni = require("./DropdownBase.uni.driver");
var _DropdownLayoutUni = require("../DropdownLayout/DropdownLayout.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var dropdownBasePrivateDriverFactory = (base, body) => {
  var byDataHook = dataHook => base.$("[data-hook=\"".concat(dataHook, "\"]"));
  var _getTargetElement = () => byDataHook('popover-element');
  var getContentElement = () => byDataHook('popover-content');
  var createDropdownLayoutDriver = () => (0, _DropdownLayoutUni.dropdownLayoutDriverFactory)(base);
  return _objectSpread(_objectSpread({}, (0, _DropdownBaseUni.dropdownBaseDriverFactory)(base, body)), {}, {
    /** Returns the native target element */
    getTargetElement: () => _getTargetElement().getNative(),
    /** Returns the native DropdownLayout element */
    getDropdownElement: () => getContentElement().getNative(),
    /** Return `true` if the option is hovered by the mouse */
    isOptionHovered: function () {
      var _isOptionHovered = (0, _asyncToGenerator2.default)(function* (index) {
        return createDropdownLayoutDriver().isOptionHovered(index);
      });
      function isOptionHovered(_x) {
        return _isOptionHovered.apply(this, arguments);
      }
      return isOptionHovered;
    }(),
    /** Return `true` if the option is selected */
    isOptionSelected: function () {
      var _isOptionSelected = (0, _asyncToGenerator2.default)(function* (index) {
        return createDropdownLayoutDriver().isOptionSelected(index);
      });
      function isOptionSelected(_x2) {
        return _isOptionSelected.apply(this, arguments);
      }
      return isOptionSelected;
    }(),
    /** Trigger a keyDown event on the target element */
    keyDown: function () {
      var _keyDown = (0, _asyncToGenerator2.default)(function* (key) {
        return (yield _getTargetElement()).pressKey(key);
      });
      function keyDown(_x3) {
        return _keyDown.apply(this, arguments);
      }
      return keyDown;
    }(),
    /** Perform a mouseLeave on the target element */
    mouseLeaveTarget: function () {
      var _mouseLeaveTarget = (0, _asyncToGenerator2.default)(function* () {
        return (yield _getTargetElement()).mouse.leave();
      });
      function mouseLeaveTarget() {
        return _mouseLeaveTarget.apply(this, arguments);
      }
      return mouseLeaveTarget;
    }(),
    getDropdownLayoutDriver: createDropdownLayoutDriver,
    keyDownListItem: function () {
      var _keyDownListItem = (0, _asyncToGenerator2.default)(function* (position, key) {
        return createDropdownLayoutDriver().keyDownListItem(position, key);
      });
      function keyDownListItem(_x4, _x5) {
        return _keyDownListItem.apply(this, arguments);
      }
      return keyDownListItem;
    }(),
    isListItemFocused: function () {
      var _isListItemFocused = (0, _asyncToGenerator2.default)(function* (position) {
        return createDropdownLayoutDriver().isListItemFocused(position);
      });
      function isListItemFocused(_x6) {
        return _isListItemFocused.apply(this, arguments);
      }
      return isListItemFocused;
    }()
  });
};
exports.dropdownBasePrivateDriverFactory = dropdownBasePrivateDriverFactory;
//# sourceMappingURL=DropdownBase.private.uni.driver.js.map