"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _wixUiIconsCommon = require("@wix/wix-ui-icons-common");
var _Input = _interopRequireDefault(require("../../Input"));
var _Tooltip = _interopRequireDefault(require("../../Tooltip"));
var _IconButton = _interopRequireDefault(require("../../IconButton"));
var _EditableSelectorSt = require("../EditableSelector.st.css");
var _constants = require("./constants");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/EditableSelector/EditableRow/EditableRow.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class EditableRow extends _react.Component {
  constructor(props) {
    super(props);
    this.onApprove = () => {
      this.props.onApprove && this.props.onApprove(this.state.newOption);
    };
    this.onCancel = () => {
      this.props.onCancel && this.props.onCancel();
    };
    this.state = {
      newOption: props.newOption || ''
    };
  }
  componentDidMount() {
    this.input.focus();
  }
  render() {
    var {
      dataHook
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      "data-hook": dataHook,
      className: _EditableSelectorSt.classes.editableRowContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 40,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: _EditableSelectorSt.classes.editableRowInputWrap,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react.default.createElement(_Input.default, {
      ref: input => this.input = input,
      className: _EditableSelectorSt.classes.editableRowInput,
      dataHook: _constants.dataHooks.editRowInput,
      value: this.state.newOption,
      onChange: event => this.setState({
        newOption: event.target.value
      }),
      onEnterPressed: () => this.onApprove(),
      onEscapePressed: () => this.onCancel(),
      size: "medium",
      textOverflow: "clip",
      theme: "normal",
      width: "initial",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 42,
        columnNumber: 11
      }
    })), /*#__PURE__*/_react.default.createElement("div", {
      className: _EditableSelectorSt.classes.editableRowButtons,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 57,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
      content: "Cancel",
      timeout: 0,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 58,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
      onClick: this.onCancel,
      size: "medium",
      priority: "secondary",
      dataHook: _constants.dataHooks.editRowCancelButton,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 59,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react.default.createElement(_wixUiIconsCommon.X, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 65,
        columnNumber: 15
      }
    }))), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
      content: "Confirm",
      timeout: 0,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 69,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
      onClick: this.onApprove,
      size: "medium",
      disabled: this.state.newOption.length === 0,
      dataHook: _constants.dataHooks.editRowApproveButton,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 70,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react.default.createElement(_wixUiIconsCommon.Check, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 76,
        columnNumber: 15
      }
    })))));
  }
}
EditableRow.propTypes = {
  newOption: _propTypes.default.string,
  onApprove: _propTypes.default.func,
  onCancel: _propTypes.default.func
};
var _default = exports.default = EditableRow;
//# sourceMappingURL=EditableRow.js.map