"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.editableRowUniDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _InputUni = require("../../Input/Input.uni.driver");
var _IconButtonUni = require("../../IconButton/IconButton.uni.driver");
var _unidriver = require("../../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var editableRowUniDriverFactory = base => {
  var input = (0, _unidriver.findByHook)(base, _constants.dataHooks.editRowInput);
  var approveBtn = (0, _unidriver.findByHook)(base, _constants.dataHooks.editRowApproveButton);
  var cancelBtn = (0, _unidriver.findByHook)(base, _constants.dataHooks.editRowCancelButton);
  var inputDriver = (0, _InputUni.testkit)(input);
  var approveBtnDriver = (0, _IconButtonUni.iconButtonDriverFactory)(approveBtn);
  var cancelBtnDriver = (0, _IconButtonUni.iconButtonDriverFactory)(cancelBtn);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    isInputFocused: () => inputDriver.isFocus(),
    clickApprove: () => approveBtnDriver.click(),
    isApproveDisabled: () => approveBtnDriver.isButtonDisabled(),
    clickCancel: () => cancelBtnDriver.click(),
    getText: () => inputDriver.getValue(),
    setText: text => inputDriver.enterText(text),
    keyDown: keyCode => inputDriver.trigger('keyDown', {
      keyCode
    })
  });
};
exports.editableRowUniDriverFactory = editableRowUniDriverFactory;
//# sourceMappingURL=EditableRow.uni.driver.js.map