"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.emptyStateUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var emptyStateUniDriverFactory = base => {
  var byDataHook = dataHook => base.$("[data-hook=\"".concat(dataHook, "\"]"));
  var getTitleContainer = () => byDataHook('empty-state-title-container');
  var getSubtitleContainer = () => byDataHook('empty-state-subtitle-container');
  var getImageContainer = () => byDataHook('empty-state-image-container');
  var getChildrenContainer = () => byDataHook('empty-state-children-container');
  var getTitle = () => getTitleContainer().$(':first-child');
  var getSubtitle = () => getSubtitleContainer().$(':first-child');
  var getImageElement = () => getImageContainer().$('[data-hook="image-element"]');
  var getImageNode = () => getImageContainer().$('[data-hook="image-node"]');
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** Returns the element */
    element: () => base.getNative(),
    // eslint-disable-line no-restricted-properties

    /** Returns the text of the title */
    getTitleText: function () {
      var _getTitleText = (0, _asyncToGenerator2.default)(function* () {
        return getTitle().text();
      });
      function getTitleText() {
        return _getTitleText.apply(this, arguments);
      }
      return getTitleText;
    }(),
    /** Returns the text of the subtitle */
    getSubtitleText: function () {
      var _getSubtitleText = (0, _asyncToGenerator2.default)(function* () {
        return getSubtitle().text();
      });
      function getSubtitleText() {
        return _getSubtitleText.apply(this, arguments);
      }
      return getSubtitleText;
    }(),
    /** Returns true if the component was configured with given theme */
    hasTheme: function () {
      var _hasTheme = (0, _asyncToGenerator2.default)(function* (themeName) {
        return (yield base.attr('data-theme')) === themeName;
      });
      function hasTheme(_x) {
        return _hasTheme.apply(this, arguments);
      }
      return hasTheme;
    }(),
    /** Returns the URL of the image element (if persist) */
    getImageUrl: () => getImageElement()._prop('src') || '',
    getImageContainerClassName: function () {
      var _getImageContainerClassName = (0, _asyncToGenerator2.default)(function* () {
        var classList = yield (0, _unidriver.ReactBase)(getImageContainer())._DEPRECATED_getClassList();
        return classList;
      });
      function getImageContainerClassName() {
        return _getImageContainerClassName.apply(this, arguments);
      }
      return getImageContainerClassName;
    }(),
    /** Returns `true` if a node passed via the `image` prop exists */
    imageNodeExists: () => getImageNode().exists(),
    /** Returns `true` if children content exists */
    childrenContentExists: () => getChildrenContainer().exists(),
    /** Returns true if the component was configured with given align */
    hasAlign: function () {
      var _hasAlign = (0, _asyncToGenerator2.default)(function* (align) {
        return (yield base.attr('data-align')) === align;
      });
      function hasAlign(_x2) {
        return _hasAlign.apply(this, arguments);
      }
      return hasAlign;
    }()
  });
};
exports.emptyStateUniDriverFactory = emptyStateUniDriverFactory;
//# sourceMappingURL=EmptyState.uni.driver.js.map