import React from 'react';
import PropTypes from 'prop-types';
import { FieldSetProps } from './FieldSet.types';
declare const FieldSet: {
    ({ dataHook, children, legend: label, legendPlacement: labelPlacement, legendAlignment: labelAlignment, legendSize: labelSize, required, infoContent, infoTooltipProps, suffix, charCount, status, statusMessage, statusId, alignment, direction, gap, columns, }: FieldSetProps): React.JSX.Element;
    displayName: string;
    propTypes: {
        dataHook: PropTypes.Requireable<string>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        legend: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
        legendPlacement: PropTypes.Requireable<"top" | "right" | "left" | "none">;
        legendAlignment: PropTypes.Requireable<"top" | "middle">;
        legendSize: PropTypes.Requireable<"small" | "tiny">;
        required: PropTypes.Requireable<boolean>;
        infoContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        infoTooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        charCount: PropTypes.Requireable<number>;
        status: PropTypes.Requireable<"error" | "warning">;
        statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        statusId: PropTypes.Requireable<string>;
        alignment: PropTypes.Requireable<"center" | "end" | "start">;
        direction: PropTypes.Requireable<"horizontal" | "vertical">;
        gap: PropTypes.Requireable<"small" | "medium" | "large">;
        columns: PropTypes.Requireable<string>;
    };
};
export default FieldSet;
//# sourceMappingURL=FieldSet.d.ts.map