import type { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
import { LegendAlignment, LegendPlacement, LegendSize, FieldSetStatusType, Alignment, Direction, Gap } from './FieldSet.types';
export declare const fieldSetDriverFactory: (base: UniDriver, body: UniDriver) => {
    /** get legend text */
    getLegendText: () => Promise<string>;
    /** returns legend size */
    getLegendSize: () => Promise<LegendSize>;
    /** returns legend placement */
    getLegendPlacement: () => Promise<LegendPlacement>;
    /** returns legend alignment */
    getLegendAlignment: () => Promise<LegendAlignment>;
    /** returns true whether field set is required */
    isRequired: () => Promise<boolean>;
    /** returns the length left */
    getCharCount: () => Promise<number>;
    /** returns whether the field set length is exceeded */
    isLengthExceeded: () => Promise<boolean>;
    /** returns tooltip text of the info content */
    getInfoContent: () => Promise<string>;
    getAlignment: () => Promise<Alignment>;
    getDirection: () => Promise<Direction>;
    getGap: () => Promise<Gap>;
    /** returns status message text */
    getStatusMessage: () => Promise<string>;
    /** return true if it has a given status */
    hasStatus: (status: FieldSetStatusType) => Promise<boolean>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
    click: () => Promise<void>;
};
export type FieldSetUniDriver = ReturnType<typeof fieldSetDriverFactory>;
//# sourceMappingURL=FieldSet.uni.driver.d.ts.map