"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.filePickerUniDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var filePickerUniDriverFactory = base => {
  var error = base.$("[data-hook=filePicker-error]");
  var input = base.$('[data-hook="file-upload-input"]');
  var subLabel = base.$("[data-hook=\"sub-label\"]");
  var mainLabel = base.$("[data-hook=\"main-label\"]");
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether there's a visible error icon
     * @return {Promise<boolean>}
     */
    hasError: () => error.exists(),
    /**
     * Gets error message text
     * @return {Promise<string>}
     */
    errorMessage: () => error.text(),
    /**
     * Gets sub label text
     * @return {Promise<string>}
     */
    getSubLabel: () => subLabel.text(),
    /**
     * Gets main label text
     * @return {Promise<string>}
     */
    getMainLabel: () => mainLabel.text(),
    /**
     * Gets FilePicker input name
     * @return {Promise<string>}
     */
    getName: () => input._prop('name')
  });
};
exports.filePickerUniDriverFactory = filePickerUniDriverFactory;
//# sourceMappingURL=FilePicker.uni.driver.js.map