"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.parseUrl = exports.parseGradient = exports.parseElement = exports.parseColor = void 0;
var _react = _interopRequireDefault(require("react"));
var _UrlUtils = require("../utils/UrlUtils");
var _gradientParser = _interopRequireDefault(require("gradient-parser"));
var _color = _interopRequireDefault(require("color"));
var parseColor = fill => {
  if (typeof fill !== 'string') {
    return;
  }
  try {
    return (0, _color.default)(fill);
  } catch (_unused) {
    return;
  }
};
exports.parseColor = parseColor;
var parseGradient = fill => {
  if (typeof fill !== 'string') {
    return;
  }
  try {
    return _gradientParser.default.parse(fill);
  } catch (_unused2) {
    return;
  }
};
exports.parseGradient = parseGradient;
var parseUrl = fill => {
  if (typeof fill !== 'string') {
    return;
  }
  if ((0, _UrlUtils.isUrl)(fill)) {
    return fill;
  }
  if (/.jpg|.png|.svg/.test(fill)) {
    return "".concat(location.hostname, "/").concat(fill);
  }
  return;
};
exports.parseUrl = parseUrl;
var parseElement = fill => {
  if (typeof fill !== 'string') {
    if (/*#__PURE__*/_react.default.isValidElement(fill)) {
      return fill;
    }
  }
  return;
};
exports.parseElement = parseElement;
//# sourceMappingURL=utils.js.map