"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Popover = _interopRequireDefault(require("../../Popover"));
var _constants = require("./constants");
var _excluded = ["content", "appearance", "target", "children", "onClose", "onOpen", "initiallyOpened", "closeOnMouseLeave", "hideDelay"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/FloatingHelper/ClosablePopover/ClosablePopover.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var controlledErrorMsg = method => "ClosablePopover.".concat(method, "() can not be called when component is Controlled. (opened prop should be undefined)");

/**
 * Closable Popover
 * Either a normal Controlled Popover, or a Popover that is initially opened and can be the closed by
 * calling a closeAction.
 */
class ClosablePopover extends _react.PureComponent {
  constructor() {
    super(...arguments);
    this.state = {
      open: this.props.initiallyOpened,
      mode: this.props.initiallyOpened ? _constants.Mode.ClickToClose : _constants.Mode.Hover
    };
    this.open = () => this._doOpen(_constants.Mode.ClickToClose);
    this._doOpen = nextMode => {
      !this.state.open && this.setState({
        open: true,
        mode: nextMode
      }, () => {
        this.props.onOpen && this.props.onOpen();
      });
    };
    this.close = () => {
      if (this._isControlled()) {
        throw new Error(controlledErrorMsg('close'));
      }
      this.state.open && this.setState({
        open: false,
        mode: _constants.Mode.Hover
      }, () => {
        this.props.onClose && this.props.onClose();
      });
    };
    this._handleMouseEnter = () => {
      if (this.state.mode === _constants.Mode.Hover) {
        this._doOpen(_constants.Mode.Hover);
      }
    };
    this._handleMouseLeave = () => {
      if (this.state.mode === _constants.Mode.Hover && this.props.closeOnMouseLeave) {
        this.close();
      }
    };
    this.actions = {
      close: this.close
    };
  }
  _isControlled() {
    return typeof this.props.opened === 'boolean';
  }
  render() {
    var _this$props = this.props,
      {
        content,
        appearance,
        target,
        children,
        onClose,
        onOpen,
        initiallyOpened,
        closeOnMouseLeave,
        hideDelay
      } = _this$props,
      rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
    var open = this._isControlled() ? this.props.opened : this.state.open;
    var popoverProps = _objectSpread(_objectSpread({}, rest), {}, {
      animate: true,
      theme: appearance,
      shown: open,
      onMouseEnter: this._handleMouseEnter,
      onMouseLeave: this._handleMouseLeave
    });
    return /*#__PURE__*/_react.default.createElement(_Popover.default, (0, _extends2.default)({}, popoverProps, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 93,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react.default.createElement(_Popover.default.Element, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 94,
        columnNumber: 9
      }
    }, target), /*#__PURE__*/_react.default.createElement(_Popover.default.Content, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 95,
        columnNumber: 9
      }
    }, content(this.actions)));
  }
}
ClosablePopover.defaultProps = {
  hideDelay: 0,
  initiallyOpened: true,
  closeOnMouseLeave: true
};
ClosablePopover.propTypes = {
  /** Controls whether the popover's content is shown or not.
   * When undefined, then the component is Uncontrolled,
   * It is initially open, and it can be closed by close-action */
  opened: _propTypes.default.bool,
  /** Controls whether the popover's content is initially opened (in Uncontrolled mode only) */
  initiallyOpened: _propTypes.default.bool,
  /** The popover's target element*/
  target: _propTypes.default.node.isRequired,
  /** Callback to call when the popover content is requested to be opened (Uncontrolled mode only) */
  onOpen: _propTypes.default.func,
  /** callback to call when the popover content is requested to be closed (Uncontrolled mode only). NOTE: this callback is called when the close timeout (if exists) starts */
  onClose: _propTypes.default.func,
  /** Disable close on mouseLeave */
  closeOnMouseLeave: _propTypes.default.bool,
  /** The popover's content, given as a function that receives control-actions and renders the contet.
   * In Uncontrolled mode, this function is still called only once.
   */
  content: _propTypes.default.func.isRequired,
  /** A css class to be applied to the component's root element */
  className: _propTypes.default.string
};
var _default = exports.default = ClosablePopover;
//# sourceMappingURL=ClosablePopover.js.map