"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _ClosablePopover = require("./ClosablePopover/ClosablePopover.driver");
var _constants = require("./constants");
var _FloatingHelperContent = require("./FloatingHelperContent/FloatingHelperContent.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var floatingHelperDriverFactory = _ref => {
  var {
    wrapper,
    element,
    eventTrigger
  } = _ref;
  var closablePopoverDriver = (0, _ClosablePopover.closablePopoverDriverFactory)({
    wrapper,
    element,
    eventTrigger
  });
  var popoverContent = () => closablePopoverDriver.getContentElement();
  var innerContent = () => popoverContent().querySelector("[data-hook='".concat(_constants.dataHooks.innerContent, "']"));
  var closeButton = () => popoverContent().querySelector("[data-hook='".concat(_constants.dataHooks.closeButton, "']"));
  var contentWrapper = () => popoverContent().querySelector("[data-hook='".concat(_constants.dataHooks.contentWrapper, "']"));
  return _objectSpread(_objectSpread({}, closablePopoverDriver), {}, {
    /** check whether the helper has a close button */
    hasCloseButton: () => !!closeButton(),
    /** click the close button */
    clickCloseButton: () => eventTrigger.click(closeButton()),
    /** Get the driver for the helper's content */
    getHelperContentDriver: () => (0, _FloatingHelperContent.floatingHelperContentDriverFactory)({
      wrapper,
      element: innerContent(),
      eventTrigger
    }),
    /** Get width of content's root element */
    getWidth: () => window.getComputedStyle(contentWrapper()).width
  });
};
var _default = exports.default = floatingHelperDriverFactory;
//# sourceMappingURL=FloatingHelper.driver.js.map