"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.FunnelBadge = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tooltip = _interopRequireDefault(require("../../Tooltip"));
var _Heading = _interopRequireDefault(require("../../Heading"));
var _Focusable = require("../../common/Focusable");
var _FunnelBadgeSt = require("./FunnelBadge.st.css");
var _constants = require("../constants");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/FunnelChart/FunnelBadge/FunnelBadge.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class Badge extends _react.PureComponent {
  render() {
    var {
      value,
      className,
      focusableOnBlur,
      focusableOnFocus,
      dataHook
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _FunnelBadgeSt.st)(_FunnelBadgeSt.classes.badge, className),
      "data-hook": dataHook,
      tabIndex: 0,
      onBlur: focusableOnBlur,
      onFocus: focusableOnFocus,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 16,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: _FunnelBadgeSt.classes.badgeContent,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 23,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react.default.createElement(_Heading.default, {
      className: _FunnelBadgeSt.classes.badgeText,
      size: "extraTiny",
      dataHook: _constants.dataHooks.badgeValue,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 24,
        columnNumber: 11
      }
    }, value)));
  }
}
var FocusedBadge = (0, _Focusable.withFocusable)(Badge);
var FunnelBadge = props => {
  var {
    tooltipContent,
    onTooltipShow,
    value
  } = props;
  return /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    dataHook: _constants.dataHooks.badgeTooltip,
    disabled: !tooltipContent,
    content: tooltipContent,
    onShow: onTooltipShow,
    moveBy: {
      y: 2
    },
    textAlign: "start",
    size: "small",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(FocusedBadge, {
    value: value,
    dataHook: _constants.dataHooks.badge,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 7
    }
  }));
};
exports.FunnelBadge = FunnelBadge;
FunnelBadge.propTypes = {
  /** Badge's value */
  value: _propTypes.default.string.isRequired,
  /** Tooltip content. Can be either string or renderable node */
  tooltipContent: _propTypes.default.node,
  /** Callback on tooltip content show event */
  onTooltipShow: _propTypes.default.func
};
//# sourceMappingURL=FunnelBadge.js.map