"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.headingUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _baseDriver = require("@wix/wix-ui-test-utils/base-driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var headingUniDriverFactory = base => {
  var baseUniDriver = (0, _baseDriver.baseUniDriverFactory)(base);
  return _objectSpread(_objectSpread({}, baseUniDriver), {}, {
    /**
     * Gets text content
     * @returns {Promise<string>} innerHTML
     */
    getText: () => base._prop('innerHTML'),
    /**
     * Gets heading appearance
     * @returns {Promise<'H1' | 'H2' | 'H3' | 'H4' | 'H5' | 'H6'>}
     */
    getAppearance: () => base.attr('data-appearance'),
    /**
     * Gets heading size
     * @returns {Promise<'extraLarge' | 'large' | 'medium' | 'small' | 'tiny' | 'extraTiny'>}
     */
    getSize: () => base.attr('data-size'),
    /**
     * Gets heading tag name
     * @returns {Promise<keyof HTMLElementTagNameMap>}
     */
    getTagName: function () {
      var _getTagName = (0, _asyncToGenerator2.default)(function* () {
        return baseUniDriver.element().then(el => el.tagName);
      });
      function getTagName() {
        return _getTagName.apply(this, arguments);
      }
      return getTagName;
    }(),
    /**
     * Checks whether heading is light
     * @return {Promise<boolean>}
     */
    isLight: function () {
      var _isLight = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-light')) === 'true';
      });
      function isLight() {
        return _isLight.apply(this, arguments);
      }
      return isLight;
    }(),
    /**
     * Checks if heading has masking classNames
     * @return {Promise<boolean>}
     */
    isMasked: function () {
      var _isMasked = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-mask')) === 'true';
      });
      function isMasked() {
        return _isMasked.apply(this, arguments);
      }
      return isMasked;
    }(),
    /**
     * Gets heading id
     * @returns {Promise<string>}
     */
    getId: () => base.attr('data-id')
  });
};
exports.headingUniDriverFactory = headingUniDriverFactory;
//# sourceMappingURL=Heading.uni.driver.js.map