"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _HighlightedItem = _interopRequireDefault(require("./HighlightedItem"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Highlighter/Highlighter.js";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * Highlighter
 *
 * It highlights string type children by wrapping match
 * with strong dom element.
 * It remains children element structure.
 */

var childKeyGenerator = () => {
  var childKey = 0;
  return () => "highlighted-child-".concat(childKey++);
};
var ELEM_TYPES = {
  STRING: 'string',
  ARRAY: 'array',
  REACT_ELEMENT: 'React_element'
};
var getElementType = element => {
  if (Array.isArray(element)) {
    return ELEM_TYPES.ARRAY;
  }
  if (/*#__PURE__*/_react.default.isValidElement(element)) {
    return ELEM_TYPES.REACT_ELEMENT;
  }
  if (typeof element === 'string') {
    return ELEM_TYPES.STRING;
  }
  return '';
};
var highlight = (element, match, nextChildKey, props) => {
  if (!element) {
    return null;
  }
  var elementType = getElementType(element);
  var elementTypesMap = {
    [ELEM_TYPES.STRING]: (elem, _match) => /*#__PURE__*/_react.default.createElement(_HighlightedItem.default, {
      key: nextChildKey(),
      match: _match,
      emphasize: props.emphasize,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 45,
        columnNumber: 7
      }
    }, elem),
    [ELEM_TYPES.REACT_ELEMENT]: elem => {
      if (elem.props.children) {
        return /*#__PURE__*/_react.default.cloneElement(elem, _objectSpread(_objectSpread({}, elem.props), {}, {
          key: nextChildKey()
        }), highlight(elem.props.children, match, nextChildKey, props));
      }
      return elem;
    },
    [ELEM_TYPES.ARRAY]: elem => elem.map(el => highlight(el, match, nextChildKey, props))
  };
  return elementTypesMap[elementType] ? elementTypesMap[elementType](element, match) : element;
};
class Highlighter extends _react.default.PureComponent {
  constructor(props) {
    super(props);
    // we want to create new react keys generator for instance of highlighter
    this.nextChildKey = childKeyGenerator();
  }
  render() {
    var {
      dataHook,
      children,
      match
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("span", {
      "data-hook": dataHook,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 91,
        columnNumber: 7
      }
    }, highlight(children, match, this.nextChildKey, this.props));
  }
}
Highlighter.propTypes = {
  /** Applied as data-hook HTML attribute that can be used in the tests */
  dataHook: _propTypes.default.string,
  /** match to highlight */
  match: _propTypes.default.string,
  /** style of highlight */
  emphasize: _propTypes.default.oneOf(['text', 'background'])
};
Highlighter.displayName = 'Highlighter';
var _default = exports.default = Highlighter;
//# sourceMappingURL=Highlighter.js.map