"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _constants = require("./constants");
var _generateDataAttr = require("../utils/generateDataAttr");
var _IconButtonSt = require("./IconButton.st.css");
var _WixStyleReactDefaultsOverrideProvider = require("../WixStyleReactDefaultsOverrideProvider");
var _context = require("../WixStyleReactProvider/context");
var _deprecationLog = _interopRequireDefault(require("../utils/deprecationLog"));
var _ButtonCore = _interopRequireDefault(require("../Button/ButtonCore"));
var _excluded = ["skin", "className", "priority", "size", "children", "dataHook", "ariaLabel", "ariaLabelledBy"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/IconButton/IconButton.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
class IconButton extends _react.PureComponent {
  constructor(props) {
    super(props);
    /**
     * Sets focus on the button element
     */
    this.focus = () => {
      this.button.current && this.button.current.focus();
    };
    this.button = /*#__PURE__*/_react.default.createRef();
    if (props.skin === 'inverted') {
      (0, _deprecationLog.default)('<IconButton/> - skin="inverted" is deprecated and will be removed in next major version, please use skin="standard" and priority="secondary" instead');
    }
  }
  render() {
    var {
      button: buttonPropsDefaults
    } = this.context;
    var _this$props = this.props,
      {
        skin,
        className,
        priority,
        size = buttonPropsDefaults.size,
        children,
        dataHook,
        ariaLabel,
        ariaLabelledBy
      } = _this$props,
      rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
    var childSize = _constants.iconChildSize[size];
    return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 95,
        columnNumber: 7
      }
    }, _ref => {
      var {
        newColorsBranding
      } = _ref;
      return /*#__PURE__*/_react.default.createElement(_ButtonCore.default, (0, _extends2.default)({}, rest, {
        ref: this.button,
        className: (0, _IconButtonSt.st)(_IconButtonSt.classes.root, {
          skin,
          priority,
          size,
          newColorsBranding
        }, className)
      }, (0, _generateDataAttr.generateDataAttr)(_objectSpread(_objectSpread({}, this.props), {}, {
        size
      }), ['skin', 'size', 'priority']), {
        "data-hook": dataHook,
        "aria-label": ariaLabel,
        "aria-labelledby": ariaLabelledBy,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 97,
          columnNumber: 11
        }
      }), children && /*#__PURE__*/_react.default.cloneElement(children, {
        size: childSize,
        width: childSize,
        height: childSize,
        'aria-hidden': true
      }));
    });
  }
}
IconButton.contextType = _WixStyleReactDefaultsOverrideProvider.WixStyleReactDefaultsOverrideContext;
IconButton.displayName = 'IconButton';
IconButton.propTypes = {
  /** Render button as another component or a custom HTML tag */
  as: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object, _propTypes.default.string]),
  /** Specifies a CSS class name to be appended to the component’s root element */
  className: _propTypes.default.string,
  /** Accept any WSR icon. In order to use external icons make sure to follow sizing guidelines and contact design system UX for approval. */
  children: _propTypes.default.node,
  /** Sets the skin of a component */
  skin: _propTypes.default.oneOf(['standard', 'inverted', 'light', 'transparent', 'premium', 'dark']),
  /** Control the priority of a component */
  priority: _propTypes.default.oneOf(['primary', 'secondary']),
  /** Control the size of a component */
  size: _propTypes.default.oneOf(['tiny', 'small', 'medium', 'large']),
  /** Defines a callback function which is called whenever a button is clicked */
  onClick: _propTypes.default.func,
  /** Specify whether button should be disabled */
  disabled: _propTypes.default.bool,
  /** Applies a data-hook HTML attribute that can be used in the tests */
  dataHook: _propTypes.default.string,
  /** Define a string value that labels the button element */
  ariaLabel: _propTypes.default.string,
  /** Identify the element that labels the button element */
  ariaLabelledBy: _propTypes.default.string
};
IconButton.defaultProps = {
  skin: 'standard',
  priority: 'primary',
  disabled: false
};
var _default = exports.default = IconButton;
//# sourceMappingURL=IconButton.js.map