"use strict";

exports.__esModule = true;
exports.default = void 0;
var _Tooltip = require("../Tooltip/Tooltip.driver");
var _constants = require("./constants");
var infoIconDriverFactory = _ref => {
  var {
    element: _element,
    eventTrigger
  } = _ref;
  var getTooltip = () => (0, _Tooltip.tooltipLegacyDriverFactory)({
    element: _element.querySelector("[data-hook=\"".concat(_constants.dataHooks.tooltip, "\"]")),
    eventTrigger
  });
  return {
    /** returns whether element is rendered */
    exists: () => !!_element,
    /** returns element **/
    element: () => _element,
    /** Hover on icon. */
    hover: () => getTooltip().mouseEnter(),
    /** Get size. */
    getSize: () => _element.getAttribute('data-size'),
    /** Get content as a tooltip text value. */
    getContent: () => getTooltip().getTooltipText()
  };
};
var _default = exports.default = infoIconDriverFactory;
//# sourceMappingURL=InfoIcon.driver.js.map