"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _wixUiIconsCommon = require("@wix/wix-ui-icons-common");
var _TooltipCommon = require("../common/PropTypes/TooltipCommon");
var _constants = require("./constants");
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _InfoIconSt = require("./InfoIcon.st.css");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/InfoIcon/InfoIcon.js";
var iconComponentBySizeMap = {
  small: _wixUiIconsCommon.InfoCircleSmall,
  medium: _wixUiIconsCommon.InfoCircle
};
var InfoIcon = _ref => {
  var {
    dataHook,
    content,
    size = 'medium',
    tooltipProps,
    className
  } = _ref;
  var Icon = iconComponentBySizeMap[size];
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _InfoIconSt.st)(_InfoIconSt.classes.root, className),
    "data-size": size,
    "data-hook": dataHook,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 24,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(_Tooltip.default, (0, _extends2.default)({}, tooltipProps, {
    content: content,
    dataHook: _constants.dataHooks.tooltip,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 29,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement(Icon, {
    className: _InfoIconSt.classes.icon,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 30,
      columnNumber: 9
    }
  })));
};
InfoIcon.displayName = 'InfoIcon';
InfoIcon.propTypes = {
  /** A hook for testing purposes. */
  dataHook: _propTypes.default.string,
  /** A css class to be applied to the component's root element */
  className: _propTypes.default.string,
  /** Controls the icon size. */
  size: _propTypes.default.oneOf(['small', 'medium']),
  /** Tooltip content. */
  content: _propTypes.default.node.isRequired,
  /** Customize <Tooltip/> appearance with its props component.
   * @linkTypeTo components-overlays--tooltip
   * @setTypeName TooltipCommonProps
   */
  tooltipProps: _propTypes.default.shape(_TooltipCommon.TooltipCommonProps)
};
var _default = exports.default = InfoIcon;
//# sourceMappingURL=InfoIcon.js.map