"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.inputWithLabelDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _InputUni = require("../Input/Input.uni.driver");
var _LabelledElementUni = require("../LabelledElement/LabelledElement.uni.driver");
var _dataHooks = _interopRequireDefault(require("./dataHooks"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var inputWithLabelDriverFactory = base => {
  var inputWrapperSelector = "[data-hook=\"".concat(_dataHooks.default.input, "\"]");
  var labelledElementSelector = "[data-hook=\"".concat(_dataHooks.default.labelledElement, "\"]");
  var statusMessageSelector = "[data-hook=\"".concat(_dataHooks.default.errorMessage, "\"]");
  var inputDriver = (0, _InputUni.testkit)(base.$(inputWrapperSelector));
  var labelledElementDriver = (0, _LabelledElementUni.labelledElementDriverFactory)(base.$(labelledElementSelector));
  var errorMessageDriver = base.$(statusMessageSelector);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** Gets the amount of rendered suffixes */
    getSuffixesCount: () => base.$$("[data-hook=\"suffix-container\"]").count(),
    /** Returns true if an error status message exists */
    hasErrorMessage: () => errorMessageDriver.exists(),
    /** Gets the error status message */
    getErrorMessage: () => errorMessageDriver.text(),
    getValue: () => inputDriver.getValue(),
    clickInput: () => inputDriver.click(),
    enterText: value => inputDriver.enterText(value),
    getLabelText: () => labelledElementDriver.getLabelText(),
    isCustomInput: () => inputDriver.isCustomInput(),
    isFocusedStyle: () => inputDriver.isFocusedStyle(),
    getMaxLength: () => inputDriver.getMaxLength(),
    getPlaceholder: function () {
      var _getPlaceholder = (0, _asyncToGenerator2.default)(function* () {
        yield inputDriver.click();
        var placeholder = inputDriver.getPlaceholder();
        yield inputDriver.blur();
        return placeholder;
      });
      function getPlaceholder() {
        return _getPlaceholder.apply(this, arguments);
      }
      return getPlaceholder;
    }()
  });
};
exports.inputWithLabelDriverFactory = inputWithLabelDriverFactory;
//# sourceMappingURL=InputWithLabel.uni.driver.js.map