export function DEFAULT_VALUE_PARSER(option: any): any;
export namespace DEFAULT_POPOVER_PROPS {
    let appendTo: string;
    let flip: boolean;
    let fixed: boolean;
    let placement: string;
}
export default InputWithOptions;
declare class InputWithOptions extends React.Component<any, any, any> {
    constructor(props: any);
    inputClasses(): void;
    dropdownClasses(): void;
    dropdownAdditionalProps(): void;
    inputAdditionalProps(): void;
    rootAdditionalProps(): {};
    /**
     * An array of key codes that act as manual submit. Will be used within
     * onKeyDown(event).
     *
     * @returns {KeyboardEvent.key[]}
     */
    getManualSubmitKeys(): KeyboardEvent.key[];
    state: {
        inputValue: any;
        showOptions: boolean;
        lastOptionsShow: number;
        isEditing: boolean;
    };
    uniqueId: string;
    _onSelect(option: any, isSelectedOption: any): void;
    _onFocus(e: any): void;
    _onBlur(event: any): void;
    _onChange(event: any): void;
    _onKeyDown(event: any): void;
    /**
     * Sets focus on the input element
     * @param {FocusOptions} options
     */
    focus(options?: FocusOptions): void;
    /**
     * Removes focus on the input element
     */
    blur(): void;
    /**
     * Selects all text in the input element
     */
    select(): void;
    /**
     * Hides dropdown options
     */
    hideOptions(): void;
    /**
     * Shows dropdown options
     */
    showOptions(): void;
    _onManuallyInput(inputValue?: string): void;
    _renderDropdownLayout(): React.JSX.Element;
    _onInputClicked(event: any): void;
    closeOnSelect(): any;
    onCompositionChange(isComposing: any): void;
    componentDidUpdate(prevProps: any, prevState: any): void;
    onClickOutside: () => void;
    input: React.RefObject<any>;
    renderInput(): React.DetailedReactHTMLElement<any, HTMLElement>;
    isDropdownLayoutVisible: () => any;
    dropdownLayout: DropdownLayout | null | undefined;
    _renderNativeSelect(): React.JSX.Element;
    render(): React.JSX.Element;
    get isReadOnly(): any;
    /**
     * Determine if the provided key should cause the dropdown to be opened.
     *
     * @param {KeyboardEvent.key}
     * @returns {boolean}
     */
    shouldOpenDropdown(key: any): boolean;
    /**
     * Determine if the provided key should delegate the keydown event to the
     * DropdownLayout.
     *
     * @param {KeyboardEvent.key}
     * @returns {boolean}
     */
    shouldDelegateKeyDown(key: any): boolean;
    /**
     * Determine if the provided key should cause manual submit.
     *
     * @param {KeyboardEvent.key}
     * @returns {boolean}
     */
    shouldPerformManualSubmit(key: any): boolean;
    _focused: boolean | undefined;
    /** Checks if focus event is related to selecting an option */
    _didSelectOption: (event: any) => any;
    /**
     * Clears the input.
     *
     * @param event delegated to the onClear call
     */
    clear: (event: any) => void;
}
declare namespace InputWithOptions {
    let defaultProps: any;
    let propTypes: any;
    let displayName: string;
}
import React from 'react';
import DropdownLayout from '../DropdownLayout/DropdownLayout';
//# sourceMappingURL=InputWithOptions.d.ts.map