"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _Tooltip = require("../Tooltip/Tooltip.driver");
var _LinearProgressBarCore = require("./LinearProgressBarCore/LinearProgressBarCore.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var linearProgressBarDriverFactory = _ref => {
  var {
    element,
    eventTrigger,
    wrapper
  } = _ref;
  var getElementByDataHook = dataHook => element.querySelector("[data-hook='".concat(dataHook, "']"));
  var createTooltipDriver = () => (0, _Tooltip.tooltipLegacyDriverFactory)({
    element: getElementByDataHook(_constants.dataHooks.tooltip),
    eventTrigger
  });
  var coreProgressBarDriver = (0, _LinearProgressBarCore.linearProgressBarDriverFactory)({
    element,
    wrapper,
    eventTrigger
  });
  return _objectSpread(_objectSpread({}, coreProgressBarDriver), {}, {
    isErrorIconShown: () => !!getElementByDataHook(_constants.dataHooks.errorIcon),
    isSuccessIconShown: () => !!getElementByDataHook(_constants.dataHooks.successIcon),
    getTooltipErrorMessage: () => {
      var tooltipDriver = createTooltipDriver();
      return tooltipDriver.getTooltipText();
    },
    getSkin: () => element.getAttribute('data-skin')
  });
};
var _default = exports.default = linearProgressBarDriverFactory;
//# sourceMappingURL=LinearProgressBar.driver.js.map