"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _LinearProgressBarSt = require("./LinearProgressBar.st.css");
var _LinearProgressBarCore = _interopRequireDefault(require("./LinearProgressBarCore"));
var _system = require("@wix/wix-ui-icons-common/system");
var _StatusIndicator = _interopRequireDefault(require("../StatusIndicator"));
var _constants = require("./constants");
var _excluded = ["errorMessage", "skin", "light", "dataHook", "error", "shouldLoadAsync"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/LinearProgressBar/LinearProgressBar.js";
/**
 * This component is used for indicating a progress along a process.*/
class LinearProgressBar extends _react.default.PureComponent {
  render() {
    var _this$props = this.props,
      {
        errorMessage,
        skin,
        light,
        dataHook,
        error,
        shouldLoadAsync
      } = _this$props,
      otherProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
    return /*#__PURE__*/_react.default.createElement(_LinearProgressBarCore.default, (0, _extends2.default)({
      "data-hook": dataHook,
      className: (0, _LinearProgressBarSt.st)(_LinearProgressBarSt.classes.root, {
        light,
        skin
      }),
      "data-skin": skin
    }, otherProps, {
      error: error,
      successIcon: /*#__PURE__*/_react.default.createElement(_system.ToggleOn, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 30,
          columnNumber: 22
        }
      }),
      errorIcon: /*#__PURE__*/_react.default.createElement(_StatusIndicator.default, {
        dataHook: _constants.dataHooks.errorIcon,
        status: "error",
        message: errorMessage,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 32,
          columnNumber: 11
        }
      }),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 24,
        columnNumber: 7
      }
    }));
  }
}
LinearProgressBar.displayName = 'LinearProgressBar';
LinearProgressBar.propTypes = {
  /** Hook for testing purposes. */
  dataHook: _propTypes.default.string,
  /** Use to apply error styles */
  error: _propTypes.default.bool,
  /** Message to display when an error happens */
  errorMessage: _propTypes.default.string,
  /** Use light theme instead of dark theme */
  light: _propTypes.default.bool,
  /** Use to display a percentage progress.*/
  showProgressIndication: _propTypes.default.bool,
  /** The number of the percentage progress */
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  /** Sets the skin of the Linear Progress Bar. */
  skin: _propTypes.default.oneOf(['standard', 'success', 'warning', 'premium', 'neutral'])
};
LinearProgressBar.defaultProps = {
  skin: 'standard'
};
var _default = exports.default = LinearProgressBar;
//# sourceMappingURL=LinearProgressBar.js.map