"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.linearProgressBarDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _constants = require("./constants");
var _LinearProgressBarCoreUni = require("./LinearProgressBarCore/LinearProgressBarCore.uni.driver");
var _StatusIndicatorUni = require("../StatusIndicator/StatusIndicator.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var linearProgressBarDriverFactory = (base, body) => {
  var statusIndicatorTestkit = () => (0, _StatusIndicatorUni.statusIndicatorDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.errorIcon, "\"]")), body);
  var coreProgressBarDriver = (0, _LinearProgressBarCoreUni.linearProgressBarUniDriverFactory)(base);
  return _objectSpread(_objectSpread({}, coreProgressBarDriver), {}, {
    /** Checks whether error icon is shown */
    isErrorIconShown: () => base.$("[data-hook=".concat(_constants.dataHooks.errorIcon, "]")).exists(),
    /** Checks whether success icon is shown */
    isSuccessIconShown: () => base.$("[data-hook=".concat(_constants.dataHooks.successIcon, "]")).exists(),
    /** Returns the tooltip error message */
    getTooltipErrorMessage: statusIndicatorTestkit().getMessage,
    /** Returns the linear progress bar skin */
    getSkin: () => base.attr('data-skin')
  });
};
exports.linearProgressBarDriverFactory = linearProgressBarDriverFactory;
//# sourceMappingURL=LinearProgressBar.uni.driver.js.map