"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ListItemActionDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createSelector = dataHook => "[data-hook=\"".concat(dataHook, "\"]");
var ListItemActionDriverFactory = base => {
  var titleSelector = createSelector(_constants.dataHooks.title);
  var subtitleSelector = createSelector(_constants.dataHooks.subtitle);
  var prefixIconSelector = createSelector(_constants.dataHooks.prefixIcon);
  var suffixSelector = createSelector(_constants.dataHooks.suffix);
  var suffixIconSelector = createSelector(_constants.dataHooks.suffixIcon);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    isTitleExists: function () {
      var _isTitleExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$(titleSelector).exists();
      });
      function isTitleExists() {
        return _isTitleExists.apply(this, arguments);
      }
      return isTitleExists;
    }(),
    getTitleText: function () {
      var _getTitleText = (0, _asyncToGenerator2.default)(function* () {
        return base.$(titleSelector).text();
      });
      function getTitleText() {
        return _getTitleText.apply(this, arguments);
      }
      return getTitleText;
    }(),
    isPrefixIconExists: function () {
      var _isPrefixIconExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$(prefixIconSelector).exists();
      });
      function isPrefixIconExists() {
        return _isPrefixIconExists.apply(this, arguments);
      }
      return isPrefixIconExists;
    }(),
    isSuffixIconExists: function () {
      var _isSuffixIconExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$(suffixIconSelector).exists();
      });
      function isSuffixIconExists() {
        return _isSuffixIconExists.apply(this, arguments);
      }
      return isSuffixIconExists;
    }(),
    isSubtitleExists: function () {
      var _isSubtitleExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$(subtitleSelector).exists();
      });
      function isSubtitleExists() {
        return _isSubtitleExists.apply(this, arguments);
      }
      return isSubtitleExists;
    }(),
    getSubtitleText: function () {
      var _getSubtitleText = (0, _asyncToGenerator2.default)(function* () {
        return base.$(subtitleSelector).text();
      });
      function getSubtitleText() {
        return _getSubtitleText.apply(this, arguments);
      }
      return getSubtitleText;
    }(),
    isSuffixExists: function () {
      var _isSuffixExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$(suffixSelector).exists();
      });
      function isSuffixExists() {
        return _isSuffixExists.apply(this, arguments);
      }
      return isSuffixExists;
    }(),
    getSuffixText: () => base.$(suffixSelector).text(),
    getSkin: () => base.attr('data-skin'),
    isDisabled: function () {
      var _isDisabled = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-disabled')) === 'true';
      });
      function isDisabled() {
        return _isDisabled.apply(this, arguments);
      }
      return isDisabled;
    }()
  });
};
exports.ListItemActionDriverFactory = ListItemActionDriverFactory;
//# sourceMappingURL=ListItemAction.uni.driver.js.map