"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.listItemSelectDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var listItemSelectDriverFactory = base => {
  var byDataHook = dataHook => base.$("[data-hook=\"".concat(dataHook, "\"]"));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** Check whether the checkbox appears */
    hasCheckbox: function () {
      var _hasCheckbox = (0, _asyncToGenerator2.default)(function* () {
        return yield byDataHook(_constants.dataHooks.CHECKBOX).exists();
      });
      function hasCheckbox() {
        return _hasCheckbox.apply(this, arguments);
      }
      return hasCheckbox;
    }(),
    /** Get prefix */
    getPrefix: () => byDataHook(_constants.dataHooks.PREFIX),
    /** Get title Text */
    getTitle: function () {
      var _getTitle = (0, _asyncToGenerator2.default)(function* () {
        return yield byDataHook(_constants.dataHooks.TITLE).text();
      });
      function getTitle() {
        return _getTitle.apply(this, arguments);
      }
      return getTitle;
    }(),
    /** Get subtitle Text */
    getSubtitle: function () {
      var _getSubtitle = (0, _asyncToGenerator2.default)(function* () {
        var subtitleElement = yield byDataHook(_constants.dataHooks.SUBTITLE);
        if (yield subtitleElement.exists()) {
          return subtitleElement.text();
        }
        return undefined;
      });
      function getSubtitle() {
        return _getSubtitle.apply(this, arguments);
      }
      return getSubtitle;
    }(),
    /** Get suffix */
    getSuffix: () => byDataHook(_constants.dataHooks.SUFFIX)
  });
};
exports.listItemSelectDriverFactory = listItemSelectDriverFactory;
//# sourceMappingURL=ListItemSelect.uni.driver.js.map