"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.marketingPageLayoutDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var marketingPageLayoutDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Checks whether MarketingPageLayout content exist
     * @returns {Promise<boolean>}
     */
    hasContent: function () {
      var _hasContent = (0, _asyncToGenerator2.default)(function* () {
        return (0, _unidriver.findByHook)(base, _constants.dataHooks.contentContainer).exists();
      });
      function hasContent() {
        return _hasContent.apply(this, arguments);
      }
      return hasContent;
    }(),
    /**
     * Checks whether MarketingPageLayout image exist
     * @returns {Promise<boolean>}
     */
    hasImage: function () {
      var _hasImage = (0, _asyncToGenerator2.default)(function* () {
        return (0, _unidriver.findByHook)(base, _constants.dataHooks.imageContainer).exists();
      });
      function hasImage() {
        return _hasImage.apply(this, arguments);
      }
      return hasImage;
    }(),
    /**
     * Checks whether MarketingPageLayout footer exist
     * @returns {Promise<boolean>}
     */
    hasFooter: function () {
      var _hasFooter = (0, _asyncToGenerator2.default)(function* () {
        return (0, _unidriver.findByHook)(base, _constants.dataHooks.footerContainer).exists();
      });
      function hasFooter() {
        return _hasFooter.apply(this, arguments);
      }
      return hasFooter;
    }()
  });
};
exports.marketingPageLayoutDriverFactory = marketingPageLayoutDriverFactory;
//# sourceMappingURL=MarketingPageLayout.uni.driver.js.map