"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _MarketingPageLayoutContentSt = require("./MarketingPageLayoutContent.st.css");
var _constants = require("./constants");
var _Divider = _interopRequireDefault(require("../Divider"));
var _Text = _interopRequireWildcard(require("../Text"));
var _Heading = _interopRequireWildcard(require("../Heading"));
var _Box = _interopRequireDefault(require("../Box"));
var _StringUtils = require("../utils/StringUtils");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/MarketingPageLayoutContent/MarketingPageLayoutContent.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var sizesMap = {
  overline: {
    [_constants.size.medium]: _Text.SIZES.small,
    [_constants.size.large]: _Text.SIZES.medium
  },
  title: {
    [_constants.size.medium]: _Heading.SIZE.LARGE,
    [_constants.size.large]: _Heading.SIZE.EXTRA_LARGE
  },
  subtitle: {
    [_constants.size.medium]: _Heading.SIZE.SMALL,
    [_constants.size.large]: _Heading.SIZE.MEDIUM
  },
  content: {
    [_constants.size.medium]: _Text.SIZES.small,
    [_constants.size.large]: _Text.SIZES.medium
  }
};

/** This component is used in the MarketingPageLayout component. It includes all the content of the page. */
class MarketingPageLayoutContent extends _react.default.PureComponent {
  render() {
    var {
      dataHook,
      className,
      size,
      overline,
      title,
      subtitle,
      content,
      actions
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      "data-hook": dataHook,
      className: (0, _MarketingPageLayoutContentSt.st)(_MarketingPageLayoutContentSt.classes.root, className),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 47,
        columnNumber: 7
      }
    }, overline && /*#__PURE__*/_react.default.createElement("div", {
      "data-hook": _constants.dataHooks.overlineContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react.default.createElement(_Box.default, {
      color: "D20",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 13
      }
    }, (0, _StringUtils.isString)(overline) ? /*#__PURE__*/_react.default.createElement(_Text.default, {
      dataHook: _constants.dataHooks.overline,
      size: sizesMap.overline[size],
      skin: "standard",
      secondary: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 52,
        columnNumber: 17
      }
    }, overline) : overline), /*#__PURE__*/_react.default.createElement("div", {
      className: _MarketingPageLayoutContentSt.classes.overlineDividerContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 64,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react.default.createElement(_Divider.default, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 65,
        columnNumber: 15
      }
    }))), title && /*#__PURE__*/_react.default.createElement(_Box.default, {
      dataHook: _constants.dataHooks.titleContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 70,
        columnNumber: 11
      }
    }, (0, _StringUtils.isString)(title) ? /*#__PURE__*/_react.default.createElement(_Heading.default, {
      dataHook: _constants.dataHooks.title,
      size: sizesMap.title[size],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 72,
        columnNumber: 15
      }
    }, title) : title), subtitle && /*#__PURE__*/_react.default.createElement(_Box.default, {
      dataHook: _constants.dataHooks.subtitleContainer,
      marginTop: "SP2",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 81,
        columnNumber: 11
      }
    }, (0, _StringUtils.isString)(subtitle) ? /*#__PURE__*/_react.default.createElement(_Heading.default, {
      dataHook: _constants.dataHooks.subtitle,
      size: sizesMap.subtitle[size],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 83,
        columnNumber: 15
      }
    }, subtitle) : subtitle), content && /*#__PURE__*/_react.default.createElement(_Box.default, {
      dataHook: _constants.dataHooks.contentContainer,
      marginTop: "SP4",
      color: "D10",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 95,
        columnNumber: 11
      }
    }, (0, _StringUtils.isString)(content) ? /*#__PURE__*/_react.default.createElement(_Text.default, {
      dataHook: _constants.dataHooks.content,
      size: sizesMap.content[size],
      skin: "standard",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 101,
        columnNumber: 15
      }
    }, content) : content), actions && /*#__PURE__*/_react.default.createElement(_Box.default, {
      dataHook: _constants.dataHooks.actions,
      marginTop: "SP7",
      children: actions,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 114,
        columnNumber: 11
      }
    }));
  }
}
MarketingPageLayoutContent.displayName = 'MarketingPageLayoutContent';
MarketingPageLayoutContent.propTypes = {
  /** Applies a data-hook HTML attribute that can be used in tests */
  dataHook: _propTypes.default.string,
  /** Specifies a CSS class name to be appended to the component’s root element */
  className: _propTypes.default.string,
  /** Controls the size of the marketing page layout content */
  size: _propTypes.default.oneOf(['medium', 'large']),
  /** Set overline content. Accepts text string or a custom element. */
  overline: _propTypes.default.node,
  /** Set the page layout title. Accepts text string or a custom element. */
  title: _propTypes.default.node,
  /** Set pages layout subtitle. Accepts text string or a custom element. */
  subtitle: _propTypes.default.node,
  /** Sets the main content. Accepts a text paragraph or any custom elements. */
  content: _propTypes.default.node,
  /** Adds a container for page actions. Accepts single or multiple components. Most commonly contains `<Button/>` and `<TextButton/>`.   */
  actions: _propTypes.default.node
};
MarketingPageLayoutContent.defaultProps = {
  size: 'large'
};
var _default = exports.default = MarketingPageLayoutContent;
//# sourceMappingURL=MarketingPageLayoutContent.js.map