"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var messageBoxFunctionalLayoutDriverFactory = _ref => {
  var {
    element: _element
  } = _ref;
  var confirmationButton = () => _element.querySelector('[data-hook="confirmation-button"]');
  var cancellationButton = () => _element.querySelector('[data-hook="cancellation-button"]');
  var headerCloseButton = () => _element.querySelector('[data-hook="header-close-button"]');
  return {
    exists: () => !!_element,
    element: () => _element,
    getConfirmationButtonText: () => confirmationButton().textContent,
    isConfirmationButtonPrefixIconExists: () => confirmationButton().innerHTML.indexOf('prefix') !== -1,
    isConfirmationButtonSuffixIconExists: () => confirmationButton().innerHTML.indexOf('suffix') !== -1,
    clickOnConfirmationButton: () => _testUtils.default.Simulate.click(confirmationButton()),
    getConfirmationButton: confirmationButton,
    getCancellationButton: cancellationButton,
    getHeaderCloseButton: headerCloseButton,
    getCancellationButtonText: () => cancellationButton().textContent,
    isCancellationButtonPrefixIconExists: () => cancellationButton().innerHTML.indexOf('prefix') !== -1,
    isCancellationButtonSuffixIconExists: () => cancellationButton().innerHTML.indexOf('suffix') !== -1,
    clickOnCancellationButton: () => _testUtils.default.Simulate.click(cancellationButton()),
    clickOnHeaderCloseButton: () => _testUtils.default.Simulate.click(headerCloseButton()),
    isThemeExist: theme => _element.dataset.theme === theme,
    getFooter: () => _element.querySelector('[data-hook="message-box-footer"]'),
    getTitle: () => _element.querySelector('[data-hook="header-layout-title"]').textContent,
    getChildBySelector: selector => _element.querySelector(selector),
    isCancelEnable: () => !cancellationButton().disabled,
    isConfirmationEnable: () => !confirmationButton().disabled,
    toHaveBodyPadding: () => _element.dataset.nobodypadding !== 'true'
  };
};
var _default = exports.default = messageBoxFunctionalLayoutDriverFactory;
//# sourceMappingURL=MessageBoxFunctionalLayout.driver.js.map