export default ModalMobileLayout;
declare class ModalMobileLayout extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Applied as data-hook HTML attribute that can be used in the tests */
        dataHook: PropTypes.Requireable<string>;
        /** A css class to be applied to the component's root element */
        className: PropTypes.Requireable<string>;
        /** title node to be displayed in the header strip */
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** If true, the title will be sticky to the top of the modal */
        stickyTitle: PropTypes.Requireable<boolean>;
        /** content node to be displayed */
        content: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** footer node to be displayed */
        footer: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** If true, the footer will be sticky to the bottom of the modal */
        stickyFooter: PropTypes.Requireable<boolean>;
        /** callback for when there's a click on the overlay (in case the modal in not fullscreen) */
        onOverlayClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** callback for when the the close button is clicked.  **Note**: if this prop is not provided, then the close button will not be shown. */
        onCloseButtonClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** If true, the modal will take all of the screen */
        fullscreen: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        stickyTitle: boolean;
        stickyFooter: boolean;
        fullscreen: boolean;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    render(): React.JSX.Element;
    _renderTitle: () => React.JSX.Element;
    _renderFooter: () => React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=ModalMobileLayout.d.ts.map