"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.modalMobileLayoutDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var modalMobileLayoutDriverFactory = base => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Gets the title node
     * @return {Promise<UniDriver>} Title testkit
     */
    getTitle: function () {
      var _getTitle = (0, _asyncToGenerator2.default)(function* () {
        return base.$('[data-hook="modalMobileLayout-title"]');
      });
      function getTitle() {
        return _getTitle.apply(this, arguments);
      }
      return getTitle;
    }(),
    /**
     * Gets the content node
     * @return {Promise<UniDriver>} Content testkit
     */
    getContent: function () {
      var _getContent = (0, _asyncToGenerator2.default)(function* () {
        return base.$('[data-hook="modalMobileLayout-content"]');
      });
      function getContent() {
        return _getContent.apply(this, arguments);
      }
      return getContent;
    }(),
    /**
     * Gets the footer node
     * @return {Promise<UniDriver>} Footer testkit
     */
    getFooter: function () {
      var _getFooter = (0, _asyncToGenerator2.default)(function* () {
        return base.$('[data-hook="modalMobileLayout-footer"]');
      });
      function getFooter() {
        return _getFooter.apply(this, arguments);
      }
      return getFooter;
    }(),
    /**
     * Clicks on the overlay
     * @return {Promise<void>}
     */
    clickOverlay: function () {
      var _clickOverlay = (0, _asyncToGenerator2.default)(function* () {
        return base.click();
      });
      function clickOverlay() {
        return _clickOverlay.apply(this, arguments);
      }
      return clickOverlay;
    }(),
    /**
     * Clicks on the close button
     * @return {Promise<void>}
     */
    clickCloseButton: function () {
      var _clickCloseButton = (0, _asyncToGenerator2.default)(function* () {
        return base.$('[data-hook="modalMobileLayout-close-button"]').click();
      });
      function clickCloseButton() {
        return _clickCloseButton.apply(this, arguments);
      }
      return clickCloseButton;
    }(),
    /**
     * Checks whether close button exist
     * @return {Promise<boolean>}
     */
    closeButtonExists: function () {
      var _closeButtonExists = (0, _asyncToGenerator2.default)(function* () {
        return base.$('[data-hook="modalMobileLayout-close-button"]').exists();
      });
      function closeButtonExists() {
        return _closeButtonExists.apply(this, arguments);
      }
      return closeButtonExists;
    }()
  });
};
exports.modalMobileLayoutDriverFactory = modalMobileLayoutDriverFactory;
//# sourceMappingURL=ModalMobileLayout.uni.driver.js.map