"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var _vanilla = require("@wix/wix-ui-test-utils/vanilla");
var _Loader = _interopRequireDefault(require("../Loader/Loader.driver"));
var _Selector = _interopRequireDefault(require("../Selector/Selector.driver"));
var _Search = _interopRequireDefault(require("../Search/Search.driver"));
var _Text = _interopRequireDefault(require("../Text/Text.driver"));
var _SelectorList = require("../SelectorList/SelectorList.helpers");
var _Checkbox = _interopRequireDefault(require("../Checkbox/Checkbox.driver"));
var _ButtonLegacy = _interopRequireDefault(require("../Button/Button.legacy.driver"));
var textTestkitFactory = (0, _vanilla.testkitFactoryCreator)(_Text.default);
var loaderTestkitFactory = (0, _vanilla.testkitFactoryCreator)(_Loader.default);
var buttonTestkitFactory = (0, _vanilla.testkitFactoryCreator)(_ButtonLegacy.default);
var searchTestkitFactory = (0, _vanilla.testkitFactoryCreator)(_Search.default);
var checkboxTestkitFactory = (0, _vanilla.testkitFactoryCreator)(_Checkbox.default);
var modalSelectorLayoutDriverFactory = _ref => {
  var {
    element
  } = _ref;
  var findInModalByDataHook = dataHook => element.querySelector("[data-hook=\"".concat(dataHook, "\"]"));
  var mainLoaderDriver = () => loaderTestkitFactory({
    wrapper: element,
    dataHook: _SelectorList.dataHooks.mainLoader
  });
  var nextPageLoaderDriver = () => loaderTestkitFactory({
    wrapper: element,
    dataHook: _SelectorList.dataHooks.nextPageLoader
  });
  var cancelButtonDriver = () => buttonTestkitFactory({
    wrapper: element,
    dataHook: 'cancellation-button'
  });
  var okButtonDriver = () => buttonTestkitFactory({
    wrapper: element,
    dataHook: 'confirmation-button'
  });
  var subtitleTextDriver = () => textTestkitFactory({
    wrapper: element,
    dataHook: _SelectorList.dataHooks.subtitle
  });
  var searchDriver = () => searchTestkitFactory({
    wrapper: element,
    dataHook: _SelectorList.dataHooks.search
  });
  var getList = () => findInModalByDataHook(_SelectorList.dataHooks.list);
  var getSelectorListContent = () => findInModalByDataHook(_SelectorList.dataHooks.content);
  var getSelectors = () => getList().querySelectorAll("[data-hook=\"".concat(_SelectorList.dataHooks.selector, "\"]"));
  var selectorDriverAt = i => (0, _Selector.default)({
    element: getSelectors()[i]
  });
  var emptyState = () => findInModalByDataHook(_SelectorList.dataHooks.emptyState);
  var noResultsFoundState = () => findInModalByDataHook(_SelectorList.dataHooks.noResultsFoundState);
  var _footerSelector = checkboxTestkitFactory({
    wrapper: element,
    dataHook: _SelectorList.dataHooks.toggleAllCheckbox
  });
  return {
    exists: () => !!element,
    mainLoaderDriver,
    nextPageLoaderDriver,
    cancelButtonDriver,
    okButtonDriver,
    searchDriver,
    subtitleTextDriver,
    getTitle: () => findInModalByDataHook('header-layout-title').textContent,
    clickOnClose: () => _testUtils.default.Simulate.click(findInModalByDataHook('header-close-button')),
    showsEmptyState: () => !!emptyState(),
    getEmptyState: () => emptyState().childNodes[0],
    showsNoResultsFoundState: () => !!noResultsFoundState(),
    getNoResultsFoundState: () => noResultsFoundState().childNodes[0],
    listExists: () => !!getList(),
    numberOfItemsInList: () => getSelectors().length,
    getSelectorDriverAt: i => selectorDriverAt(i),
    scrollDown: () => getSelectorListContent().dispatchEvent(new Event('scroll')),
    footerSelector: () => _footerSelector
  };
};
var _default = exports.default = modalSelectorLayoutDriverFactory;
//# sourceMappingURL=ModalSelectorLayout.driver.js.map