export const LOCAL_NOTIFICATION: "local";
export const GLOBAL_NOTIFICATION: "global";
export const STICKY_NOTIFICATION: "sticky";
export const DEFAULT_AUTO_HIDE_TIMEOUT: 6000;
export const DEFAULT_TIMEOUT: 6000;
export default Notification;
declare class Notification extends React.PureComponent<any, any, any> {
    constructor(props: any);
    constructor(props: any, context: any);
    closeTimeout: any;
    transitionTimeout: any;
    ref: React.RefObject<any>;
    childRef: React.RefObject<any>;
    state: {
        hideByCloseClick: boolean;
        hideByTimer: boolean;
        height: number;
        showChildren: boolean;
    };
    UNSAFE_componentWillReceiveProps(nextProps: any): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: any, prevState: any): void;
    _setChildrenVisibility({ show }: {
        show: any;
    }): void;
    _clearTransitionTimeout(): void;
    _startCloseTimer({ autoHideTimeout }: {
        autoHideTimeout: any;
    }): void;
    _clearCloseTimeout(): void;
    _hideNotificationOnCloseClick: () => void;
    _hideNotificationOnTimeout: () => void;
    _bypassCloseFlags(): void;
    _shouldShowNotification(show: any): any;
    _setHeightToChild(node: any): any;
    _getChildren(): React.JSX.Element | null;
    render(): React.JSX.Element;
}
declare namespace Notification {
    export let displayName: string;
    export namespace propTypes {
        let show: PropTypes.Requireable<boolean>;
        let theme: PropTypes.Requireable<string>;
        let type: PropTypes.Requireable<string>;
        let autoHideTimeout: PropTypes.Requireable<number>;
        let zIndex: PropTypes.Requireable<number>;
        let onClose: PropTypes.Requireable<(...args: any[]) => any>;
        let children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    }
    export namespace defaultProps {
        let theme_1: string;
        export { theme_1 as theme };
        export { GLOBAL_NOTIFICATION as type };
        let onClose_1: null;
        export { onClose_1 as onClose };
    }
    export { Close as CloseButton };
    export { TextLabel };
    export { ActionButton };
}
import React from 'react';
import PropTypes from 'prop-types';
declare function Close(props: any): React.JSX.Element;
declare namespace Close {
    let displayName_1: string;
    export { displayName_1 as displayName };
}
import TextLabel from './TextLabel';
import ActionButton from './ActionButton';
//# sourceMappingURL=Notification.d.ts.map