"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Input = _interopRequireDefault(require("../Input"));
var _utils = require("./utils");
var _constants = require("./constants");
var _deprecationLog = _interopRequireDefault(require("../utils/deprecationLog"));
var _excluded = ["suffix", "defaultValue", "strict", "max", "min", "hideStepper", "onChange", "value", "inputRef", "step", "status", "invalidMessage", "statusMessage", "onInvalid", "onKeyDown"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/NumberInput/NumberInput.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var NumberInput = _ref => {
  var {
      suffix,
      defaultValue,
      strict = false,
      max,
      min,
      hideStepper = false,
      onChange,
      value: givenValue,
      inputRef,
      step = 1,
      status,
      invalidMessage,
      statusMessage,
      onInvalid,
      onKeyDown
    } = _ref,
    props = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var initialState = {
    hasError: false,
    numberInputValue: ''
  };
  var [state, setState] = _react.default.useReducer((currentState, newState) => _objectSpread(_objectSpread({}, currentState), newState), initialState);
  var [inputDOM, setInputDOM] = _react.default.useState(null);
  var shouldShowError = state.hasError && invalidMessage;
  var setValueAndValidate = _ref2 => {
    var {
      value,
      shouldCallOnChangeCallback = true
    } = _ref2;
    var normalizedValue = (0, _utils.normalizeValue)(String(value));
    var {
      hasError,
      validationType
    } = (0, _utils.validateValue)({
      value: normalizedValue,
      minValue: min,
      maxValue: max
    });
    setState({
      hasError,
      numberInputValue: normalizedValue
    });
    if (shouldCallOnChangeCallback && !hasError) {
      onChange == null || onChange(normalizedValue === '' ? null : Number(normalizedValue), normalizedValue);
    }
    if (hasError) {
      onInvalid == null || onInvalid(normalizedValue, {
        validationType,
        value: normalizedValue
      });
    }
  };
  (0, _react.useEffect)(() => {
    if (strict) {
      (0, _deprecationLog.default)('<NumberInput/> - prop strict is deprecated and not needed anymore. By using min and max it will enforce strict both for the ticker and input automatically.');
    }
  }, [strict]);
  (0, _react.useEffect)(() => {
    var newNumberInputValue = (0, _utils.defaultValueToNullIfEmpty)(givenValue, defaultValue);
    setValueAndValidate({
      value: newNumberInputValue,
      shouldCallOnChangeCallback: false
    });
    // TODO: fix ESLint error
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [givenValue, defaultValue]);
  var increment = () => {
    var numberValue = parseFloat(String(state.numberInputValue) || String(inputDOM == null ? void 0 : inputDOM.value)) || 0;
    var updatedValue = Number((numberValue + step).toPrecision(12));
    if ((0, _utils.isInRange)({
      value: updatedValue,
      minValue: min,
      maxValue: max
    })) {
      setValueAndValidate({
        value: updatedValue
      });
    }
    inputDOM == null || inputDOM.focus();
  };
  var decrement = () => {
    var numberValue = parseFloat(String(state.numberInputValue) || String(inputDOM == null ? void 0 : inputDOM.value)) || 0;
    var updatedValue = Number((numberValue - step).toPrecision(12));
    if ((0, _utils.isInRange)({
      value: updatedValue,
      minValue: min,
      maxValue: max
    })) {
      setValueAndValidate({
        value: updatedValue
      });
    }
    inputDOM == null || inputDOM.focus();
  };
  var getInputRef = ref => {
    setInputDOM(ref);
    if (inputRef) {
      inputRef(ref);
    }
  };
  var getStatusMessage = () => {
    if (shouldShowError) {
      return invalidMessage;
    }
    return statusMessage;
  };
  var onInputValueChange = event => {
    var {
      value
    } = event.target;
    if (/^-?\d*[.,]?\d*$/.test(value)) {
      setValueAndValidate({
        value
      });
    } else {
      setState({
        numberInputValue: state.numberInputValue
      });
    }
  };
  var incrementOrDecrementValue = e => {
    if (e.key === 'ArrowUp') {
      increment();
      e.preventDefault();
    }
    if (e.key === 'ArrowDown') {
      decrement();
      e.preventDefault();
    }
    onKeyDown == null || onKeyDown(e);
  };
  return /*#__PURE__*/_react.default.createElement(_Input.default, (0, _extends2.default)({}, props, {
    max: max,
    min: min,
    type: "text",
    value: state.numberInputValue,
    onChange: onInputValueChange,
    inputRef: getInputRef,
    status: shouldShowError ? 'error' : status,
    statusMessage: getStatusMessage(),
    onKeyDown: incrementOrDecrementValue,
    ariaRoledescription: "spin button",
    inputmode: "numeric",
    suffix: /*#__PURE__*/_react.default.createElement(_Input.default.Group, {
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 193,
        columnNumber: 9
      }
    }, suffix, !hideStepper && /*#__PURE__*/_react.default.createElement(_Input.default.Ticker, {
      onUp: increment,
      onDown: decrement,
      dataHook: _constants.dataHooks.numberInputTicker,
      upDisabled: max === state.numberInputValue,
      downDisabled: min === state.numberInputValue,
      onMouseDown: e => e.preventDefault(),
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 196,
        columnNumber: 13
      }
    })),
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 179,
      columnNumber: 5
    }
  }));
};
NumberInput.displayName = 'NumberInput';
NumberInput.propTypes = {
  dataHook: _propTypes.default.string,
  className: _propTypes.default.string,
  id: _propTypes.default.string,
  defaultValue: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  disabled: _propTypes.default.bool,
  status: _propTypes.default.oneOf(['error', 'warning', 'loading']),
  statusMessage: _propTypes.default.node,
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.node,
  size: _propTypes.default.oneOf(['small', 'medium', 'large']),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  min: _propTypes.default.number,
  max: _propTypes.default.number,
  step: _propTypes.default.number,
  strict: _propTypes.default.bool,
  hideStepper: _propTypes.default.bool
};
var _default = exports.default = NumberInput;
//# sourceMappingURL=NumberInput.js.map