"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var Content = _ref => {
  var {
    children,
    stickyStyle
  } = _ref;
  if (typeof children === 'function') {
    return children({
      stickyStyle
    });
  } else {
    return children;
  }
};
Content.displayName = 'Page.Content';
Content.propTypes = {
  /** Accept single or multiple compound <Cell/> elements which store content items. Other nodes are accepted but not recommended. */
  children: _propTypes.default.node.isRequired,
  /** Specifies a CSS class name to be appended to the component’s root element. */
  className: _propTypes.default.string,
  /** Stretches the component to a full screen mode */
  fullScreen: _propTypes.default.bool
};
var _default = exports.default = Content;
//# sourceMappingURL=Content.js.map