"use strict";

exports.__esModule = true;
exports.PagePrivateDriver = void 0;
var _react = require("../test-utils/utils/react");
class PagePrivateDriver {
  constructor(_ref) {
    var {
      element,
      eventTrigger
    } = _ref;
    this.element = element;
    this.eventTrigger = eventTrigger;
  }
  static fromJsxElement(jsxElement) {
    var driverFactory = _ref2 => {
      var {
        element,
        eventTrigger
      } = _ref2;
      return new PagePrivateDriver({
        element,
        eventTrigger
      });
    };
    var {
      driver
    } = (0, _react.createRendererWithDriver)(driverFactory)(jsxElement);
    return driver;
  }
  byDataHook(dataHook) {
    return this.element.querySelector("[data-hook=\"".concat(dataHook, "\"]"));
  }
  get fixedContainer() {
    return this.byDataHook('page-header-container');
  }
  get scrollableContainer() {
    return this.byDataHook('page-scrollable-content');
  }
  wheelOnFixedContainer(amount) {
    this.eventTrigger.wheel(this.fixedContainer, {
      deltaY: amount
    });
  }
  getScrollAmount() {
    return this.scrollableContainer.scrollTop;
  }
  setScrollAmount(amount) {
    this.scrollableContainer.scrollTop = amount;
    this.eventTrigger.scroll(this.byDataHook('page-scrollable-content'));
  }
  getStyle() {
    return this.element.style;
  }
}
exports.PagePrivateDriver = PagePrivateDriver;
//# sourceMappingURL=Page.private.driver.js.map