"use strict";

exports.__esModule = true;
exports.PageHeaderPrivateDriver = void 0;
var _react = require("../test-utils/utils/react");
class PageHeaderPrivateDriver {
  constructor(_ref) {
    var {
      element,
      eventTrigger
    } = _ref;
    this.existsByDataHook = dataHook => !!this.byDataHook(dataHook);
    this.element = element;
    this.eventTrigger = eventTrigger;
  }
  static fromJsxElement(jsxElement) {
    var driverFactory = _ref2 => {
      var {
        element,
        eventTrigger
      } = _ref2;
      return new PageHeaderPrivateDriver({
        element,
        eventTrigger
      });
    };
    var {
      driver
    } = (0, _react.createRendererWithDriver)(driverFactory)(jsxElement);
    return driver;
  }
  byDataHook(dataHook) {
    return this.element.querySelector("[data-hook=\"".concat(dataHook, "\"]"));
  }
  propExists(dataHook, prop) {
    return !!this.byDataHook(dataHook).getAttribute(prop);
  }
}
exports.PageHeaderPrivateDriver = PageHeaderPrivateDriver;
//# sourceMappingURL=PageHeader.private.driver.js.map