"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.pageHeaderUniDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _IconButtonUni = require("../IconButton/IconButton.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var pageHeaderUniDriverFactory = base => {
  var titleElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.title);
  var subtitleElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.subtitle);
  var breadcrumbsElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.breadcrumbs);
  var actionBarElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.actionBar);
  var backButtonElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.backButton);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Checks whether the PageHeader class exists
     * @param {name} className
     * @returns {Promise<boolean>}
     */
    hasClass: className => base.hasClass(className),
    /**
     * Gets PageHeader title text
     * @return {Promise<string>}
     */
    titleText: () => titleElement().text(),
    /**
     * Checks whether the PageHeader title exists
     * @returns {Promise<boolean>}
     */
    isTitleExists: () => titleElement().exists(),
    /**
     * Gets PageHeader subtitle text
     * @return {Promise<string>}
     */
    subtitleText: () => subtitleElement().text(),
    /**
     * Checks whether the PageHeader subtitle exists
     * @returns {Promise<boolean>}
     */
    isSubtitleExists: () => subtitleElement().exists(),
    /**
     * Checks whether the PageHeader breadcrumbs exists
     * @returns {Promise<boolean>}
     */
    isBreadcrumbsExists: () => breadcrumbsElement().exists(),
    /**
     * Gets PageHeader breadcrumbs text
     * @return {Promise<string>}
     */
    breadcrumbsText: () => breadcrumbsElement().text(),
    /**
     * Checks whether the PageHeader action bar exists
     * @returns {Promise<boolean>}
     */
    isActionBarExists: () => actionBarElement().exists(),
    /**
     * Checks whether the PageHeader back button exists
     * @returns {Promise<boolean>}
     */
    isBackButtonExists: () => backButtonElement().exists(),
    /**
     * Clicks PageHeader back button
     * @returns {Promise<void>}
     */
    clickBackButton: () => (0, _IconButtonUni.iconButtonDriverFactory)(backButtonElement()).click()
  });
};
exports.pageHeaderUniDriverFactory = pageHeaderUniDriverFactory;
//# sourceMappingURL=PageHeader.uni.driver.js.map