"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Heading = _interopRequireDefault(require("../Heading"));
var _Text = _interopRequireDefault(require("../Text"));
var _Divider = _interopRequireDefault(require("../Divider"));
var _PageSectionSt = require("./PageSection.st.css");
var _constants = require("./constants");
var _context = require("../WixStyleReactProvider/context");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/PageSection/PageSection.js",
  _this = void 0;
/** Page Section */
var PageSection = function PageSection() {
  var {
    dataHook,
    showDivider,
    title,
    subtitle,
    actionsBar,
    className
  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 19,
      columnNumber: 3
    }
  }, _ref => {
    var {
      newColorsBranding
    } = _ref;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _PageSectionSt.st)(_PageSectionSt.classes.root, {
        showDivider
      }, className),
      "data-hook": dataHook,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 21,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: _PageSectionSt.classes.content,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 25,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: _PageSectionSt.classes.titleColumn,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 26,
        columnNumber: 11
      }
    }, title && /*#__PURE__*/_react.default.createElement(_Heading.default, {
      size: newColorsBranding ? 'small' : 'large',
      as: "h2",
      dataHook: _constants.dataHooks.pageSectionTitle,
      ellipsis: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 28,
        columnNumber: 15
      }
    }, title), subtitle && /*#__PURE__*/_react.default.createElement(_Text.default, {
      secondary: true,
      weight: "thin",
      ellipsis: true,
      dataHook: _constants.dataHooks.pageSectionSubtitle,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 38,
        columnNumber: 15
      }
    }, subtitle)), actionsBar && /*#__PURE__*/_react.default.createElement("div", {
      className: _PageSectionSt.classes.actionsBar,
      "data-hook": _constants.dataHooks.pageSectionActionsBar,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 13
      }
    }, actionsBar)), showDivider && /*#__PURE__*/_react.default.createElement(_Divider.default, {
      className: _PageSectionSt.classes.divider,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 57,
        columnNumber: 25
      }
    }));
  });
};
PageSection.displayName = 'Page.Section';
PageSection.propTypes = {
  /** Applied as data-hook HTML attribute that can be used in the tests */
  dataHook: _propTypes.default.string,
  /** A css class to be applied to the component's root element */
  className: _propTypes.default.string,
  /** The main title content */
  title: _propTypes.default.node,
  /** The subtitle content */
  subtitle: _propTypes.default.node,
  /** A placeholder for a component that can contain actions.*/
  actionsBar: _propTypes.default.node,
  /** Renders a divider */
  showDivider: _propTypes.default.bool
};
var _default = exports.default = PageSection;
//# sourceMappingURL=PageSection.js.map