"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.pageSectionDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var pageSectionDriverFactory = (base, body) => {
  var titleElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.pageSectionTitle);
  var subtitleElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.pageSectionSubtitle);
  var actionsBarElement = () => (0, _unidriver.findByHook)(base, _constants.dataHooks.pageSectionActionsBar);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Gets PageSection title text
     * @return {Promise<string>}
     */
    getTitleText: () => titleElement().text(),
    /**
     * Checks whether the PageSection title exists
     * @returns {Promise<boolean>}
     */
    isTitleExists: () => titleElement().exists(),
    /**
     * Gets PageSection subtitle text
     * @return {Promise<string>}
     */
    getSubtitleText: () => subtitleElement().text(),
    /**
     * Checks whether the PageSection subtitle exists
     * @returns {Promise<boolean>}
     */
    isSubtitleExists: () => subtitleElement().exists(),
    /**
     * Checks whether the PageHeader action bar exists
     * @returns {Promise<boolean>}
     */
    isActionsBarExists: () => actionsBarElement().exists()
  });
};
exports.pageSectionDriverFactory = pageSectionDriverFactory;
//# sourceMappingURL=PageSection.uni.driver.js.map