"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = exports.Pagination = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Focusable = require("../common/Focusable");
var _wixUiIconsCommon = require("@wix/wix-ui-icons-common");
var _PaginationCore = _interopRequireDefault(require("./PaginationCore"));
var _PaginationSt = require("./Pagination.st.css");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Pagination/Pagination.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var coreComponentDefaults = {
  showFirstPage: true,
  showLastPage: true,
  responsive: false,
  showFirstLastNavButtons: false,
  showInputModeTotalPages: false,
  paginationMode: 'pages',
  nextLabel: /*#__PURE__*/_react.default.createElement(_wixUiIconsCommon.ChevronRight, {
    className: _PaginationSt.classes.arrow,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 17,
      columnNumber: 14
    }
  }),
  previousLabel: /*#__PURE__*/_react.default.createElement(_wixUiIconsCommon.ChevronLeft, {
    className: _PaginationSt.classes.arrow,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 18,
      columnNumber: 18
    }
  })
};

/** Component for pagination */
class Pagination extends _react.PureComponent {
  constructor() {
    super(...arguments);
    this._getMaxPagesToShow = () => {
      var {
        currentPage,
        totalPages
      } = this.props;
      var defaultCount = 7;
      if (!currentPage || !totalPages) return defaultCount;
      var absoluteNumDistance = Math.min(Math.abs(1 - currentPage), Math.abs(currentPage - totalPages));
      if (absoluteNumDistance >= 4) {
        return 9;
      } else if (absoluteNumDistance === 3) {
        return 8;
      }
      return defaultCount;
    };
  }
  render() {
    var {
      dataHook,
      currentPage,
      totalPages,
      onChange,
      nextLabel,
      previousLabel,
      className,
      pageUrl
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _PaginationSt.st)(_PaginationSt.classes.root, className),
      "data-hook": dataHook,
      onFocus: this.props.focusableOnFocus,
      onBlur: this.props.focusableOnBlur,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 72,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement(_PaginationCore.default, (0, _extends2.default)({
      className: _PaginationSt.classes.pagination
    }, coreComponentDefaults, {
      previousLabel: previousLabel || coreComponentDefaults.previousLabel,
      nextLabel: nextLabel || coreComponentDefaults.nextLabel,
      onChange: onChange,
      totalPages: totalPages,
      currentPage: currentPage,
      maxPagesToShow: this._getMaxPagesToShow(),
      showNextLabel: currentPage !== totalPages,
      showPreviousLabel: currentPage !== 1,
      pageUrl: pageUrl,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 78,
        columnNumber: 9
      }
    })));
  }
}
exports.Pagination = Pagination;
Pagination.displayName = 'Pagination';
Pagination.propTypes = {
  dataHook: _propTypes.default.string,
  className: _propTypes.default.string,
  totalPages: _propTypes.default.number,
  currentPage: _propTypes.default.number,
  onChange: _propTypes.default.func,
  pageUrl: _propTypes.default.func
};
Pagination.defaultProps = {
  currentPage: 1
};
var _default = exports.default = (0, _Focusable.withFocusable)(Pagination);
//# sourceMappingURL=Pagination.js.map