import * as React from 'react';
import { PageStripLayout } from './constants';
export interface PageStripProps {
    id?: string;
    totalPages: number;
    currentPage: number;
    maxPagesToShow: number;
    showFirstPage: boolean;
    showLastPage: boolean;
    responsive: boolean;
    pageUrl?(pageNumber: number): string;
    gapLabel: React.ReactNode;
    onPageClick(event: React.MouseEvent, page: number): void;
    onPageKeyDown(event: React.KeyboardEvent, page: number): void;
    updateResponsiveLayout?(callback: () => void): void;
    disabled: boolean;
    className?: string;
}
export interface PageStripState {
    responsiveLayout: PageStripLayout | null;
}
export declare class PageStrip extends React.Component<PageStripProps, PageStripState> {
    private responsiveLayoutIsFresh;
    private unmounted;
    private rootNode;
    state: {
        responsiveLayout: null;
    };
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): React.JSX.Element;
    private forceRepaintInMsEdge;
    private renderLayout;
    private isResponsive;
    private getLayout;
    private updateLayoutIfNeeded;
}
//# sourceMappingURL=PageStrip.d.ts.map