"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.paginationCoreUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var paginationCoreUniDriverFactory = base => {
  var byDataHook = dataHook => base.$("[data-hook=\"".concat(dataHook, "\"]"));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** Check if element is rendered */
    isVisible: function () {
      var _isVisible = (0, _asyncToGenerator2.default)(function* () {
        return byDataHook(_constants.DataHooks.pageStrip).exists();
      });
      function isVisible() {
        return _isVisible.apply(this, arguments);
      }
      return isVisible;
    }(),
    /** Returns currently selected page */
    getCurrentPage: function () {
      var _getCurrentPage = (0, _asyncToGenerator2.default)(function* () {
        return parseInt(yield base.$("[data-hook~=".concat(_constants.DataHooks.currentPage, "]")).text(), 10);
      });
      function getCurrentPage() {
        return _getCurrentPage.apply(this, arguments);
      }
      return getCurrentPage;
    }(),
    /** Returns a total amount of pages available */
    getTotalPages: function () {
      var _getTotalPages = (0, _asyncToGenerator2.default)(function* () {
        return parseInt(yield byDataHook(_constants.DataHooks.totalPages).text(), 10);
      });
      function getTotalPages() {
        return _getTotalPages.apply(this, arguments);
      }
      return getTotalPages;
    }(),
    /** Clicks on gives page number */
    clickOnPage: function () {
      var _clickOnPage = (0, _asyncToGenerator2.default)(function* (n) {
        return byDataHook("page-".concat(n)).click();
      });
      function clickOnPage(_x) {
        return _clickOnPage.apply(this, arguments);
      }
      return clickOnPage;
    }(),
    /** Clicks on next button */
    clickNextButton: function () {
      var _clickNextButton = (0, _asyncToGenerator2.default)(function* () {
        return byDataHook(_constants.DataHooks.next).click();
      });
      function clickNextButton() {
        return _clickNextButton.apply(this, arguments);
      }
      return clickNextButton;
    }(),
    /** Clicks on previous button */
    clickPreviousButton: function () {
      var _clickPreviousButton = (0, _asyncToGenerator2.default)(function* () {
        return byDataHook(_constants.DataHooks.previous).click();
      });
      function clickPreviousButton() {
        return _clickPreviousButton.apply(this, arguments);
      }
      return clickPreviousButton;
    }()
  });
};
exports.paginationCoreUniDriverFactory = paginationCoreUniDriverFactory;
//# sourceMappingURL=PaginationCore.uni.driver.js.map