import { Simulate } from 'react-dom/test-utils';
export declare const popoverLegacyDriverFactory: ({ element, eventTrigger, }: {
    element: Element | undefined;
    eventTrigger: typeof Simulate;
}) => {
    /** Whether the element exists or not */
    exists: () => boolean;
    /** Returns the target element (`<Popover.Element/>`) */
    getTargetElement: () => Element | undefined;
    /** Returns the content element (`<Popover.Content/>`) */
    getContentElement: () => Element | null;
    /** Returns the arrow element */
    getArrowElement: () => Element | undefined;
    /** Returns `true` whether the target element (`<Popover.Element/>`) exists */
    isTargetElementExists: () => boolean;
    /** Returns `true` whether the content element (`<Popover.Content/>`) exists */
    isContentElementExists: () => boolean;
    /** Trigger `mouseEnter` on the element */
    mouseEnter: () => void | undefined;
    /** Trigger `mouseLeave` on the element */
    mouseLeave: () => void | undefined;
    /** Click on the element */
    click: () => void;
    /** Click outside the element */
    clickOutside: () => void;
    /** Returns the arrow offset */
    getArrowOffset: () => {
        top: any;
        left: any;
        right: any;
        bottom: any;
    };
    /** Returns the element's inline styles */
    inlineStyles: () => any;
    /** Returns the element's id */
    getElementId: () => string | undefined;
};
export type PopoverDriver = ReturnType<typeof popoverLegacyDriverFactory>;
//# sourceMappingURL=Popover.driver.d.ts.map