import { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
export declare const popoverUniDriverFactory: (base: UniDriver, body: UniDriver) => {
    /**
     * Clicks on the target element
     * @returns {Promise<void>}
     */
    click: () => Promise<void>;
    /**
     * Gets the target element
     * @returns {Promise<any>}
     */
    getTargetElement: () => Promise<any>;
    /**
     * Checks whether target element exists
     * @returns {Promise<boolean>}
     */
    isTargetElementExists: () => Promise<boolean>;
    /**
     * Gets the portal element
     * @returns {Promise<any>}
     */
    getPortalElement: () => Promise<any>;
    /**
     * Gets the content element
     * @returns {Promise<any>}
     */
    getContentElement: () => Promise<any>;
    /**
     * Checks whether content element exists
     * @returns {Promise<boolean>}
     */
    isContentElementExists: () => Promise<boolean>;
    /**
     * Triggers a mouseEnter event
     * @returns {Promise<void>}
     */
    mouseEnter: () => Promise<void>;
    /**
     * Triggers a mouseLeave event
     * @returns {Promise<void>}
     */
    mouseLeave: () => Promise<void>;
    /**
     * Clicks outside the target element (triggers mouseDown and mouseUp events)
     * @returns {Promise<void>}
     */
    clickOutside: () => Promise<void>;
    /**
     * Gets the arrow offset
     * @returns {Promise<any>}
     */
    getArrowOffset: () => Promise<any>;
    /**
     * Gets content as unidriver element
     * @private
     */
    getContentElementUniDriver: () => Promise<UniDriver<any>>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
};
export type PopoverUniDriver = ReturnType<typeof popoverUniDriverFactory>;
//# sourceMappingURL=Popover.uni.driver.d.ts.map