export default PreviewWidget;
/** Preview content widget*/
declare class PreviewWidget extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Applies a data-hook HTML attribute to be used in the tests*/
        dataHook: PropTypes.Requireable<string>;
        /** Applies a CSS class to the component's root element */
        className: PropTypes.Requireable<string>;
        /** Sets the color of the content area background (`neutral` or `gradient`). To use custom skin color, set it to `custom` and use the `backgroundColor` prop*/
        skin: PropTypes.Requireable<string>;
        /** Sets content area background color in HEX code. Can be set with custom colors (from WSR design system color palette) */
        backgroundColor: PropTypes.Requireable<string>;
        /** Sets the content outline as `shadow` (default), `border` or `none`*/
        contentOutline: PropTypes.Requireable<string>;
        /** Adjusts the height of the component or can be set in specific % or px */
        height: PropTypes.Requireable<string>;
        /** Sets the width of the component in % or px */
        width: PropTypes.Requireable<string>;
        /** Sets the main preview content. Accepts an image, text paragraph or any other custom element */
        children: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
        /** Enables vertical scroll of the overflowed content **/
        scrollable: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        skin: string;
        contentOutline: string;
        height: string;
        width: string;
        scrollable: boolean;
        children: React.JSX.Element;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=PreviewWidget.d.ts.map