"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.radarChartDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var radarChartDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /** Returns the number of scale circles */
    getScaleLinesCount: () => (0, _unidriver.countByHook)(base, _constants.dataHooks.radarChartScaleLine),
    /** Returns the number of data item points */
    getDataItemsCount: () => (0, _unidriver.countByHook)(base, _constants.dataHooks.radarChartDataItem),
    /** Checks whether the component is in the disabled state */
    isDisabled: function () {
      var _isDisabled = (0, _asyncToGenerator2.default)(function* () {
        return (yield (0, _unidriver.getDataAttributeValue)(base, 'data-disabled')) === 'true';
      });
      function isDisabled() {
        return _isDisabled.apply(this, arguments);
      }
      return isDisabled;
    }(),
    getHoverIndex: function () {
      var _getHoverIndex = (0, _asyncToGenerator2.default)(function* () {
        return yield (0, _unidriver.getDataAttributeValue)(base, 'data-hover-index');
      });
      function getHoverIndex() {
        return _getHoverIndex.apply(this, arguments);
      }
      return getHoverIndex;
    }()
  });
};
exports.radarChartDriverFactory = radarChartDriverFactory;
//# sourceMappingURL=RadarChart.uni.driver.js.map