"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _RadioSt = require("./Radio.st.css");
var _Text = _interopRequireDefault(require("../Text"));
var _generateDataAttr = require("../utils/generateDataAttr");
var _generateId = require("../utils/generateId");
var _constants = require("./constants");
var _Focusable = require("../common/Focusable");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Radio/Radio.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Radio = _ref => {
  var {
    dataHook,
    checked = false,
    disabled = false,
    label,
    id,
    name,
    value,
    focusableOnFocus,
    focusableOnBlur,
    onChange = () => null,
    onMouseEnter = () => null,
    onMouseLeave = () => null,
    alignItems = 'center',
    className,
    style
  } = _ref;
  var defaultId = (0, _generateId.generateID)();
  var _onClick = event => {
    if (!disabled && !checked) {
      onChange(_objectSpread({
        value
      }, event));
    }
  };
  var _onMouseEnter = event => {
    if (!disabled) {
      onMouseEnter(event);
    }
  };
  var _onMouseLeave = event => {
    if (!disabled) {
      onMouseLeave(event);
    }
  };
  var renderLabel = (0, _react.useMemo)(() => {
    return /*#__PURE__*/_react.default.createElement(_Text.default, {
      tagName: "div",
      size: "medium",
      weight: "thin",
      secondary: true,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 7
      }
    }, label);
  }, [label]);
  var radioId = id || defaultId;
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: (0, _RadioSt.st)(_RadioSt.classes.root, {
      checked,
      disabled,
      alignItems
    }, className)
  }, (0, _generateDataAttr.generateDataAttr)({
    checked,
    disabled
  }, ['checked', 'disabled']), {
    style: style,
    "data-hook": dataHook,
    onClick: _onClick,
    onMouseEnter: _onMouseEnter,
    onMouseLeave: _onMouseLeave,
    "aria-checked": !!checked,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react.default.createElement("input", {
    type: "radio",
    className: _RadioSt.classes.input,
    "data-hook": _constants.dataHooks.input,
    disabled: disabled,
    checked: checked,
    value: value,
    name: name,
    id: radioId,
    onChange: () => null,
    onFocus: focusableOnFocus,
    onBlur: focusableOnBlur,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 75,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement("span", {
    className: _RadioSt.classes.icon,
    "data-hook": _constants.dataHooks.icon,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 88,
      columnNumber: 7
    }
  }), label && /*#__PURE__*/_react.default.createElement("label", {
    className: _RadioSt.classes.label,
    "data-hook": _constants.dataHooks.label,
    htmlFor: radioId,
    onClick: e => e.stopPropagation(),
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 90,
      columnNumber: 9
    }
  }, renderLabel));
};
Radio.displayName = 'Radio';
Radio.propTypes = {
  /** Applies a data-hook HTML attribute that can be used in tests */
  dataHook: _propTypes.default.string,
  /** Specifies a CSS class name to be appended to the component’s root element */
  className: _propTypes.default.string,
  /** Specifies whether a radio is selected */
  checked: _propTypes.default.bool,
  /** Specifies whether radio should be disabled */
  disabled: _propTypes.default.bool,
  /** Sets the label on the right side of a radio. The default accepted value is a text string, but it can be overridden to any other component. */
  label: _propTypes.default.node,
  /** Sets a unique name for the radio */
  name: _propTypes.default.node,
  /** Assigns an unique identifier for the radio */
  id: _propTypes.default.string,
  /** Sets the value that the radio represents */
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  /** Defines a callback function which is called when radio is selected */
  onChange: _propTypes.default.func,
  /** Defines a callback function which is called when cursor enters radio */
  onMouseEnter: _propTypes.default.func,
  /** Defines a callback function which is called when cursor leaves radio */
  onMouseLeave: _propTypes.default.func,
  /** Control radio alignment with a label */
  alignItems: _propTypes.default.oneOf(['top', 'center'])
};
var _default = exports.default = (0, _Focusable.withFocusable)(Radio);
//# sourceMappingURL=Radio.js.map