"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.radioUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var radioUniDriverFactory = (base, body) => {
  var byHook = hook => base.$("[data-hook=\"".concat(hook, "\"]"));
  var getInput = () => byHook(_constants.dataHooks.input);
  var getIcon = () => byHook(_constants.dataHooks.icon);
  var _getLabel = () => byHook(_constants.dataHooks.label);
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Triggers a keyDown event on the radio input
     * @param {string} key
     * @return {Promise<void>}
     */
    keyDown: key => getInput().pressKey(key),
    /**
     * Gets value of radio input
     * @return {Promise<string>}
     */
    getValue: () => getInput().attr('value'),
    /**
     * Gets name of radio input
     * @return {Promise<string>}
     */
    getName: () => getInput().attr('name'),
    /**
     * Gets id of radio input
     * @return {Promise<string>}
     */
    getId: () => getInput().attr('id'),
    /**
     * Gets label text of radio
     * @return {Promise<string>}
     */
    getLabel: () => _getLabel().text(),
    /**
     * Checks if icon of radio exists
     * @return {Promise<boolean>}
     */
    iconExists: () => getIcon().exists(),
    /**
     * Checks if label of radio exists
     * @return {Promise<boolean>}
     */
    labelExists: () => _getLabel().exists(),
    /**
     * Checks if radio is checked
     * @return {Promise<boolean>}
     */
    isChecked: function () {
      var _isChecked = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-checked')) === 'true';
      });
      function isChecked() {
        return _isChecked.apply(this, arguments);
      }
      return isChecked;
    }(),
    /**
     * Checks if radio is disabled
     * @return {Promise<boolean>}
     */
    isDisabled: function () {
      var _isDisabled = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-disabled')) === 'true';
      });
      function isDisabled() {
        return _isDisabled.apply(this, arguments);
      }
      return isDisabled;
    }(),
    /**
     * Triggers a mouseEnter event
     * @return {Promise<void>}
     */
    mouseEnter: () => base.hover(),
    /**
     * Triggers a mouseLeave event
     * @return {Promise<void>}
     */
    mouseLeave: () => base.mouse.leave()
  });
};
exports.radioUniDriverFactory = radioUniDriverFactory;
//# sourceMappingURL=Radio.uni.driver.js.map