declare namespace _default {
    export { hasStyle };
    export { hasBlockType };
    export { hasEntity };
    export { hasRemovableEntityInSelection };
    export { toggleStyle };
    export { toggleBlockType };
    export { toggleLink };
    export { getSelectedText };
    export { findLinkEntities };
    export { convertToHtml };
    export { isEditorFocused };
    export { isEditorEmpty };
}
export default _default;
/** Returns whether the specified style is applied on a block */
declare function hasStyle(editorState: any, style: any): any;
/** Returns whether a block with the specified type exists */
declare function hasBlockType(editorState: any, blockType: any): boolean;
/** Returns whether the specified entity is applied on a block */
declare function hasEntity(editorState: any, entity: any): boolean;
/** Returns whether the block of the selected text is linked to an entity */
declare function hasRemovableEntityInSelection(editorState: any): boolean;
/** Returns an EditorState so that the specified style is toggled on the selection */
declare function toggleStyle(editorState: any, toggledStyle: any): any;
/** Returns an EditorState so that the specified block type is toggled on the selection */
declare function toggleBlockType(editorState: any, toggledBlockType: any): any;
declare function toggleLink(editorState: any, linkData: any): any;
declare function getSelectedText(editorState: any): any;
declare function findLinkEntities(contentBlock: any, callback: any, contentState: any): void;
declare function convertToHtml(editorState: any): string;
declare function isEditorFocused(editorState: any): any;
/** Returns true in case the editor's content does not contain any block which has a non-default type or text.
    It means that if the user changes the block type before entering any text, the content will be considered as non-empty.
 */
declare function isEditorEmpty(editorState: any): boolean;
//# sourceMappingURL=EditorUtilities.d.ts.map