"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));
var _constants = require("./constants");
var sectionHelperDriverFactory = _ref => {
  var {
    element
  } = _ref;
  var hasAppearance = appearance => element.dataset.appearance === appearance;
  var byHook = hook => element.querySelector("[data-hook=\"".concat(hook, "\"]"));
  var getCloseButton = () => byHook('sectionhelper-close-btn');
  var getActionButton = () => byHook('sectionhelper-action-btn');
  return {
    exists: () => !!element,
    titleText: () => byHook('sectionhelper-title').textContent,
    actionText: () => getActionButton().textContent,
    clickAction: () => {
      _testUtils.default.Simulate.click(getActionButton());
    },
    clickClose: () => {
      _testUtils.default.Simulate.click(getCloseButton());
    },
    isCloseButtonDisplayed: () => !!getCloseButton(),
    textContent: () => element.textContent,
    isWarning: () => hasAppearance(_constants.Appearance.Warning),
    isStandard: () => hasAppearance(_constants.Appearance.Standard),
    isDanger: () => hasAppearance(_constants.Appearance.Danger),
    isExperimentalDark: () => hasAppearance(_constants.Appearance.ExperimentalDark),
    isSuccess: () => hasAppearance(_constants.Appearance.Success),
    isPremium: () => hasAppearance(_constants.Appearance.Premium),
    isPreview: () => hasAppearance(_constants.Appearance.Preview)
  };
};
var _default = exports.default = sectionHelperDriverFactory;
//# sourceMappingURL=SectionHelper.driver.js.map