"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.sectionHelperUniDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _ButtonUni = require("../Button/Button.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var sectionHelperUniDriverFactory = base => {
  var actionButtonDriver = () => (0, _ButtonUni.buttonDriverFactory)(base.$('[data-hook="sectionhelper-action-btn"]'));
  var closeButtonDriver = () => (0, _ButtonUni.buttonDriverFactory)(base.$('[data-hook="sectionhelper-close-btn"]'));
  var hasAppearance = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)(function* (appearance) {
      return (yield base.attr('data-appearance')) === appearance;
    });
    return function hasAppearance(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Gets the title text
     * @return {Promise<string>}
     */
    titleText: () => base.$('[data-hook="sectionhelper-title"]').text(),
    /**
     * Gets the action text
     * @return {Promise<string>}
     */
    actionText: () => actionButtonDriver().getButtonTextContent(),
    /**
     * Clicks the action
     * @return {Promise<void>}
     */
    clickAction: () => actionButtonDriver().click(),
    /**
     * Clicks the close button
     * @return {Promise<void>}
     */
    clickClose: () => closeButtonDriver().click(),
    /**
     * Checks whether the close button is displayed
     * @return {Promise<boolean>}
     */
    isCloseButtonDisplayed: () => closeButtonDriver().exists(),
    /**
     * Gets the text content
     * @return {Promise<string>}
     */
    textContent: () => base.text(),
    /**
     * Checks whether the component appears as "warning"
     * @return {Promise<boolean>}
     */
    isWarning: () => hasAppearance(_constants.Appearance.Warning),
    /**
     * Checks whether the component appears as "standard"
     * @return {Promise<boolean>}
     */
    isStandard: () => hasAppearance(_constants.Appearance.Standard),
    /**
     * Checks whether the component appears as "danger"
     * @return {Promise<boolean>}
     */
    isDanger: () => hasAppearance(_constants.Appearance.Danger),
    /**
     * Checks whether the component appears as "experimentalDark"
     * @return {Promise<boolean>}
     */
    isExperimentalDark: () => hasAppearance(_constants.Appearance.ExperimentalDark),
    /**
     * Checks whether the component appears as "success"
     * @return {Promise<boolean>}
     */
    isSuccess: () => hasAppearance(_constants.Appearance.Success),
    /**
     * Checks whether the component appears as "premium"
     * @return {Promise<boolean>}
     */
    isPremium: () => hasAppearance(_constants.Appearance.Premium),
    /**
     * Checks whether the component appears as "preview"
     * @return {Promise<boolean>}
     */
    isPreview: () => hasAppearance(_constants.Appearance.Preview)
  });
};
exports.sectionHelperUniDriverFactory = sectionHelperUniDriverFactory;
//# sourceMappingURL=SectionHelper.uni.driver.js.map