"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.selectableAccordionDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _utils = require("./utils");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var selectableAccordionDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Clicks the item by item index
     * @param {number} idx Item index
     * @returns {Promise<void>} Title at item index
     */
    clickItemAt: function () {
      var _clickItemAt = (0, _asyncToGenerator2.default)(function* (idx) {
        var item = yield (0, _utils.getItemAt)(base, idx);
        return (0, _unidriver.findByHook)(item, _constants.dataHooks.itemHeader).click();
      });
      function clickItemAt(_x) {
        return _clickItemAt.apply(this, arguments);
      }
      return clickItemAt;
    }(),
    /**
     * Checks whether the item is expanded by item index
     * @param {number} idx Item index
     * @returns {Promise<boolean>} Title at item index
     */
    isItemExpandedAt: function () {
      var _isItemExpandedAt = (0, _asyncToGenerator2.default)(function* (idx) {
        var item = yield (0, _utils.getItemAt)(base, idx);
        var itemState = yield (0, _unidriver.getDataAttributeValue)(item, _constants.dataAttr.STATE);
        return itemState === 'open';
      });
      function isItemExpandedAt(_x2) {
        return _isItemExpandedAt.apply(this, arguments);
      }
      return isItemExpandedAt;
    }(),
    /**
     * Checks whether the item is disabled by item index
     * @param {number} idx Item index
     * @returns {Promise<boolean>}
     */
    isItemDisabledAt: function () {
      var _isItemDisabledAt = (0, _asyncToGenerator2.default)(function* (idx) {
        var item = yield (0, _utils.getItemAt)(base, idx);
        var itemState = yield (0, _unidriver.getDataAttributeValue)(item, _constants.dataAttr.DISABLED);
        return itemState === 'true';
      });
      function isItemDisabledAt(_x3) {
        return _isItemDisabledAt.apply(this, arguments);
      }
      return isItemDisabledAt;
    }()
  });
};
exports.selectableAccordionDriverFactory = selectableAccordionDriverFactory;
//# sourceMappingURL=SelectableAccordion.uni.driver.js.map