export default Selector;
declare class Selector extends React.PureComponent<any, any, any> {
    static propTypes: {
        /** Applied as data-hook HTML attribute that can be used in the tests */
        dataHook: PropTypes.Requireable<string>;
        id: PropTypes.Validator<NonNullable<NonNullable<string | number | null | undefined>>>;
        image: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        size: PropTypes.Requireable<string>;
        imageSize: PropTypes.Requireable<string>;
        imageShape: PropTypes.Requireable<string>;
        hasDivider: PropTypes.Requireable<boolean>;
        title: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
        isSelected: PropTypes.Requireable<boolean>;
        isDisabled: PropTypes.Requireable<boolean>;
        indeterminate: PropTypes.Requireable<boolean>;
        subtitle: PropTypes.Requireable<string>;
        extraNode: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        onToggle: PropTypes.Requireable<(...args: any[]) => any>;
        toggleType: PropTypes.Requireable<string>;
        showBelowNodeOnSelect: PropTypes.Requireable<boolean>;
        belowNode: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        subtitleNode: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
    };
    static defaultProps: {
        isSelected: boolean;
        isDisabled: boolean;
        toggleType: string;
        size: string;
        imageSize: string;
        imageShape: string;
        hasDivider: boolean;
        onToggle: (i: any) => any;
        showBelowNodeOnSelect: boolean;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    _onClick: () => any;
    render(): React.JSX.Element;
}
declare namespace Selector {
    export { ExtraText };
    export { ProgressBar };
}
import React from 'react';
import PropTypes from 'prop-types';
import ExtraText from './ExtraText';
import ProgressBar from './ProgressBar';
//# sourceMappingURL=Selector.d.ts.map