"use strict";

var _reactHooks = require("@testing-library/react-hooks");
var _useId = require("./useId");
describe('useId', () => {
  it('should return a string', () => {
    var {
      result
    } = (0, _reactHooks.renderHook)(() => (0, _useId.useId)());
    expect(typeof result.current).toBe('string');
  });
  it('should return unique id', () => {
    var {
      result: result1
    } = (0, _reactHooks.renderHook)(() => (0, _useId.useId)());
    var {
      result: result2
    } = (0, _reactHooks.renderHook)(() => (0, _useId.useId)());
    expect(result1.current).not.toBe(result2.current);
  });
  it('should return an id with the given prefix', () => {
    var prefix = 'test';
    var {
      result
    } = (0, _reactHooks.renderHook)(() => (0, _useId.useId)(prefix));
    expect(result.current.startsWith(prefix)).toBe(true);
  });
});
//# sourceMappingURL=useId.test.js.map