"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _SidePanelSt = require("./SidePanel.st.css");
var _Header = _interopRequireDefault(require("./Header"));
var _Content = _interopRequireDefault(require("./Content"));
var _Footer = _interopRequireDefault(require("./Footer"));
var _Divider = _interopRequireDefault(require("./Divider"));
var _SidePanelAPI = require("./SidePanelAPI");
var _Section = _interopRequireDefault(require("./Section"));
var _Field = _interopRequireDefault(require("./Field"));
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/SidePanel/SidePanel.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class SidePanel extends _react.PureComponent {
  render() {
    var {
      dataHook,
      skin = 'standard',
      children,
      className,
      width,
      height,
      maxHeight,
      onCloseButtonClick,
      onHelpButtonClick,
      draggable
    } = this.props;
    var isDraggable = draggable && skin === 'floating';
    return /*#__PURE__*/_react.default.createElement(_SidePanelAPI.SidePanelContext.Provider, {
      value: {
        onCloseButtonClick,
        onHelpButtonClick,
        skin,
        isDraggable
      },
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 56,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _SidePanelSt.st)(_SidePanelSt.classes.root, {
        skin
      }, className),
      "data-hook": dataHook,
      style: {
        width,
        height,
        maxHeight
      },
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 59,
        columnNumber: 9
      }
    }, children));
  }
}
SidePanel.displayName = 'SidePanel';
SidePanel.Header = _Header.default;
SidePanel.Content = _Content.default;
SidePanel.Footer = _Footer.default;
SidePanel.Divider = _Divider.default;
SidePanel.Section = _Section.default;
SidePanel.Field = _Field.default;
SidePanel.propTypes = {
  className: _propTypes.default.string,
  dataHook: _propTypes.default.string,
  onCloseButtonClick: _propTypes.default.func,
  onHelpButtonClick: _propTypes.default.func,
  children: _propTypes.default.node,
  width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  maxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  skin: _propTypes.default.oneOf(['standard', 'floating']),
  draggable: _propTypes.default.bool
};
SidePanel.defaultProps = {
  width: '420px',
  height: '100%'
};
var _default = exports.default = SidePanel;
//# sourceMappingURL=SidePanel.js.map