"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.sidePanelDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _DividerUni = require("../Divider/Divider.uni.driver");
var _CloseButtonUni = require("../CloseButton/CloseButton.uni.driver");
var _HeadingUni = require("../Heading/Heading.uni.driver");
var _InfoIconUni = require("../InfoIcon/InfoIcon.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var sidePanelDriverFactory = (base, body) => {
  var headerTitle = (0, _HeadingUni.headingUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderTitle, "\"]")));
  var headerSubtitle = (0, _HeadingUni.headingUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderSubtitle, "\"]")));
  var headerTitleInfoIcon = (0, _InfoIconUni.infoIconDriverFactory)(base, body, {
    dataHook: _constants.dataHooks.sidePanelHeaderTitleInfoIcon
  });
  var headerDividerDriver = (0, _DividerUni.dividerDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderDivider, "\"]")));
  var footerDividerDriver = (0, _DividerUni.dividerDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderDivider, "\"]")));
  var closeButtonDriver = (0, _CloseButtonUni.closeButtonDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderCloseButton, "\"]")));
  var helpButtonDriver = (0, _CloseButtonUni.closeButtonDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.sidePanelHeaderHelpButton, "\"]")));
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** Click help the button */
    clickHelp: () => helpButtonDriver.click(),
    /** Click close the button */
    clickClose: () => closeButtonDriver.click(),
    /** Get title text */
    getTitleText: () => headerTitle.getText(),
    /** Get subtitle text */
    getSubtitleText: () => headerSubtitle.getText(),
    /** Get tooltip text */
    getTooltipContent: () => headerTitleInfoIcon.getContent(),
    /** Check if header divider exists */
    isHeaderDividerExists: () => headerDividerDriver.exists(),
    /** Check if close button exists */
    isCloseButtonExists: () => closeButtonDriver.exists(),
    /** Check if help button exists */
    isHelpButtonExists: () => helpButtonDriver.exists(),
    /** Check if footer divider exists */
    isFooterDividerExists: () => footerDividerDriver.exists()
  });
};
exports.sidePanelDriverFactory = sidePanelDriverFactory;
//# sourceMappingURL=SidePanel.uni.driver.js.map