"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SidebarContentWrapper = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _SidebarSt = require("./Sidebar.st.css");
var _constants = require("./constants");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Sidebar/SidebarContentWrapper.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/** A sidebar content children wrapper to add gradient  */
class SidebarContentWrapper extends _react.Component {
  constructor(props) {
    super(props);
    this._handleChildrenResize = () => {
      this._shouldAddGradient();
    };
    this.childrenContainerRef = /*#__PURE__*/_react.default.createRef();
    this.childrenContentRef = /*#__PURE__*/_react.default.createRef();
    this.state = {
      isScrollbarDisplayed: false
    };
    this.childrenResizeObserver = typeof window !== 'undefined' && 'ResizeObserver' in window && new ResizeObserver(this._handleChildrenResize);
  }
  componentDidMount() {
    this._shouldAddGradient();
    var {
      childrenResizeObserver,
      childrenContainerRef,
      childrenContentRef
    } = this;
    if (childrenResizeObserver && childrenContainerRef.current) {
      childrenResizeObserver.observe(childrenContainerRef.current);
    }
    if (childrenResizeObserver && childrenContentRef.current) {
      childrenResizeObserver.observe(childrenContentRef.current);
    }
  }
  componentWillUnmount() {
    var {
      childrenResizeObserver,
      childrenContainerRef,
      childrenContentRef
    } = this;
    if (childrenResizeObserver && childrenContainerRef.current) {
      childrenResizeObserver.unobserve(childrenContainerRef.current);
    }
    if (childrenResizeObserver && childrenContentRef.current) {
      childrenResizeObserver.unobserve(childrenContentRef.current);
    }
  }
  _shouldAddGradient() {
    var {
      scrollHeight,
      clientHeight
    } = this.childrenContainerRef.current;
    this.setState({
      isScrollbarDisplayed: scrollHeight > clientHeight
    });
  }
  render() {
    var {
      skin,
      containerClasses,
      children,
      containerDataHook
    } = this.props;
    var css = _objectSpread(_objectSpread({}, _SidebarSt.classes), {}, {
      containerClasses
    });
    var gradientClasses = (0, _SidebarSt.st)(_SidebarSt.classes.gradient, {
      skin
    });
    return /*#__PURE__*/_react.default.createElement("div", {
      className: css.containerClasses,
      ref: this.childrenContainerRef,
      "data-hook": containerDataHook,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 80,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: css.childrenContent,
      ref: this.childrenContentRef,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 85,
        columnNumber: 9
      }
    }, children), this.state.isScrollbarDisplayed && /*#__PURE__*/_react.default.createElement("div", {
      className: gradientClasses,
      "data-hook": _constants.dataHooks.scrollBarGradient,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 89,
        columnNumber: 11
      }
    }));
  }
}
exports.SidebarContentWrapper = SidebarContentWrapper;
SidebarContentWrapper.propTypes = {
  skin: _propTypes.default.oneOf(['dark', 'light']),
  containerDataHook: _propTypes.default.string,
  containerClasses: _propTypes.default.string,
  children: _propTypes.default.node
};
SidebarContentWrapper.defaultProps = {
  skin: _constants.sidebarSkins.dark
};
//# sourceMappingURL=SidebarContentWrapper.js.map