"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.sidebarItemNextDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _SidebarItemButtonNextUni = require("./SidebarItemButtonNext.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var sidebarItemNextDriverFactory = (base, body) => {
  // SidebarItemNext is just a small wrapper for SidebarItemButtonNext, so we
  // reuse SidebarItemButtonNext driver.
  // We can't simply spread the driver because `findByHook` might become async
  // in the near future and the driver factory itself is sync.

  var getButtonDriver = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)(function* () {
      var button = yield (0, _unidriver.findByHook)(base, _constants.dataHooks.button);
      return (0, _SidebarItemButtonNextUni.sidebarItemButtonNextDriverFactory)(button, body);
    });
    return function getButtonDriver() {
      return _ref.apply(this, arguments);
    };
  }();
  var getButtonDriverMethod = methodName => /*#__PURE__*/(0, _asyncToGenerator2.default)(function* () {
    var buttonDriver = yield getButtonDriver();
    return buttonDriver[methodName](...arguments);
  });
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    click: getButtonDriverMethod('click'),
    isSelected: getButtonDriverMethod('isSelected'),
    isDisabled: getButtonDriverMethod('isDisabled'),
    suffixExists: getButtonDriverMethod('suffixExists'),
    getSuffixCount: getButtonDriverMethod('getSuffixCount'),
    prefixExists: getButtonDriverMethod('prefixExists'),
    getSkin: getButtonDriverMethod('getSkin'),
    getText: getButtonDriverMethod('getText')
  });
};
exports.sidebarItemNextDriverFactory = sidebarItemNextDriverFactory;
//# sourceMappingURL=SidebarItemNext.uni.driver.js.map