"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.sliderUniDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _TooltipUni = require("../Tooltip/Tooltip.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var sliderUniDriverFactory = (base, body) => {
  var $sliderHandles = () => base.$$("[data-hook=\"".concat(_constants.dataHooks.sliderHandle, "\"]"));
  var $sliderDots = () => base.$$('.wsr-slider-dot');
  var $sliderMarks = () => base.$$("[data-hook=\"".concat(_constants.dataHooks.sliderMarkLabel, "\"]"));
  var getTooltipDriver = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)(function* (index) {
      var sliderDataHook = yield base.attr('data-hook');
      var tooltipDataHook = sliderDataHook ? "".concat(sliderDataHook, "-").concat(_constants.dataHooks.sliderTooltip, "-").concat(index) : "".concat(_constants.dataHooks.sliderTooltip, "-").concat(index);
      return (0, _TooltipUni.tooltipDriverFactory)(base.$("[data-hook=\"".concat(tooltipDataHook, "\"]")), body);
    });
    return function getTooltipDriver(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /** returns true if slider grade is selected */
    isDotSelected: number => $sliderDots().get(number - 1).hasClass('wsr-slider-dot-active'),
    /** returns number of slider grades */
    numOfSliderDots: () => $sliderDots().count(),
    /** returns number of slider handles */
    numOfSliderHandles: () => $sliderHandles().count(),
    /** returns number of slider marks labels */
    numOfSliderMarksLabels: () => $sliderMarks().count(),
    /** returns slider tooltip value */
    getToolTipValue: function () {
      var _getToolTipValue = (0, _asyncToGenerator2.default)(function* (index) {
        var tooltipDriver = yield getTooltipDriver(index);
        var text = null;
        try {
          text = yield tooltipDriver.getTooltipText();
        } catch (_unused) {}
        return text;
      });
      function getToolTipValue(_x2) {
        return _getToolTipValue.apply(this, arguments);
      }
      return getToolTipValue;
    }(),
    /** returns if the slider is disabled */
    isDisabled: function () {
      var _isDisabled = (0, _asyncToGenerator2.default)(function* () {
        return !!(yield base.$('.wsr-slider-disabled'));
      });
      function isDisabled() {
        return _isDisabled.apply(this, arguments);
      }
      return isDisabled;
    }(),
    /** returns direction either horizontal or vertical */
    getDirection: function () {
      var _getDirection = (0, _asyncToGenerator2.default)(function* () {
        return base.attr('data-direction');
      });
      function getDirection() {
        return _getDirection.apply(this, arguments);
      }
      return getDirection;
    }()
  });
};
exports.sliderUniDriverFactory = sliderUniDriverFactory;
//# sourceMappingURL=Slider.uni.driver.js.map