"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rcSlider = require("rc-slider");
var _Focusable = require("../common/Focusable");
var _constants = require("./constants");
var _SliderSt = require("./Slider.st.css");
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _utils = require("./utils");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Slider/SliderHandle.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var SliderHandle = _ref => {
  var {
    tooltipValue,
    className,
    onFocusCustom = () => {},
    onBlurCustom = () => {},
    focusableOnFocus,
    focusableOnBlur,
    disabled,
    handleProps,
    displayTooltip = true,
    index,
    dataHook,
    direction,
    gradientColor,
    ariaLabelledBy
  } = _ref;
  var {
    min,
    max,
    value
  } = handleProps;
  var gradientValue = (value - min) / (max - min);
  var [hovered, setHovered] = (0, _react.useState)(false);
  var tooltipRef = _react.default.useRef(null);
  var handleMouseEnter = () => {
    setHovered(true);
  };
  var handleMouseLeave = () => {
    setHovered(false);
  };
  var handleOnFocus = event => {
    focusableOnFocus();
    tooltipRef.current.open();
    onFocusCustom(Number(tooltipValue), event);
  };
  var handleOnBlur = event => {
    focusableOnBlur();
    tooltipRef.current.close();
    onBlurCustom(Number(tooltipValue), event);
  };
  var tooltipDataHook = dataHook ? "".concat(dataHook, "-").concat(_constants.dataHooks.sliderTooltip, "-").concat(index) : "".concat(_constants.dataHooks.sliderTooltip, "-").concat(index);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _SliderSt.st)(_SliderSt.classes.sliderHandleWrapper, {}, className),
    onBlur: handleOnBlur,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(_rcSlider.Handle, (0, _extends2.default)({}, handleProps, {
    vertical: direction === 'vertical',
    onFocus: handleOnFocus,
    className: (0, _SliderSt.st)(_SliderSt.classes.sliderHandle, {
      disabled
    }),
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    "data-hook": _constants.dataHooks.sliderHandle,
    ariaLabelledBy: ariaLabelledBy,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 61,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    ref: tooltipRef,
    className: _SliderSt.classes.sliderHandleTooltip,
    disabled: !displayTooltip || disabled || !tooltipValue,
    content: tooltipValue,
    moveBy: !!gradientColor ? {
      y: 3.5
    } : {
      y: 3
    },
    dataHook: tooltipDataHook,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 71,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _SliderSt.st)(_SliderSt.classes.sliderThumb, {
      hovered,
      hasGradient: !!gradientColor
    }),
    style: (0, _utils.getThumbStyle)({
      gradientColor,
      alpha: gradientValue,
      disabled
    }),
    "data-hook": _constants.dataHooks.sliderThumb,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 79,
      columnNumber: 11
    }
  }))));
};
SliderHandle.propTypes = {
  onFocusCustom: _propTypes.default.func,
  onBlurCustom: _propTypes.default.func,
  disabled: _propTypes.default.bool,
  displayTooltip: _propTypes.default.bool,
  tooltipValue: _propTypes.default.string,
  index: _propTypes.default.number,
  dataHook: _propTypes.default.string,
  gradientColor: _propTypes.default.string,
  handleProps: _propTypes.default.shape({
    ref: _propTypes.default.func.isRequired,
    offset: _propTypes.default.number.isRequired,
    min: _propTypes.default.number.isRequired,
    max: _propTypes.default.number.isRequired,
    value: _propTypes.default.number.isRequired,
    reverse: _propTypes.default.bool,
    ariaLabel: _propTypes.default.string
  }),
  direction: _propTypes.default.oneOf(['horizontal', 'vertical'])
};
var _default = exports.default = (0, _Focusable.withFocusable)(SliderHandle);
//# sourceMappingURL=SliderHandle.js.map