"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.starsRatingBarDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var starsRatingBarDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Selects a star rating bar value
     * @param {number} rating- The rating of that we want to select (a number between 1 to 5)
     * @returns {Promise<void>}
     */
    selectRating: function () {
      var _selectRating = (0, _asyncToGenerator2.default)(function* (rating) {
        return base.$("[data-index=\"".concat(rating, "\"]")).click();
      });
      function selectRating(_x) {
        return _selectRating.apply(this, arguments);
      }
      return selectRating;
    }(),
    /**
     * Gets the selected rating (a number between 0 to 5)
     * @returns {Promise<number>}
     */
    getSelectedRating: function () {
      var _getSelectedRating = (0, _asyncToGenerator2.default)(function* () {
        return (0, _unidriver.countByHook)(base, _constants.dataHooks.filledStar);
      });
      function getSelectedRating() {
        return _getSelectedRating.apply(this, arguments);
      }
      return getSelectedRating;
    }()
  });
};
exports.starsRatingBarDriverFactory = starsRatingBarDriverFactory;
//# sourceMappingURL=StarsRatingBar.uni.driver.js.map