"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _StatisticsItem = _interopRequireDefault(require("./StatisticsItem"));
var _StatisticsWidgetSt = require("./StatisticsWidget.st.css");
var _constants = require("./constants");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/StatisticsWidget/StatisticsWidget.js";
class StatisticsWidget extends _react.default.PureComponent {
  constructor() {
    super(...arguments);
    this._renderStat = (stat, key) => {
      var {
        size,
        alignItems,
        isLoading
      } = this.props;
      return /*#__PURE__*/_react.default.createElement(_StatisticsItem.default, (0, _extends2.default)({}, stat, {
        isLoading: isLoading,
        key: key,
        size: size,
        alignItems: alignItems,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 54,
          columnNumber: 7
        }
      }));
    };
  }
  render() {
    var {
      dataHook,
      size
    } = this.props;
    var {
      items
    } = this.props;
    items = items || [];
    if (items.length > 5) {
      // eslint-disable-next-line
      console.warn("".concat(items.length, " items were passed in items array. StatisticsWidget will display only the first 5."));
    }
    var firstFive = items.slice(0, 5);
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _StatisticsWidgetSt.st)(_StatisticsWidgetSt.classes.root, {
        size
      }),
      "data-hook": dataHook,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 79,
        columnNumber: 7
      }
    }, firstFive.map(this._renderStat));
  }
}
StatisticsWidget.displayName = 'StatisticsWidget';
StatisticsWidget.defaultProps = {
  size: _constants.SIZES.tiny
};
StatisticsWidget.propTypes = {
  /** Applied as data-hook HTML attribute that can be used to create driver in testing */
  dataHook: _propTypes.default.string,
  /** Displayed value size (default: large) */
  size: _propTypes.default.oneOf(['tiny', 'large']),
  /** Alignment of inner items (default: center) */
  alignItems: _propTypes.default.oneOf(['start', 'center', 'end']),
  /** Show loader instead of values for all statistic items (default: undefined) */
  isLoading: _propTypes.default.bool,
  /**
   * Array of statistic items
   *  * `value` - Value of the statistic. Displayed as big text in the first row.
   *  * `valueInShort` - Short version of value. Will be applied when there is no space for long value. If not specified, part of the value will be hidden with ellipsis
   *  * `description` - Description of the statistic. Displayed in the second row.
   *  * `descriptionInfo` - More info about the description. Displayed as an info icon with this text inside a tooltip
   *  * `percentage` - Change in percents. Positive number - arrow up, negative - arrow down.
   *  * `invertedPercentage` - When set to true renders positive percentage in red and negative in green.
   *  * `onClick` - Callback to be executed on click (also on Enter/Space key press)
   *  * `isLoading` - Shows a loader instead of value.
   *  * `children` - Node to render on bottom of section.
   */
  items: _propTypes.default.arrayOf(_propTypes.default.shape({
    value: _propTypes.default.string,
    valueInShort: _propTypes.default.string,
    description: _propTypes.default.string,
    descriptionInfo: _propTypes.default.string,
    percentage: _propTypes.default.number,
    invertedPercentage: _propTypes.default.bool,
    onClick: _propTypes.default.func,
    children: _propTypes.default.node
  }))
};
var _default = exports.default = StatisticsWidget;
//# sourceMappingURL=StatisticsWidget.js.map