export function tablePrivateUniDriverFactory(base: any, ...args: any[]): {
    getInnerHtml: () => any;
    getRowCheckboxDriver: (index: number) => Promise<import("../Checkbox/Checkbox.uni.driver").CheckboxUniDriver>;
    getBulkSelectionCheckboxDriver: () => Promise<import("../Checkbox/Checkbox.uni.driver").CheckboxUniDriver>;
    isBulkSelectionDisabled: () => Promise<boolean>;
    isRowSelectionDisabled: (index: number) => Promise<boolean>;
    clickRowCheckbox: (index: number) => Promise<void>;
    clickBulkSelectionCheckbox: () => Promise<void>;
    isRowSelected: (index: number) => Promise<boolean>;
    getBulkSelectionState: () => Promise<"ALL" | "SOME" | "NONE">;
    getTitlebar: () => Promise<import("@wix/unidriver-core").UniDriver | null>;
    getCellTextValue: (row?: number, column?: number) => Promise<string>;
    isSelectionTooltipEnabled: (index: number) => Promise<boolean>;
    getSelectionTooltipContent: (index: number) => Promise<string>;
    getRow: (rowIndex: number) => import("@wix/unidriver-core").UniDriver;
    getRowsCount: () => Promise<number>;
    getRowsWithClassCount: (className: string) => Promise<number>;
    getRowsWithDataHook: (dataHookName: string) => Promise<any[]>;
    getRowWithDataHook: (dataHookName: string) => Promise<any>;
    getRowText: (index: number) => Promise<string[]>;
    getRowClasses: (index: number) => Promise<string[]>;
    getHeaderRowClasses: () => Promise<string[]>;
    getHeaderClasses: () => Promise<string[]>;
    getHeaderCellByDataHook: (dataHookName: string) => Promise<any>;
    getHeaderCell: (index: number) => Promise<any>;
    getHeaderCellStyle: (index: number) => Promise<string | null>;
    getHeaderCellWidth: (index: number) => Promise<string | null>;
    getCell: (rowIndex: number, cellIndex: number) => Promise<any>;
    getCellStyle: (rowIndex: number, colIndex: number) => Promise<string | null>;
    getCellWidth: (rowIndex: number, colIndex: number) => Promise<string | null>;
    isRowClickable: (index: number) => Promise<boolean>;
    isRowAnimated: (index: number) => Promise<boolean>;
    isRowHighlighted: (index: number) => Promise<boolean>;
    getTitles: () => Promise<string[]>;
    isDisplayingNothing: () => Promise<boolean>;
    isDisplayingHeaderOnly: () => Promise<boolean>;
    isDisplayingHeader: () => Promise<boolean>;
    isHeaderVisible: () => Promise<boolean>;
    hasChildWithId: (id: string) => Promise<boolean>;
    clickRow: (index: number, eventData?: import("react-dom/test-utils").SyntheticEventData) => Promise<void>;
    mouseEnterRow: (index: number, eventData?: import("react-dom/test-utils").SyntheticEventData) => Promise<void>;
    mouseLeaveRow: (index: number, eventData?: import("react-dom/test-utils").SyntheticEventData) => Promise<void>;
    hasRowDetails: (index: number) => Promise<number>;
    getRowDetailsText: (index: number) => Promise<string>;
    hasSortableTitle: (index: number) => Promise<boolean>;
    hasInfoIcon: (index: number) => Promise<boolean>;
    hasSortDescending: (index: number) => Promise<boolean>;
    clickSort: (index: number, eventData?: import("react-dom/test-utils").SyntheticEventData) => Promise<void>;
    getRowDetails: (index: number) => Promise<any>;
    isCellMasked: (rowIndex: number, colIndex: number) => Promise<boolean>;
    getStickyColumnsCount: () => Promise<number>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
    click: () => Promise<void>;
};
//# sourceMappingURL=Table.private.uni.driver.d.ts.map