export default TableActionCell;
declare function TableActionCell({ onClick, dataHook, primaryAction, secondaryActions, numOfVisibleSecondaryActions, alwaysShowSecondaryActions, moreActionsTooltipText, popoverMenuProps, size, }: {
    onClick?: (() => void) | undefined;
    dataHook: any;
    primaryAction?: null | undefined;
    secondaryActions?: never[] | undefined;
    numOfVisibleSecondaryActions?: number | undefined;
    alwaysShowSecondaryActions?: boolean | undefined;
    moreActionsTooltipText: any;
    popoverMenuProps: any;
    size?: string | undefined;
}): React.JSX.Element;
declare namespace TableActionCell {
    let displayName: string;
    namespace propTypes {
        let dataHook: PropTypes.Requireable<string>;
        let primaryAction: PropTypes.Requireable<PropTypes.InferProps<{
            text: PropTypes.Validator<string>;
            skin: PropTypes.Requireable<string>;
            onClick: PropTypes.Validator<(...args: any[]) => any>;
            disabled: PropTypes.Requireable<boolean>;
            prefixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            suffixIcon: PropTypes.Requireable<PropTypes.ReactElementLike>;
            as: PropTypes.Requireable<NonNullable<string | object | null | undefined>>;
            visibility: PropTypes.Requireable<string>;
        }>>;
        let secondaryActions: PropTypes.Requireable<(NonNullable<PropTypes.InferProps<{
            text: PropTypes.Validator<string>;
            icon: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
            onClick: PropTypes.Validator<(...args: any[]) => any>;
            subtitle: PropTypes.Requireable<string>;
            disabled: PropTypes.Requireable<boolean>;
            dataHook: PropTypes.Requireable<string>;
            disabledDescription: PropTypes.Requireable<string>;
            tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
            skin: PropTypes.Requireable<string>;
        }> | PropTypes.InferProps<{
            divider: PropTypes.Validator<boolean>;
        }> | null | undefined> | null | undefined)[]>;
        let numOfVisibleSecondaryActions: PropTypes.Requireable<number>;
        let alwaysShowSecondaryActions: PropTypes.Requireable<boolean>;
        let moreActionsTooltipText: PropTypes.Requireable<string>;
        let popoverMenuProps: PropTypes.Requireable<PropTypes.InferProps<{
            /** The maximum width applied to the list */
            maxWidth: PropTypes.Requireable<number>;
            /** The minimum width applied to the list */
            minWidth: PropTypes.Requireable<number>;
            /** The maximum height value applied to the list */
            maxHeight: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
            /** Popover content z-index */
            zIndex: PropTypes.Requireable<number>;
            /** Moves popover content relative to the parent by x or y */
            moveBy: PropTypes.Requireable<PropTypes.InferProps<{
                x: PropTypes.Requireable<number>;
                y: PropTypes.Requireable<number>;
            }>>;
            /** The Popover's placement:
             *  * auto-start
             *  * auto
             *  * auto-end
             *  * top-start
             *  * top
             *  * top-end
             *  * right-start
             *  * right
             *  * right-end
             *  * bottom-end
             *  * bottom
             *  * bottom-start
             *  * left-end
             *  * left
             *  * left-start
             */
            placement: PropTypes.Requireable<string>;
            /** Changing text size */
            textSize: PropTypes.Requireable<string>;
            /** Enables text ellipsis on tight containers */
            ellipsis: PropTypes.Requireable<boolean>;
            /** The Popover's appendTo */
            appendTo: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
            /**
             * Whether to enable the flip behaviour. This behaviour is used to flip the `<Popover/>`'s placement
             * when it starts to overlap the target element (`<Popover.Element/>`).
             */
            flip: PropTypes.Requireable<boolean>;
            /**
             * Whether to enable the fixed behaviour. This behaviour is used to keep the `<Popover/>` at it's
             * original placement even when it's being positioned outside the boundary.
             */
            fixed: PropTypes.Requireable<boolean>;
            /** Whether to show the Popover's arrow */
            showArrow: PropTypes.Requireable<boolean>;
        }>>;
        let size: PropTypes.Requireable<string>;
    }
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=TableActionCell.d.ts.map