"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _system = require("@wix/wix-ui-icons-common/system");
var _constants = require("./constants");
var _TableListHeaderSt = require("./TableListHeader.st.css");
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _TooltipCommon = require("../common/PropTypes/TooltipCommon");
var _InfoIcon = _interopRequireDefault(require("../InfoIcon"));
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/TableListHeader/TableListHeader.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var ALIGN = {
  left: 'left',
  center: 'center',
  right: 'right'
};
var CHECKBOX_STATE = {
  normal: 'normal',
  checked: 'checked',
  indeterminate: 'indeterminate',
  hasError: 'hasError',
  disabled: 'disabled',
  hidden: 'hidden'
};
var getWidthStyle = options => options.reduce((acc, _ref) => {
  var {
    width
  } = _ref;
  return "".concat(acc, " ").concat(typeof width === 'number' ? width + 'px' : width || '1fr');
}, '');

/** TableListHeader */
var TableListHeader = /*#__PURE__*/(0, _react.forwardRef)((_ref2, ref) => {
  var {
    options = [],
    checkboxState = CHECKBOX_STATE.hidden,
    onCheckboxChange = () => {},
    onSortChange = () => {},
    className,
    dataHook
  } = _ref2;
  var onColumnClick = (0, _react.useCallback)((sortable, colNum) => evt => {
    sortable && onSortChange && onSortChange(colNum, evt);
  }, [onSortChange]);
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: ref,
    className: (0, _TableListHeaderSt.st)(_TableListHeaderSt.classes.root, className),
    "data-hook": dataHook,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 7
    }
  }, checkboxState !== CHECKBOX_STATE.hidden && /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    dataHook: _constants.dataHooks.tableListHeaderCheckbox,
    checked: checkboxState === CHECKBOX_STATE.checked,
    indeterminate: checkboxState === CHECKBOX_STATE.indeterminate,
    hasError: checkboxState === CHECKBOX_STATE.hasError,
    disabled: checkboxState === CHECKBOX_STATE.disabled,
    selectionArea: "none",
    selectionAreaSkin: "filled",
    selectionAreaPadding: "13px 12px 13px 6px",
    onChange: onCheckboxChange,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 63,
      columnNumber: 11
    }
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: _TableListHeaderSt.classes.optionsContainer,
    style: {
      gridTemplateColumns: getWidthStyle(options)
    },
    "data-hook": _constants.dataHooks.tableListHeaderOptionsContainer,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 76,
      columnNumber: 9
    }
  }, options.map((_ref3, index) => {
    var {
      value,
      align,
      sortable,
      sortDescending,
      infoTooltipProps
    } = _ref3;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _TableListHeaderSt.st)(_TableListHeaderSt.classes.option, {
        position: ALIGN[align],
        sortable
      }),
      key: index,
      "data-hook": _constants.dataHooks.tableListHeaderValue,
      onClick: onColumnClick(sortable, index),
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 88,
        columnNumber: 15
      }
    }, value, /*#__PURE__*/_react.default.createElement(TableListHeaderSortingArrow, {
      sortDescending: sortDescending,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 98,
        columnNumber: 17
      }
    }), /*#__PURE__*/_react.default.createElement(TableListHeaderInfoTooltip, {
      tooltipProps: infoTooltipProps,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 99,
        columnNumber: 17
      }
    }));
  })));
});
TableListHeader.displayName = 'TableListHeader';
TableListHeader.propTypes = {
  dataHook: _propTypes.default.string,
  className: _propTypes.default.string,
  /**
   * `width` supports px/%/fr
   * `sortable`: Sets whether this field is sortable. If `true` clicking the header will call `onSortChange`
   * `sortDescending`: Sets what sort icon to display in the column header. `true` will show an up arrow, `false` will show a down arrow, `undefined' will show no icon
   * `infoTooltipProps`: Props object for column header's [tooltip](/?path=/story/components-api-components--tooltip). Note: `dataHook`, `moveBy` and `children` will not be passed to tooltip.
   */
  options: _propTypes.default.arrayOf(_propTypes.default.shape({
    value: _propTypes.default.node,
    width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
    align: _propTypes.default.oneOf([ALIGN.left, ALIGN.center, ALIGN.right]),
    sortable: _propTypes.default.bool,
    sortDescending: _propTypes.default.bool,
    infoTooltipProps: _propTypes.default.shape(_TooltipCommon.TooltipCommonProps)
  })),
  /**
   * State of Checkbox rendered at first column. 'hidden' to not render it
   */
  checkboxState: _propTypes.default.oneOf([CHECKBOX_STATE.normal, CHECKBOX_STATE.checked, CHECKBOX_STATE.indeterminate, CHECKBOX_STATE.hasError, CHECKBOX_STATE.disabled, CHECKBOX_STATE.hidden]),
  /**
   * Called when checkbox is clicked
   */
  onCheckboxChange: _propTypes.default.func,
  /**
   * A callback function called on each column title click. Signature `onSortChange(colNum, nativeEvent)`
   */
  onSortChange: _propTypes.default.func
};
var _default = exports.default = TableListHeader;
var TableListHeaderSortingArrow = _ref4 => {
  var {
    sortDescending
  } = _ref4;
  if (sortDescending === undefined) {
    return null;
  }
  var Arrow = sortDescending ? _system.SortByArrowDown : _system.SortByArrowUp;
  var dataHook = sortDescending ? _constants.dataHooks.tableListHeaderArrowDescending : _constants.dataHooks.tableListHeaderArrowAscending;
  return /*#__PURE__*/_react.default.createElement(Arrow, {
    "data-hook": dataHook,
    className: _TableListHeaderSt.classes.sortArrow,
    height: 12,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 168,
      columnNumber: 5
    }
  });
};
var TableListHeaderInfoTooltip = _ref5 => {
  var {
    tooltipProps
  } = _ref5;
  if (tooltipProps === undefined) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement(_InfoIcon.default, (0, _extends2.default)({
    dataHook: _constants.dataHooks.tableListHeaderInfoIcon
  }, tooltipProps, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 178,
      columnNumber: 5
    }
  }));
};
//# sourceMappingURL=TableListHeader.js.map