"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = exports.PADDING = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _constants = require("./constants");
var _TableListItemSt = require("./TableListItem.st.css");
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _Box = _interopRequireDefault(require("../Box"));
var _context = require("../WixStyleReactProvider/context");
var _DragHandle = require("../DragHandle/DragHandle");
var _fillRef = require("../utils/fillRef");
var _useDraggableContainer = require("../DraggableContainer/useDraggableContainer");
var _system = require("@wix/wix-ui-icons-common/system");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/TableListItem/TableListItem.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var ALIGN = {
  left: 'left',
  center: 'center',
  right: 'right'
};
var PADDING = exports.PADDING = {
  xxTiny: 'xxTiny',
  xTiny: 'xTiny',
  tiny: 'tiny',
  small: 'small',
  medium: 'medium',
  large: 'large'
};
var getWidthStyle = options => options.reduce((acc, _ref) => {
  var {
    width
  } = _ref;
  return "".concat(acc, " ").concat(typeof width === 'number' ? width + 'px' : width || '1fr');
}, '');

/** TableListItem */
var TableListItem = /*#__PURE__*/(0, _react.forwardRef)((_ref2, ref) => {
  var {
    options,
    verticalPadding = PADDING.small,
    horizontalPadding = PADDING.large,
    checkbox = false,
    checkboxDisabled,
    checkboxTooltipContent,
    checkboxTooltipProps,
    checked,
    onCheckboxChange = () => {},
    draggable = false,
    focused,
    onBlur,
    dragDisabled,
    showDivider = false,
    onKeyUp,
    onClick,
    dragging,
    className,
    dataHook,
    dragHandleProps,
    border = false,
    dragHandleSize = 'large',
    expandable = false,
    expandDisabled,
    onClickExpand,
    expanded = false
  } = _ref2;
  var draggableRef = (0, _react.useRef)();
  var rootRef = (0, _react.useRef)();
  _react.default.useEffect(() => {
    if (draggableRef.current && focused) {
      draggableRef.current.focus();
    }
  }, [draggableRef, focused]);
  _react.default.useImperativeHandle(ref, () => ({
    focus: () => rootRef.current && rootRef.current.focus()
  }));
  var {
    className: draggableContainerClassName
  } = (0, _useDraggableContainer.useDraggableContainer)({
    dragging,
    draggable,
    dragDisabled,
    highlight: true
  });
  var showControls = draggable || expandable || checkbox;
  return /*#__PURE__*/_react.default.createElement(_context.WixStyleReactContext.Consumer, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 92,
      columnNumber: 7
    }
  }, _ref3 => {
    var {
      newColorsBranding
    } = _ref3;
    return /*#__PURE__*/_react.default.createElement("div", {
      ref: rootRef,
      tabIndex: -1,
      onClick: onClick,
      className: (0, _TableListItemSt.st)(_TableListItemSt.classes.root, {
        draggable: draggable && !dragDisabled,
        dragDisabled,
        dragging,
        checked: checkbox && checked,
        showDivider,
        clickable: !!onClick,
        verticalPadding,
        horizontalPadding,
        newColorsBranding,
        border,
        dragHandleSize
      }, className, draggableContainerClassName),
      "data-hook": dataHook,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 94,
        columnNumber: 11
      }
    }, showControls && /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _TableListItemSt.st)(_TableListItemSt.classes.controlsContainer, {
        dragHandleSize
      }),
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 119,
        columnNumber: 15
      }
    }, draggable && /*#__PURE__*/_react.default.createElement("div", {
      className: _TableListItemSt.classes.handleContainer,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 123,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react.default.createElement(_DragHandle.DragHandle, (0, _extends2.default)({
      tabIndex: onKeyUp ? 0 : undefined
    }, dragHandleProps, {
      domRef: el => {
        draggableRef.current = el;
        (0, _fillRef.fillRef)(dragHandleProps == null ? void 0 : dragHandleProps.domRef, el);
      },
      onBlur: onBlur,
      onKeyUp: onKeyUp,
      draggable: draggable,
      dragging: dragging,
      disabled: dragDisabled,
      dataHook: _constants.dataHooks.tableListItemDragHandle,
      dragHandleSize: dragHandleSize,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 124,
        columnNumber: 21
      }
    }))), expandable && /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _TableListItemSt.st)(_TableListItemSt.classes.expandHandle, {
        expandable: expandable && !expandDisabled
      }),
      "data-hook": _constants.dataHooks.tableListItemExpandHandleContainer,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 142,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react.default.createElement(_system.CaretRight, {
      className: (0, _TableListItemSt.st)(_TableListItemSt.classes.caretIcon, {
        expanded
      }),
      onClick: expandDisabled ? null : onClickExpand,
      "data-hook": _constants.dataHooks.tableListItemExpandHandle,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 148,
        columnNumber: 21
      }
    })), checkbox && /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _TableListItemSt.st)(_TableListItemSt.classes.checkbox, {
        checkboxDisabled
      }),
      "data-hook": _constants.dataHooks.tableListItemCheckboxContainer,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 158,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
      checked: checked,
      disabled: checkboxDisabled,
      onChange: checkboxDisabled ? null : onCheckboxChange,
      dataHook: _constants.dataHooks.tableListItemCheckbox,
      tooltipContent: checkboxTooltipContent,
      tooltipProps: checkboxTooltipProps,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 162,
        columnNumber: 21
      }
    }))), /*#__PURE__*/_react.default.createElement("div", {
      className: _TableListItemSt.classes.optionsContainer,
      style: {
        gridTemplateColumns: getWidthStyle(options)
      },
      "data-hook": _constants.dataHooks.tableListItemOptionsContainer,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 174,
        columnNumber: 13
      }
    }, options.map((_ref4, index) => {
      var {
        value,
        align
      } = _ref4;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _TableListItemSt.st)(_TableListItemSt.classes.align, {
          position: ALIGN[align]
        }),
        key: index,
        "data-hook": _constants.dataHooks.tableListItemValue,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 182,
          columnNumber: 17
        }
      }, value);
    })));
  });
});
TableListItem.displayName = 'TableListItem';
TableListItem.propTypes = {
  /** Applies a data-hook HTML attribute to be used in the tests */
  dataHook: _propTypes.default.string,
  /** Specifies a CSS class name to be appended to the component’s root element. */
  className: _propTypes.default.string,
  /** Defines each TableListItem column  individually, using the following props:
   * - `value` - defines column’s content.
   * - `width` - sets the width of a column. It supports all grid-template-column values: [https://developer.mozilla.org/en-US/docs/Web/CSS/grid-template-columns](https://developer.mozilla.org/en-US/docs/Web/CSS/grid-template-columns)
   * - `align` - aligns the content in the horizontal axis.
   */
  options: _propTypes.default.arrayOf(_propTypes.default.shape({
    value: _propTypes.default.node.isRequired,
    width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
    align: _propTypes.default.oneOf([ALIGN.left, ALIGN.center, ALIGN.right])
  })).isRequired,
  /** Adjusts the top and bottom padding size */
  verticalPadding: _propTypes.default.oneOf([PADDING.large, PADDING.medium, PADDING.small, PADDING.tiny, PADDING.xTiny, PADDING.xxTiny]),
  /** Adjusts the left and right padding size */
  horizontalPadding: _propTypes.default.oneOf([PADDING.large, PADDING.medium, PADDING.small, PADDING.tiny, PADDING.xTiny, PADDING.xxTiny]),
  /** Visually indicates that component is being dragged */
  dragging: _propTypes.default.bool,
  /** Makes the checkbox visible */
  checkbox: _propTypes.default.bool,
  /** Disables the visible checkbox */
  checkboxDisabled: _propTypes.default.bool,
  /** Selects the visible checkbox */
  checked: _propTypes.default.bool,
  /** Defines a callback when checkbox is clicked */
  onCheckboxChange: _propTypes.default.func,
  /** Makes drag handle visible */
  draggable: _propTypes.default.bool,
  /** Disables the visible drag handle */
  dragDisabled: _propTypes.default.bool,
  /** Enables a divider at the bottom of the list item */
  showDivider: _propTypes.default.bool,
  /** Defines a callback when item loses its focus */
  onBlur: _propTypes.default.func,
  /** Defines a callback when the item is focused, and a key is pressed and released. Used for NestableList solutions controlled with a keyboard. */
  onKeyUp: _propTypes.default.func,
  /** Forces focus on drag handle */
  focused: _propTypes.default.bool,
  /** Defines a callback when the item is clicked */
  onClick: _propTypes.default.func,
  /**
   Extra props to pass to the `<DragHandle />` element
   */
  dragHandleProps: _propTypes.default.object,
  /** Defines a message to be displayed in a tooltip. Tooltip is displayed on a checkbox hover. */
  checkboxTooltipContent: _propTypes.default.node,
  /**
   * Tooltip props (when hovering over the checkbox)
   */
  checkboxTooltipProps: _propTypes.default.object,
  /** Adds a border around the component */
  border: _propTypes.default.bool,
  /** Changes the size of the DragHandle */
  dragHandleSize: _propTypes.default.oneOf(['small', 'large']),
  /** Adds functionality to expand the list item */
  expandable: _propTypes.default.bool,
  /** Defines whether the list component is expanded/collapsed */
  expanded: _propTypes.default.bool,
  /** Defines a callback when caret handle is clicked */
  onClickExpand: _propTypes.default.func,
  /** Disables the visible expand handle */
  expandDisabled: _propTypes.default.bool
};
var _default = exports.default = TableListItem;
//# sourceMappingURL=TableListItem.js.map