"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.tableListItemDriverFactory = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
var _CheckboxUni = require("../Checkbox/Checkbox.uni.driver");
var _DragHandleUni = require("../DragHandle/DragHandle.uni.driver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var tableListItemDriverFactory = (base, body) => {
  var getColumnAt = index => base.$$("[data-hook=\"".concat(_constants.dataHooks.tableListItemValue, "\"]")).get(index);
  var getCheckboxDriver = () => (0, _CheckboxUni.checkboxUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.tableListItemCheckbox, "\"]")), body);
  var getColumnTextAt = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)(function* (index) {
      var column = yield getColumnAt(index);
      return column.text();
    });
    return function getColumnTextAt(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var getDragHandleDriver = () => (0, _DragHandleUni.dragHandleUniDriverFactory)(base.$("[data-hook=\"".concat(_constants.dataHooks.tableListItemDragHandle, "\"]")), body);
  var getExpandHandle = () => {
    return {
      exists: () => base.$("[data-hook=\"".concat(_constants.dataHooks.tableListItemExpandHandle, "\"]")).exists(),
      click: () => base.$("[data-hook=\"".concat(_constants.dataHooks.tableListItemExpandHandle, "\"]")).click()
    };
  };
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    getColumnTextAt,
    isCheckboxExists: () => {
      var driver = getCheckboxDriver();
      return driver.exists();
    },
    isCheckboxChecked: () => {
      var driver = getCheckboxDriver();
      return driver.isChecked();
    },
    isCheckboxDisabled: () => {
      var driver = getCheckboxDriver();
      return driver.isDisabled();
    },
    toggleCheckbox: () => {
      var driver = getCheckboxDriver();
      return driver.click();
    },
    expandHandleExists: () => getExpandHandle().exists(),
    toggleExpandHandle: () => getExpandHandle().click(),
    hoverDragHandle: () => getDragHandleDriver().hover(),
    getDragHandleDisabled: () => getDragHandleDriver().getDisabled(),
    isDragHandleTooltipEnabled: () => getDragHandleDriver().isTooltipEnabled(),
    getDragHandleTooltipContent: () => getDragHandleDriver().getTooltipContent(),
    isCheckboxTooltipEnabled: () => getCheckboxDriver().isTooltipEnabled(),
    getCheckboxTooltipContent: () => getCheckboxDriver().getTooltipContent()
  });
};
exports.tableListItemDriverFactory = tableListItemDriverFactory;
//# sourceMappingURL=TableListItem.uni.driver.js.map