"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _pick = _interopRequireDefault(require("../../../utils/operators/pick"));
var _Text = _interopRequireDefault(require("../../../Text"));
var TabPropTypes = _interopRequireWildcard(require("../constants/tab-prop-types"));
var _TabsSt = require("../../Tabs.st.css");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Tabs/core/TabItem/index.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
class TabItem extends _react.default.Component {
  getItemStyle() {
    var {
      type,
      width,
      itemMaxWidth,
      item: {
        minWidth,
        maxWidth
      },
      alignment
    } = this.props;
    var inlineStyle = {
      uniformSide: {
        width
      },
      compactSide: itemMaxWidth ? {
        maxWidth: "".concat(itemMaxWidth, "pt")
      } : {}
    }[type] || {};
    if (minWidth) {
      inlineStyle.minWidth = minWidth;
    }
    if (maxWidth) {
      inlineStyle.maxWidth = maxWidth;
    }
    if (alignment) {
      inlineStyle.textAlign = alignment;
    }
    return inlineStyle;
  }
  render() {
    var {
      item,
      onItemClick,
      isActive,
      dynamicProperties,
      size
    } = this.props;
    var containerProps = _objectSpread({
      key: item.id,
      onClick: () => onItemClick(item),
      className: (0, _TabsSt.st)(_TabsSt.classes.tab, {
        size,
        active: isActive
      }),
      style: this.getItemStyle()
    }, (0, _pick.default)(this.props, dynamicProperties));
    return /*#__PURE__*/_react.default.createElement("button", (0, _extends2.default)({
      role: "tab",
      type: "button",
      "aria-selected": isActive,
      "data-active": isActive,
      "data-hook": item.dataHook
    }, containerProps, {
      ref: this.createRef,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react.default.createElement(_Text.default, {
      size: size,
      className: _TabsSt.classes.tabText,
      weight: "thin",
      ellipsis: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 63,
        columnNumber: 9
      }
    }, item.title));
  }
}
TabItem.propTypes = {
  itemMaxWidth: _propTypes.default.number,
  isActive: _propTypes.default.bool,
  item: TabPropTypes.item.isRequired,
  onItemClick: TabPropTypes.onClick,
  type: TabPropTypes.type,
  width: TabPropTypes.width,
  dynamicProperties: _propTypes.default.array
};
var _default = exports.default = TabItem;
//# sourceMappingURL=index.js.map