"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _RawText = _interopRequireWildcard(require("./RawText"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TextSt = require("./Text.st.css");
var _Ellipsis = _interopRequireWildcard(require("../common/Ellipsis"));
var _TooltipCommon = require("../common/PropTypes/TooltipCommon");
var _excluded = ["ellipsis", "appendTo", "flip", "fixed", "placement", "zIndex", "enterDelay", "exitDelay", "showTooltip", "size", "secondary", "skin", "light", "weight", "tagName", "listStyle", "widows", "id"],
  _excluded2 = ["className", "tooltipProps"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Text/Text.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TextWithEllipsis = _ref => {
  var {
      ellipsis = false,
      appendTo = _Ellipsis.default.defaultProps.appendTo,
      flip = _Ellipsis.default.defaultProps.flip,
      fixed = _Ellipsis.default.defaultProps.fixed,
      placement = _Ellipsis.default.defaultProps.placement,
      zIndex = _Ellipsis.default.defaultProps.zIndex,
      enterDelay = _Ellipsis.default.defaultProps.enterDelay,
      exitDelay = _Ellipsis.default.defaultProps.exitDelay,
      showTooltip = _Ellipsis.default.defaultProps.showTooltip,
      size = _RawText.RawTextDefaultProps.size,
      secondary = _RawText.RawTextDefaultProps.secondary,
      skin = _RawText.RawTextDefaultProps.skin,
      light = _RawText.RawTextDefaultProps.light,
      weight = _RawText.RawTextDefaultProps.weight,
      tagName = _RawText.RawTextDefaultProps.tagName,
      listStyle = _RawText.RawTextDefaultProps.listStyle,
      widows = _RawText.RawTextDefaultProps.widows,
      id
    } = _ref,
    propsWithNoDefaults = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var _RawTextDefaultProps$ = _objectSpread(_objectSpread(_objectSpread({}, _RawText.RawTextDefaultProps), _Ellipsis.default.defaultProps), {}, {
      ellipsis,
      appendTo,
      flip,
      fixed,
      placement,
      zIndex,
      enterDelay,
      exitDelay,
      showTooltip,
      size,
      secondary,
      skin,
      light,
      weight,
      tagName,
      listStyle,
      id,
      widows
    }, propsWithNoDefaults),
    {
      className,
      tooltipProps
    } = _RawTextDefaultProps$,
    props = (0, _objectWithoutProperties2.default)(_RawTextDefaultProps$, _excluded2);
  var {
    ellipsisProps,
    componentProps
  } = (0, _Ellipsis.extractEllipsisProps)(props);
  return /*#__PURE__*/_react.default.createElement(_Ellipsis.default, (0, _extends2.default)({}, ellipsisProps, tooltipProps, {
    wrapperClassName: (0, _TextSt.st)(_TextSt.classes.root, {
      size: props.size,
      weight: props.weight,
      listStyle: props.listStyle
    }),
    render: _ref2 => {
      var {
        ref,
        ellipsisClasses,
        ellipsisInlineStyle
      } = _ref2;
      return /*#__PURE__*/_react.default.createElement(_RawText.default, (0, _extends2.default)({}, componentProps, {
        ref: ref,
        className: ellipsisClasses(className),
        style: ellipsisInlineStyle,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 63,
          columnNumber: 9
        }
      }));
    },
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 5
    }
  }));
};
TextWithEllipsis.displayName = 'Text';
TextWithEllipsis.propTypes = {
  /*
   * Text props
   */

  /** Applies a data-hook HTML attribute that can be used in the tests. */
  dataHook: _propTypes.default.string,
  /** Specifies a CSS class name to be appended to the component’s root element. */
  className: _propTypes.default.string,
  /** Defines a tag name that text should be rendered inside of (e.g., div, a, p). */
  tagName: _propTypes.default.string,
  /** Controls the font size of the text. */
  size: _propTypes.default.oneOf(['tiny', 'small', 'medium']),
  /** Renders any kind of content within a heading. Usually it’s a text string. */
  children: _propTypes.default.any,
  /** Sets text type to secondary. Affects font color only. */
  secondary: _propTypes.default.bool,
  /** Controls the skin of the text. */
  skin: _propTypes.default.oneOf(['standard', 'success', 'error', 'premium', 'disabled', 'primary']),
  /** Sets list items style. */
  listStyle: _propTypes.default.oneOf(['checkmark', 'circle']),
  /** Inverts text color so it can be used on dark backgrounds. */
  light: _propTypes.default.bool,
  /** Controls the font weight of the text. */
  weight: _propTypes.default.oneOf(['thin', 'normal', 'bold']),
  /** Applies id HTML attribute. */
  id: _propTypes.default.string,
  /*
   * Ellipsis props
   */

  /** Truncates text that is longer than its parent container and displays ellipsis at the end of the last line. */
  ellipsis: _propTypes.default.bool,
  /** Specifies whether to show a tooltip for ellipsis.  */
  showTooltip: _propTypes.default.bool,
  /** Specifies tooltip content z index. */
  zIndex: _propTypes.default.number,
  /** Defines tooltip placement in relation to target element. */
  placement: _propTypes.default.string,
  /** Disables tooltip element trigger. If not specified, disabled prop value of the children element will be used. */
  disabled: _propTypes.default.bool,
  /** Defines a tooltip content calculation relation to a dom element. */
  appendTo: _propTypes.default.oneOfType([_propTypes.default.oneOf(['window', 'scrollParent', 'viewport', 'parent']), _propTypes.default.element, _propTypes.default.func]),
  /** Flips tooltip placement when it starts to overlap the target element. */
  flip: _propTypes.default.bool,
  /** Keeps tooltip at its original placement even when it's being positioned outside the boundary. */
  fixed: _propTypes.default.bool,
  /** Specifies time to wait before showing the tooltip in milliseconds. */
  enterDelay: _propTypes.default.number,
  /** Specifies time to wait before hiding the tooltip in milliseconds. */
  exitDelay: _propTypes.default.number,
  /** Specifies tooltip width in pixels. */
  maxWidth: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  /** Defines a callback function which is called every time tooltip is shown. */
  onShow: _propTypes.default.func,
  /** Defines a callback function which is called every time tooltip is hidden. */
  onHide: _propTypes.default.func,
  /** Moves tooltip content relative to the parent on X or Y axis. */
  moveBy: _propTypes.default.shape({
    x: _propTypes.default.number,
    y: _propTypes.default.number
  }),
  /** Moves tooltip arrow by a specified amount. */
  moveArrowTo: _propTypes.default.number,
  /** Controls tooltip content alignment on X axis. */
  textAlign: _propTypes.default.oneOf(['start', 'center']),
  /** Allows to pass all common tooltip props.
   * @linkTypeTo components-overlays--tooltip
   * @setTypeName TooltipCommonProps
   */
  tooltipProps: _propTypes.default.shape(_TooltipCommon.TooltipCommonProps),
  /** if true it will support widows in the text */
  widows: _propTypes.default.bool
};
var _default = exports.default = TextWithEllipsis;
//# sourceMappingURL=Text.js.map