"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.textUniDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var textUniDriverFactory = base => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    /**
     * Get the root element's tagName
     * @return {Promise<string>} html tagName
     */
    getTagName: function () {
      var _getTagName = (0, _asyncToGenerator2.default)(function* () {
        return (yield base._prop('tagName')).toLowerCase();
      });
      function getTagName() {
        return _getTagName.apply(this, arguments);
      }
      return getTagName;
    }(),
    /**
     * Get text content (innerHTML)
     * @return {Promise<string>} innerHTML content
     */
    getText: () => base._prop('innerHTML'),
    /**
     * Get size
     * @return {Promise<'tiny' | 'small' | 'medium'>}
     */
    getSize: () => base.attr('data-size'),
    /**
     * Get skin
     * @return {Promise<'standard'| 'error'| 'success'| 'premium'| 'disabled'>}
     */
    getSkin: () => base.attr('data-skin'),
    /**
     * Get weight
     * @return {Promise<'thin' | 'normal' | 'bold'>}
     */
    getWeight: () => base.attr('data-weight'),
    /**
     * Get id
     * @return {Promise<string>}
     */
    getId: () => base.attr('id'),
    /**
     * Is light
     * @return {Promise<boolean>}
     */
    isLight: function () {
      var _isLight = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-light')) === 'true';
      });
      function isLight() {
        return _isLight.apply(this, arguments);
      }
      return isLight;
    }(),
    /**
     * Is secondary
     * @return {Promise<boolean>}
     */
    isSecondary: function () {
      var _isSecondary = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-secondary')) === 'true';
      });
      function isSecondary() {
        return _isSecondary.apply(this, arguments);
      }
      return isSecondary;
    }(),
    /**
     * Checks if component has masking classNames
     * @return {Promise<boolean>}
     */
    isMasked: function () {
      var _isMasked = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-mask')) === 'true';
      });
      function isMasked() {
        return _isMasked.apply(this, arguments);
      }
      return isMasked;
    }(),
    /**
     * Checks if the text is using &nbsp;
     * @return {Promise<boolean>}
     */

    isWidows: function () {
      var _isWidows = (0, _asyncToGenerator2.default)(function* () {
        return (yield base.attr('data-widows')) === 'true';
      });
      function isWidows() {
        return _isWidows.apply(this, arguments);
      }
      return isWidows;
    }()
  });
};
exports.textUniDriverFactory = textUniDriverFactory;
//# sourceMappingURL=Text.uni.driver.js.map