"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.thumbnailPrivateDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _ThumbnailUni = require("./Thumbnail.uni.driver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var thumbnailPrivateDriverFactory = base => {
  var byHook = hook => base.$("[data-hook*=\"".concat(hook, "\"]"));
  var publicDriver = (0, _ThumbnailUni.thumbnailDriverFactory)(base);
  return _objectSpread(_objectSpread({}, publicDriver), {}, {
    /** Does the title exist */
    titleExists: () => byHook(_constants.dataHooks.thumbnailTitle).exists(),
    /** Does bottom title exist */
    bottomTitleExists: () => byHook(_constants.dataHooks.thumbnailBottomTitle).exists(),
    /** Does the description exist */
    descriptionExists: () => byHook(_constants.dataHooks.thumbnailDescription).exists(),
    /** Does the selected icon exist */
    selectedIconExists: () => !!publicDriver.getSelectedIcon(),
    /** Does the thumbnails image exist */
    imageExists: () => byHook(_constants.dataHooks.thumbnailImage).exists(),
    /** Does custom child exist */
    customChildExists: () => byHook('custom-child').exists(),
    keyDown: function () {
      var _keyDown = (0, _asyncToGenerator2.default)(function* (keyCode) {
        return base.pressKey(keyCode);
      });
      function keyDown(_x) {
        return _keyDown.apply(this, arguments);
      }
      return keyDown;
    }()
  });
};
exports.thumbnailPrivateDriverFactory = thumbnailPrivateDriverFactory;
//# sourceMappingURL=Thumbnail.private.uni.driver.js.map