"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.timelineDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var timelineDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Gets the label text of timeline item by index
     * @param {number} timeline item index
     * @returns {Promise<string>} timeline item label text at index
     */
    getLabelText: function () {
      var _getLabelText = (0, _asyncToGenerator2.default)(function* (idx) {
        return yield (0, _unidriver.findByHook)(base, "".concat(_constants.dataHooks.timelineLabel, "-").concat(idx)).text();
      });
      function getLabelText(_x) {
        return _getLabelText.apply(this, arguments);
      }
      return getLabelText;
    }(),
    /**
     * Get the suffix text of timeline item  by index
     * @param {number} timeline item index
     * @returns {Promise<string>} timeline item suffix text at index
     */
    getSuffixText: function () {
      var _getSuffixText = (0, _asyncToGenerator2.default)(function* (idx) {
        return yield (0, _unidriver.findByHook)(base, "".concat(_constants.dataHooks.timelineTextSuffix, "-").concat(idx)).text();
      });
      function getSuffixText(_x2) {
        return _getSuffixText.apply(this, arguments);
      }
      return getSuffixText;
    }()
  });
};
exports.timelineDriverFactory = timelineDriverFactory;
//# sourceMappingURL=Timeline.uni.driver.js.map