"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _ToastItem = require("./components/ToastItem/ToastItem");
var _useToastContainer = require("./hooks/useToastContainer");
var _ToastSt = require("./Toast.st.css");
var _framerMotion = require("framer-motion");
var _excluded = ["offset", "zIndex"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Toast/Toast.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Toast = /*#__PURE__*/(0, _react.forwardRef)((_ref, ref) => {
  var {
      offset = '26px',
      zIndex = 5500
    } = _ref,
    propsWithNoDefaults = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var props = _objectSpread({
    offset,
    zIndex
  }, propsWithNoDefaults);
  var {
    toasts,
    containerRef
  } = (0, _useToastContainer.useToastContainer)(props);
  (0, _react.useEffect)(() => {
    if (ref) {
      ref.current = containerRef.current;
    }
    // TODO: fix ESLint error
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var motionProps = {
    initial: {
      y: 150,
      x: 0,
      opacity: 0
    },
    animate: {
      y: 0,
      x: 0,
      opacity: 1
    },
    exit: {
      opacity: 0
    }
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: containerRef,
    className: (0, _ToastSt.st)(_ToastSt.classes.toastContainer, props.className),
    "data-hook": props.dataHook,
    style: {
      zIndex: props.zIndex,
      bottom: props.offset
    },
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 34,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react.default.createElement(_framerMotion.AnimatePresence, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 41,
      columnNumber: 9
    }
  }, toasts.map(_ref2 => {
    var {
      content,
      props: toastProps
    } = _ref2;
    return /*#__PURE__*/_react.default.createElement(_framerMotion.motion.div, (0, _extends2.default)({
      key: "toast-".concat(toastProps.key),
      layout: true,
      transition: {
        default: {
          ease: 'linear'
        }
      }
    }, motionProps, {
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 43,
        columnNumber: 13
      }
    }), /*#__PURE__*/_react.default.createElement(_ToastItem.ToastItem, (0, _extends2.default)({}, toastProps, {
      key: "toast-".concat(toastProps.key),
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 15
      }
    }), content));
  })));
});
Toast.displayName = 'Toast';
var _default = exports.default = Toast;
//# sourceMappingURL=Toast.js.map