"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.toastDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var toastItemDriver = item => ({
  getStatus: () => item.attr('data-status'),
  getContent: () => item.$('[data-hook="toast-text"]').text(),
  isDismissExists: () => item.$('[data-hook="dismiss-button"]').exists(),
  clickOnDismiss: () => item.$('[data-hook="dismiss-button"]').click(),
  isActionExists: () => item.$('[data-hook="action-button"]').exists(),
  getActionTitle: () => item.$('[data-hook="action-button"]').text(),
  getActionHref: () => item.$('[data-hook="action-button"]').attr('href'),
  clickOnAction: () => item.$('[data-hook="action-button"]').click()
});
var toastDriverFactory = base => {
  var getToastItems = () => base.$$('[data-hook*="toast-item"]');
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base)), {}, {
    getItems: function () {
      var _getItems = (0, _asyncToGenerator2.default)(function* () {
        return getToastItems().map(/*#__PURE__*/function () {
          var _ref = (0, _asyncToGenerator2.default)(function* (item) {
            return toastItemDriver(item);
          });
          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }());
      });
      function getItems() {
        return _getItems.apply(this, arguments);
      }
      return getItems;
    }(),
    getItemsCount: function () {
      var _getItemsCount = (0, _asyncToGenerator2.default)(function* () {
        return getToastItems().count();
      });
      function getItemsCount() {
        return _getItemsCount.apply(this, arguments);
      }
      return getItemsCount;
    }(),
    getItemByDataHook: function () {
      var _getItemByDataHook = (0, _asyncToGenerator2.default)(function* (dataHook) {
        return toastItemDriver(base.$("[data-hook*=\"".concat(dataHook, "\"]")));
      });
      function getItemByDataHook(_x2) {
        return _getItemByDataHook.apply(this, arguments);
      }
      return getItemByDataHook;
    }()
  });
};
exports.toastDriverFactory = toastDriverFactory;
//# sourceMappingURL=Toast.uni.driver.js.map