"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.showToast = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _eventManager = require("./eventManager");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var container;
var queue = [];
_eventManager.eventManager.on(_eventManager.Event.DidMount, containerInstance => {
  if (container) {
    return;
  }
  container = containerInstance;
  queue.forEach(item => {
    _eventManager.eventManager.emit(_eventManager.Event.Show, item.content, item.options);
  });
  queue = [];
}).on(_eventManager.Event.WillUnmount, () => {
  container = undefined;
  _eventManager.eventManager.off(_eventManager.Event.Show).off(_eventManager.Event.Clear);
});
var generateToastId = () => Math.random().toString(36).substring(2, 9);
var dispatchToast = (content, options) => {
  container ? _eventManager.eventManager.emit(_eventManager.Event.Show, content, options) : queue.push({
    content,
    options
  });
};
var mergeOptions = options => _objectSpread(_objectSpread({}, options), {}, {
  toastId: generateToastId()
});
var showToast = (content, options) => {
  return dispatchToast(content, mergeOptions(options));
};
exports.showToast = showToast;
//# sourceMappingURL=showToast.js.map