export default ToggleButton;
declare class ToggleButton extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** render as some other component or DOM tag */
        as: PropTypes.Requireable<NonNullable<string | object | null | undefined>>;
        /** Used for passing any wix-style-react icon. For external icon make sure to follow ux sizing guidelines */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Button skins */
        skin: PropTypes.Requireable<string>;
        /** Button size */
        size: PropTypes.Requireable<string>;
        /** Button shape */
        shape: PropTypes.Requireable<string>;
        /** Label content */
        labelValue: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Label placement */
        labelPlacement: PropTypes.Requireable<string>;
        /** Whether label should have ellipsis */
        labelEllipsis: PropTypes.Requireable<boolean>;
        /** Click event handler  */
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** Applies selected styles */
        selected: PropTypes.Requireable<boolean>;
        /** Applies disabled styles */
        disabled: PropTypes.Requireable<boolean>;
        /** Applies border */
        border: PropTypes.Requireable<boolean>;
        /** String based data hook */
        dataHook: PropTypes.Requireable<string>;
        /** Tooltip props for label. Applied only when `labelPlacement` is `tooltip`.
         * @linkTypeTo components-overlays--tooltip
         * @setTypeName TooltipCommonProps
         */
        tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
    };
    static defaultProps: {
        skin: string;
        size: string;
        shape: string;
        border: boolean;
        disabled: boolean;
        labelValue: string;
        labelPlacement: string;
        labelEllipsis: boolean;
        tooltipProps: {
            placement: string;
        };
    };
    constructor(props: any);
    constructor(props: any, context: any);
    renderLabel: () => React.JSX.Element;
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=ToggleButton.d.ts.map