"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Popover = _interopRequireDefault(require("../Popover"));
var _RawText = _interopRequireDefault(require("../Text/RawText"));
var _constants = require("./constants");
var _TooltipSt = require("./Tooltip.st.css");
var _excluded = ["onShow", "onHide", "size", "className", "placement", "exitDelay", "enterDelay", "moveArrowTo", "appendTo", "flip", "fixed", "maxWidth", "fluid", "moveBy", "disabled", "children", "zIndex", "textAlign", "content", "inline", "aria-describedby", "aria-labelledby"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/Tooltip/Tooltip.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Tooltip = /*#__PURE__*/(0, _react.forwardRef)((_ref, ref) => {
  var {
      onShow = () => ({}),
      onHide = () => ({}),
      size = 'medium',
      className,
      placement = 'top',
      exitDelay = 0,
      enterDelay = 0,
      moveArrowTo,
      appendTo = 'window',
      flip = true,
      fixed = false,
      maxWidth = 204,
      fluid,
      moveBy,
      disabled,
      children,
      zIndex = 6000,
      textAlign = 'start',
      content = '',
      inline,
      'aria-describedby': ariaDescribedBy,
      'aria-labelledby': ariaLabelledBy
    } = _ref,
    rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var [shown, setShown] = (0, _react.useState)(false);
  (0, _react.useImperativeHandle)(ref, () => ({
    open,
    close
  }));
  var open = (0, _react.useCallback)(() => {
    setShown(true);
    onShow == null || onShow();
  }, [onShow]);
  var close = (0, _react.useCallback)(() => {
    setShown(false);
    onHide == null || onHide();
  }, [onHide]);
  var isDisabled = (0, _react.useMemo)(() => {
    var _children$props;
    return disabled === undefined ?
    // @ts-expect-error
    (children == null ? void 0 : children.props) && (children == null || (_children$props = children.props) == null ? void 0 : _children$props.disabled) : disabled;
  }, [children, disabled]);
  var onFocus = (0, _react.useCallback)((event, handlers) => {
    var focusableHOC = handlers && handlers.focus;
    var target = event.target;
    try {
      if (process.env.NODE_ENV !== 'test' && target instanceof Element && !target.matches(':focus-visible')) {
        handlers == null || handlers.blur();
        return;
      }
    } catch (e) {
      // browser does not support `matches(':focus-visible')` fallback to original focus behavior
    }
    open();
    return focusableHOC ? handlers.focus() : null;
  }, [open]);
  var onBlur = (0, _react.useCallback)((_event, handlers) => {
    var focusableHOC = handlers && handlers.blur;
    close();
    return focusableHOC ? handlers.blur() : null;
  }, [close]);
  var triggerElement = (0, _react.useMemo)(() => {
    if (typeof children === 'string' || !children) {
      return children;
    }
    if (/*#__PURE__*/_react.default.isValidElement(children)) {
      return /*#__PURE__*/_react.default.cloneElement(children, _objectSpread({
        onFocus: isDisabled ? undefined : onFocus,
        onBlur: isDisabled ? undefined : onBlur
      }, ariaLabelledBy ? {
        'aria-labelledby': ariaLabelledBy
      } : {
        'aria-describedby': ariaDescribedBy
      }));
    }
    if (typeof children === 'function') {
      return children({
        onFocus,
        onBlur
      });
    }
    return;
  }, [children, isDisabled, onFocus, onBlur, ariaDescribedBy, ariaLabelledBy]);
  var contentElement = (0, _react.useMemo)(() => {
    var textSize = size === 'small' ? 'tiny' : 'small';
    var textWeight = size === 'small' ? 'normal' : 'thin';
    return /*#__PURE__*/_react.default.createElement("div", {
      style: {
        textAlign
      },
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 142,
        columnNumber: 9
      }
    }, typeof content === 'string' ?
    /*#__PURE__*/
    // @ts-ignore
    _react.default.createElement(_RawText.default, {
      dataHook: _constants.dataHooks.tooltipText,
      size: textSize,
      weight: textWeight,
      light: true,
      className: _TooltipSt.classes.text,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 145,
        columnNumber: 13
      }
    }, content) : content);
  }, [content, textAlign, size]);
  return /*#__PURE__*/_react.default.createElement(_Popover.default, (0, _extends2.default)({
    role: "tooltip",
    showArrow: size !== 'small',
    className: (0, _TooltipSt.st)(_TooltipSt.classes.root, {
      size,
      inline
    }, className),
    placement: placement,
    shown: isDisabled ? false : shown,
    onMouseEnter: isDisabled ? undefined : open,
    onMouseLeave: close,
    onClickOutside: close,
    "data-size": size,
    hideDelay: exitDelay,
    showDelay: enterDelay,
    moveBy: moveBy,
    moveArrowTo: moveArrowTo,
    appendTo: appendTo,
    id: ariaLabelledBy || ariaDescribedBy,
    flip: flip,
    fixed: fixed,
    maxWidth: maxWidth,
    fluid: fluid,
    disableClickOutsideWhenClosed: true,
    zIndex: zIndex
  }, rest, {
    theme: "dark",
    timeout: _constants.TIMEOUT,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 162,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement(_Popover.default.Element, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 188,
      columnNumber: 9
    }
  }, triggerElement), /*#__PURE__*/_react.default.createElement(_Popover.default.Content, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 189,
      columnNumber: 9
    }
  }, contentElement));
});
Tooltip.displayName = 'Tooltip';
Tooltip.propTypes = {
  dataHook: _propTypes.default.string,
  className: _propTypes.default.string,
  // @ts-ignore
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  // @ts-ignore
  content: _propTypes.default.node,
  textAlign: _propTypes.default.oneOf(['start', 'center']),
  enterDelay: _propTypes.default.number,
  exitDelay: _propTypes.default.number,
  // @ts-expect-error
  moveBy: _propTypes.default.shape({
    x: _propTypes.default.number,
    y: _propTypes.default.number
  }),
  moveArrowTo: _propTypes.default.number,
  // @ts-expect-error
  appendTo: _propTypes.default.oneOfType([_propTypes.default.oneOf(['window', 'scrollParent', 'viewport', 'parent']), _propTypes.default.element, _propTypes.default.func]),
  flip: _propTypes.default.bool,
  fixed: _propTypes.default.bool,
  maxWidth: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  onShow: _propTypes.default.func,
  onHide: _propTypes.default.func,
  placement: _propTypes.default.oneOf(['auto-start', 'auto', 'auto-end', 'top-start', 'top', 'top-end', 'right-start', 'right', 'right-end', 'bottom-end', 'bottom', 'bottom-start', 'left-end', 'left', 'left-start']),
  disabled: _propTypes.default.bool,
  size: _propTypes.default.oneOf(['small', 'medium']),
  'aria-describedby': _propTypes.default.string,
  'aria-labelledby': _propTypes.default.string,
  zIndex: _propTypes.default.number,
  fluid: _propTypes.default.bool
};
var _default = exports.default = Tooltip;
//# sourceMappingURL=Tooltip.js.map