import type { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
import type { TooltipSize } from './Tooltip.types';
export declare const tooltipDriverFactory: (base: UniDriver, body: UniDriver) => {
    /** Clicks on the target element */
    click: () => Promise<void>;
    /** returns true if tooltip element exists on the DOM */
    tooltipExists: () => Promise<boolean>;
    /** mouse over the target element */
    mouseEnter: () => Promise<void>;
    /** mouse leaves the target element */
    mouseLeave: () => Promise<void>;
    /** clicks outside the tooltip target */
    clickOutside: () => Promise<void>;
    /** returns tooltips content value in string */
    getTooltipText: () => Promise<string | null>;
    /**
     * Checks whether tooltip has a given size
     * @param {boolean} sizeName The tooltip size
     * @return {Promise<boolean>}
     */
    hasSize: (sizeName: TooltipSize) => Promise<boolean>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
};
export type TooltipUniDriver = ReturnType<typeof tooltipDriverFactory>;
//# sourceMappingURL=Tooltip.uni.driver.d.ts.map