import { ReactElement } from 'react';
import PropTypes from 'prop-types';
import { TransitionProps } from './Transition.types';
/** Transition is a wrapper that allows animations of other components. */
declare const Transition: {
    ({ animateOnLoad, dataHook, children, enterAnimation, exitAnimation, mountOnEnter, unmountOnExit, onEnd, onStart, show, className, }: TransitionProps): ReactElement;
    displayName: string;
    propTypes: {
        animateOnLoad: PropTypes.Requireable<boolean>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        dataHook: PropTypes.Requireable<string>;
        enterAnimation: PropTypes.Requireable<PropTypes.InferProps<{
            fadeIn: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            moveIn: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            expand: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            scaleUp: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
        }>>;
        exitAnimation: PropTypes.Requireable<PropTypes.InferProps<{
            fadeOut: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            moveOut: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            collapse: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
            scaleDown: PropTypes.Requireable<NonNullable<boolean | object | null | undefined>>;
        }>>;
        mountOnEnter: PropTypes.Requireable<boolean>;
        onStart: PropTypes.Requireable<(...args: any[]) => any>;
        onEnd: PropTypes.Requireable<(...args: any[]) => any>;
        show: PropTypes.Requireable<boolean>;
        unmountOnExit: PropTypes.Requireable<boolean>;
    };
};
export default Transition;
//# sourceMappingURL=Transition.d.ts.map