"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.trendIndicatorDriverFactory = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _unidriver = require("../test-utils/utils/unidriver");
var _constants = require("./constants");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var trendIndicatorDriverFactory = (base, body) => {
  return _objectSpread(_objectSpread({}, (0, _unidriver.baseUniDriverFactory)(base, body)), {}, {
    /**
     * Returns true if trend icon exist
     * @returns {Promise<boolean>}
     */
    hasTrendIndicatorIcon: () => (0, _unidriver.findByHook)(base, _constants.dataHooks.trendIndicatorIcon).exists(),
    /**
     * Returns true if trend icon is sort up
     * @returns {Promise<boolean>}
     */
    isTrendIndicatorIconUp: () => (0, _unidriver.findByHook)(base, _constants.dataHooks.trendIndicatorUp).exists(),
    /**
     * Returns true if trend icon is sort down
     * @returns {Promise<boolean>}
     */
    isTrendIndicatorIconDown: () => (0, _unidriver.findByHook)(base, _constants.dataHooks.trendIndicatorDown).exists(),
    /**
     * Gets trend value
     * @returns {Promise<number>}
     */
    getTrendValue: function () {
      var _getTrendValue = (0, _asyncToGenerator2.default)(function* () {
        var text = yield (0, _unidriver.findByHook)(base, _constants.dataHooks.trendIndicatorValue).text();
        return Number(text.replace('%', ''));
      });
      function getTrendValue() {
        return _getTrendValue.apply(this, arguments);
      }
      return getTrendValue;
    }()
  });
};
exports.trendIndicatorDriverFactory = trendIndicatorDriverFactory;
//# sourceMappingURL=TrendIndicator.uni.driver.js.map