declare namespace _default {
    export { insertText };
    export { insertEntity };
    export { getMatchesInString };
    export { convertToString };
    export { stringToContentState };
    export { decoratorFactory };
    export { pushAndKeepSelection };
    export { hasUnparsedEntity };
    export { moveToEdge };
    export { isContentChanged };
    export { isBlured };
}
export default _default;
/** Insert text in current cursor position */
declare function insertText(editorState: any, text: any): any;
/** Insert new entity in current cursor position, with the given text and value */
declare function insertEntity(editorState: any, { text, value, tagProps }: {
    text: any;
    value: any;
    tagProps: any;
}): any;
/** Get variable with given prefix and suffix in the given string */
declare function getMatchesInString(str: any, prefix: any, suffix: any): RegExpExecArray[];
/** Convert editor content state, to string with placeholders instead of entities */
declare function convertToString({ editorState, prefix, suffix }: {
    editorState: any;
    prefix: any;
    suffix: any;
}): any;
/** Convert string to editor content state */
declare function stringToContentState({ str, variableParser, variableTagPropsParser, prefix, suffix, }: {
    str?: string | undefined;
    variableParser?: (() => void) | undefined;
    variableTagPropsParser?: (() => void) | undefined;
    prefix?: string | undefined;
    suffix?: string | undefined;
}): any;
declare function decoratorFactory({ tag: { size, disabled } }: {
    tag: {
        size: any;
        disabled: any;
    };
}): any;
/** When pushing content to EditorState selection is resets, we keep the selection and reset it after push */
declare function pushAndKeepSelection({ editorState, content }: {
    editorState: any;
    content: any;
}): any;
/** Check if editor has unparsed entities */
declare function hasUnparsedEntity(editorState: any, prefix: any, suffix: any): boolean;
/** Move selection to edge of entity */
declare function moveToEdge(editorState: any, forceEnd?: boolean): any;
/** Returns true if content has changed */
declare function isContentChanged(editorStateBefore: any, editorStateAfter: any): boolean;
/** Returns true if state lost focus */
declare function isBlured(editorStateBefore: any, editorStateAfter: any): any;
//# sourceMappingURL=EditorUtilities.d.ts.map