"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.extractEllipsisProps = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _excluded = ["appendTo", "disabled", "ellipsis", "enterDelay", "exitDelay", "fixed", "flip", "maxWidth", "moveArrowTo", "onHide", "onShow", "placement", "showTooltip", "textAlign", "zIndex", "maxLines"];
/**
 * A utility function that extracts Ellipsis relevant props and wrapped Component relevant props
 * @returns {{ellipsisProps: *, componentProps: *}}
 */
var extractEllipsisProps = _ref => {
  var {
      appendTo,
      disabled,
      ellipsis,
      enterDelay,
      exitDelay,
      fixed,
      flip,
      maxWidth,
      moveArrowTo,
      onHide,
      onShow,
      placement,
      showTooltip,
      textAlign,
      zIndex,
      maxLines
    } = _ref,
    componentProps = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  return {
    ellipsisProps: {
      appendTo,
      disabled,
      ellipsis,
      enterDelay,
      exitDelay,
      fixed,
      flip,
      maxWidth,
      moveArrowTo,
      onHide,
      onShow,
      placement,
      showTooltip,
      textAlign,
      zIndex,
      maxLines
    },
    componentProps
  };
};
exports.extractEllipsisProps = extractEllipsisProps;
//# sourceMappingURL=EllipsisUtils.js.map