"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.createDriver = exports.WithFocusablePureComponent = exports.PureChildComponent = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _react2 = require("../../test-utils/utils/react");
var _Focusable = require("./Focusable");
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/common/Focusable/Focusable.driver.js";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _hasFocusState = element => element.className.includes('focus') === true;
var _hasFocusVisibleState = element => element.className.includes('focus-visible') === true;
class PureChildComponent extends _react.default.PureComponent {
  constructor(props) {
    super(props);
    this.id = void 0;
    this.unboundMethod = () => 'unboundMethod';
    this.boundMethod = () => this.id;
    this.id = props.id;
    this.boundMethod = this.boundMethod.bind(this);
  }
  render() {
    return /*#__PURE__*/_react.default.createElement("div", {
      onFocus: this.props.focusableOnFocus,
      onBlur: this.props.focusableOnBlur,
      "data-hook": this.props['data-hook'],
      className: this.props.className,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 27,
        columnNumber: 7
      }
    }, "Hello");
  }
}
exports.PureChildComponent = PureChildComponent;
PureChildComponent.staticVariable = 'staticVariable';
PureChildComponent.staticMethod = () => 'staticMethod';
var focusableDriverFactory = _ref => {
  var {
    element,
    eventTrigger
  } = _ref;
  return {
    exists: () => !!element,
    focus: () => !!element && eventTrigger.focus(element),
    blur: () => !!element && eventTrigger.blur(element),
    hasFocusState: () => !!element && _hasFocusState(element),
    hasFocusVisibleState: () => !!element && _hasFocusVisibleState(element)
  };
};
var render = (0, _react2.createRendererWithDriver)(focusableDriverFactory);
var createDriver = Component => {
  var {
    driver
  } = render(Component);
  var fireMouseDown = () => window.dispatchEvent(new window.Event('mousedown'));
  var fireMouseUp = () => window.dispatchEvent(new window.Event('mouseup'));
  var fireKeyDown = () => window.dispatchEvent(new window.Event('keydown'));
  var fireKeyUp = () => window.dispatchEvent(new window.Event('keyup'));
  var tabOut = () => {
    fireKeyDown();
    driver.blur();
    fireKeyUp();
  };
  var tabIn = () => {
    fireKeyDown();
    driver.focus();
    fireKeyUp();
  };
  var click = () => {
    fireMouseDown();
    driver.focus();
    fireMouseUp();
  };
  return _objectSpread(_objectSpread({}, driver), {}, {
    fireMouseDown,
    fireKeyDown,
    fireKeyUp,
    tabOut,
    tabIn,
    click
  });
};
exports.createDriver = createDriver;
var WithFocusablePureComponent = exports.WithFocusablePureComponent = (0, _Focusable.withFocusable)(PureChildComponent);
//# sourceMappingURL=Focusable.driver.js.map