"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.TooltipCommonProps = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var propTypes = {
  /** applied as data-hook HTML attribute that can be used to create driver in testing */
  dataHook: _propTypes.default.string,
  /** A css class to be applied to the component's root element */
  className: _propTypes.default.string,
  /** tooltip trigger element. Can be either string or renderable node */
  children: _propTypes.default.node.isRequired,
  /** tooltip content. Can be either string or renderable node */
  content: _propTypes.default.node,
  /** align tooltip content */
  textAlign: _propTypes.default.oneOf(['start', 'center']),
  /** time in milliseconds to wait before showing the tooltip */
  enterDelay: _propTypes.default.number,
  /**  time in milliseconds to wait before hiding the  Defaults to 0. */
  exitDelay: _propTypes.default.number,
  /** moves tooltip content relative to the parent by x or y */
  moveBy: _propTypes.default.shape({
    x: _propTypes.default.number,
    y: _propTypes.default.number
  }),
  /** Moves arrow by amount */
  moveArrowTo: _propTypes.default.number,
  /** tooltips content calculation relation to a dom element. Can be either:
   *  `'window', 'scrollParent', 'viewport', 'parent'`, `element` or
   * `function` based predicate i.e. (elm) =>
   *  elm.getAttribute('data-hook') === 'value'
   */
  appendTo: _propTypes.default.oneOfType([_propTypes.default.oneOf(['window', 'scrollParent', 'viewport', 'parent']), _propTypes.default.element, _propTypes.default.func]),
  /** whether to enable the flip behaviour. This behaviour is used to flip the Tooltips placement when it starts to overlap the target element. */
  flip: _propTypes.default.bool,
  /** whether to enable the fixed behaviour. This behaviour is used to keep the Tooltip at it's original placement even when it's being positioned outside the boundary. */
  fixed: _propTypes.default.bool,
  /** tooltip content container width in pixels */
  maxWidth: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  /** callback on tooltips content show event */
  onShow: _propTypes.default.func,
  /** callback on tooltips content hide event */
  onHide: _propTypes.default.func,
  /** tooltip content placement in relation to target element */
  placement: _propTypes.default.string,
  /** disables tooltip element trigger behaviour. If not specified, `disabled` prop of the `children` element will be used. */
  disabled: _propTypes.default.bool,
  /** sets size of the tooltip */
  size: _propTypes.default.oneOf(['small', 'medium']),
  /** establishes a relationship between tooltip element and tooltip content for a11y purposes */
  'aria-describedby': _propTypes.default.string,
  /** tooltips content zindex */
  zIndex: _propTypes.default.number,
  /** stretch root element to the width of its container. */
  fluid: _propTypes.default.bool
};
var TooltipCommonProps = exports.TooltipCommonProps = {
  appendTo: propTypes['appendTo'],
  disabled: propTypes['disabled'],
  enterDelay: propTypes['enterDelay'],
  exitDelay: propTypes['exitDelay'],
  fixed: propTypes['fixed'],
  flip: propTypes['flip'],
  maxWidth: propTypes['maxWidth'],
  moveArrowTo: propTypes['moveArrowTo'],
  moveBy: propTypes['moveBy'],
  onHide: propTypes['onHide'],
  onShow: propTypes['onShow'],
  placement: propTypes['placement'],
  textAlign: propTypes['textAlign'],
  zIndex: propTypes['zIndex'],
  size: propTypes['size']
};
//# sourceMappingURL=TooltipCommon.js.map