"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var _scrollAreaLogic = require("./scrollAreaLogic");
var _extractAttributes = require("../../utils/extractAttributes");
var _excluded = ["dataHook", "className", "style", "children", "onScrollAreaChanged", "onScrollChanged", "scrollThrottleWait"];
var _jsxFileName = "/home/builduser/work/2084893ac9ffd449/packages/wix-style-react/dist/cjs/common/ScrollableContainer/ScrollableContainer.js";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ScrollableContainer = /*#__PURE__*/(0, _react.forwardRef)(function ScrollableContainer(_ref, ref) {
  var {
      dataHook,
      className,
      style,
      children,
      onScrollAreaChanged,
      onScrollChanged,
      scrollThrottleWait = 100
    } = _ref,
    restProps = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var elementRef = (0, _react.useRef)(null);
  // In case a ref was passed from outside we should use it so allow the parent access to the dom node as well.
  var scrollContainerElement = ref || elementRef;
  var scrollAreaY = (0, _react.useRef)('');

  // TODO: fix ESLint error
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var handleScrollAreaChanged = (0, _react.useCallback)((0, _throttle.default)(_ref2 => {
    var {
      target
    } = _ref2;
    var newScrollAreaY = (0, _scrollAreaLogic.getScrollAreaY)(target);
    if (scrollAreaY.current !== newScrollAreaY) {
      scrollAreaY.current = newScrollAreaY;
      onScrollAreaChanged({
        target,
        area: {
          y: newScrollAreaY
        }
      });
    }
  }, scrollThrottleWait, {
    trailing: true
  }), [onScrollAreaChanged, scrollThrottleWait]);

  // TODO: fix ESLint error
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var handleScrollChanged = (0, _react.useCallback)((0, _throttle.default)(e => onScrollChanged(e), scrollThrottleWait, {
    trailing: true
  }), [onScrollChanged, scrollThrottleWait]);
  (0, _react.useEffect)(() => {
    // Registering to the scroll event only if the relevant handlers were provided
    var scrollableElement = scrollContainerElement.current;
    if (onScrollAreaChanged) {
      scrollableElement.addEventListener('scroll', handleScrollAreaChanged);
      // We trigger a call to this handler to expose the initial scroll area to registering consumers
      handleScrollAreaChanged({
        target: scrollableElement
      });
    }
    if (onScrollChanged) {
      scrollableElement.addEventListener('scroll', handleScrollChanged);
    }
    return () => {
      // Unregistering from relevant events on component unmount
      if (onScrollAreaChanged) {
        handleScrollAreaChanged.cancel();
        scrollableElement.removeEventListener('scroll', handleScrollAreaChanged);
      }
      if (onScrollChanged) {
        handleScrollChanged.cancel();
        scrollableElement.removeEventListener('scroll', handleScrollChanged);
      }
    };
  }, [handleScrollChanged, handleScrollAreaChanged, onScrollChanged, onScrollAreaChanged, scrollContainerElement]);
  var stl = _objectSpread({
    height: 'inherit',
    width: 'inherit',
    overflowY: 'auto'
  }, style);
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    "data-hook": dataHook,
    className: className,
    style: stl,
    ref: scrollContainerElement
  }, (0, _extractAttributes.extractDataAttributes)(restProps), {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 93,
      columnNumber: 5
    }
  }), children);
});
ScrollableContainer.propTypes = {
  /* The wait time value the scroll event will be throttled by */
  scrollThrottleWait: _propTypes.default.number,
  /** A Handler for scroll area changes, will trigger only when the user scrolls to a different area of
   * the container, see signature for possible areas
   *
   * ##### Signature:
   * `function({area: {y: AreaY, x: AreaX}, target: HTMLElement}) => void`
   *
   * `AreaY`: top | middle | bottom | none
   *
   * `AreaX`: start | middle | end | none (not implemented yet)
   */
  onScrollAreaChanged: _propTypes.default.func,
  /** A Generic Handler for scroll changes with throttling
   * ##### Signature:
   * function({target: HTMLElement}) => void
   */
  onScrollChanged: _propTypes.default.func
};
var _default = exports.default = ScrollableContainer;
//# sourceMappingURL=ScrollableContainer.js.map