"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = require("react");
// Returns a function that checks whether component is still mounted
var useIsMounted = () => {
  var mountedRef = (0, _react.useRef)(true);
  (0, _react.useEffect)(() => {
    // React performs the cleanup when the component unmounts
    var cleanup = () => {
      mountedRef.current = false;
    };
    return cleanup;
  }, []);
  return () => mountedRef.current;
};
var _default = exports.default = useIsMounted;
//# sourceMappingURL=useIsMounted.js.map