import {ReactWrapper} from 'enzyme';

type EnzymeTestkitFactory<T> = (
  params: EnzymeTestkitParams,
) => T;

type EnzymeUniTestkitFactory<T> = (
  params: EnzymeTestkitParams,
) => T;

interface EnzymeTestkitParams {
  wrapper: ReactWrapper;
  dataHook: string;
}

type DeprecatedEnzymeTestkit = any;

import { AccordionUniDriver } from '../src/Accordion/Accordion.uni.driver';

export const AccordionTestkit: EnzymeUniTestkitFactory<AccordionUniDriver>;
export const accordionTestkitFactory: EnzymeUniTestkitFactory<AccordionUniDriver>;

import { AddItemUniDriver } from '../src/AddItem/AddItem.uni.driver';
import { AddItemDriver } from '../src/AddItem/AddItem.driver';
export const AddItemTestkit: EnzymeUniTestkitFactory<AddItemUniDriver>;
export const addItemTestkitFactory: EnzymeTestkitFactory<AddItemDriver>;

import { AddressInputUniDriver } from '../src/AddressInput/AddressInput.uni.driver';

export const AddressInputTestkit: EnzymeUniTestkitFactory<AddressInputUniDriver>;
export const addressInputTestkitFactory: EnzymeUniTestkitFactory<AddressInputUniDriver>;

import { AddressInputItemUniDriver } from '../src/AddressInputItem/AddressInputItem.uni.driver';

export const AddressInputItemTestkit: EnzymeUniTestkitFactory<AddressInputItemUniDriver>;
export const addressInputItemTestkitFactory: EnzymeUniTestkitFactory<AddressInputItemUniDriver>;

import { AnalyticsLayoutUniDriver } from '../src/AnalyticsLayout/AnalyticsLayout.uni.driver';

export const AnalyticsLayoutTestkit: EnzymeUniTestkitFactory<AnalyticsLayoutUniDriver>;
export const analyticsLayoutTestkitFactory: EnzymeUniTestkitFactory<AnalyticsLayoutUniDriver>;

import { AnalyticsSummaryCardUniDriver } from '../src/AnalyticsSummaryCard/AnalyticsSummaryCard.uni.driver';

export const AnalyticsSummaryCardTestkit: EnzymeUniTestkitFactory<AnalyticsSummaryCardUniDriver>;
export const analyticsSummaryCardTestkitFactory: EnzymeUniTestkitFactory<AnalyticsSummaryCardUniDriver>;

import { AnimateUniDriver } from '../src/Animate/Animate.uni.driver';

export const AnimateTestkit: EnzymeUniTestkitFactory<AnimateUniDriver>;
export const animateTestkitFactory: EnzymeUniTestkitFactory<AnimateUniDriver>;

import { AnnouncementModalLayoutUniDriver } from '../src/AnnouncementModalLayout/AnnouncementModalLayout.uni.driver';

export const AnnouncementModalLayoutTestkit: EnzymeUniTestkitFactory<AnnouncementModalLayoutUniDriver>;
export const announcementModalLayoutTestkitFactory: EnzymeUniTestkitFactory<AnnouncementModalLayoutUniDriver>;

import { AreaChartUniDriver } from '../src/AreaChart/AreaChart.uni.driver';

export const AreaChartTestkit: EnzymeUniTestkitFactory<AreaChartUniDriver>;
export const areaChartTestkitFactory: EnzymeUniTestkitFactory<AreaChartUniDriver>;

import { AtlasAddressInputUniDriver } from '../src/AtlasAddressInput/AtlasAddressInput.uni.driver';

export const AtlasAddressInputTestkit: EnzymeUniTestkitFactory<AtlasAddressInputUniDriver>;
export const atlasAddressInputTestkitFactory: EnzymeUniTestkitFactory<AtlasAddressInputUniDriver>;

import { AudioPlayerUniDriver } from '../src/AudioPlayer/AudioPlayer.uni.driver';

export const AudioPlayerTestkit: EnzymeUniTestkitFactory<AudioPlayerUniDriver>;
export const audioPlayerTestkitFactory: EnzymeUniTestkitFactory<AudioPlayerUniDriver>;

import { AutoCompleteUniDriver } from '../src/AutoComplete/AutoComplete.uni.driver';
import { AutoCompleteDriver } from '../src/AutoComplete/AutoComplete.driver';
export const AutoCompleteTestkit: EnzymeUniTestkitFactory<AutoCompleteUniDriver>;
export const autoCompleteTestkitFactory: EnzymeTestkitFactory<AutoCompleteDriver>;

import { AutoCompleteWithLabelUniDriver } from '../src/AutoCompleteWithLabel/AutoCompleteWithLabel.uni.driver';

export const AutoCompleteWithLabelTestkit: EnzymeUniTestkitFactory<AutoCompleteWithLabelUniDriver>;
export const autoCompleteWithLabelTestkitFactory: EnzymeUniTestkitFactory<AutoCompleteWithLabelUniDriver>;

import { AvatarUniDriver } from '../src/Avatar/Avatar.uni.driver';

export const AvatarTestkit: EnzymeUniTestkitFactory<AvatarUniDriver>;
export const avatarTestkitFactory: EnzymeUniTestkitFactory<AvatarUniDriver>;

import { AvatarGroupUniDriver } from '../src/AvatarGroup/AvatarGroup.uni.driver';

export const AvatarGroupTestkit: EnzymeUniTestkitFactory<AvatarGroupUniDriver>;
export const avatarGroupTestkitFactory: EnzymeUniTestkitFactory<AvatarGroupUniDriver>;

import { BadgeUniDriver } from '../src/Badge/Badge.uni.driver';
import { BadgeDriver } from '../src/Badge/Badge.driver';
export const BadgeTestkit: EnzymeUniTestkitFactory<BadgeUniDriver>;
export const badgeTestkitFactory: EnzymeTestkitFactory<BadgeDriver>;

import { BadgeSelectUniDriver } from '../src/BadgeSelect/BadgeSelect.uni.driver';
import { BadgeSelectDriver } from '../src/BadgeSelect/BadgeSelect.driver';
export const BadgeSelectTestkit: EnzymeUniTestkitFactory<BadgeSelectUniDriver>;
export const badgeSelectTestkitFactory: EnzymeTestkitFactory<BadgeSelectDriver>;

import { BadgeSelectItemUniDriver } from '../src/BadgeSelectItem/BadgeSelectItem.uni.driver';

export const BadgeSelectItemTestkit: EnzymeUniTestkitFactory<BadgeSelectItemUniDriver>;
export const badgeSelectItemTestkitFactory: EnzymeUniTestkitFactory<BadgeSelectItemUniDriver>;

import { BarChartUniDriver } from '../src/BarChart/BarChart.uni.driver';

export const BarChartTestkit: EnzymeUniTestkitFactory<BarChartUniDriver>;
export const barChartTestkitFactory: EnzymeUniTestkitFactory<BarChartUniDriver>;

import { BounceAnimationUniDriver } from '../src/BounceAnimation/BounceAnimation.uni.driver';

export const BounceAnimationTestkit: EnzymeUniTestkitFactory<BounceAnimationUniDriver>;
export const bounceAnimationTestkitFactory: EnzymeUniTestkitFactory<BounceAnimationUniDriver>;

import { BoxUniDriver } from '../src/Box/Box.uni.driver';

export const BoxTestkit: EnzymeUniTestkitFactory<BoxUniDriver>;
export const boxTestkitFactory: EnzymeUniTestkitFactory<BoxUniDriver>;

import { BreadcrumbsUniDriver } from '../src/Breadcrumbs/Breadcrumbs.uni.driver';
import { BreadcrumbsDriver } from '../src/Breadcrumbs/Breadcrumbs.driver';
export const BreadcrumbsTestkit: EnzymeUniTestkitFactory<BreadcrumbsUniDriver>;
export const breadcrumbsTestkitFactory: EnzymeTestkitFactory<BreadcrumbsDriver>;

import { BrowserPreviewWidgetUniDriver } from '../src/BrowserPreviewWidget/BrowserPreviewWidget.uni.driver';

export const BrowserPreviewWidgetTestkit: EnzymeUniTestkitFactory<BrowserPreviewWidgetUniDriver>;
export const browserPreviewWidgetTestkitFactory: EnzymeUniTestkitFactory<BrowserPreviewWidgetUniDriver>;

import { ButtonUniDriver } from '../src/Button/Button.uni.driver';

export const ButtonTestkit: EnzymeUniTestkitFactory<ButtonUniDriver>;
export const buttonTestkitFactory: EnzymeUniTestkitFactory<ButtonUniDriver>;

import { CalendarUniDriver } from '../src/Calendar/Calendar.uni.driver';
import { CalendarDriver } from '../src/Calendar/Calendar.driver';
export const CalendarTestkit: EnzymeUniTestkitFactory<CalendarUniDriver>;
export const calendarTestkitFactory: EnzymeTestkitFactory<CalendarDriver>;

import { CalendarPanelUniDriver } from '../src/CalendarPanel/CalendarPanel.uni.driver';
import { CalendarPanelDriver } from '../src/CalendarPanel/CalendarPanel.driver';
export const CalendarPanelTestkit: EnzymeUniTestkitFactory<CalendarPanelUniDriver>;
export const calendarPanelTestkitFactory: EnzymeTestkitFactory<CalendarPanelDriver>;

import { CalendarPanelFooterUniDriver } from '../src/CalendarPanelFooter/CalendarPanelFooter.uni.driver';

export const CalendarPanelFooterTestkit: EnzymeUniTestkitFactory<CalendarPanelFooterUniDriver>;
export const calendarPanelFooterTestkitFactory: EnzymeUniTestkitFactory<CalendarPanelFooterUniDriver>;

import { CardFolderTabsUniDriver } from '../src/CardFolderTabs/CardFolderTabs.uni.driver';

export const CardFolderTabsTestkit: EnzymeUniTestkitFactory<CardFolderTabsUniDriver>;
export const cardFolderTabsTestkitFactory: EnzymeUniTestkitFactory<CardFolderTabsUniDriver>;

import { CardGalleryItemUniDriver } from '../src/CardGalleryItem/CardGalleryItem.uni.driver';

export const CardGalleryItemTestkit: EnzymeUniTestkitFactory<CardGalleryItemUniDriver>;
export const cardGalleryItemTestkitFactory: EnzymeUniTestkitFactory<CardGalleryItemUniDriver>;

import { CarouselUniDriver } from '../src/Carousel/Carousel.uni.driver';
import { CarouselDriver } from '../src/Carousel/Carousel.driver';
export const CarouselTestkit: EnzymeUniTestkitFactory<CarouselUniDriver>;
export const carouselTestkitFactory: EnzymeTestkitFactory<CarouselDriver>;

import { CarouselWIPUniDriver } from '../src/CarouselWIP/CarouselWIP.uni.driver';

export const CarouselWIPTestkit: EnzymeUniTestkitFactory<CarouselWIPUniDriver>;
export const carouselWipTestkitFactory: EnzymeUniTestkitFactory<CarouselWIPUniDriver>;

import { CheckToggleUniDriver } from '../src/CheckToggle/CheckToggle.uni.driver';

export const CheckToggleTestkit: EnzymeUniTestkitFactory<CheckToggleUniDriver>;
export const checkToggleTestkitFactory: EnzymeUniTestkitFactory<CheckToggleUniDriver>;

import { CheckboxUniDriver } from '../src/Checkbox/Checkbox.uni.driver';
import { CheckboxDriver } from '../src/Checkbox/Checkbox.driver';
export const CheckboxTestkit: EnzymeUniTestkitFactory<CheckboxUniDriver>;
export const checkboxTestkitFactory: EnzymeTestkitFactory<CheckboxDriver>;

import { CircularProgressBarUniDriver } from '../src/CircularProgressBar/CircularProgressBar.uni.driver';
import { CircularProgressBarDriver } from '../src/CircularProgressBar/CircularProgressBar.driver';
export const CircularProgressBarTestkit: EnzymeUniTestkitFactory<CircularProgressBarUniDriver>;
export const circularProgressBarTestkitFactory: EnzymeTestkitFactory<CircularProgressBarDriver>;

import { CloseButtonUniDriver } from '../src/CloseButton/CloseButton.uni.driver';

export const CloseButtonTestkit: EnzymeUniTestkitFactory<CloseButtonUniDriver>;
export const closeButtonTestkitFactory: EnzymeUniTestkitFactory<CloseButtonUniDriver>;

import { CollapseUniDriver } from '../src/Collapse/Collapse.uni.driver';

export const CollapseTestkit: EnzymeUniTestkitFactory<CollapseUniDriver>;
export const collapseTestkitFactory: EnzymeUniTestkitFactory<CollapseUniDriver>;

import { ColorInputUniDriver } from '../src/ColorInput/ColorInput.uni.driver';

export const ColorInputTestkit: EnzymeUniTestkitFactory<ColorInputUniDriver>;
export const colorInputTestkitFactory: EnzymeUniTestkitFactory<ColorInputUniDriver>;

import { ColorPickerUniDriver } from '../src/ColorPicker/ColorPicker.uni.driver';
import { ColorPickerDriver } from '../src/ColorPicker/ColorPicker.driver';
export const ColorPickerTestkit: EnzymeUniTestkitFactory<ColorPickerUniDriver>;
export const colorPickerTestkitFactory: EnzymeTestkitFactory<ColorPickerDriver>;

import { ComposerHeaderUniDriver } from '../src/ComposerHeader/ComposerHeader.uni.driver';

export const ComposerHeaderTestkit: EnzymeUniTestkitFactory<ComposerHeaderUniDriver>;
export const composerHeaderTestkitFactory: EnzymeUniTestkitFactory<ComposerHeaderUniDriver>;

import { ComposerSidebarUniDriver } from '../src/ComposerSidebar/ComposerSidebar.uni.driver';

export const ComposerSidebarTestkit: EnzymeUniTestkitFactory<ComposerSidebarUniDriver>;
export const composerSidebarTestkitFactory: EnzymeUniTestkitFactory<ComposerSidebarUniDriver>;

import { CopyClipboardUniDriver } from '../src/CopyClipboard/CopyClipboard.uni.driver';

export const CopyClipboardTestkit: EnzymeUniTestkitFactory<CopyClipboardUniDriver>;
export const copyClipboardTestkitFactory: EnzymeUniTestkitFactory<CopyClipboardUniDriver>;

import { CounterBadgeUniDriver } from '../src/CounterBadge/CounterBadge.uni.driver';

export const CounterBadgeTestkit: EnzymeUniTestkitFactory<CounterBadgeUniDriver>;
export const counterBadgeTestkitFactory: EnzymeUniTestkitFactory<CounterBadgeUniDriver>;

import { CustomModalLayoutUniDriver } from '../src/CustomModalLayout/CustomModalLayout.uni.driver';

export const CustomModalLayoutTestkit: EnzymeUniTestkitFactory<CustomModalLayoutUniDriver>;
export const customModalLayoutTestkitFactory: EnzymeUniTestkitFactory<CustomModalLayoutUniDriver>;

import { DatePickerUniDriver } from '../src/DatePicker/DatePicker.uni.driver';
import { DatePickerDriver } from '../src/DatePicker/DatePicker.driver';
export const DatePickerTestkit: EnzymeUniTestkitFactory<DatePickerUniDriver>;
export const datePickerTestkitFactory: EnzymeTestkitFactory<DatePickerDriver>;

import { DividerUniDriver } from '../src/Divider/Divider.uni.driver';

export const DividerTestkit: EnzymeUniTestkitFactory<DividerUniDriver>;
export const dividerTestkitFactory: EnzymeUniTestkitFactory<DividerUniDriver>;

import { DropdownUniDriver } from '../src/Dropdown/Dropdown.uni.driver';
import { DropdownDriver } from '../src/Dropdown/Dropdown.driver';
export const DropdownTestkit: EnzymeUniTestkitFactory<DropdownUniDriver>;
export const dropdownTestkitFactory: EnzymeTestkitFactory<DropdownDriver>;

import { DropdownBaseUniDriver } from '../src/DropdownBase/DropdownBase.uni.driver';

export const DropdownBaseTestkit: EnzymeUniTestkitFactory<DropdownBaseUniDriver>;
export const dropdownBaseTestkitFactory: EnzymeUniTestkitFactory<DropdownBaseUniDriver>;

import { DropdownLayoutUniDriver } from '../src/DropdownLayout/DropdownLayout.uni.driver';
import { DropdownLayoutDriver } from '../src/DropdownLayout/DropdownLayout.driver';
export const DropdownLayoutTestkit: EnzymeUniTestkitFactory<DropdownLayoutUniDriver>;
export const dropdownLayoutTestkitFactory: EnzymeTestkitFactory<DropdownLayoutDriver>;

import { DropzoneUniDriver } from '../src/Dropzone/Dropzone.uni.driver';

export const DropzoneTestkit: EnzymeUniTestkitFactory<DropzoneUniDriver>;
export const dropzoneTestkitFactory: EnzymeUniTestkitFactory<DropzoneUniDriver>;

import { EditableSelectorUniDriver } from '../src/EditableSelector/EditableSelector.uni.driver';
import { EditableSelectorDriver } from '../src/EditableSelector/EditableSelector.driver';
export const EditableSelectorTestkit: EnzymeUniTestkitFactory<EditableSelectorUniDriver>;
export const editableSelectorTestkitFactory: EnzymeTestkitFactory<EditableSelectorDriver>;

import { EditableTitleUniDriver } from '../src/EditableTitle/EditableTitle.uni.driver';

export const EditableTitleTestkit: EnzymeUniTestkitFactory<EditableTitleUniDriver>;
export const editableTitleTestkitFactory: EnzymeUniTestkitFactory<EditableTitleUniDriver>;

import { EmptyStateUniDriver } from '../src/EmptyState/EmptyState.uni.driver';
import { EmptyStateDriver } from '../src/EmptyState/EmptyState.driver';
export const EmptyStateTestkit: EnzymeUniTestkitFactory<EmptyStateUniDriver>;
export const emptyStateTestkitFactory: EnzymeTestkitFactory<EmptyStateDriver>;

import { FacesRatingBarUniDriver } from '../src/FacesRatingBar/FacesRatingBar.uni.driver';

export const FacesRatingBarTestkit: EnzymeUniTestkitFactory<FacesRatingBarUniDriver>;
export const facesRatingBarTestkitFactory: EnzymeUniTestkitFactory<FacesRatingBarUniDriver>;

import { FeatureListUniDriver } from '../src/FeatureList/FeatureList.uni.driver';

export const FeatureListTestkit: EnzymeUniTestkitFactory<FeatureListUniDriver>;
export const featureListTestkitFactory: EnzymeUniTestkitFactory<FeatureListUniDriver>;

import { FieldSetUniDriver } from '../src/FieldSet/FieldSet.uni.driver';

export const FieldSetTestkit: EnzymeUniTestkitFactory<FieldSetUniDriver>;
export const fieldSetTestkitFactory: EnzymeUniTestkitFactory<FieldSetUniDriver>;

import { FilePickerUniDriver } from '../src/FilePicker/FilePicker.uni.driver';
import { FilePickerDriver } from '../src/FilePicker/FilePicker.driver';
export const FilePickerTestkit: EnzymeUniTestkitFactory<FilePickerUniDriver>;
export const filePickerTestkitFactory: EnzymeTestkitFactory<FilePickerDriver>;

import { FileUploadUniDriver } from '../src/FileUpload/FileUpload.uni.driver';

export const FileUploadTestkit: EnzymeUniTestkitFactory<FileUploadUniDriver>;
export const fileUploadTestkitFactory: EnzymeUniTestkitFactory<FileUploadUniDriver>;

import { FillButtonUniDriver } from '../src/FillButton/FillButton.uni.driver';

export const FillButtonTestkit: EnzymeUniTestkitFactory<FillButtonUniDriver>;
export const fillButtonTestkitFactory: EnzymeUniTestkitFactory<FillButtonUniDriver>;

import { FillPreviewUniDriver } from '../src/FillPreview/FillPreview.uni.driver';

export const FillPreviewTestkit: EnzymeUniTestkitFactory<FillPreviewUniDriver>;
export const fillPreviewTestkitFactory: EnzymeUniTestkitFactory<FillPreviewUniDriver>;

import { FloatingHelperUniDriver } from '../src/FloatingHelper/FloatingHelper.uni.driver';
import { FloatingHelperDriver } from '../src/FloatingHelper/FloatingHelper.driver';
export const FloatingHelperTestkit: EnzymeUniTestkitFactory<FloatingHelperUniDriver>;
export const floatingHelperTestkitFactory: EnzymeTestkitFactory<FloatingHelperDriver>;

import { FloatingNotificationUniDriver } from '../src/FloatingNotification/FloatingNotification.uni.driver';

export const FloatingNotificationTestkit: EnzymeUniTestkitFactory<FloatingNotificationUniDriver>;
export const floatingNotificationTestkitFactory: EnzymeUniTestkitFactory<FloatingNotificationUniDriver>;

import { FormFieldUniDriver } from '../src/FormField/FormField.uni.driver';
import { FormFieldDriver } from '../src/FormField/FormField.driver';
export const FormFieldTestkit: EnzymeUniTestkitFactory<FormFieldUniDriver>;
export const formFieldTestkitFactory: EnzymeTestkitFactory<FormFieldDriver>;

import { FunnelChartUniDriver } from '../src/FunnelChart/FunnelChart.uni.driver';

export const FunnelChartTestkit: EnzymeUniTestkitFactory<FunnelChartUniDriver>;
export const funnelChartTestkitFactory: EnzymeUniTestkitFactory<FunnelChartUniDriver>;

import { GooglePreviewUniDriver } from '../src/GooglePreview/GooglePreview.uni.driver';

export const GooglePreviewTestkit: EnzymeUniTestkitFactory<GooglePreviewUniDriver>;
export const googlePreviewTestkitFactory: EnzymeUniTestkitFactory<GooglePreviewUniDriver>;

import { HeadingUniDriver } from '../src/Heading/Heading.uni.driver';
import { HeadingDriver } from '../src/Heading/Heading.driver';
export const HeadingTestkit: EnzymeUniTestkitFactory<HeadingUniDriver>;
export const headingTestkitFactory: EnzymeTestkitFactory<HeadingDriver>;

import { HighlighterUniDriver } from '../src/Highlighter/Highlighter.uni.driver';
import { HighlighterDriver } from '../src/Highlighter/Highlighter.driver';
export const HighlighterTestkit: EnzymeUniTestkitFactory<HighlighterUniDriver>;
export const highlighterTestkitFactory: EnzymeTestkitFactory<HighlighterDriver<ReactWrapper>>;

import { HorizontalTimelineUniDriver } from '../src/HorizontalTimeline/HorizontalTimeline.uni.driver';

export const HorizontalTimelineTestkit: EnzymeUniTestkitFactory<HorizontalTimelineUniDriver>;
export const horizontalTimelineTestkitFactory: EnzymeUniTestkitFactory<HorizontalTimelineUniDriver>;

import { IconButtonUniDriver } from '../src/IconButton/IconButton.uni.driver';

export const IconButtonTestkit: EnzymeUniTestkitFactory<IconButtonUniDriver>;
export const iconButtonTestkitFactory: EnzymeUniTestkitFactory<IconButtonUniDriver>;

import { ImageUniDriver } from '../src/Image/Image.uni.driver';

export const ImageTestkit: EnzymeUniTestkitFactory<ImageUniDriver>;
export const imageTestkitFactory: EnzymeUniTestkitFactory<ImageUniDriver>;

import { ImageViewerUniDriver } from '../src/ImageViewer/ImageViewer.uni.driver';
import { ImageViewerDriver } from '../src/ImageViewer/ImageViewer.driver';
export const ImageViewerTestkit: EnzymeUniTestkitFactory<ImageViewerUniDriver>;
export const imageViewerTestkitFactory: EnzymeTestkitFactory<ImageViewerDriver<ReactWrapper>>;

import { InfoIconUniDriver } from '../src/InfoIcon/InfoIcon.uni.driver';

export const InfoIconTestkit: EnzymeUniTestkitFactory<InfoIconUniDriver>;
export const infoIconTestkitFactory: EnzymeUniTestkitFactory<InfoIconUniDriver>;

import { InputUniDriver } from '../src/Input/Input.uni.driver';
import { InputDriver } from '../src/Input/Input.driver';
export const InputTestkit: EnzymeUniTestkitFactory<InputUniDriver>;
export const inputTestkitFactory: EnzymeTestkitFactory<InputDriver>;

import { InputAreaUniDriver } from '../src/InputArea/InputArea.uni.driver';
import { InputAreaDriver } from '../src/InputArea/InputArea.driver';
export const InputAreaTestkit: EnzymeUniTestkitFactory<InputAreaUniDriver>;
export const inputAreaTestkitFactory: EnzymeTestkitFactory<InputAreaDriver<ReactWrapper>>;

import { InputWithLabelUniDriver } from '../src/InputWithLabel/InputWithLabel.uni.driver';

export const InputWithLabelTestkit: EnzymeUniTestkitFactory<InputWithLabelUniDriver>;
export const inputWithLabelTestkitFactory: EnzymeUniTestkitFactory<InputWithLabelUniDriver>;

import { InputWithOptionsUniDriver } from '../src/InputWithOptions/InputWithOptions.uni.driver';
import { InputWithOptionsDriver } from '../src/InputWithOptions/InputWithOptions.driver';
export const InputWithOptionsTestkit: EnzymeUniTestkitFactory<InputWithOptionsUniDriver>;
export const inputWithOptionsTestkitFactory: EnzymeTestkitFactory<InputWithOptionsDriver>;

import { LinearProgressBarUniDriver } from '../src/LinearProgressBar/LinearProgressBar.uni.driver';
import { LinearProgressBarDriver } from '../src/LinearProgressBar/LinearProgressBar.driver';
export const LinearProgressBarTestkit: EnzymeUniTestkitFactory<LinearProgressBarUniDriver>;
export const linearProgressBarTestkitFactory: EnzymeTestkitFactory<LinearProgressBarDriver>;

import { ListItemActionUniDriver } from '../src/ListItemAction/ListItemAction.uni.driver';

export const ListItemActionTestkit: EnzymeUniTestkitFactory<ListItemActionUniDriver>;
export const listItemActionTestkitFactory: EnzymeUniTestkitFactory<ListItemActionUniDriver>;

import { ListItemEditableUniDriver } from '../src/ListItemEditable/ListItemEditable.uni.driver';

export const ListItemEditableTestkit: EnzymeUniTestkitFactory<ListItemEditableUniDriver>;
export const listItemEditableTestkitFactory: EnzymeUniTestkitFactory<ListItemEditableUniDriver>;

import { ListItemSectionUniDriver } from '../src/ListItemSection/ListItemSection.uni.driver';

export const ListItemSectionTestkit: EnzymeUniTestkitFactory<ListItemSectionUniDriver>;
export const listItemSectionTestkitFactory: EnzymeUniTestkitFactory<ListItemSectionUniDriver>;

import { ListItemSelectUniDriver } from '../src/ListItemSelect/ListItemSelect.uni.driver';

export const ListItemSelectTestkit: EnzymeUniTestkitFactory<ListItemSelectUniDriver>;
export const listItemSelectTestkitFactory: EnzymeUniTestkitFactory<ListItemSelectUniDriver>;

import { LiveRegionUniDriver } from '../src/LiveRegion/LiveRegion.uni.driver';

export const LiveRegionTestkit: EnzymeUniTestkitFactory<LiveRegionUniDriver>;
export const liveRegionTestkitFactory: EnzymeUniTestkitFactory<LiveRegionUniDriver>;

import { LoaderUniDriver } from '../src/Loader/Loader.uni.driver';
import { LoaderDriver } from '../src/Loader/Loader.driver';
export const LoaderTestkit: EnzymeUniTestkitFactory<LoaderUniDriver>;
export const loaderTestkitFactory: EnzymeTestkitFactory<LoaderDriver>;

import { MarketingLayoutUniDriver } from '../src/MarketingLayout/MarketingLayout.uni.driver';

export const MarketingLayoutTestkit: EnzymeUniTestkitFactory<MarketingLayoutUniDriver>;
export const marketingLayoutTestkitFactory: EnzymeUniTestkitFactory<MarketingLayoutUniDriver>;

import { MarketingPageLayoutUniDriver } from '../src/MarketingPageLayout/MarketingPageLayout.uni.driver';

export const MarketingPageLayoutTestkit: EnzymeUniTestkitFactory<MarketingPageLayoutUniDriver>;
export const marketingPageLayoutTestkitFactory: EnzymeUniTestkitFactory<MarketingPageLayoutUniDriver>;

import { MarketingPageLayoutContentUniDriver } from '../src/MarketingPageLayoutContent/MarketingPageLayoutContent.uni.driver';

export const MarketingPageLayoutContentTestkit: EnzymeUniTestkitFactory<MarketingPageLayoutContentUniDriver>;
export const marketingPageLayoutContentTestkitFactory: EnzymeUniTestkitFactory<MarketingPageLayoutContentUniDriver>;

import { MediaOverlayUniDriver } from '../src/MediaOverlay/MediaOverlay.uni.driver';

export const MediaOverlayTestkit: EnzymeUniTestkitFactory<MediaOverlayUniDriver<ReactWrapper>>;
export const mediaOverlayTestkitFactory: EnzymeUniTestkitFactory<MediaOverlayUniDriver<ReactWrapper>>;

import { MessageBoxFunctionalLayoutUniDriver } from '../src/MessageBoxFunctionalLayout/MessageBoxFunctionalLayout.uni.driver';
import { MessageBoxFunctionalLayoutDriver } from '../src/MessageBoxFunctionalLayout/MessageBoxFunctionalLayout.driver';
export const MessageBoxFunctionalLayoutTestkit: EnzymeUniTestkitFactory<MessageBoxFunctionalLayoutUniDriver>;
export const messageBoxFunctionalLayoutTestkitFactory: EnzymeTestkitFactory<MessageBoxFunctionalLayoutDriver>;

import { MessageBoxMarketerialLayoutUniDriver } from '../src/MessageBoxMarketerialLayout/MessageBoxMarketerialLayout.uni.driver';
import { MessageBoxMarketerialLayoutDriver } from '../src/MessageBoxMarketerialLayout/MessageBoxMarketerialLayout.driver';
export const MessageBoxMarketerialLayoutTestkit: EnzymeUniTestkitFactory<MessageBoxMarketerialLayoutUniDriver>;
export const messageBoxMarketerialLayoutTestkitFactory: EnzymeTestkitFactory<MessageBoxMarketerialLayoutDriver>;

import { MessageModalLayoutUniDriver } from '../src/MessageModalLayout/MessageModalLayout.uni.driver';

export const MessageModalLayoutTestkit: EnzymeUniTestkitFactory<MessageModalLayoutUniDriver>;
export const messageModalLayoutTestkitFactory: EnzymeUniTestkitFactory<MessageModalLayoutUniDriver>;

import { MobilePreviewWidgetUniDriver } from '../src/MobilePreviewWidget/MobilePreviewWidget.uni.driver';

export const MobilePreviewWidgetTestkit: EnzymeUniTestkitFactory<MobilePreviewWidgetUniDriver>;
export const mobilePreviewWidgetTestkitFactory: EnzymeUniTestkitFactory<MobilePreviewWidgetUniDriver>;

import { ModalUniDriver } from '../src/Modal/Modal.uni.driver';
import { ModalDriver } from '../src/Modal/Modal.driver';
export const ModalTestkit: EnzymeUniTestkitFactory<ModalUniDriver>;
export const modalTestkitFactory: EnzymeTestkitFactory<ModalDriver<ReactWrapper>>;

import { ModalMobileLayoutUniDriver } from '../src/ModalMobileLayout/ModalMobileLayout.uni.driver';

export const ModalMobileLayoutTestkit: EnzymeUniTestkitFactory<ModalMobileLayoutUniDriver>;
export const modalMobileLayoutTestkitFactory: EnzymeUniTestkitFactory<ModalMobileLayoutUniDriver>;

import { ModalPreviewLayoutUniDriver } from '../src/ModalPreviewLayout/ModalPreviewLayout.uni.driver';

export const ModalPreviewLayoutTestkit: EnzymeUniTestkitFactory<ModalPreviewLayoutUniDriver>;
export const modalPreviewLayoutTestkitFactory: EnzymeUniTestkitFactory<ModalPreviewLayoutUniDriver>;

import { ModalSelectorLayoutUniDriver } from '../src/ModalSelectorLayout/ModalSelectorLayout.uni.driver';
import { ModalSelectorLayoutDriver } from '../src/ModalSelectorLayout/ModalSelectorLayout.driver';
export const ModalSelectorLayoutTestkit: EnzymeUniTestkitFactory<ModalSelectorLayoutUniDriver>;
export const modalSelectorLayoutTestkitFactory: EnzymeTestkitFactory<ModalSelectorLayoutDriver>;

import { MultiSelectUniDriver } from '../src/MultiSelect/MultiSelect.uni.driver';
import { MultiSelectDriver } from '../src/MultiSelect/MultiSelect.driver';
export const MultiSelectTestkit: EnzymeUniTestkitFactory<MultiSelectUniDriver>;
export const multiSelectTestkitFactory: EnzymeTestkitFactory<MultiSelectDriver>;

import { MultiSelectCheckboxUniDriver } from '../src/MultiSelectCheckbox/MultiSelectCheckbox.uni.driver';
import { MultiSelectCheckboxDriver } from '../src/MultiSelectCheckbox/MultiSelectCheckbox.driver';
export const MultiSelectCheckboxTestkit: EnzymeUniTestkitFactory<MultiSelectCheckboxUniDriver>;
export const multiSelectCheckboxTestkitFactory: EnzymeTestkitFactory<MultiSelectCheckboxDriver>;

import { NestableListUniDriver } from '../src/NestableList/NestableList.uni.driver';

export const NestableListTestkit: EnzymeUniTestkitFactory<NestableListUniDriver>;
export const nestableListTestkitFactory: EnzymeUniTestkitFactory<NestableListUniDriver>;

import { NestableListBaseUniDriver } from '../src/NestableListBase/NestableListBase.uni.driver';

export const NestableListBaseTestkit: EnzymeUniTestkitFactory<NestableListBaseUniDriver>;
export const nestableListBaseTestkitFactory: EnzymeUniTestkitFactory<NestableListBaseUniDriver>;

import { NotificationUniDriver } from '../src/Notification/Notification.uni.driver';
import { NotificationDriver } from '../src/Notification/Notification.driver';
export const NotificationTestkit: EnzymeUniTestkitFactory<NotificationUniDriver>;
export const notificationTestkitFactory: EnzymeTestkitFactory<NotificationDriver>;

import { NumberInputUniDriver } from '../src/NumberInput/NumberInput.uni.driver';

export const NumberInputTestkit: EnzymeUniTestkitFactory<NumberInputUniDriver>;
export const numberInputTestkitFactory: EnzymeUniTestkitFactory<NumberInputUniDriver>;

import { PageUniDriver } from '../src/Page/Page.uni.driver';
import { PageDriver } from '../src/Page/Page.driver';
export const PageTestkit: EnzymeUniTestkitFactory<PageUniDriver>;
export const pageTestkitFactory: EnzymeTestkitFactory<PageDriver>;

import { PageFooterUniDriver } from '../src/PageFooter/PageFooter.uni.driver';

export const PageFooterTestkit: EnzymeUniTestkitFactory<PageFooterUniDriver>;
export const pageFooterTestkitFactory: EnzymeUniTestkitFactory<PageFooterUniDriver>;

import { PageHeaderUniDriver } from '../src/PageHeader/PageHeader.uni.driver';
import { PageHeaderDriver } from '../src/PageHeader/PageHeader.driver';
export const PageHeaderTestkit: EnzymeUniTestkitFactory<PageHeaderUniDriver>;
export const pageHeaderTestkitFactory: EnzymeTestkitFactory<PageHeaderDriver>;

import { PageSectionUniDriver } from '../src/PageSection/PageSection.uni.driver';

export const PageSectionTestkit: EnzymeUniTestkitFactory<PageSectionUniDriver>;
export const pageSectionTestkitFactory: EnzymeUniTestkitFactory<PageSectionUniDriver>;

import { PaginationUniDriver } from '../src/Pagination/Pagination.uni.driver';

export const PaginationTestkit: EnzymeUniTestkitFactory<PaginationUniDriver>;
export const paginationTestkitFactory: EnzymeUniTestkitFactory<PaginationUniDriver>;

import { PaletteUniDriver } from '../src/Palette/Palette.uni.driver';

export const PaletteTestkit: EnzymeUniTestkitFactory<PaletteUniDriver>;
export const paletteTestkitFactory: EnzymeUniTestkitFactory<PaletteUniDriver>;

import { PopoverUniDriver } from '../src/Popover/Popover.uni.driver';
import { PopoverDriver } from '../src/Popover/Popover.driver';
export const PopoverTestkit: EnzymeUniTestkitFactory<PopoverUniDriver>;
export const popoverTestkitFactory: EnzymeTestkitFactory<PopoverDriver>;

import { PopoverMenuUniDriver } from '../src/PopoverMenu/PopoverMenu.uni.driver';

export const PopoverMenuTestkit: EnzymeUniTestkitFactory<PopoverMenuUniDriver>;
export const popoverMenuTestkitFactory: EnzymeUniTestkitFactory<PopoverMenuUniDriver>;

import { PreviewWidgetUniDriver } from '../src/PreviewWidget/PreviewWidget.uni.driver';

export const PreviewWidgetTestkit: EnzymeUniTestkitFactory<PreviewWidgetUniDriver>;
export const previewWidgetTestkitFactory: EnzymeUniTestkitFactory<PreviewWidgetUniDriver>;

import { ProportionUniDriver } from '../src/Proportion/Proportion.uni.driver';

export const ProportionTestkit: EnzymeUniTestkitFactory<ProportionUniDriver>;
export const proportionTestkitFactory: EnzymeUniTestkitFactory<ProportionUniDriver>;

import { PulseAnimationUniDriver } from '../src/PulseAnimation/PulseAnimation.uni.driver';

export const PulseAnimationTestkit: EnzymeUniTestkitFactory<PulseAnimationUniDriver>;
export const pulseAnimationTestkitFactory: EnzymeUniTestkitFactory<PulseAnimationUniDriver>;

import { RadarChartUniDriver } from '../src/RadarChart/RadarChart.uni.driver';

export const RadarChartTestkit: EnzymeUniTestkitFactory<RadarChartUniDriver>;
export const radarChartTestkitFactory: EnzymeUniTestkitFactory<RadarChartUniDriver>;

import { RadioUniDriver } from '../src/Radio/Radio.uni.driver';
import { RadioDriver } from '../src/Radio/Radio.driver';
export const RadioTestkit: EnzymeUniTestkitFactory<RadioUniDriver>;
export const radioTestkitFactory: EnzymeTestkitFactory<RadioDriver>;

import { RadioGroupUniDriver } from '../src/RadioGroup/RadioGroup.uni.driver';
import { RadioGroupDriver } from '../src/RadioGroup/RadioGroup.driver';
export const RadioGroupTestkit: EnzymeUniTestkitFactory<RadioGroupUniDriver>;
export const radioGroupTestkitFactory: EnzymeTestkitFactory<RadioGroupDriver>;

import { RangeUniDriver } from '../src/Range/Range.uni.driver';
import { RangeDriver } from '../src/Range/Range.driver';
export const RangeTestkit: EnzymeUniTestkitFactory<RangeUniDriver>;
export const rangeTestkitFactory: EnzymeTestkitFactory<RangeDriver>;

import { RichTextInputAreaUniDriver } from '../src/RichTextInputArea/RichTextInputArea.uni.driver';

export const RichTextInputAreaTestkit: EnzymeUniTestkitFactory<RichTextInputAreaUniDriver>;
export const richTextInputAreaTestkitFactory: EnzymeUniTestkitFactory<RichTextInputAreaUniDriver>;

import { SearchUniDriver } from '../src/Search/Search.uni.driver';
import { SearchDriver } from '../src/Search/Search.driver';
export const SearchTestkit: EnzymeUniTestkitFactory<SearchUniDriver>;
export const searchTestkitFactory: EnzymeTestkitFactory<SearchDriver>;

import { SectionHeaderUniDriver } from '../src/SectionHeader/SectionHeader.uni.driver';

export const SectionHeaderTestkit: EnzymeUniTestkitFactory<SectionHeaderUniDriver>;
export const sectionHeaderTestkitFactory: EnzymeUniTestkitFactory<SectionHeaderUniDriver>;

import { SectionHelperUniDriver } from '../src/SectionHelper/SectionHelper.uni.driver';
import { SectionHelperDriver } from '../src/SectionHelper/SectionHelper.driver';
export const SectionHelperTestkit: EnzymeUniTestkitFactory<SectionHelperUniDriver>;
export const sectionHelperTestkitFactory: EnzymeTestkitFactory<SectionHelperDriver>;

import { SegmentedToggleUniDriver } from '../src/SegmentedToggle/SegmentedToggle.uni.driver';

export const SegmentedToggleTestkit: EnzymeUniTestkitFactory<SegmentedToggleUniDriver>;
export const segmentedToggleTestkitFactory: EnzymeUniTestkitFactory<SegmentedToggleUniDriver>;

import { SelectableAccordionUniDriver } from '../src/SelectableAccordion/SelectableAccordion.uni.driver';

export const SelectableAccordionTestkit: EnzymeUniTestkitFactory<SelectableAccordionUniDriver>;
export const selectableAccordionTestkitFactory: EnzymeUniTestkitFactory<SelectableAccordionUniDriver>;

import { SelectorUniDriver } from '../src/Selector/Selector.uni.driver';
import { SelectorDriver } from '../src/Selector/Selector.driver';
export const SelectorTestkit: EnzymeUniTestkitFactory<SelectorUniDriver>;
export const selectorTestkitFactory: EnzymeTestkitFactory<SelectorDriver>;

import { SelectorListUniDriver } from '../src/SelectorList/SelectorList.uni.driver';

export const SelectorListTestkit: EnzymeUniTestkitFactory<SelectorListUniDriver>;
export const selectorListTestkitFactory: EnzymeUniTestkitFactory<SelectorListUniDriver>;

import { SidePanelUniDriver } from '../src/SidePanel/SidePanel.uni.driver';

export const SidePanelTestkit: EnzymeUniTestkitFactory<SidePanelUniDriver>;
export const sidePanelTestkitFactory: EnzymeUniTestkitFactory<SidePanelUniDriver>;

import { SidebarUniDriver } from '../src/Sidebar/Sidebar.uni.driver';

export const SidebarTestkit: EnzymeUniTestkitFactory<SidebarUniDriver>;
export const sidebarTestkitFactory: EnzymeUniTestkitFactory<SidebarUniDriver>;

import { SidebarBackButtonUniDriver } from '../src/SidebarBackButton/SidebarBackButton.uni.driver';

export const SidebarBackButtonTestkit: EnzymeUniTestkitFactory<SidebarBackButtonUniDriver>;
export const sidebarBackButtonTestkitFactory: EnzymeUniTestkitFactory<SidebarBackButtonUniDriver>;

import { SidebarDividerUniDriver } from '../src/SidebarDivider/SidebarDivider.uni.driver';

export const SidebarDividerTestkit: EnzymeUniTestkitFactory<SidebarDividerUniDriver>;
export const sidebarDividerTestkitFactory: EnzymeUniTestkitFactory<SidebarDividerUniDriver>;

import { SidebarDividerNextUniDriver } from '../src/SidebarDividerNext/SidebarDividerNext.uni.driver';

export const SidebarDividerNextTestkit: EnzymeUniTestkitFactory<SidebarDividerNextUniDriver>;
export const sidebarDividerNextTestkitFactory: EnzymeUniTestkitFactory<SidebarDividerNextUniDriver>;

import { SidebarHeaderUniDriver } from '../src/SidebarHeader/SidebarHeader.uni.driver';

export const SidebarHeaderTestkit: EnzymeUniTestkitFactory<SidebarHeaderUniDriver>;
export const sidebarHeaderTestkitFactory: EnzymeUniTestkitFactory<SidebarHeaderUniDriver>;

import { SidebarHeaderNextUniDriver } from '../src/SidebarHeaderNext/SidebarHeaderNext.uni.driver';

export const SidebarHeaderNextTestkit: EnzymeUniTestkitFactory<SidebarHeaderNextUniDriver>;
export const sidebarHeaderNextTestkitFactory: EnzymeUniTestkitFactory<SidebarHeaderNextUniDriver>;

import { SidebarItemNextUniDriver } from '../src/SidebarItemNext/SidebarItemNext.uni.driver';

export const SidebarItemNextTestkit: EnzymeUniTestkitFactory<SidebarItemNextUniDriver>;
export const sidebarItemNextTestkitFactory: EnzymeUniTestkitFactory<SidebarItemNextUniDriver>;

import { SidebarNextUniDriver } from '../src/SidebarNext/SidebarNext.uni.driver';

export const SidebarNextTestkit: EnzymeUniTestkitFactory<SidebarNextUniDriver>;
export const sidebarNextTestkitFactory: EnzymeUniTestkitFactory<SidebarNextUniDriver>;

import { SidebarSectionItemUniDriver } from '../src/SidebarSectionItem/SidebarSectionItem.uni.driver';

export const SidebarSectionItemTestkit: EnzymeUniTestkitFactory<SidebarSectionItemUniDriver>;
export const sidebarSectionItemTestkitFactory: EnzymeUniTestkitFactory<SidebarSectionItemUniDriver>;

import { SidebarSectionTitleUniDriver } from '../src/SidebarSectionTitle/SidebarSectionTitle.uni.driver';

export const SidebarSectionTitleTestkit: EnzymeUniTestkitFactory<SidebarSectionTitleUniDriver>;
export const sidebarSectionTitleTestkitFactory: EnzymeUniTestkitFactory<SidebarSectionTitleUniDriver>;

import { SidebarSubMenuNextUniDriver } from '../src/SidebarSubMenuNext/SidebarSubMenuNext.uni.driver';

export const SidebarSubMenuNextTestkit: EnzymeUniTestkitFactory<SidebarSubMenuNextUniDriver>;
export const sidebarSubMenuNextTestkitFactory: EnzymeUniTestkitFactory<SidebarSubMenuNextUniDriver>;

import { SidebarTitleItemNextUniDriver } from '../src/SidebarTitleItemNext/SidebarTitleItemNext.uni.driver';

export const SidebarTitleItemNextTestkit: EnzymeUniTestkitFactory<SidebarTitleItemNextUniDriver>;
export const sidebarTitleItemNextTestkitFactory: EnzymeUniTestkitFactory<SidebarTitleItemNextUniDriver>;

import { SkeletonUniDriver } from '../src/Skeleton/Skeleton.uni.driver';
import { SkeletonDriver } from '../src/Skeleton/Skeleton.driver';
export const SkeletonTestkit: EnzymeUniTestkitFactory<SkeletonUniDriver>;
export const skeletonTestkitFactory: EnzymeTestkitFactory<SkeletonDriver>;

import { SkeletonCircleUniDriver } from '../src/SkeletonCircle/SkeletonCircle.uni.driver';

export const SkeletonCircleTestkit: EnzymeUniTestkitFactory<SkeletonCircleUniDriver>;
export const skeletonCircleTestkitFactory: EnzymeUniTestkitFactory<SkeletonCircleUniDriver>;

import { SkeletonGroupUniDriver } from '../src/SkeletonGroup/SkeletonGroup.uni.driver';

export const SkeletonGroupTestkit: EnzymeUniTestkitFactory<SkeletonGroupUniDriver>;
export const skeletonGroupTestkitFactory: EnzymeUniTestkitFactory<SkeletonGroupUniDriver>;

import { SkeletonLineUniDriver } from '../src/SkeletonLine/SkeletonLine.uni.driver';

export const SkeletonLineTestkit: EnzymeUniTestkitFactory<SkeletonLineUniDriver>;
export const skeletonLineTestkitFactory: EnzymeUniTestkitFactory<SkeletonLineUniDriver>;

import { SkeletonRectangleUniDriver } from '../src/SkeletonRectangle/SkeletonRectangle.uni.driver';

export const SkeletonRectangleTestkit: EnzymeUniTestkitFactory<SkeletonRectangleUniDriver>;
export const skeletonRectangleTestkitFactory: EnzymeUniTestkitFactory<SkeletonRectangleUniDriver>;

import { SliderUniDriver } from '../src/Slider/Slider.uni.driver';
import { SliderDriver } from '../src/Slider/Slider.driver';
export const SliderTestkit: EnzymeUniTestkitFactory<SliderUniDriver>;
export const sliderTestkitFactory: EnzymeTestkitFactory<SliderDriver>;

import { SocialButtonUniDriver } from '../src/SocialButton/SocialButton.uni.driver';

export const SocialButtonTestkit: EnzymeUniTestkitFactory<SocialButtonUniDriver>;
export const socialButtonTestkitFactory: EnzymeUniTestkitFactory<SocialButtonUniDriver>;

import { SocialPostPreviewUniDriver } from '../src/SocialPostPreview/SocialPostPreview.uni.driver';

export const SocialPostPreviewTestkit: EnzymeUniTestkitFactory<SocialPostPreviewUniDriver>;
export const socialPostPreviewTestkitFactory: EnzymeUniTestkitFactory<SocialPostPreviewUniDriver>;

import { SocialPreviewUniDriver } from '../src/SocialPreview/SocialPreview.uni.driver';

export const SocialPreviewTestkit: EnzymeUniTestkitFactory<SocialPreviewUniDriver>;
export const socialPreviewTestkitFactory: EnzymeUniTestkitFactory<SocialPreviewUniDriver>;

import { SortableGridBaseUniDriver } from '../src/SortableGridBase/SortableGridBase.uni.driver';

export const SortableGridBaseTestkit: EnzymeUniTestkitFactory<SortableGridBaseUniDriver>;
export const sortableGridBaseTestkitFactory: EnzymeUniTestkitFactory<SortableGridBaseUniDriver>;

import { SortableListBaseUniDriver } from '../src/SortableListBase/SortableListBase.uni.driver';
import { SortableListBaseDriver } from '../src/SortableListBase/SortableListBase.driver';
export const SortableListBaseTestkit: EnzymeUniTestkitFactory<SortableListBaseUniDriver>;
export const sortableListBaseTestkitFactory: EnzymeTestkitFactory<SortableListBaseDriver>;

import { SparklineChartUniDriver } from '../src/SparklineChart/SparklineChart.uni.driver';

export const SparklineChartTestkit: EnzymeUniTestkitFactory<SparklineChartUniDriver>;
export const sparklineChartTestkitFactory: EnzymeUniTestkitFactory<SparklineChartUniDriver>;

import { StackedBarChartUniDriver } from '../src/StackedBarChart/StackedBarChart.uni.driver';

export const StackedBarChartTestkit: EnzymeUniTestkitFactory<StackedBarChartUniDriver>;
export const stackedBarChartTestkitFactory: EnzymeUniTestkitFactory<StackedBarChartUniDriver>;

import { StarsRatingBarUniDriver } from '../src/StarsRatingBar/StarsRatingBar.uni.driver';

export const StarsRatingBarTestkit: EnzymeUniTestkitFactory<StarsRatingBarUniDriver>;
export const starsRatingBarTestkitFactory: EnzymeUniTestkitFactory<StarsRatingBarUniDriver>;

import { StatisticsWidgetUniDriver } from '../src/StatisticsWidget/StatisticsWidget.uni.driver';

export const StatisticsWidgetTestkit: EnzymeUniTestkitFactory<StatisticsWidgetUniDriver>;
export const statisticsWidgetTestkitFactory: EnzymeUniTestkitFactory<StatisticsWidgetUniDriver>;

import { StatusIndicatorUniDriver } from '../src/StatusIndicator/StatusIndicator.uni.driver';

export const StatusIndicatorTestkit: EnzymeUniTestkitFactory<StatusIndicatorUniDriver>;
export const statusIndicatorTestkitFactory: EnzymeUniTestkitFactory<StatusIndicatorUniDriver>;

import { StepperUniDriver } from '../src/Stepper/Stepper.uni.driver';

export const StepperTestkit: EnzymeUniTestkitFactory<StepperUniDriver>;
export const stepperTestkitFactory: EnzymeUniTestkitFactory<StepperUniDriver>;

import { SwatchesUniDriver } from '../src/Swatches/Swatches.uni.driver';

export const SwatchesTestkit: EnzymeUniTestkitFactory<SwatchesUniDriver>;
export const swatchesTestkitFactory: EnzymeUniTestkitFactory<SwatchesUniDriver>;

import { TableUniDriver } from '../src/Table/Table.uni.driver';
import { TableDriver } from '../src/Table/Table.driver';
export const TableTestkit: EnzymeUniTestkitFactory<TableUniDriver>;
export const tableTestkitFactory: EnzymeTestkitFactory<TableDriver<ReactWrapper>>;

import { TableActionCellUniDriver } from '../src/TableActionCell/TableActionCell.uni.driver';
import { TableActionCellDriver } from '../src/TableActionCell/TableActionCell.driver';
export const TableActionCellTestkit: EnzymeUniTestkitFactory<TableActionCellUniDriver>;
export const tableActionCellTestkitFactory: EnzymeTestkitFactory<TableActionCellDriver<ReactWrapper>>;

import { TableListHeaderUniDriver } from '../src/TableListHeader/TableListHeader.uni.driver';

export const TableListHeaderTestkit: EnzymeUniTestkitFactory<TableListHeaderUniDriver>;
export const tableListHeaderTestkitFactory: EnzymeUniTestkitFactory<TableListHeaderUniDriver>;

import { TableListItemUniDriver } from '../src/TableListItem/TableListItem.uni.driver';

export const TableListItemTestkit: EnzymeUniTestkitFactory<TableListItemUniDriver>;
export const tableListItemTestkitFactory: EnzymeUniTestkitFactory<TableListItemUniDriver>;

import { TabsUniDriver } from '../src/Tabs/Tabs.uni.driver';
import { TabsDriver } from '../src/Tabs/Tabs.driver';
export const TabsTestkit: EnzymeUniTestkitFactory<TabsUniDriver>;
export const tabsTestkitFactory: EnzymeTestkitFactory<TabsDriver>;

import { TagUniDriver } from '../src/Tag/Tag.uni.driver';
import { TagDriver } from '../src/Tag/Tag.driver';
export const TagTestkit: EnzymeUniTestkitFactory<TagUniDriver>;
export const tagTestkitFactory: EnzymeTestkitFactory<TagDriver>;

import { TagListUniDriver } from '../src/TagList/TagList.uni.driver';

export const TagListTestkit: EnzymeUniTestkitFactory<TagListUniDriver>;
export const tagListTestkitFactory: EnzymeUniTestkitFactory<TagListUniDriver>;

import { TestimonialListUniDriver } from '../src/TestimonialList/TestimonialList.uni.driver';

export const TestimonialListTestkit: EnzymeUniTestkitFactory<TestimonialListUniDriver>;
export const testimonialListTestkitFactory: EnzymeUniTestkitFactory<TestimonialListUniDriver>;

import { TextUniDriver } from '../src/Text/Text.uni.driver';
import { TextDriver } from '../src/Text/Text.driver';
export const TextTestkit: EnzymeUniTestkitFactory<TextUniDriver>;
export const textTestkitFactory: EnzymeTestkitFactory<TextDriver>;

import { TextButtonUniDriver } from '../src/TextButton/TextButton.uni.driver';

export const TextButtonTestkit: EnzymeUniTestkitFactory<TextButtonUniDriver>;
export const textButtonTestkitFactory: EnzymeUniTestkitFactory<TextButtonUniDriver>;

import { ThumbnailUniDriver } from '../src/Thumbnail/Thumbnail.uni.driver';

export const ThumbnailTestkit: EnzymeUniTestkitFactory<ThumbnailUniDriver>;
export const thumbnailTestkitFactory: EnzymeUniTestkitFactory<ThumbnailUniDriver>;

import { TimeInputUniDriver } from '../src/TimeInput/TimeInput.uni.driver';

export const TimeInputTestkit: EnzymeUniTestkitFactory<TimeInputUniDriver>;
export const timeInputTestkitFactory: EnzymeUniTestkitFactory<TimeInputUniDriver>;

import { TimeTableUniDriver } from '../src/TimeTable/TimeTable.uni.driver';

export const TimeTableTestkit: EnzymeUniTestkitFactory<TimeTableUniDriver>;
export const timeTableTestkitFactory: EnzymeUniTestkitFactory<TimeTableUniDriver>;

import { TimelineUniDriver } from '../src/Timeline/Timeline.uni.driver';

export const TimelineTestkit: EnzymeUniTestkitFactory<TimelineUniDriver>;
export const timelineTestkitFactory: EnzymeUniTestkitFactory<TimelineUniDriver>;

import { ToastUniDriver } from '../src/Toast/Toast.uni.driver';

export const ToastTestkit: EnzymeUniTestkitFactory<ToastUniDriver>;
export const toastTestkitFactory: EnzymeUniTestkitFactory<ToastUniDriver>;

import { ToggleButtonUniDriver } from '../src/ToggleButton/ToggleButton.uni.driver';

export const ToggleButtonTestkit: EnzymeUniTestkitFactory<ToggleButtonUniDriver>;
export const toggleButtonTestkitFactory: EnzymeUniTestkitFactory<ToggleButtonUniDriver>;

import { ToggleSwitchUniDriver } from '../src/ToggleSwitch/ToggleSwitch.uni.driver';
import { ToggleSwitchDriver } from '../src/ToggleSwitch/ToggleSwitch.driver';
export const ToggleSwitchTestkit: EnzymeUniTestkitFactory<ToggleSwitchUniDriver>;
export const toggleSwitchTestkitFactory: EnzymeTestkitFactory<ToggleSwitchDriver>;

import { TooltipUniDriver } from '../src/Tooltip/Tooltip.uni.driver';

export const TooltipTestkit: EnzymeUniTestkitFactory<TooltipUniDriver>;
export const tooltipTestkitFactory: EnzymeUniTestkitFactory<TooltipUniDriver>;

import { TransitionUniDriver } from '../src/Transition/Transition.uni.driver';

export const TransitionTestkit: EnzymeUniTestkitFactory<TransitionUniDriver>;
export const transitionTestkitFactory: EnzymeUniTestkitFactory<TransitionUniDriver>;

import { TrendIndicatorUniDriver } from '../src/TrendIndicator/TrendIndicator.uni.driver';

export const TrendIndicatorTestkit: EnzymeUniTestkitFactory<TrendIndicatorUniDriver>;
export const trendIndicatorTestkitFactory: EnzymeUniTestkitFactory<TrendIndicatorUniDriver>;

import { VariableInputUniDriver } from '../src/VariableInput/VariableInput.uni.driver';

export const VariableInputTestkit: EnzymeUniTestkitFactory<VariableInputUniDriver>;
export const variableInputTestkitFactory: EnzymeUniTestkitFactory<VariableInputUniDriver>;

import { VerticalTabsUniDriver } from '../src/VerticalTabs/VerticalTabs.uni.driver';

export const VerticalTabsTestkit: EnzymeUniTestkitFactory<VerticalTabsUniDriver>;
export const verticalTabsTestkitFactory: EnzymeUniTestkitFactory<VerticalTabsUniDriver>;

import { VerticalTabsItemUniDriver } from '../src/VerticalTabsItem/VerticalTabsItem.uni.driver';

export const VerticalTabsItemTestkit: EnzymeUniTestkitFactory<VerticalTabsItemUniDriver>;
export const verticalTabsItemTestkitFactory: EnzymeUniTestkitFactory<VerticalTabsItemUniDriver>;

import { WixDesignSystemProviderUniDriver } from '../src/WixDesignSystemProvider/WixDesignSystemProvider.uni.driver';

export const WixDesignSystemProviderTestkit: EnzymeUniTestkitFactory<WixDesignSystemProviderUniDriver>;
export const wixDesignSystemProviderTestkitFactory: EnzymeUniTestkitFactory<WixDesignSystemProviderUniDriver>;

import { WixStyleReactProviderUniDriver } from '../src/WixStyleReactProvider/WixStyleReactProvider.uni.driver';

export const WixStyleReactProviderTestkit: EnzymeUniTestkitFactory<WixStyleReactProviderUniDriver>;
export const wixStyleReactProviderTestkitFactory: EnzymeUniTestkitFactory<WixStyleReactProviderUniDriver>;

import { CardHeaderUniDriver } from '../src/Card/Header/Header.uni.driver';
import { CardHeaderDriver } from '../src/Card/Header/Header.driver';
export const CardHeaderTestkit: EnzymeUniTestkitFactory<CardHeaderUniDriver>;
export const cardHeaderTestkitFactory: EnzymeTestkitFactory<CardHeaderDriver>;

import { EditableRowUniDriver } from '../src/EditableSelector/EditableRow/EditableRow.uni.driver';
import { EditableRowDriver } from '../src/EditableSelector/EditableRow/EditableRow.driver';
export const EditableRowTestkit: EnzymeUniTestkitFactory<EditableRowUniDriver>;
export const editableRowTestkitFactory: EnzymeTestkitFactory<EditableRowDriver>;

import { CardSubheaderUniDriver } from '../src/Card/Subheader/Subheader.uni.driver';

export const CardSubheaderTestkit: EnzymeUniTestkitFactory<CardSubheaderUniDriver>;
export const cardSubheaderTestkitFactory: EnzymeUniTestkitFactory<CardSubheaderUniDriver>;

import { CardContentUniDriver } from '../src/Card/Content/Content.uni.driver';

export const CardContentTestkit: EnzymeUniTestkitFactory<CardContentUniDriver>;
export const cardContentTestkitFactory: EnzymeUniTestkitFactory<CardContentUniDriver>;



