type VanillaTestkitFactory<T> = (
  params: VanillaTestkitParams,
) => T;

type VanillaUniTestkitFactory<T> = (
  params: VanillaTestkitParams,
) => T;

interface VanillaTestkitParams {
  wrapper: Element;
  dataHook: string;
}

type DeprecatedVanillaTestkit = any;

import { AccordionUniDriver } from '../src/Accordion/Accordion.uni.driver';

export const AccordionTestkit: VanillaUniTestkitFactory<AccordionUniDriver>;
export const accordionTestkitFactory: VanillaUniTestkitFactory<AccordionUniDriver>;

import { AddItemUniDriver } from '../src/AddItem/AddItem.uni.driver';
import { AddItemDriver } from '../src/AddItem/AddItem.driver';
export const AddItemTestkit: VanillaUniTestkitFactory<AddItemUniDriver>;
export const addItemTestkitFactory: VanillaTestkitFactory<AddItemDriver>;

import { AddressInputUniDriver } from '../src/AddressInput/AddressInput.uni.driver';

export const AddressInputTestkit: VanillaUniTestkitFactory<AddressInputUniDriver>;
export const addressInputTestkitFactory: VanillaUniTestkitFactory<AddressInputUniDriver>;

import { AddressInputItemUniDriver } from '../src/AddressInputItem/AddressInputItem.uni.driver';

export const AddressInputItemTestkit: VanillaUniTestkitFactory<AddressInputItemUniDriver>;
export const addressInputItemTestkitFactory: VanillaUniTestkitFactory<AddressInputItemUniDriver>;

import { AnalyticsLayoutUniDriver } from '../src/AnalyticsLayout/AnalyticsLayout.uni.driver';

export const AnalyticsLayoutTestkit: VanillaUniTestkitFactory<AnalyticsLayoutUniDriver>;
export const analyticsLayoutTestkitFactory: VanillaUniTestkitFactory<AnalyticsLayoutUniDriver>;

import { AnalyticsSummaryCardUniDriver } from '../src/AnalyticsSummaryCard/AnalyticsSummaryCard.uni.driver';

export const AnalyticsSummaryCardTestkit: VanillaUniTestkitFactory<AnalyticsSummaryCardUniDriver>;
export const analyticsSummaryCardTestkitFactory: VanillaUniTestkitFactory<AnalyticsSummaryCardUniDriver>;

import { AnimateUniDriver } from '../src/Animate/Animate.uni.driver';

export const AnimateTestkit: VanillaUniTestkitFactory<AnimateUniDriver>;
export const animateTestkitFactory: VanillaUniTestkitFactory<AnimateUniDriver>;

import { AnnouncementModalLayoutUniDriver } from '../src/AnnouncementModalLayout/AnnouncementModalLayout.uni.driver';

export const AnnouncementModalLayoutTestkit: VanillaUniTestkitFactory<AnnouncementModalLayoutUniDriver>;
export const announcementModalLayoutTestkitFactory: VanillaUniTestkitFactory<AnnouncementModalLayoutUniDriver>;

import { AreaChartUniDriver } from '../src/AreaChart/AreaChart.uni.driver';

export const AreaChartTestkit: VanillaUniTestkitFactory<AreaChartUniDriver>;
export const areaChartTestkitFactory: VanillaUniTestkitFactory<AreaChartUniDriver>;

import { AtlasAddressInputUniDriver } from '../src/AtlasAddressInput/AtlasAddressInput.uni.driver';

export const AtlasAddressInputTestkit: VanillaUniTestkitFactory<AtlasAddressInputUniDriver>;
export const atlasAddressInputTestkitFactory: VanillaUniTestkitFactory<AtlasAddressInputUniDriver>;

import { AudioPlayerUniDriver } from '../src/AudioPlayer/AudioPlayer.uni.driver';

export const AudioPlayerTestkit: VanillaUniTestkitFactory<AudioPlayerUniDriver>;
export const audioPlayerTestkitFactory: VanillaUniTestkitFactory<AudioPlayerUniDriver>;

import { AutoCompleteUniDriver } from '../src/AutoComplete/AutoComplete.uni.driver';
import { AutoCompleteDriver } from '../src/AutoComplete/AutoComplete.driver';
export const AutoCompleteTestkit: VanillaUniTestkitFactory<AutoCompleteUniDriver>;
export const autoCompleteTestkitFactory: VanillaTestkitFactory<AutoCompleteDriver>;

import { AutoCompleteWithLabelUniDriver } from '../src/AutoCompleteWithLabel/AutoCompleteWithLabel.uni.driver';

export const AutoCompleteWithLabelTestkit: VanillaUniTestkitFactory<AutoCompleteWithLabelUniDriver>;
export const autoCompleteWithLabelTestkitFactory: VanillaUniTestkitFactory<AutoCompleteWithLabelUniDriver>;

import { AvatarUniDriver } from '../src/Avatar/Avatar.uni.driver';

export const AvatarTestkit: VanillaUniTestkitFactory<AvatarUniDriver>;
export const avatarTestkitFactory: VanillaUniTestkitFactory<AvatarUniDriver>;

import { AvatarGroupUniDriver } from '../src/AvatarGroup/AvatarGroup.uni.driver';

export const AvatarGroupTestkit: VanillaUniTestkitFactory<AvatarGroupUniDriver>;
export const avatarGroupTestkitFactory: VanillaUniTestkitFactory<AvatarGroupUniDriver>;

import { BadgeUniDriver } from '../src/Badge/Badge.uni.driver';
import { BadgeDriver } from '../src/Badge/Badge.driver';
export const BadgeTestkit: VanillaUniTestkitFactory<BadgeUniDriver>;
export const badgeTestkitFactory: VanillaTestkitFactory<BadgeDriver>;

import { BadgeSelectUniDriver } from '../src/BadgeSelect/BadgeSelect.uni.driver';
import { BadgeSelectDriver } from '../src/BadgeSelect/BadgeSelect.driver';
export const BadgeSelectTestkit: VanillaUniTestkitFactory<BadgeSelectUniDriver>;
export const badgeSelectTestkitFactory: VanillaTestkitFactory<BadgeSelectDriver>;

import { BadgeSelectItemUniDriver } from '../src/BadgeSelectItem/BadgeSelectItem.uni.driver';

export const BadgeSelectItemTestkit: VanillaUniTestkitFactory<BadgeSelectItemUniDriver>;
export const badgeSelectItemTestkitFactory: VanillaUniTestkitFactory<BadgeSelectItemUniDriver>;

import { BarChartUniDriver } from '../src/BarChart/BarChart.uni.driver';

export const BarChartTestkit: VanillaUniTestkitFactory<BarChartUniDriver>;
export const barChartTestkitFactory: VanillaUniTestkitFactory<BarChartUniDriver>;

import { BounceAnimationUniDriver } from '../src/BounceAnimation/BounceAnimation.uni.driver';

export const BounceAnimationTestkit: VanillaUniTestkitFactory<BounceAnimationUniDriver>;
export const bounceAnimationTestkitFactory: VanillaUniTestkitFactory<BounceAnimationUniDriver>;

import { BoxUniDriver } from '../src/Box/Box.uni.driver';

export const BoxTestkit: VanillaUniTestkitFactory<BoxUniDriver>;
export const boxTestkitFactory: VanillaUniTestkitFactory<BoxUniDriver>;

import { BreadcrumbsUniDriver } from '../src/Breadcrumbs/Breadcrumbs.uni.driver';
import { BreadcrumbsDriver } from '../src/Breadcrumbs/Breadcrumbs.driver';
export const BreadcrumbsTestkit: VanillaUniTestkitFactory<BreadcrumbsUniDriver>;
export const breadcrumbsTestkitFactory: VanillaTestkitFactory<BreadcrumbsDriver>;

import { BrowserPreviewWidgetUniDriver } from '../src/BrowserPreviewWidget/BrowserPreviewWidget.uni.driver';

export const BrowserPreviewWidgetTestkit: VanillaUniTestkitFactory<BrowserPreviewWidgetUniDriver>;
export const browserPreviewWidgetTestkitFactory: VanillaUniTestkitFactory<BrowserPreviewWidgetUniDriver>;

import { ButtonUniDriver } from '../src/Button/Button.uni.driver';

export const ButtonTestkit: VanillaUniTestkitFactory<ButtonUniDriver>;
export const buttonTestkitFactory: VanillaUniTestkitFactory<ButtonUniDriver>;

import { CalendarUniDriver } from '../src/Calendar/Calendar.uni.driver';
import { CalendarDriver } from '../src/Calendar/Calendar.driver';
export const CalendarTestkit: VanillaUniTestkitFactory<CalendarUniDriver>;
export const calendarTestkitFactory: VanillaTestkitFactory<CalendarDriver>;

import { CalendarPanelUniDriver } from '../src/CalendarPanel/CalendarPanel.uni.driver';
import { CalendarPanelDriver } from '../src/CalendarPanel/CalendarPanel.driver';
export const CalendarPanelTestkit: VanillaUniTestkitFactory<CalendarPanelUniDriver>;
export const calendarPanelTestkitFactory: VanillaTestkitFactory<CalendarPanelDriver>;

import { CalendarPanelFooterUniDriver } from '../src/CalendarPanelFooter/CalendarPanelFooter.uni.driver';

export const CalendarPanelFooterTestkit: VanillaUniTestkitFactory<CalendarPanelFooterUniDriver>;
export const calendarPanelFooterTestkitFactory: VanillaUniTestkitFactory<CalendarPanelFooterUniDriver>;

import { CardFolderTabsUniDriver } from '../src/CardFolderTabs/CardFolderTabs.uni.driver';

export const CardFolderTabsTestkit: VanillaUniTestkitFactory<CardFolderTabsUniDriver>;
export const cardFolderTabsTestkitFactory: VanillaUniTestkitFactory<CardFolderTabsUniDriver>;

import { CardGalleryItemUniDriver } from '../src/CardGalleryItem/CardGalleryItem.uni.driver';

export const CardGalleryItemTestkit: VanillaUniTestkitFactory<CardGalleryItemUniDriver>;
export const cardGalleryItemTestkitFactory: VanillaUniTestkitFactory<CardGalleryItemUniDriver>;

import { CarouselUniDriver } from '../src/Carousel/Carousel.uni.driver';
import { CarouselDriver } from '../src/Carousel/Carousel.driver';
export const CarouselTestkit: VanillaUniTestkitFactory<CarouselUniDriver>;
export const carouselTestkitFactory: VanillaTestkitFactory<CarouselDriver>;

import { CarouselWIPUniDriver } from '../src/CarouselWIP/CarouselWIP.uni.driver';

export const CarouselWIPTestkit: VanillaUniTestkitFactory<CarouselWIPUniDriver>;
export const carouselWipTestkitFactory: VanillaUniTestkitFactory<CarouselWIPUniDriver>;

import { CheckToggleUniDriver } from '../src/CheckToggle/CheckToggle.uni.driver';

export const CheckToggleTestkit: VanillaUniTestkitFactory<CheckToggleUniDriver>;
export const checkToggleTestkitFactory: VanillaUniTestkitFactory<CheckToggleUniDriver>;

import { CheckboxUniDriver } from '../src/Checkbox/Checkbox.uni.driver';
import { CheckboxDriver } from '../src/Checkbox/Checkbox.driver';
export const CheckboxTestkit: VanillaUniTestkitFactory<CheckboxUniDriver>;
export const checkboxTestkitFactory: VanillaTestkitFactory<CheckboxDriver>;

import { CircularProgressBarUniDriver } from '../src/CircularProgressBar/CircularProgressBar.uni.driver';
import { CircularProgressBarDriver } from '../src/CircularProgressBar/CircularProgressBar.driver';
export const CircularProgressBarTestkit: VanillaUniTestkitFactory<CircularProgressBarUniDriver>;
export const circularProgressBarTestkitFactory: VanillaTestkitFactory<CircularProgressBarDriver>;

import { CloseButtonUniDriver } from '../src/CloseButton/CloseButton.uni.driver';

export const CloseButtonTestkit: VanillaUniTestkitFactory<CloseButtonUniDriver>;
export const closeButtonTestkitFactory: VanillaUniTestkitFactory<CloseButtonUniDriver>;

import { CollapseUniDriver } from '../src/Collapse/Collapse.uni.driver';

export const CollapseTestkit: VanillaUniTestkitFactory<CollapseUniDriver>;
export const collapseTestkitFactory: VanillaUniTestkitFactory<CollapseUniDriver>;

import { ColorInputUniDriver } from '../src/ColorInput/ColorInput.uni.driver';

export const ColorInputTestkit: VanillaUniTestkitFactory<ColorInputUniDriver>;
export const colorInputTestkitFactory: VanillaUniTestkitFactory<ColorInputUniDriver>;

import { ColorPickerUniDriver } from '../src/ColorPicker/ColorPicker.uni.driver';
import { ColorPickerDriver } from '../src/ColorPicker/ColorPicker.driver';
export const ColorPickerTestkit: VanillaUniTestkitFactory<ColorPickerUniDriver>;
export const colorPickerTestkitFactory: VanillaTestkitFactory<ColorPickerDriver>;

import { ComposerHeaderUniDriver } from '../src/ComposerHeader/ComposerHeader.uni.driver';

export const ComposerHeaderTestkit: VanillaUniTestkitFactory<ComposerHeaderUniDriver>;
export const composerHeaderTestkitFactory: VanillaUniTestkitFactory<ComposerHeaderUniDriver>;

import { ComposerSidebarUniDriver } from '../src/ComposerSidebar/ComposerSidebar.uni.driver';

export const ComposerSidebarTestkit: VanillaUniTestkitFactory<ComposerSidebarUniDriver>;
export const composerSidebarTestkitFactory: VanillaUniTestkitFactory<ComposerSidebarUniDriver>;

import { CopyClipboardUniDriver } from '../src/CopyClipboard/CopyClipboard.uni.driver';

export const CopyClipboardTestkit: VanillaUniTestkitFactory<CopyClipboardUniDriver>;
export const copyClipboardTestkitFactory: VanillaUniTestkitFactory<CopyClipboardUniDriver>;

import { CounterBadgeUniDriver } from '../src/CounterBadge/CounterBadge.uni.driver';

export const CounterBadgeTestkit: VanillaUniTestkitFactory<CounterBadgeUniDriver>;
export const counterBadgeTestkitFactory: VanillaUniTestkitFactory<CounterBadgeUniDriver>;

import { CustomModalLayoutUniDriver } from '../src/CustomModalLayout/CustomModalLayout.uni.driver';

export const CustomModalLayoutTestkit: VanillaUniTestkitFactory<CustomModalLayoutUniDriver>;
export const customModalLayoutTestkitFactory: VanillaUniTestkitFactory<CustomModalLayoutUniDriver>;

import { DatePickerUniDriver } from '../src/DatePicker/DatePicker.uni.driver';
import { DatePickerDriver } from '../src/DatePicker/DatePicker.driver';
export const DatePickerTestkit: VanillaUniTestkitFactory<DatePickerUniDriver>;
export const datePickerTestkitFactory: VanillaTestkitFactory<DatePickerDriver>;

import { DividerUniDriver } from '../src/Divider/Divider.uni.driver';

export const DividerTestkit: VanillaUniTestkitFactory<DividerUniDriver>;
export const dividerTestkitFactory: VanillaUniTestkitFactory<DividerUniDriver>;

import { DropdownUniDriver } from '../src/Dropdown/Dropdown.uni.driver';
import { DropdownDriver } from '../src/Dropdown/Dropdown.driver';
export const DropdownTestkit: VanillaUniTestkitFactory<DropdownUniDriver>;
export const dropdownTestkitFactory: VanillaTestkitFactory<DropdownDriver>;

import { DropdownBaseUniDriver } from '../src/DropdownBase/DropdownBase.uni.driver';

export const DropdownBaseTestkit: VanillaUniTestkitFactory<DropdownBaseUniDriver>;
export const dropdownBaseTestkitFactory: VanillaUniTestkitFactory<DropdownBaseUniDriver>;

import { DropdownLayoutUniDriver } from '../src/DropdownLayout/DropdownLayout.uni.driver';
import { DropdownLayoutDriver } from '../src/DropdownLayout/DropdownLayout.driver';
export const DropdownLayoutTestkit: VanillaUniTestkitFactory<DropdownLayoutUniDriver>;
export const dropdownLayoutTestkitFactory: VanillaTestkitFactory<DropdownLayoutDriver>;

import { DropzoneUniDriver } from '../src/Dropzone/Dropzone.uni.driver';

export const DropzoneTestkit: VanillaUniTestkitFactory<DropzoneUniDriver>;
export const dropzoneTestkitFactory: VanillaUniTestkitFactory<DropzoneUniDriver>;

import { EditableSelectorUniDriver } from '../src/EditableSelector/EditableSelector.uni.driver';
import { EditableSelectorDriver } from '../src/EditableSelector/EditableSelector.driver';
export const EditableSelectorTestkit: VanillaUniTestkitFactory<EditableSelectorUniDriver>;
export const editableSelectorTestkitFactory: VanillaTestkitFactory<EditableSelectorDriver>;

import { EditableTitleUniDriver } from '../src/EditableTitle/EditableTitle.uni.driver';

export const EditableTitleTestkit: VanillaUniTestkitFactory<EditableTitleUniDriver>;
export const editableTitleTestkitFactory: VanillaUniTestkitFactory<EditableTitleUniDriver>;

import { EmptyStateUniDriver } from '../src/EmptyState/EmptyState.uni.driver';
import { EmptyStateDriver } from '../src/EmptyState/EmptyState.driver';
export const EmptyStateTestkit: VanillaUniTestkitFactory<EmptyStateUniDriver>;
export const emptyStateTestkitFactory: VanillaTestkitFactory<EmptyStateDriver>;

import { FacesRatingBarUniDriver } from '../src/FacesRatingBar/FacesRatingBar.uni.driver';

export const FacesRatingBarTestkit: VanillaUniTestkitFactory<FacesRatingBarUniDriver>;
export const facesRatingBarTestkitFactory: VanillaUniTestkitFactory<FacesRatingBarUniDriver>;

import { FeatureListUniDriver } from '../src/FeatureList/FeatureList.uni.driver';

export const FeatureListTestkit: VanillaUniTestkitFactory<FeatureListUniDriver>;
export const featureListTestkitFactory: VanillaUniTestkitFactory<FeatureListUniDriver>;

import { FieldSetUniDriver } from '../src/FieldSet/FieldSet.uni.driver';

export const FieldSetTestkit: VanillaUniTestkitFactory<FieldSetUniDriver>;
export const fieldSetTestkitFactory: VanillaUniTestkitFactory<FieldSetUniDriver>;

import { FilePickerUniDriver } from '../src/FilePicker/FilePicker.uni.driver';
import { FilePickerDriver } from '../src/FilePicker/FilePicker.driver';
export const FilePickerTestkit: VanillaUniTestkitFactory<FilePickerUniDriver>;
export const filePickerTestkitFactory: VanillaTestkitFactory<FilePickerDriver>;

import { FileUploadUniDriver } from '../src/FileUpload/FileUpload.uni.driver';

export const FileUploadTestkit: VanillaUniTestkitFactory<FileUploadUniDriver>;
export const fileUploadTestkitFactory: VanillaUniTestkitFactory<FileUploadUniDriver>;

import { FillButtonUniDriver } from '../src/FillButton/FillButton.uni.driver';

export const FillButtonTestkit: VanillaUniTestkitFactory<FillButtonUniDriver>;
export const fillButtonTestkitFactory: VanillaUniTestkitFactory<FillButtonUniDriver>;

import { FillPreviewUniDriver } from '../src/FillPreview/FillPreview.uni.driver';

export const FillPreviewTestkit: VanillaUniTestkitFactory<FillPreviewUniDriver>;
export const fillPreviewTestkitFactory: VanillaUniTestkitFactory<FillPreviewUniDriver>;

import { FloatingHelperUniDriver } from '../src/FloatingHelper/FloatingHelper.uni.driver';
import { FloatingHelperDriver } from '../src/FloatingHelper/FloatingHelper.driver';
export const FloatingHelperTestkit: VanillaUniTestkitFactory<FloatingHelperUniDriver>;
export const floatingHelperTestkitFactory: VanillaTestkitFactory<FloatingHelperDriver>;

import { FloatingNotificationUniDriver } from '../src/FloatingNotification/FloatingNotification.uni.driver';

export const FloatingNotificationTestkit: VanillaUniTestkitFactory<FloatingNotificationUniDriver>;
export const floatingNotificationTestkitFactory: VanillaUniTestkitFactory<FloatingNotificationUniDriver>;

import { FormFieldUniDriver } from '../src/FormField/FormField.uni.driver';
import { FormFieldDriver } from '../src/FormField/FormField.driver';
export const FormFieldTestkit: VanillaUniTestkitFactory<FormFieldUniDriver>;
export const formFieldTestkitFactory: VanillaTestkitFactory<FormFieldDriver>;

import { FunnelChartUniDriver } from '../src/FunnelChart/FunnelChart.uni.driver';

export const FunnelChartTestkit: VanillaUniTestkitFactory<FunnelChartUniDriver>;
export const funnelChartTestkitFactory: VanillaUniTestkitFactory<FunnelChartUniDriver>;

import { GooglePreviewUniDriver } from '../src/GooglePreview/GooglePreview.uni.driver';

export const GooglePreviewTestkit: VanillaUniTestkitFactory<GooglePreviewUniDriver>;
export const googlePreviewTestkitFactory: VanillaUniTestkitFactory<GooglePreviewUniDriver>;

import { HeadingUniDriver } from '../src/Heading/Heading.uni.driver';
import { HeadingDriver } from '../src/Heading/Heading.driver';
export const HeadingTestkit: VanillaUniTestkitFactory<HeadingUniDriver>;
export const headingTestkitFactory: VanillaTestkitFactory<HeadingDriver>;

import { HighlighterUniDriver } from '../src/Highlighter/Highlighter.uni.driver';
import { HighlighterDriver } from '../src/Highlighter/Highlighter.driver';
export const HighlighterTestkit: VanillaUniTestkitFactory<HighlighterUniDriver>;
export const highlighterTestkitFactory: VanillaTestkitFactory<HighlighterDriver<HTMLElement>>;

import { HorizontalTimelineUniDriver } from '../src/HorizontalTimeline/HorizontalTimeline.uni.driver';

export const HorizontalTimelineTestkit: VanillaUniTestkitFactory<HorizontalTimelineUniDriver>;
export const horizontalTimelineTestkitFactory: VanillaUniTestkitFactory<HorizontalTimelineUniDriver>;

import { IconButtonUniDriver } from '../src/IconButton/IconButton.uni.driver';

export const IconButtonTestkit: VanillaUniTestkitFactory<IconButtonUniDriver>;
export const iconButtonTestkitFactory: VanillaUniTestkitFactory<IconButtonUniDriver>;

import { ImageUniDriver } from '../src/Image/Image.uni.driver';

export const ImageTestkit: VanillaUniTestkitFactory<ImageUniDriver>;
export const imageTestkitFactory: VanillaUniTestkitFactory<ImageUniDriver>;

import { ImageViewerUniDriver } from '../src/ImageViewer/ImageViewer.uni.driver';
import { ImageViewerDriver } from '../src/ImageViewer/ImageViewer.driver';
export const ImageViewerTestkit: VanillaUniTestkitFactory<ImageViewerUniDriver>;
export const imageViewerTestkitFactory: VanillaTestkitFactory<ImageViewerDriver<HTMLElement>>;

import { InfoIconUniDriver } from '../src/InfoIcon/InfoIcon.uni.driver';

export const InfoIconTestkit: VanillaUniTestkitFactory<InfoIconUniDriver>;
export const infoIconTestkitFactory: VanillaUniTestkitFactory<InfoIconUniDriver>;

import { InputUniDriver } from '../src/Input/Input.uni.driver';
import { InputDriver } from '../src/Input/Input.driver';
export const InputTestkit: VanillaUniTestkitFactory<InputUniDriver>;
export const inputTestkitFactory: VanillaTestkitFactory<InputDriver>;

import { InputAreaUniDriver } from '../src/InputArea/InputArea.uni.driver';
import { InputAreaDriver } from '../src/InputArea/InputArea.driver';
export const InputAreaTestkit: VanillaUniTestkitFactory<InputAreaUniDriver>;
export const inputAreaTestkitFactory: VanillaTestkitFactory<InputAreaDriver<HTMLElement>>;

import { InputWithLabelUniDriver } from '../src/InputWithLabel/InputWithLabel.uni.driver';

export const InputWithLabelTestkit: VanillaUniTestkitFactory<InputWithLabelUniDriver>;
export const inputWithLabelTestkitFactory: VanillaUniTestkitFactory<InputWithLabelUniDriver>;

import { InputWithOptionsUniDriver } from '../src/InputWithOptions/InputWithOptions.uni.driver';
import { InputWithOptionsDriver } from '../src/InputWithOptions/InputWithOptions.driver';
export const InputWithOptionsTestkit: VanillaUniTestkitFactory<InputWithOptionsUniDriver>;
export const inputWithOptionsTestkitFactory: VanillaTestkitFactory<InputWithOptionsDriver>;

import { LinearProgressBarUniDriver } from '../src/LinearProgressBar/LinearProgressBar.uni.driver';
import { LinearProgressBarDriver } from '../src/LinearProgressBar/LinearProgressBar.driver';
export const LinearProgressBarTestkit: VanillaUniTestkitFactory<LinearProgressBarUniDriver>;
export const linearProgressBarTestkitFactory: VanillaTestkitFactory<LinearProgressBarDriver>;

import { ListItemActionUniDriver } from '../src/ListItemAction/ListItemAction.uni.driver';

export const ListItemActionTestkit: VanillaUniTestkitFactory<ListItemActionUniDriver>;
export const listItemActionTestkitFactory: VanillaUniTestkitFactory<ListItemActionUniDriver>;

import { ListItemEditableUniDriver } from '../src/ListItemEditable/ListItemEditable.uni.driver';

export const ListItemEditableTestkit: VanillaUniTestkitFactory<ListItemEditableUniDriver>;
export const listItemEditableTestkitFactory: VanillaUniTestkitFactory<ListItemEditableUniDriver>;

import { ListItemSectionUniDriver } from '../src/ListItemSection/ListItemSection.uni.driver';

export const ListItemSectionTestkit: VanillaUniTestkitFactory<ListItemSectionUniDriver>;
export const listItemSectionTestkitFactory: VanillaUniTestkitFactory<ListItemSectionUniDriver>;

import { ListItemSelectUniDriver } from '../src/ListItemSelect/ListItemSelect.uni.driver';

export const ListItemSelectTestkit: VanillaUniTestkitFactory<ListItemSelectUniDriver>;
export const listItemSelectTestkitFactory: VanillaUniTestkitFactory<ListItemSelectUniDriver>;

import { LiveRegionUniDriver } from '../src/LiveRegion/LiveRegion.uni.driver';

export const LiveRegionTestkit: VanillaUniTestkitFactory<LiveRegionUniDriver>;
export const liveRegionTestkitFactory: VanillaUniTestkitFactory<LiveRegionUniDriver>;

import { LoaderUniDriver } from '../src/Loader/Loader.uni.driver';
import { LoaderDriver } from '../src/Loader/Loader.driver';
export const LoaderTestkit: VanillaUniTestkitFactory<LoaderUniDriver>;
export const loaderTestkitFactory: VanillaTestkitFactory<LoaderDriver>;

import { MarketingLayoutUniDriver } from '../src/MarketingLayout/MarketingLayout.uni.driver';

export const MarketingLayoutTestkit: VanillaUniTestkitFactory<MarketingLayoutUniDriver>;
export const marketingLayoutTestkitFactory: VanillaUniTestkitFactory<MarketingLayoutUniDriver>;

import { MarketingPageLayoutUniDriver } from '../src/MarketingPageLayout/MarketingPageLayout.uni.driver';

export const MarketingPageLayoutTestkit: VanillaUniTestkitFactory<MarketingPageLayoutUniDriver>;
export const marketingPageLayoutTestkitFactory: VanillaUniTestkitFactory<MarketingPageLayoutUniDriver>;

import { MarketingPageLayoutContentUniDriver } from '../src/MarketingPageLayoutContent/MarketingPageLayoutContent.uni.driver';

export const MarketingPageLayoutContentTestkit: VanillaUniTestkitFactory<MarketingPageLayoutContentUniDriver>;
export const marketingPageLayoutContentTestkitFactory: VanillaUniTestkitFactory<MarketingPageLayoutContentUniDriver>;

import { MediaOverlayUniDriver } from '../src/MediaOverlay/MediaOverlay.uni.driver';

export const MediaOverlayTestkit: VanillaUniTestkitFactory<MediaOverlayUniDriver<HTMLElement>>;
export const mediaOverlayTestkitFactory: VanillaUniTestkitFactory<MediaOverlayUniDriver<HTMLElement>>;

import { MessageBoxFunctionalLayoutUniDriver } from '../src/MessageBoxFunctionalLayout/MessageBoxFunctionalLayout.uni.driver';
import { MessageBoxFunctionalLayoutDriver } from '../src/MessageBoxFunctionalLayout/MessageBoxFunctionalLayout.driver';
export const MessageBoxFunctionalLayoutTestkit: VanillaUniTestkitFactory<MessageBoxFunctionalLayoutUniDriver>;
export const messageBoxFunctionalLayoutTestkitFactory: VanillaTestkitFactory<MessageBoxFunctionalLayoutDriver>;

import { MessageBoxMarketerialLayoutUniDriver } from '../src/MessageBoxMarketerialLayout/MessageBoxMarketerialLayout.uni.driver';
import { MessageBoxMarketerialLayoutDriver } from '../src/MessageBoxMarketerialLayout/MessageBoxMarketerialLayout.driver';
export const MessageBoxMarketerialLayoutTestkit: VanillaUniTestkitFactory<MessageBoxMarketerialLayoutUniDriver>;
export const messageBoxMarketerialLayoutTestkitFactory: VanillaTestkitFactory<MessageBoxMarketerialLayoutDriver>;

import { MessageModalLayoutUniDriver } from '../src/MessageModalLayout/MessageModalLayout.uni.driver';

export const MessageModalLayoutTestkit: VanillaUniTestkitFactory<MessageModalLayoutUniDriver>;
export const messageModalLayoutTestkitFactory: VanillaUniTestkitFactory<MessageModalLayoutUniDriver>;

import { MobilePreviewWidgetUniDriver } from '../src/MobilePreviewWidget/MobilePreviewWidget.uni.driver';

export const MobilePreviewWidgetTestkit: VanillaUniTestkitFactory<MobilePreviewWidgetUniDriver>;
export const mobilePreviewWidgetTestkitFactory: VanillaUniTestkitFactory<MobilePreviewWidgetUniDriver>;

import { ModalUniDriver } from '../src/Modal/Modal.uni.driver';
import { ModalDriver } from '../src/Modal/Modal.driver';
export const ModalTestkit: VanillaUniTestkitFactory<ModalUniDriver>;
export const modalTestkitFactory: VanillaTestkitFactory<ModalDriver<HTMLElement>>;

import { ModalMobileLayoutUniDriver } from '../src/ModalMobileLayout/ModalMobileLayout.uni.driver';

export const ModalMobileLayoutTestkit: VanillaUniTestkitFactory<ModalMobileLayoutUniDriver>;
export const modalMobileLayoutTestkitFactory: VanillaUniTestkitFactory<ModalMobileLayoutUniDriver>;

import { ModalPreviewLayoutUniDriver } from '../src/ModalPreviewLayout/ModalPreviewLayout.uni.driver';

export const ModalPreviewLayoutTestkit: VanillaUniTestkitFactory<ModalPreviewLayoutUniDriver>;
export const modalPreviewLayoutTestkitFactory: VanillaUniTestkitFactory<ModalPreviewLayoutUniDriver>;

import { ModalSelectorLayoutUniDriver } from '../src/ModalSelectorLayout/ModalSelectorLayout.uni.driver';
import { ModalSelectorLayoutDriver } from '../src/ModalSelectorLayout/ModalSelectorLayout.driver';
export const ModalSelectorLayoutTestkit: VanillaUniTestkitFactory<ModalSelectorLayoutUniDriver>;
export const modalSelectorLayoutTestkitFactory: VanillaTestkitFactory<ModalSelectorLayoutDriver>;

import { MultiSelectUniDriver } from '../src/MultiSelect/MultiSelect.uni.driver';
import { MultiSelectDriver } from '../src/MultiSelect/MultiSelect.driver';
export const MultiSelectTestkit: VanillaUniTestkitFactory<MultiSelectUniDriver>;
export const multiSelectTestkitFactory: VanillaTestkitFactory<MultiSelectDriver>;

import { MultiSelectCheckboxUniDriver } from '../src/MultiSelectCheckbox/MultiSelectCheckbox.uni.driver';
import { MultiSelectCheckboxDriver } from '../src/MultiSelectCheckbox/MultiSelectCheckbox.driver';
export const MultiSelectCheckboxTestkit: VanillaUniTestkitFactory<MultiSelectCheckboxUniDriver>;
export const multiSelectCheckboxTestkitFactory: VanillaTestkitFactory<MultiSelectCheckboxDriver>;

import { NestableListUniDriver } from '../src/NestableList/NestableList.uni.driver';

export const NestableListTestkit: VanillaUniTestkitFactory<NestableListUniDriver>;
export const nestableListTestkitFactory: VanillaUniTestkitFactory<NestableListUniDriver>;

import { NestableListBaseUniDriver } from '../src/NestableListBase/NestableListBase.uni.driver';

export const NestableListBaseTestkit: VanillaUniTestkitFactory<NestableListBaseUniDriver>;
export const nestableListBaseTestkitFactory: VanillaUniTestkitFactory<NestableListBaseUniDriver>;

import { NotificationUniDriver } from '../src/Notification/Notification.uni.driver';
import { NotificationDriver } from '../src/Notification/Notification.driver';
export const NotificationTestkit: VanillaUniTestkitFactory<NotificationUniDriver>;
export const notificationTestkitFactory: VanillaTestkitFactory<NotificationDriver>;

import { NumberInputUniDriver } from '../src/NumberInput/NumberInput.uni.driver';

export const NumberInputTestkit: VanillaUniTestkitFactory<NumberInputUniDriver>;
export const numberInputTestkitFactory: VanillaUniTestkitFactory<NumberInputUniDriver>;

import { PageUniDriver } from '../src/Page/Page.uni.driver';
import { PageDriver } from '../src/Page/Page.driver';
export const PageTestkit: VanillaUniTestkitFactory<PageUniDriver>;
export const pageTestkitFactory: VanillaTestkitFactory<PageDriver>;

import { PageFooterUniDriver } from '../src/PageFooter/PageFooter.uni.driver';

export const PageFooterTestkit: VanillaUniTestkitFactory<PageFooterUniDriver>;
export const pageFooterTestkitFactory: VanillaUniTestkitFactory<PageFooterUniDriver>;

import { PageHeaderUniDriver } from '../src/PageHeader/PageHeader.uni.driver';
import { PageHeaderDriver } from '../src/PageHeader/PageHeader.driver';
export const PageHeaderTestkit: VanillaUniTestkitFactory<PageHeaderUniDriver>;
export const pageHeaderTestkitFactory: VanillaTestkitFactory<PageHeaderDriver>;

import { PageSectionUniDriver } from '../src/PageSection/PageSection.uni.driver';

export const PageSectionTestkit: VanillaUniTestkitFactory<PageSectionUniDriver>;
export const pageSectionTestkitFactory: VanillaUniTestkitFactory<PageSectionUniDriver>;

import { PaginationUniDriver } from '../src/Pagination/Pagination.uni.driver';

export const PaginationTestkit: VanillaUniTestkitFactory<PaginationUniDriver>;
export const paginationTestkitFactory: VanillaUniTestkitFactory<PaginationUniDriver>;

import { PaletteUniDriver } from '../src/Palette/Palette.uni.driver';

export const PaletteTestkit: VanillaUniTestkitFactory<PaletteUniDriver>;
export const paletteTestkitFactory: VanillaUniTestkitFactory<PaletteUniDriver>;

import { PopoverUniDriver } from '../src/Popover/Popover.uni.driver';
import { PopoverDriver } from '../src/Popover/Popover.driver';
export const PopoverTestkit: VanillaUniTestkitFactory<PopoverUniDriver>;
export const popoverTestkitFactory: VanillaTestkitFactory<PopoverDriver>;

import { PopoverMenuUniDriver } from '../src/PopoverMenu/PopoverMenu.uni.driver';

export const PopoverMenuTestkit: VanillaUniTestkitFactory<PopoverMenuUniDriver>;
export const popoverMenuTestkitFactory: VanillaUniTestkitFactory<PopoverMenuUniDriver>;

import { PreviewWidgetUniDriver } from '../src/PreviewWidget/PreviewWidget.uni.driver';

export const PreviewWidgetTestkit: VanillaUniTestkitFactory<PreviewWidgetUniDriver>;
export const previewWidgetTestkitFactory: VanillaUniTestkitFactory<PreviewWidgetUniDriver>;

import { ProportionUniDriver } from '../src/Proportion/Proportion.uni.driver';

export const ProportionTestkit: VanillaUniTestkitFactory<ProportionUniDriver>;
export const proportionTestkitFactory: VanillaUniTestkitFactory<ProportionUniDriver>;

import { PulseAnimationUniDriver } from '../src/PulseAnimation/PulseAnimation.uni.driver';

export const PulseAnimationTestkit: VanillaUniTestkitFactory<PulseAnimationUniDriver>;
export const pulseAnimationTestkitFactory: VanillaUniTestkitFactory<PulseAnimationUniDriver>;

import { RadarChartUniDriver } from '../src/RadarChart/RadarChart.uni.driver';

export const RadarChartTestkit: VanillaUniTestkitFactory<RadarChartUniDriver>;
export const radarChartTestkitFactory: VanillaUniTestkitFactory<RadarChartUniDriver>;

import { RadioUniDriver } from '../src/Radio/Radio.uni.driver';
import { RadioDriver } from '../src/Radio/Radio.driver';
export const RadioTestkit: VanillaUniTestkitFactory<RadioUniDriver>;
export const radioTestkitFactory: VanillaTestkitFactory<RadioDriver>;

import { RadioGroupUniDriver } from '../src/RadioGroup/RadioGroup.uni.driver';
import { RadioGroupDriver } from '../src/RadioGroup/RadioGroup.driver';
export const RadioGroupTestkit: VanillaUniTestkitFactory<RadioGroupUniDriver>;
export const radioGroupTestkitFactory: VanillaTestkitFactory<RadioGroupDriver>;

import { RangeUniDriver } from '../src/Range/Range.uni.driver';
import { RangeDriver } from '../src/Range/Range.driver';
export const RangeTestkit: VanillaUniTestkitFactory<RangeUniDriver>;
export const rangeTestkitFactory: VanillaTestkitFactory<RangeDriver>;

import { RichTextInputAreaUniDriver } from '../src/RichTextInputArea/RichTextInputArea.uni.driver';

export const RichTextInputAreaTestkit: VanillaUniTestkitFactory<RichTextInputAreaUniDriver>;
export const richTextInputAreaTestkitFactory: VanillaUniTestkitFactory<RichTextInputAreaUniDriver>;

import { SearchUniDriver } from '../src/Search/Search.uni.driver';
import { SearchDriver } from '../src/Search/Search.driver';
export const SearchTestkit: VanillaUniTestkitFactory<SearchUniDriver>;
export const searchTestkitFactory: VanillaTestkitFactory<SearchDriver>;

import { SectionHeaderUniDriver } from '../src/SectionHeader/SectionHeader.uni.driver';

export const SectionHeaderTestkit: VanillaUniTestkitFactory<SectionHeaderUniDriver>;
export const sectionHeaderTestkitFactory: VanillaUniTestkitFactory<SectionHeaderUniDriver>;

import { SectionHelperUniDriver } from '../src/SectionHelper/SectionHelper.uni.driver';
import { SectionHelperDriver } from '../src/SectionHelper/SectionHelper.driver';
export const SectionHelperTestkit: VanillaUniTestkitFactory<SectionHelperUniDriver>;
export const sectionHelperTestkitFactory: VanillaTestkitFactory<SectionHelperDriver>;

import { SegmentedToggleUniDriver } from '../src/SegmentedToggle/SegmentedToggle.uni.driver';

export const SegmentedToggleTestkit: VanillaUniTestkitFactory<SegmentedToggleUniDriver>;
export const segmentedToggleTestkitFactory: VanillaUniTestkitFactory<SegmentedToggleUniDriver>;

import { SelectableAccordionUniDriver } from '../src/SelectableAccordion/SelectableAccordion.uni.driver';

export const SelectableAccordionTestkit: VanillaUniTestkitFactory<SelectableAccordionUniDriver>;
export const selectableAccordionTestkitFactory: VanillaUniTestkitFactory<SelectableAccordionUniDriver>;

import { SelectorUniDriver } from '../src/Selector/Selector.uni.driver';
import { SelectorDriver } from '../src/Selector/Selector.driver';
export const SelectorTestkit: VanillaUniTestkitFactory<SelectorUniDriver>;
export const selectorTestkitFactory: VanillaTestkitFactory<SelectorDriver>;

import { SelectorListUniDriver } from '../src/SelectorList/SelectorList.uni.driver';

export const SelectorListTestkit: VanillaUniTestkitFactory<SelectorListUniDriver>;
export const selectorListTestkitFactory: VanillaUniTestkitFactory<SelectorListUniDriver>;

import { SidePanelUniDriver } from '../src/SidePanel/SidePanel.uni.driver';

export const SidePanelTestkit: VanillaUniTestkitFactory<SidePanelUniDriver>;
export const sidePanelTestkitFactory: VanillaUniTestkitFactory<SidePanelUniDriver>;

import { SidebarUniDriver } from '../src/Sidebar/Sidebar.uni.driver';

export const SidebarTestkit: VanillaUniTestkitFactory<SidebarUniDriver>;
export const sidebarTestkitFactory: VanillaUniTestkitFactory<SidebarUniDriver>;

import { SidebarBackButtonUniDriver } from '../src/SidebarBackButton/SidebarBackButton.uni.driver';

export const SidebarBackButtonTestkit: VanillaUniTestkitFactory<SidebarBackButtonUniDriver>;
export const sidebarBackButtonTestkitFactory: VanillaUniTestkitFactory<SidebarBackButtonUniDriver>;

import { SidebarDividerUniDriver } from '../src/SidebarDivider/SidebarDivider.uni.driver';

export const SidebarDividerTestkit: VanillaUniTestkitFactory<SidebarDividerUniDriver>;
export const sidebarDividerTestkitFactory: VanillaUniTestkitFactory<SidebarDividerUniDriver>;

import { SidebarDividerNextUniDriver } from '../src/SidebarDividerNext/SidebarDividerNext.uni.driver';

export const SidebarDividerNextTestkit: VanillaUniTestkitFactory<SidebarDividerNextUniDriver>;
export const sidebarDividerNextTestkitFactory: VanillaUniTestkitFactory<SidebarDividerNextUniDriver>;

import { SidebarHeaderUniDriver } from '../src/SidebarHeader/SidebarHeader.uni.driver';

export const SidebarHeaderTestkit: VanillaUniTestkitFactory<SidebarHeaderUniDriver>;
export const sidebarHeaderTestkitFactory: VanillaUniTestkitFactory<SidebarHeaderUniDriver>;

import { SidebarHeaderNextUniDriver } from '../src/SidebarHeaderNext/SidebarHeaderNext.uni.driver';

export const SidebarHeaderNextTestkit: VanillaUniTestkitFactory<SidebarHeaderNextUniDriver>;
export const sidebarHeaderNextTestkitFactory: VanillaUniTestkitFactory<SidebarHeaderNextUniDriver>;

import { SidebarItemNextUniDriver } from '../src/SidebarItemNext/SidebarItemNext.uni.driver';

export const SidebarItemNextTestkit: VanillaUniTestkitFactory<SidebarItemNextUniDriver>;
export const sidebarItemNextTestkitFactory: VanillaUniTestkitFactory<SidebarItemNextUniDriver>;

import { SidebarNextUniDriver } from '../src/SidebarNext/SidebarNext.uni.driver';

export const SidebarNextTestkit: VanillaUniTestkitFactory<SidebarNextUniDriver>;
export const sidebarNextTestkitFactory: VanillaUniTestkitFactory<SidebarNextUniDriver>;

import { SidebarSectionItemUniDriver } from '../src/SidebarSectionItem/SidebarSectionItem.uni.driver';

export const SidebarSectionItemTestkit: VanillaUniTestkitFactory<SidebarSectionItemUniDriver>;
export const sidebarSectionItemTestkitFactory: VanillaUniTestkitFactory<SidebarSectionItemUniDriver>;

import { SidebarSectionTitleUniDriver } from '../src/SidebarSectionTitle/SidebarSectionTitle.uni.driver';

export const SidebarSectionTitleTestkit: VanillaUniTestkitFactory<SidebarSectionTitleUniDriver>;
export const sidebarSectionTitleTestkitFactory: VanillaUniTestkitFactory<SidebarSectionTitleUniDriver>;

import { SidebarSubMenuNextUniDriver } from '../src/SidebarSubMenuNext/SidebarSubMenuNext.uni.driver';

export const SidebarSubMenuNextTestkit: VanillaUniTestkitFactory<SidebarSubMenuNextUniDriver>;
export const sidebarSubMenuNextTestkitFactory: VanillaUniTestkitFactory<SidebarSubMenuNextUniDriver>;

import { SidebarTitleItemNextUniDriver } from '../src/SidebarTitleItemNext/SidebarTitleItemNext.uni.driver';

export const SidebarTitleItemNextTestkit: VanillaUniTestkitFactory<SidebarTitleItemNextUniDriver>;
export const sidebarTitleItemNextTestkitFactory: VanillaUniTestkitFactory<SidebarTitleItemNextUniDriver>;

import { SkeletonUniDriver } from '../src/Skeleton/Skeleton.uni.driver';
import { SkeletonDriver } from '../src/Skeleton/Skeleton.driver';
export const SkeletonTestkit: VanillaUniTestkitFactory<SkeletonUniDriver>;
export const skeletonTestkitFactory: VanillaTestkitFactory<SkeletonDriver>;

import { SkeletonCircleUniDriver } from '../src/SkeletonCircle/SkeletonCircle.uni.driver';

export const SkeletonCircleTestkit: VanillaUniTestkitFactory<SkeletonCircleUniDriver>;
export const skeletonCircleTestkitFactory: VanillaUniTestkitFactory<SkeletonCircleUniDriver>;

import { SkeletonGroupUniDriver } from '../src/SkeletonGroup/SkeletonGroup.uni.driver';

export const SkeletonGroupTestkit: VanillaUniTestkitFactory<SkeletonGroupUniDriver>;
export const skeletonGroupTestkitFactory: VanillaUniTestkitFactory<SkeletonGroupUniDriver>;

import { SkeletonLineUniDriver } from '../src/SkeletonLine/SkeletonLine.uni.driver';

export const SkeletonLineTestkit: VanillaUniTestkitFactory<SkeletonLineUniDriver>;
export const skeletonLineTestkitFactory: VanillaUniTestkitFactory<SkeletonLineUniDriver>;

import { SkeletonRectangleUniDriver } from '../src/SkeletonRectangle/SkeletonRectangle.uni.driver';

export const SkeletonRectangleTestkit: VanillaUniTestkitFactory<SkeletonRectangleUniDriver>;
export const skeletonRectangleTestkitFactory: VanillaUniTestkitFactory<SkeletonRectangleUniDriver>;

import { SliderUniDriver } from '../src/Slider/Slider.uni.driver';
import { SliderDriver } from '../src/Slider/Slider.driver';
export const SliderTestkit: VanillaUniTestkitFactory<SliderUniDriver>;
export const sliderTestkitFactory: VanillaTestkitFactory<SliderDriver>;

import { SocialButtonUniDriver } from '../src/SocialButton/SocialButton.uni.driver';

export const SocialButtonTestkit: VanillaUniTestkitFactory<SocialButtonUniDriver>;
export const socialButtonTestkitFactory: VanillaUniTestkitFactory<SocialButtonUniDriver>;

import { SocialPostPreviewUniDriver } from '../src/SocialPostPreview/SocialPostPreview.uni.driver';

export const SocialPostPreviewTestkit: VanillaUniTestkitFactory<SocialPostPreviewUniDriver>;
export const socialPostPreviewTestkitFactory: VanillaUniTestkitFactory<SocialPostPreviewUniDriver>;

import { SocialPreviewUniDriver } from '../src/SocialPreview/SocialPreview.uni.driver';

export const SocialPreviewTestkit: VanillaUniTestkitFactory<SocialPreviewUniDriver>;
export const socialPreviewTestkitFactory: VanillaUniTestkitFactory<SocialPreviewUniDriver>;

import { SortableGridBaseUniDriver } from '../src/SortableGridBase/SortableGridBase.uni.driver';

export const SortableGridBaseTestkit: VanillaUniTestkitFactory<SortableGridBaseUniDriver>;
export const sortableGridBaseTestkitFactory: VanillaUniTestkitFactory<SortableGridBaseUniDriver>;

import { SortableListBaseUniDriver } from '../src/SortableListBase/SortableListBase.uni.driver';
import { SortableListBaseDriver } from '../src/SortableListBase/SortableListBase.driver';
export const SortableListBaseTestkit: VanillaUniTestkitFactory<SortableListBaseUniDriver>;
export const sortableListBaseTestkitFactory: VanillaTestkitFactory<SortableListBaseDriver>;

import { SparklineChartUniDriver } from '../src/SparklineChart/SparklineChart.uni.driver';

export const SparklineChartTestkit: VanillaUniTestkitFactory<SparklineChartUniDriver>;
export const sparklineChartTestkitFactory: VanillaUniTestkitFactory<SparklineChartUniDriver>;

import { StackedBarChartUniDriver } from '../src/StackedBarChart/StackedBarChart.uni.driver';

export const StackedBarChartTestkit: VanillaUniTestkitFactory<StackedBarChartUniDriver>;
export const stackedBarChartTestkitFactory: VanillaUniTestkitFactory<StackedBarChartUniDriver>;

import { StarsRatingBarUniDriver } from '../src/StarsRatingBar/StarsRatingBar.uni.driver';

export const StarsRatingBarTestkit: VanillaUniTestkitFactory<StarsRatingBarUniDriver>;
export const starsRatingBarTestkitFactory: VanillaUniTestkitFactory<StarsRatingBarUniDriver>;

import { StatisticsWidgetUniDriver } from '../src/StatisticsWidget/StatisticsWidget.uni.driver';

export const StatisticsWidgetTestkit: VanillaUniTestkitFactory<StatisticsWidgetUniDriver>;
export const statisticsWidgetTestkitFactory: VanillaUniTestkitFactory<StatisticsWidgetUniDriver>;

import { StatusIndicatorUniDriver } from '../src/StatusIndicator/StatusIndicator.uni.driver';

export const StatusIndicatorTestkit: VanillaUniTestkitFactory<StatusIndicatorUniDriver>;
export const statusIndicatorTestkitFactory: VanillaUniTestkitFactory<StatusIndicatorUniDriver>;

import { StepperUniDriver } from '../src/Stepper/Stepper.uni.driver';

export const StepperTestkit: VanillaUniTestkitFactory<StepperUniDriver>;
export const stepperTestkitFactory: VanillaUniTestkitFactory<StepperUniDriver>;

import { SwatchesUniDriver } from '../src/Swatches/Swatches.uni.driver';

export const SwatchesTestkit: VanillaUniTestkitFactory<SwatchesUniDriver>;
export const swatchesTestkitFactory: VanillaUniTestkitFactory<SwatchesUniDriver>;

import { TableUniDriver } from '../src/Table/Table.uni.driver';
import { TableDriver } from '../src/Table/Table.driver';
export const TableTestkit: VanillaUniTestkitFactory<TableUniDriver>;
export const tableTestkitFactory: VanillaTestkitFactory<TableDriver<HTMLElement>>;

import { TableActionCellUniDriver } from '../src/TableActionCell/TableActionCell.uni.driver';
import { TableActionCellDriver } from '../src/TableActionCell/TableActionCell.driver';
export const TableActionCellTestkit: VanillaUniTestkitFactory<TableActionCellUniDriver>;
export const tableActionCellTestkitFactory: VanillaTestkitFactory<TableActionCellDriver<HTMLElement>>;

import { TableListHeaderUniDriver } from '../src/TableListHeader/TableListHeader.uni.driver';

export const TableListHeaderTestkit: VanillaUniTestkitFactory<TableListHeaderUniDriver>;
export const tableListHeaderTestkitFactory: VanillaUniTestkitFactory<TableListHeaderUniDriver>;

import { TableListItemUniDriver } from '../src/TableListItem/TableListItem.uni.driver';

export const TableListItemTestkit: VanillaUniTestkitFactory<TableListItemUniDriver>;
export const tableListItemTestkitFactory: VanillaUniTestkitFactory<TableListItemUniDriver>;

import { TabsUniDriver } from '../src/Tabs/Tabs.uni.driver';
import { TabsDriver } from '../src/Tabs/Tabs.driver';
export const TabsTestkit: VanillaUniTestkitFactory<TabsUniDriver>;
export const tabsTestkitFactory: VanillaTestkitFactory<TabsDriver>;

import { TagUniDriver } from '../src/Tag/Tag.uni.driver';
import { TagDriver } from '../src/Tag/Tag.driver';
export const TagTestkit: VanillaUniTestkitFactory<TagUniDriver>;
export const tagTestkitFactory: VanillaTestkitFactory<TagDriver>;

import { TagListUniDriver } from '../src/TagList/TagList.uni.driver';

export const TagListTestkit: VanillaUniTestkitFactory<TagListUniDriver>;
export const tagListTestkitFactory: VanillaUniTestkitFactory<TagListUniDriver>;

import { TestimonialListUniDriver } from '../src/TestimonialList/TestimonialList.uni.driver';

export const TestimonialListTestkit: VanillaUniTestkitFactory<TestimonialListUniDriver>;
export const testimonialListTestkitFactory: VanillaUniTestkitFactory<TestimonialListUniDriver>;

import { TextUniDriver } from '../src/Text/Text.uni.driver';
import { TextDriver } from '../src/Text/Text.driver';
export const TextTestkit: VanillaUniTestkitFactory<TextUniDriver>;
export const textTestkitFactory: VanillaTestkitFactory<TextDriver>;

import { TextButtonUniDriver } from '../src/TextButton/TextButton.uni.driver';

export const TextButtonTestkit: VanillaUniTestkitFactory<TextButtonUniDriver>;
export const textButtonTestkitFactory: VanillaUniTestkitFactory<TextButtonUniDriver>;

import { ThumbnailUniDriver } from '../src/Thumbnail/Thumbnail.uni.driver';

export const ThumbnailTestkit: VanillaUniTestkitFactory<ThumbnailUniDriver>;
export const thumbnailTestkitFactory: VanillaUniTestkitFactory<ThumbnailUniDriver>;

import { TimeInputUniDriver } from '../src/TimeInput/TimeInput.uni.driver';

export const TimeInputTestkit: VanillaUniTestkitFactory<TimeInputUniDriver>;
export const timeInputTestkitFactory: VanillaUniTestkitFactory<TimeInputUniDriver>;

import { TimeTableUniDriver } from '../src/TimeTable/TimeTable.uni.driver';

export const TimeTableTestkit: VanillaUniTestkitFactory<TimeTableUniDriver>;
export const timeTableTestkitFactory: VanillaUniTestkitFactory<TimeTableUniDriver>;

import { TimelineUniDriver } from '../src/Timeline/Timeline.uni.driver';

export const TimelineTestkit: VanillaUniTestkitFactory<TimelineUniDriver>;
export const timelineTestkitFactory: VanillaUniTestkitFactory<TimelineUniDriver>;

import { ToastUniDriver } from '../src/Toast/Toast.uni.driver';

export const ToastTestkit: VanillaUniTestkitFactory<ToastUniDriver>;
export const toastTestkitFactory: VanillaUniTestkitFactory<ToastUniDriver>;

import { ToggleButtonUniDriver } from '../src/ToggleButton/ToggleButton.uni.driver';

export const ToggleButtonTestkit: VanillaUniTestkitFactory<ToggleButtonUniDriver>;
export const toggleButtonTestkitFactory: VanillaUniTestkitFactory<ToggleButtonUniDriver>;

import { ToggleSwitchUniDriver } from '../src/ToggleSwitch/ToggleSwitch.uni.driver';
import { ToggleSwitchDriver } from '../src/ToggleSwitch/ToggleSwitch.driver';
export const ToggleSwitchTestkit: VanillaUniTestkitFactory<ToggleSwitchUniDriver>;
export const toggleSwitchTestkitFactory: VanillaTestkitFactory<ToggleSwitchDriver>;

import { TooltipUniDriver } from '../src/Tooltip/Tooltip.uni.driver';

export const TooltipTestkit: VanillaUniTestkitFactory<TooltipUniDriver>;
export const tooltipTestkitFactory: VanillaUniTestkitFactory<TooltipUniDriver>;

import { TransitionUniDriver } from '../src/Transition/Transition.uni.driver';

export const TransitionTestkit: VanillaUniTestkitFactory<TransitionUniDriver>;
export const transitionTestkitFactory: VanillaUniTestkitFactory<TransitionUniDriver>;

import { TrendIndicatorUniDriver } from '../src/TrendIndicator/TrendIndicator.uni.driver';

export const TrendIndicatorTestkit: VanillaUniTestkitFactory<TrendIndicatorUniDriver>;
export const trendIndicatorTestkitFactory: VanillaUniTestkitFactory<TrendIndicatorUniDriver>;

import { VariableInputUniDriver } from '../src/VariableInput/VariableInput.uni.driver';

export const VariableInputTestkit: VanillaUniTestkitFactory<VariableInputUniDriver>;
export const variableInputTestkitFactory: VanillaUniTestkitFactory<VariableInputUniDriver>;

import { VerticalTabsUniDriver } from '../src/VerticalTabs/VerticalTabs.uni.driver';

export const VerticalTabsTestkit: VanillaUniTestkitFactory<VerticalTabsUniDriver>;
export const verticalTabsTestkitFactory: VanillaUniTestkitFactory<VerticalTabsUniDriver>;

import { VerticalTabsItemUniDriver } from '../src/VerticalTabsItem/VerticalTabsItem.uni.driver';

export const VerticalTabsItemTestkit: VanillaUniTestkitFactory<VerticalTabsItemUniDriver>;
export const verticalTabsItemTestkitFactory: VanillaUniTestkitFactory<VerticalTabsItemUniDriver>;

import { WixDesignSystemProviderUniDriver } from '../src/WixDesignSystemProvider/WixDesignSystemProvider.uni.driver';

export const WixDesignSystemProviderTestkit: VanillaUniTestkitFactory<WixDesignSystemProviderUniDriver>;
export const wixDesignSystemProviderTestkitFactory: VanillaUniTestkitFactory<WixDesignSystemProviderUniDriver>;

import { WixStyleReactProviderUniDriver } from '../src/WixStyleReactProvider/WixStyleReactProvider.uni.driver';

export const WixStyleReactProviderTestkit: VanillaUniTestkitFactory<WixStyleReactProviderUniDriver>;
export const wixStyleReactProviderTestkitFactory: VanillaUniTestkitFactory<WixStyleReactProviderUniDriver>;

import { CardHeaderUniDriver } from '../src/Card/Header/Header.uni.driver';
import { CardHeaderDriver } from '../src/Card/Header/Header.driver';
export const CardHeaderTestkit: VanillaUniTestkitFactory<CardHeaderUniDriver>;
export const cardHeaderTestkitFactory: VanillaTestkitFactory<CardHeaderDriver>;

import { EditableRowUniDriver } from '../src/EditableSelector/EditableRow/EditableRow.uni.driver';
import { EditableRowDriver } from '../src/EditableSelector/EditableRow/EditableRow.driver';
export const EditableRowTestkit: VanillaUniTestkitFactory<EditableRowUniDriver>;
export const editableRowTestkitFactory: VanillaTestkitFactory<EditableRowDriver>;

import { CardSubheaderUniDriver } from '../src/Card/Subheader/Subheader.uni.driver';

export const CardSubheaderTestkit: VanillaUniTestkitFactory<CardSubheaderUniDriver>;
export const cardSubheaderTestkitFactory: VanillaUniTestkitFactory<CardSubheaderUniDriver>;

import { CardContentUniDriver } from '../src/Card/Content/Content.uni.driver';

export const CardContentTestkit: VanillaUniTestkitFactory<CardContentUniDriver>;
export const cardContentTestkitFactory: VanillaUniTestkitFactory<CardContentUniDriver>;



