"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var uninstall = function uninstall() {
  delete global.requestAnimationFrame;
  delete global.cancelAnimationFrame;
};
var install = function install() {
  if (typeof window === 'undefined') {
    return;
  }
  var lastTime = 0;
  var vendors = ['ms', 'moz', 'webkit', 'o'];
  for (var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
    window.requestAnimationFrame = window[vendors[x] + 'RequestAnimationFrame'];
    window.cancelAnimationFrame = window[vendors[x] + 'CancelAnimationFrame'] || window[vendors[x] + 'CancelRequestAnimationFrame'];
  }
  if (!window.requestAnimationFrame) {
    window.requestAnimationFrame = function (callback) {
      var currTime = new Date().getTime();
      var timeToCall = Math.max(0, 16 - (currTime - lastTime));
      var id = window.setTimeout(function () {
        callback(currTime + timeToCall);
      }, timeToCall);
      lastTime = currTime + timeToCall;
      return id;
    };
  }
  if (!window.cancelAnimationFrame) {
    window.cancelAnimationFrame = function (id) {
      clearTimeout(id);
    };
  }
  global.requestAnimationFrame = global.requestAnimationFrame || window.requestAnimationFrame;
  global.cancelAnimationFrame = global.cancelAnimationFrame || window.cancelAnimationFrame;
};
var _default = exports["default"] = {
  install: install,
  uninstall: uninstall
};