import { ElementHandle as pptrElementHandle, Page as pptrPage, Frame as pptrFrame } from 'puppeteer';
import { ElementHandle as pptrCoreElementHandle, Page as pptrCorePage, Frame as pptrCoreFrame } from 'puppeteer-core';

type ElementHandle = pptrCoreElementHandle | pptrElementHandle;
type Page = pptrCorePage | pptrPage;
type Frame = pptrCoreFrame | pptrFrame;

type PuppeteerTestkitFactory<T> = (
  params: PuppeteerTestkitParams
) => Promise<T>;

type PuppeteerUniTestkitFactory<T> = (
  params: PuppeteerTestkitParams
) => Promise<T>;

interface PuppeteerTestkitParams {
  dataHook: string;
  page: Page | Frame;
  wrapper?: ElementHandle | null;
}

type DeprecatedPuppeteerTestkit = any;


import { AccordionUniDriver } from '../src/Accordion/Accordion.uni.driver';

export const AccordionTestkit: PuppeteerUniTestkitFactory<AccordionUniDriver>;
export const accordionTestkitFactory: PuppeteerUniTestkitFactory<AccordionUniDriver>;

import { AddItemUniDriver } from '../src/AddItem/AddItem.uni.driver';

export const AddItemTestkit: PuppeteerUniTestkitFactory<AddItemUniDriver>;
export const addItemTestkitFactory: PuppeteerUniTestkitFactory<AddItemUniDriver>;

import { AddressInputUniDriver } from '../src/AddressInput/AddressInput.uni.driver';

export const AddressInputTestkit: PuppeteerUniTestkitFactory<AddressInputUniDriver>;
export const addressInputTestkitFactory: PuppeteerUniTestkitFactory<AddressInputUniDriver>;

import { AddressInputItemUniDriver } from '../src/AddressInputItem/AddressInputItem.uni.driver';

export const AddressInputItemTestkit: PuppeteerUniTestkitFactory<AddressInputItemUniDriver>;
export const addressInputItemTestkitFactory: PuppeteerUniTestkitFactory<AddressInputItemUniDriver>;

import { AnalyticsLayoutUniDriver } from '../src/AnalyticsLayout/AnalyticsLayout.uni.driver';

export const AnalyticsLayoutTestkit: PuppeteerUniTestkitFactory<AnalyticsLayoutUniDriver>;
export const analyticsLayoutTestkitFactory: PuppeteerUniTestkitFactory<AnalyticsLayoutUniDriver>;

import { AnalyticsSummaryCardUniDriver } from '../src/AnalyticsSummaryCard/AnalyticsSummaryCard.uni.driver';

export const AnalyticsSummaryCardTestkit: PuppeteerUniTestkitFactory<AnalyticsSummaryCardUniDriver>;
export const analyticsSummaryCardTestkitFactory: PuppeteerUniTestkitFactory<AnalyticsSummaryCardUniDriver>;

import { AnimateUniDriver } from '../src/Animate/Animate.uni.driver';

export const AnimateTestkit: PuppeteerUniTestkitFactory<AnimateUniDriver>;
export const animateTestkitFactory: PuppeteerUniTestkitFactory<AnimateUniDriver>;

import { AnnouncementModalLayoutUniDriver } from '../src/AnnouncementModalLayout/AnnouncementModalLayout.uni.driver';

export const AnnouncementModalLayoutTestkit: PuppeteerUniTestkitFactory<AnnouncementModalLayoutUniDriver>;
export const announcementModalLayoutTestkitFactory: PuppeteerUniTestkitFactory<AnnouncementModalLayoutUniDriver>;

import { AreaChartUniDriver } from '../src/AreaChart/AreaChart.uni.driver';

export const AreaChartTestkit: PuppeteerUniTestkitFactory<AreaChartUniDriver>;
export const areaChartTestkitFactory: PuppeteerUniTestkitFactory<AreaChartUniDriver>;

import { AtlasAddressInputUniDriver } from '../src/AtlasAddressInput/AtlasAddressInput.uni.driver';

export const AtlasAddressInputTestkit: PuppeteerUniTestkitFactory<AtlasAddressInputUniDriver>;
export const atlasAddressInputTestkitFactory: PuppeteerUniTestkitFactory<AtlasAddressInputUniDriver>;

import { AudioPlayerUniDriver } from '../src/AudioPlayer/AudioPlayer.uni.driver';

export const AudioPlayerTestkit: PuppeteerUniTestkitFactory<AudioPlayerUniDriver>;
export const audioPlayerTestkitFactory: PuppeteerUniTestkitFactory<AudioPlayerUniDriver>;

import { AutoCompleteUniDriver } from '../src/AutoComplete/AutoComplete.uni.driver';

export const AutoCompleteTestkit: PuppeteerUniTestkitFactory<AutoCompleteUniDriver>;
export const autoCompleteTestkitFactory: PuppeteerUniTestkitFactory<AutoCompleteUniDriver>;

import { AutoCompleteWithLabelUniDriver } from '../src/AutoCompleteWithLabel/AutoCompleteWithLabel.uni.driver';

export const AutoCompleteWithLabelTestkit: PuppeteerUniTestkitFactory<AutoCompleteWithLabelUniDriver>;
export const autoCompleteWithLabelTestkitFactory: PuppeteerUniTestkitFactory<AutoCompleteWithLabelUniDriver>;

import { AvatarUniDriver } from '../src/Avatar/Avatar.uni.driver';

export const AvatarTestkit: PuppeteerUniTestkitFactory<AvatarUniDriver>;
export const avatarTestkitFactory: PuppeteerUniTestkitFactory<AvatarUniDriver>;

import { AvatarGroupUniDriver } from '../src/AvatarGroup/AvatarGroup.uni.driver';

export const AvatarGroupTestkit: PuppeteerUniTestkitFactory<AvatarGroupUniDriver>;
export const avatarGroupTestkitFactory: PuppeteerUniTestkitFactory<AvatarGroupUniDriver>;

import { BadgeUniDriver } from '../src/Badge/Badge.uni.driver';

export const BadgeTestkit: PuppeteerUniTestkitFactory<BadgeUniDriver>;
export const badgeTestkitFactory: PuppeteerUniTestkitFactory<BadgeUniDriver>;

import { BadgeSelectUniDriver } from '../src/BadgeSelect/BadgeSelect.uni.driver';

export const BadgeSelectTestkit: PuppeteerUniTestkitFactory<BadgeSelectUniDriver>;
export const badgeSelectTestkitFactory: PuppeteerUniTestkitFactory<BadgeSelectUniDriver>;

import { BadgeSelectItemUniDriver } from '../src/BadgeSelectItem/BadgeSelectItem.uni.driver';

export const BadgeSelectItemTestkit: PuppeteerUniTestkitFactory<BadgeSelectItemUniDriver>;
export const badgeSelectItemTestkitFactory: PuppeteerUniTestkitFactory<BadgeSelectItemUniDriver>;

import { BarChartUniDriver } from '../src/BarChart/BarChart.uni.driver';

export const BarChartTestkit: PuppeteerUniTestkitFactory<BarChartUniDriver>;
export const barChartTestkitFactory: PuppeteerUniTestkitFactory<BarChartUniDriver>;

import { BounceAnimationUniDriver } from '../src/BounceAnimation/BounceAnimation.uni.driver';

export const BounceAnimationTestkit: PuppeteerUniTestkitFactory<BounceAnimationUniDriver>;
export const bounceAnimationTestkitFactory: PuppeteerUniTestkitFactory<BounceAnimationUniDriver>;

import { BoxUniDriver } from '../src/Box/Box.uni.driver';

export const BoxTestkit: PuppeteerUniTestkitFactory<BoxUniDriver>;
export const boxTestkitFactory: PuppeteerUniTestkitFactory<BoxUniDriver>;

import { BreadcrumbsUniDriver } from '../src/Breadcrumbs/Breadcrumbs.uni.driver';

export const BreadcrumbsTestkit: PuppeteerUniTestkitFactory<BreadcrumbsUniDriver>;
export const breadcrumbsTestkitFactory: PuppeteerUniTestkitFactory<BreadcrumbsUniDriver>;

import { BrowserPreviewWidgetUniDriver } from '../src/BrowserPreviewWidget/BrowserPreviewWidget.uni.driver';

export const BrowserPreviewWidgetTestkit: PuppeteerUniTestkitFactory<BrowserPreviewWidgetUniDriver>;
export const browserPreviewWidgetTestkitFactory: PuppeteerUniTestkitFactory<BrowserPreviewWidgetUniDriver>;

import { ButtonUniDriver } from '../src/Button/Button.uni.driver';

export const ButtonTestkit: PuppeteerUniTestkitFactory<ButtonUniDriver>;
export const buttonTestkitFactory: PuppeteerUniTestkitFactory<ButtonUniDriver>;

import { CalendarUniDriver } from '../src/Calendar/Calendar.uni.driver';

export const CalendarTestkit: PuppeteerUniTestkitFactory<CalendarUniDriver>;
export const calendarTestkitFactory: PuppeteerUniTestkitFactory<CalendarUniDriver>;

import { CalendarPanelUniDriver } from '../src/CalendarPanel/CalendarPanel.uni.driver';

export const CalendarPanelTestkit: PuppeteerUniTestkitFactory<CalendarPanelUniDriver>;
export const calendarPanelTestkitFactory: PuppeteerUniTestkitFactory<CalendarPanelUniDriver>;

import { CalendarPanelFooterUniDriver } from '../src/CalendarPanelFooter/CalendarPanelFooter.uni.driver';

export const CalendarPanelFooterTestkit: PuppeteerUniTestkitFactory<CalendarPanelFooterUniDriver>;
export const calendarPanelFooterTestkitFactory: PuppeteerUniTestkitFactory<CalendarPanelFooterUniDriver>;

import { CardFolderTabsUniDriver } from '../src/CardFolderTabs/CardFolderTabs.uni.driver';

export const CardFolderTabsTestkit: PuppeteerUniTestkitFactory<CardFolderTabsUniDriver>;
export const cardFolderTabsTestkitFactory: PuppeteerUniTestkitFactory<CardFolderTabsUniDriver>;

import { CardGalleryItemUniDriver } from '../src/CardGalleryItem/CardGalleryItem.uni.driver';

export const CardGalleryItemTestkit: PuppeteerUniTestkitFactory<CardGalleryItemUniDriver>;
export const cardGalleryItemTestkitFactory: PuppeteerUniTestkitFactory<CardGalleryItemUniDriver>;

import { CarouselUniDriver } from '../src/Carousel/Carousel.uni.driver';

export const CarouselTestkit: PuppeteerUniTestkitFactory<CarouselUniDriver>;
export const carouselTestkitFactory: PuppeteerUniTestkitFactory<CarouselUniDriver>;

import { CarouselWIPUniDriver } from '../src/CarouselWIP/CarouselWIP.uni.driver';

export const CarouselWIPTestkit: PuppeteerUniTestkitFactory<CarouselWIPUniDriver>;
export const carouselWipTestkitFactory: PuppeteerUniTestkitFactory<CarouselWIPUniDriver>;

import { CheckToggleUniDriver } from '../src/CheckToggle/CheckToggle.uni.driver';

export const CheckToggleTestkit: PuppeteerUniTestkitFactory<CheckToggleUniDriver>;
export const checkToggleTestkitFactory: PuppeteerUniTestkitFactory<CheckToggleUniDriver>;

import { CheckboxUniDriver } from '../src/Checkbox/Checkbox.uni.driver';

export const CheckboxTestkit: PuppeteerUniTestkitFactory<CheckboxUniDriver>;
export const checkboxTestkitFactory: PuppeteerUniTestkitFactory<CheckboxUniDriver>;

import { CircularProgressBarUniDriver } from '../src/CircularProgressBar/CircularProgressBar.uni.driver';

export const CircularProgressBarTestkit: PuppeteerUniTestkitFactory<CircularProgressBarUniDriver>;
export const circularProgressBarTestkitFactory: PuppeteerUniTestkitFactory<CircularProgressBarUniDriver>;

import { CloseButtonUniDriver } from '../src/CloseButton/CloseButton.uni.driver';

export const CloseButtonTestkit: PuppeteerUniTestkitFactory<CloseButtonUniDriver>;
export const closeButtonTestkitFactory: PuppeteerUniTestkitFactory<CloseButtonUniDriver>;

import { CollapseUniDriver } from '../src/Collapse/Collapse.uni.driver';

export const CollapseTestkit: PuppeteerUniTestkitFactory<CollapseUniDriver>;
export const collapseTestkitFactory: PuppeteerUniTestkitFactory<CollapseUniDriver>;

import { ColorInputUniDriver } from '../src/ColorInput/ColorInput.uni.driver';

export const ColorInputTestkit: PuppeteerUniTestkitFactory<ColorInputUniDriver>;
export const colorInputTestkitFactory: PuppeteerUniTestkitFactory<ColorInputUniDriver>;

import { ColorPickerUniDriver } from '../src/ColorPicker/ColorPicker.uni.driver';

export const ColorPickerTestkit: PuppeteerUniTestkitFactory<ColorPickerUniDriver>;
export const colorPickerTestkitFactory: PuppeteerUniTestkitFactory<ColorPickerUniDriver>;

import { ComposerHeaderUniDriver } from '../src/ComposerHeader/ComposerHeader.uni.driver';

export const ComposerHeaderTestkit: PuppeteerUniTestkitFactory<ComposerHeaderUniDriver>;
export const composerHeaderTestkitFactory: PuppeteerUniTestkitFactory<ComposerHeaderUniDriver>;

import { ComposerSidebarUniDriver } from '../src/ComposerSidebar/ComposerSidebar.uni.driver';

export const ComposerSidebarTestkit: PuppeteerUniTestkitFactory<ComposerSidebarUniDriver>;
export const composerSidebarTestkitFactory: PuppeteerUniTestkitFactory<ComposerSidebarUniDriver>;

import { CopyClipboardUniDriver } from '../src/CopyClipboard/CopyClipboard.uni.driver';

export const CopyClipboardTestkit: PuppeteerUniTestkitFactory<CopyClipboardUniDriver>;
export const copyClipboardTestkitFactory: PuppeteerUniTestkitFactory<CopyClipboardUniDriver>;

import { CounterBadgeUniDriver } from '../src/CounterBadge/CounterBadge.uni.driver';

export const CounterBadgeTestkit: PuppeteerUniTestkitFactory<CounterBadgeUniDriver>;
export const counterBadgeTestkitFactory: PuppeteerUniTestkitFactory<CounterBadgeUniDriver>;

import { CustomModalLayoutUniDriver } from '../src/CustomModalLayout/CustomModalLayout.uni.driver';

export const CustomModalLayoutTestkit: PuppeteerUniTestkitFactory<CustomModalLayoutUniDriver>;
export const customModalLayoutTestkitFactory: PuppeteerUniTestkitFactory<CustomModalLayoutUniDriver>;

import { DatePickerUniDriver } from '../src/DatePicker/DatePicker.uni.driver';

export const DatePickerTestkit: PuppeteerUniTestkitFactory<DatePickerUniDriver>;
export const datePickerTestkitFactory: PuppeteerUniTestkitFactory<DatePickerUniDriver>;

import { DividerUniDriver } from '../src/Divider/Divider.uni.driver';

export const DividerTestkit: PuppeteerUniTestkitFactory<DividerUniDriver>;
export const dividerTestkitFactory: PuppeteerUniTestkitFactory<DividerUniDriver>;

import { DropdownUniDriver } from '../src/Dropdown/Dropdown.uni.driver';

export const DropdownTestkit: PuppeteerUniTestkitFactory<DropdownUniDriver>;
export const dropdownTestkitFactory: PuppeteerUniTestkitFactory<DropdownUniDriver>;

import { DropdownBaseUniDriver } from '../src/DropdownBase/DropdownBase.uni.driver';

export const DropdownBaseTestkit: PuppeteerUniTestkitFactory<DropdownBaseUniDriver>;
export const dropdownBaseTestkitFactory: PuppeteerUniTestkitFactory<DropdownBaseUniDriver>;

import { DropdownLayoutUniDriver } from '../src/DropdownLayout/DropdownLayout.uni.driver';

export const DropdownLayoutTestkit: PuppeteerUniTestkitFactory<DropdownLayoutUniDriver>;
export const dropdownLayoutTestkitFactory: PuppeteerUniTestkitFactory<DropdownLayoutUniDriver>;

import { DropzoneUniDriver } from '../src/Dropzone/Dropzone.uni.driver';

export const DropzoneTestkit: PuppeteerUniTestkitFactory<DropzoneUniDriver>;
export const dropzoneTestkitFactory: PuppeteerUniTestkitFactory<DropzoneUniDriver>;

import { EditableSelectorUniDriver } from '../src/EditableSelector/EditableSelector.uni.driver';

export const EditableSelectorTestkit: PuppeteerUniTestkitFactory<EditableSelectorUniDriver>;
export const editableSelectorTestkitFactory: PuppeteerUniTestkitFactory<EditableSelectorUniDriver>;

import { EditableTitleUniDriver } from '../src/EditableTitle/EditableTitle.uni.driver';

export const EditableTitleTestkit: PuppeteerUniTestkitFactory<EditableTitleUniDriver>;
export const editableTitleTestkitFactory: PuppeteerUniTestkitFactory<EditableTitleUniDriver>;

import { EmptyStateUniDriver } from '../src/EmptyState/EmptyState.uni.driver';

export const EmptyStateTestkit: PuppeteerUniTestkitFactory<EmptyStateUniDriver>;
export const emptyStateTestkitFactory: PuppeteerUniTestkitFactory<EmptyStateUniDriver>;

import { FacesRatingBarUniDriver } from '../src/FacesRatingBar/FacesRatingBar.uni.driver';

export const FacesRatingBarTestkit: PuppeteerUniTestkitFactory<FacesRatingBarUniDriver>;
export const facesRatingBarTestkitFactory: PuppeteerUniTestkitFactory<FacesRatingBarUniDriver>;

import { FeatureListUniDriver } from '../src/FeatureList/FeatureList.uni.driver';

export const FeatureListTestkit: PuppeteerUniTestkitFactory<FeatureListUniDriver>;
export const featureListTestkitFactory: PuppeteerUniTestkitFactory<FeatureListUniDriver>;

import { FieldSetUniDriver } from '../src/FieldSet/FieldSet.uni.driver';

export const FieldSetTestkit: PuppeteerUniTestkitFactory<FieldSetUniDriver>;
export const fieldSetTestkitFactory: PuppeteerUniTestkitFactory<FieldSetUniDriver>;

import { FilePickerUniDriver } from '../src/FilePicker/FilePicker.uni.driver';

export const FilePickerTestkit: PuppeteerUniTestkitFactory<FilePickerUniDriver>;
export const filePickerTestkitFactory: PuppeteerUniTestkitFactory<FilePickerUniDriver>;

import { FileUploadUniDriver } from '../src/FileUpload/FileUpload.uni.driver';

export const FileUploadTestkit: PuppeteerUniTestkitFactory<FileUploadUniDriver>;
export const fileUploadTestkitFactory: PuppeteerUniTestkitFactory<FileUploadUniDriver>;

import { FillButtonUniDriver } from '../src/FillButton/FillButton.uni.driver';

export const FillButtonTestkit: PuppeteerUniTestkitFactory<FillButtonUniDriver>;
export const fillButtonTestkitFactory: PuppeteerUniTestkitFactory<FillButtonUniDriver>;

import { FillPreviewUniDriver } from '../src/FillPreview/FillPreview.uni.driver';

export const FillPreviewTestkit: PuppeteerUniTestkitFactory<FillPreviewUniDriver>;
export const fillPreviewTestkitFactory: PuppeteerUniTestkitFactory<FillPreviewUniDriver>;

import { FloatingHelperUniDriver } from '../src/FloatingHelper/FloatingHelper.uni.driver';

export const FloatingHelperTestkit: PuppeteerUniTestkitFactory<FloatingHelperUniDriver>;
export const floatingHelperTestkitFactory: PuppeteerUniTestkitFactory<FloatingHelperUniDriver>;

import { FloatingNotificationUniDriver } from '../src/FloatingNotification/FloatingNotification.uni.driver';

export const FloatingNotificationTestkit: PuppeteerUniTestkitFactory<FloatingNotificationUniDriver>;
export const floatingNotificationTestkitFactory: PuppeteerUniTestkitFactory<FloatingNotificationUniDriver>;

import { FormFieldUniDriver } from '../src/FormField/FormField.uni.driver';

export const FormFieldTestkit: PuppeteerUniTestkitFactory<FormFieldUniDriver>;
export const formFieldTestkitFactory: PuppeteerUniTestkitFactory<FormFieldUniDriver>;

import { FunnelChartUniDriver } from '../src/FunnelChart/FunnelChart.uni.driver';

export const FunnelChartTestkit: PuppeteerUniTestkitFactory<FunnelChartUniDriver>;
export const funnelChartTestkitFactory: PuppeteerUniTestkitFactory<FunnelChartUniDriver>;

import { GooglePreviewUniDriver } from '../src/GooglePreview/GooglePreview.uni.driver';

export const GooglePreviewTestkit: PuppeteerUniTestkitFactory<GooglePreviewUniDriver>;
export const googlePreviewTestkitFactory: PuppeteerUniTestkitFactory<GooglePreviewUniDriver>;

import { HeadingUniDriver } from '../src/Heading/Heading.uni.driver';
import { HeadingPuppeteerDriver } from '../src/Heading/Heading.puppeteer.driver';
export const HeadingTestkit: PuppeteerUniTestkitFactory<HeadingUniDriver>;
export const headingTestkitFactory: PuppeteerTestkitFactory<HeadingPuppeteerDriver>;

import { HighlighterUniDriver } from '../src/Highlighter/Highlighter.uni.driver';

export const HighlighterTestkit: PuppeteerUniTestkitFactory<HighlighterUniDriver>;
export const highlighterTestkitFactory: PuppeteerUniTestkitFactory<HighlighterUniDriver>;

import { HorizontalTimelineUniDriver } from '../src/HorizontalTimeline/HorizontalTimeline.uni.driver';

export const HorizontalTimelineTestkit: PuppeteerUniTestkitFactory<HorizontalTimelineUniDriver>;
export const horizontalTimelineTestkitFactory: PuppeteerUniTestkitFactory<HorizontalTimelineUniDriver>;

import { IconButtonUniDriver } from '../src/IconButton/IconButton.uni.driver';

export const IconButtonTestkit: PuppeteerUniTestkitFactory<IconButtonUniDriver>;
export const iconButtonTestkitFactory: PuppeteerUniTestkitFactory<IconButtonUniDriver>;

import { ImageUniDriver } from '../src/Image/Image.uni.driver';

export const ImageTestkit: PuppeteerUniTestkitFactory<ImageUniDriver>;
export const imageTestkitFactory: PuppeteerUniTestkitFactory<ImageUniDriver>;

import { ImageViewerUniDriver } from '../src/ImageViewer/ImageViewer.uni.driver';

export const ImageViewerTestkit: PuppeteerUniTestkitFactory<ImageViewerUniDriver>;
export const imageViewerTestkitFactory: PuppeteerUniTestkitFactory<ImageViewerUniDriver>;

import { InfoIconUniDriver } from '../src/InfoIcon/InfoIcon.uni.driver';

export const InfoIconTestkit: PuppeteerUniTestkitFactory<InfoIconUniDriver>;
export const infoIconTestkitFactory: PuppeteerUniTestkitFactory<InfoIconUniDriver>;

import { InputUniDriver } from '../src/Input/Input.uni.driver';

export const InputTestkit: PuppeteerUniTestkitFactory<InputUniDriver>;
export const inputTestkitFactory: PuppeteerUniTestkitFactory<InputUniDriver>;

import { InputAreaUniDriver } from '../src/InputArea/InputArea.uni.driver';

export const InputAreaTestkit: PuppeteerUniTestkitFactory<InputAreaUniDriver>;
export const inputAreaTestkitFactory: PuppeteerUniTestkitFactory<InputAreaUniDriver>;

import { InputWithLabelUniDriver } from '../src/InputWithLabel/InputWithLabel.uni.driver';

export const InputWithLabelTestkit: PuppeteerUniTestkitFactory<InputWithLabelUniDriver>;
export const inputWithLabelTestkitFactory: PuppeteerUniTestkitFactory<InputWithLabelUniDriver>;

import { InputWithOptionsUniDriver } from '../src/InputWithOptions/InputWithOptions.uni.driver';

export const InputWithOptionsTestkit: PuppeteerUniTestkitFactory<InputWithOptionsUniDriver>;
export const inputWithOptionsTestkitFactory: PuppeteerUniTestkitFactory<InputWithOptionsUniDriver>;

import { LinearProgressBarUniDriver } from '../src/LinearProgressBar/LinearProgressBar.uni.driver';

export const LinearProgressBarTestkit: PuppeteerUniTestkitFactory<LinearProgressBarUniDriver>;
export const linearProgressBarTestkitFactory: PuppeteerUniTestkitFactory<LinearProgressBarUniDriver>;

import { ListItemActionUniDriver } from '../src/ListItemAction/ListItemAction.uni.driver';

export const ListItemActionTestkit: PuppeteerUniTestkitFactory<ListItemActionUniDriver>;
export const listItemActionTestkitFactory: PuppeteerUniTestkitFactory<ListItemActionUniDriver>;

import { ListItemEditableUniDriver } from '../src/ListItemEditable/ListItemEditable.uni.driver';

export const ListItemEditableTestkit: PuppeteerUniTestkitFactory<ListItemEditableUniDriver>;
export const listItemEditableTestkitFactory: PuppeteerUniTestkitFactory<ListItemEditableUniDriver>;

import { ListItemSectionUniDriver } from '../src/ListItemSection/ListItemSection.uni.driver';

export const ListItemSectionTestkit: PuppeteerUniTestkitFactory<ListItemSectionUniDriver>;
export const listItemSectionTestkitFactory: PuppeteerUniTestkitFactory<ListItemSectionUniDriver>;

import { ListItemSelectUniDriver } from '../src/ListItemSelect/ListItemSelect.uni.driver';

export const ListItemSelectTestkit: PuppeteerUniTestkitFactory<ListItemSelectUniDriver>;
export const listItemSelectTestkitFactory: PuppeteerUniTestkitFactory<ListItemSelectUniDriver>;

import { LiveRegionUniDriver } from '../src/LiveRegion/LiveRegion.uni.driver';

export const LiveRegionTestkit: PuppeteerUniTestkitFactory<LiveRegionUniDriver>;
export const liveRegionTestkitFactory: PuppeteerUniTestkitFactory<LiveRegionUniDriver>;

import { LoaderUniDriver } from '../src/Loader/Loader.uni.driver';

export const LoaderTestkit: PuppeteerUniTestkitFactory<LoaderUniDriver>;
export const loaderTestkitFactory: PuppeteerUniTestkitFactory<LoaderUniDriver>;

import { MarketingLayoutUniDriver } from '../src/MarketingLayout/MarketingLayout.uni.driver';

export const MarketingLayoutTestkit: PuppeteerUniTestkitFactory<MarketingLayoutUniDriver>;
export const marketingLayoutTestkitFactory: PuppeteerUniTestkitFactory<MarketingLayoutUniDriver>;

import { MarketingPageLayoutUniDriver } from '../src/MarketingPageLayout/MarketingPageLayout.uni.driver';

export const MarketingPageLayoutTestkit: PuppeteerUniTestkitFactory<MarketingPageLayoutUniDriver>;
export const marketingPageLayoutTestkitFactory: PuppeteerUniTestkitFactory<MarketingPageLayoutUniDriver>;

import { MarketingPageLayoutContentUniDriver } from '../src/MarketingPageLayoutContent/MarketingPageLayoutContent.uni.driver';

export const MarketingPageLayoutContentTestkit: PuppeteerUniTestkitFactory<MarketingPageLayoutContentUniDriver>;
export const marketingPageLayoutContentTestkitFactory: PuppeteerUniTestkitFactory<MarketingPageLayoutContentUniDriver>;

import { MediaOverlayUniDriver } from '../src/MediaOverlay/MediaOverlay.uni.driver';

export const MediaOverlayTestkit: PuppeteerUniTestkitFactory<MediaOverlayUniDriver<HTMLElement>>;
export const mediaOverlayTestkitFactory: PuppeteerUniTestkitFactory<MediaOverlayUniDriver<HTMLElement>>;

import { MessageBoxFunctionalLayoutUniDriver } from '../src/MessageBoxFunctionalLayout/MessageBoxFunctionalLayout.uni.driver';

export const MessageBoxFunctionalLayoutTestkit: PuppeteerUniTestkitFactory<MessageBoxFunctionalLayoutUniDriver>;
export const messageBoxFunctionalLayoutTestkitFactory: PuppeteerUniTestkitFactory<MessageBoxFunctionalLayoutUniDriver>;

import { MessageBoxMarketerialLayoutUniDriver } from '../src/MessageBoxMarketerialLayout/MessageBoxMarketerialLayout.uni.driver';

export const MessageBoxMarketerialLayoutTestkit: PuppeteerUniTestkitFactory<MessageBoxMarketerialLayoutUniDriver>;
export const messageBoxMarketerialLayoutTestkitFactory: PuppeteerUniTestkitFactory<MessageBoxMarketerialLayoutUniDriver>;

import { MessageModalLayoutUniDriver } from '../src/MessageModalLayout/MessageModalLayout.uni.driver';

export const MessageModalLayoutTestkit: PuppeteerUniTestkitFactory<MessageModalLayoutUniDriver>;
export const messageModalLayoutTestkitFactory: PuppeteerUniTestkitFactory<MessageModalLayoutUniDriver>;

import { MobilePreviewWidgetUniDriver } from '../src/MobilePreviewWidget/MobilePreviewWidget.uni.driver';

export const MobilePreviewWidgetTestkit: PuppeteerUniTestkitFactory<MobilePreviewWidgetUniDriver>;
export const mobilePreviewWidgetTestkitFactory: PuppeteerUniTestkitFactory<MobilePreviewWidgetUniDriver>;

import { ModalUniDriver } from '../src/Modal/Modal.uni.driver';

export const ModalTestkit: PuppeteerUniTestkitFactory<ModalUniDriver>;
export const modalTestkitFactory: PuppeteerUniTestkitFactory<ModalUniDriver>;

import { ModalMobileLayoutUniDriver } from '../src/ModalMobileLayout/ModalMobileLayout.uni.driver';

export const ModalMobileLayoutTestkit: PuppeteerUniTestkitFactory<ModalMobileLayoutUniDriver>;
export const modalMobileLayoutTestkitFactory: PuppeteerUniTestkitFactory<ModalMobileLayoutUniDriver>;

import { ModalPreviewLayoutUniDriver } from '../src/ModalPreviewLayout/ModalPreviewLayout.uni.driver';

export const ModalPreviewLayoutTestkit: PuppeteerUniTestkitFactory<ModalPreviewLayoutUniDriver>;
export const modalPreviewLayoutTestkitFactory: PuppeteerUniTestkitFactory<ModalPreviewLayoutUniDriver>;

import { ModalSelectorLayoutUniDriver } from '../src/ModalSelectorLayout/ModalSelectorLayout.uni.driver';

export const ModalSelectorLayoutTestkit: PuppeteerUniTestkitFactory<ModalSelectorLayoutUniDriver>;
export const modalSelectorLayoutTestkitFactory: PuppeteerUniTestkitFactory<ModalSelectorLayoutUniDriver>;

import { MultiSelectUniDriver } from '../src/MultiSelect/MultiSelect.uni.driver';

export const MultiSelectTestkit: PuppeteerUniTestkitFactory<MultiSelectUniDriver>;
export const multiSelectTestkitFactory: PuppeteerUniTestkitFactory<MultiSelectUniDriver>;

import { MultiSelectCheckboxUniDriver } from '../src/MultiSelectCheckbox/MultiSelectCheckbox.uni.driver';

export const MultiSelectCheckboxTestkit: PuppeteerUniTestkitFactory<MultiSelectCheckboxUniDriver>;
export const multiSelectCheckboxTestkitFactory: PuppeteerUniTestkitFactory<MultiSelectCheckboxUniDriver>;

import { NestableListUniDriver } from '../src/NestableList/NestableList.uni.driver';

export const NestableListTestkit: PuppeteerUniTestkitFactory<NestableListUniDriver>;
export const nestableListTestkitFactory: PuppeteerUniTestkitFactory<NestableListUniDriver>;

import { NestableListBaseUniDriver } from '../src/NestableListBase/NestableListBase.uni.driver';

export const NestableListBaseTestkit: PuppeteerUniTestkitFactory<NestableListBaseUniDriver>;
export const nestableListBaseTestkitFactory: PuppeteerUniTestkitFactory<NestableListBaseUniDriver>;

import { NotificationUniDriver } from '../src/Notification/Notification.uni.driver';

export const NotificationTestkit: PuppeteerUniTestkitFactory<NotificationUniDriver>;
export const notificationTestkitFactory: PuppeteerUniTestkitFactory<NotificationUniDriver>;

import { NumberInputUniDriver } from '../src/NumberInput/NumberInput.uni.driver';

export const NumberInputTestkit: PuppeteerUniTestkitFactory<NumberInputUniDriver>;
export const numberInputTestkitFactory: PuppeteerUniTestkitFactory<NumberInputUniDriver>;

import { PageUniDriver } from '../src/Page/Page.uni.driver';

export const PageTestkit: PuppeteerUniTestkitFactory<PageUniDriver>;
export const pageTestkitFactory: PuppeteerUniTestkitFactory<PageUniDriver>;

import { PageFooterUniDriver } from '../src/PageFooter/PageFooter.uni.driver';

export const PageFooterTestkit: PuppeteerUniTestkitFactory<PageFooterUniDriver>;
export const pageFooterTestkitFactory: PuppeteerUniTestkitFactory<PageFooterUniDriver>;

import { PageHeaderUniDriver } from '../src/PageHeader/PageHeader.uni.driver';

export const PageHeaderTestkit: PuppeteerUniTestkitFactory<PageHeaderUniDriver>;
export const pageHeaderTestkitFactory: PuppeteerUniTestkitFactory<PageHeaderUniDriver>;

import { PageSectionUniDriver } from '../src/PageSection/PageSection.uni.driver';

export const PageSectionTestkit: PuppeteerUniTestkitFactory<PageSectionUniDriver>;
export const pageSectionTestkitFactory: PuppeteerUniTestkitFactory<PageSectionUniDriver>;

import { PaginationUniDriver } from '../src/Pagination/Pagination.uni.driver';

export const PaginationTestkit: PuppeteerUniTestkitFactory<PaginationUniDriver>;
export const paginationTestkitFactory: PuppeteerUniTestkitFactory<PaginationUniDriver>;

import { PaletteUniDriver } from '../src/Palette/Palette.uni.driver';

export const PaletteTestkit: PuppeteerUniTestkitFactory<PaletteUniDriver>;
export const paletteTestkitFactory: PuppeteerUniTestkitFactory<PaletteUniDriver>;

import { PopoverUniDriver } from '../src/Popover/Popover.uni.driver';

export const PopoverTestkit: PuppeteerUniTestkitFactory<PopoverUniDriver>;
export const popoverTestkitFactory: PuppeteerUniTestkitFactory<PopoverUniDriver>;

import { PopoverMenuUniDriver } from '../src/PopoverMenu/PopoverMenu.uni.driver';

export const PopoverMenuTestkit: PuppeteerUniTestkitFactory<PopoverMenuUniDriver>;
export const popoverMenuTestkitFactory: PuppeteerUniTestkitFactory<PopoverMenuUniDriver>;

import { PreviewWidgetUniDriver } from '../src/PreviewWidget/PreviewWidget.uni.driver';

export const PreviewWidgetTestkit: PuppeteerUniTestkitFactory<PreviewWidgetUniDriver>;
export const previewWidgetTestkitFactory: PuppeteerUniTestkitFactory<PreviewWidgetUniDriver>;

import { ProportionUniDriver } from '../src/Proportion/Proportion.uni.driver';

export const ProportionTestkit: PuppeteerUniTestkitFactory<ProportionUniDriver>;
export const proportionTestkitFactory: PuppeteerUniTestkitFactory<ProportionUniDriver>;

import { PulseAnimationUniDriver } from '../src/PulseAnimation/PulseAnimation.uni.driver';

export const PulseAnimationTestkit: PuppeteerUniTestkitFactory<PulseAnimationUniDriver>;
export const pulseAnimationTestkitFactory: PuppeteerUniTestkitFactory<PulseAnimationUniDriver>;

import { RadarChartUniDriver } from '../src/RadarChart/RadarChart.uni.driver';

export const RadarChartTestkit: PuppeteerUniTestkitFactory<RadarChartUniDriver>;
export const radarChartTestkitFactory: PuppeteerUniTestkitFactory<RadarChartUniDriver>;

import { RadioUniDriver } from '../src/Radio/Radio.uni.driver';

export const RadioTestkit: PuppeteerUniTestkitFactory<RadioUniDriver>;
export const radioTestkitFactory: PuppeteerUniTestkitFactory<RadioUniDriver>;

import { RadioGroupUniDriver } from '../src/RadioGroup/RadioGroup.uni.driver';

export const RadioGroupTestkit: PuppeteerUniTestkitFactory<RadioGroupUniDriver>;
export const radioGroupTestkitFactory: PuppeteerUniTestkitFactory<RadioGroupUniDriver>;

import { RangeUniDriver } from '../src/Range/Range.uni.driver';

export const RangeTestkit: PuppeteerUniTestkitFactory<RangeUniDriver>;
export const rangeTestkitFactory: PuppeteerUniTestkitFactory<RangeUniDriver>;

import { RichTextInputAreaUniDriver } from '../src/RichTextInputArea/RichTextInputArea.uni.driver';

export const RichTextInputAreaTestkit: PuppeteerUniTestkitFactory<RichTextInputAreaUniDriver>;
export const richTextInputAreaTestkitFactory: PuppeteerUniTestkitFactory<RichTextInputAreaUniDriver>;

import { SearchUniDriver } from '../src/Search/Search.uni.driver';

export const SearchTestkit: PuppeteerUniTestkitFactory<SearchUniDriver>;
export const searchTestkitFactory: PuppeteerUniTestkitFactory<SearchUniDriver>;

import { SectionHeaderUniDriver } from '../src/SectionHeader/SectionHeader.uni.driver';

export const SectionHeaderTestkit: PuppeteerUniTestkitFactory<SectionHeaderUniDriver>;
export const sectionHeaderTestkitFactory: PuppeteerUniTestkitFactory<SectionHeaderUniDriver>;

import { SectionHelperUniDriver } from '../src/SectionHelper/SectionHelper.uni.driver';

export const SectionHelperTestkit: PuppeteerUniTestkitFactory<SectionHelperUniDriver>;
export const sectionHelperTestkitFactory: PuppeteerUniTestkitFactory<SectionHelperUniDriver>;

import { SegmentedToggleUniDriver } from '../src/SegmentedToggle/SegmentedToggle.uni.driver';

export const SegmentedToggleTestkit: PuppeteerUniTestkitFactory<SegmentedToggleUniDriver>;
export const segmentedToggleTestkitFactory: PuppeteerUniTestkitFactory<SegmentedToggleUniDriver>;

import { SelectableAccordionUniDriver } from '../src/SelectableAccordion/SelectableAccordion.uni.driver';

export const SelectableAccordionTestkit: PuppeteerUniTestkitFactory<SelectableAccordionUniDriver>;
export const selectableAccordionTestkitFactory: PuppeteerUniTestkitFactory<SelectableAccordionUniDriver>;

import { SelectorUniDriver } from '../src/Selector/Selector.uni.driver';

export const SelectorTestkit: PuppeteerUniTestkitFactory<SelectorUniDriver>;
export const selectorTestkitFactory: PuppeteerUniTestkitFactory<SelectorUniDriver>;

import { SelectorListUniDriver } from '../src/SelectorList/SelectorList.uni.driver';

export const SelectorListTestkit: PuppeteerUniTestkitFactory<SelectorListUniDriver>;
export const selectorListTestkitFactory: PuppeteerUniTestkitFactory<SelectorListUniDriver>;

import { SidePanelUniDriver } from '../src/SidePanel/SidePanel.uni.driver';

export const SidePanelTestkit: PuppeteerUniTestkitFactory<SidePanelUniDriver>;
export const sidePanelTestkitFactory: PuppeteerUniTestkitFactory<SidePanelUniDriver>;

import { SidebarUniDriver } from '../src/Sidebar/Sidebar.uni.driver';

export const SidebarTestkit: PuppeteerUniTestkitFactory<SidebarUniDriver>;
export const sidebarTestkitFactory: PuppeteerUniTestkitFactory<SidebarUniDriver>;

import { SidebarBackButtonUniDriver } from '../src/SidebarBackButton/SidebarBackButton.uni.driver';

export const SidebarBackButtonTestkit: PuppeteerUniTestkitFactory<SidebarBackButtonUniDriver>;
export const sidebarBackButtonTestkitFactory: PuppeteerUniTestkitFactory<SidebarBackButtonUniDriver>;

import { SidebarDividerUniDriver } from '../src/SidebarDivider/SidebarDivider.uni.driver';

export const SidebarDividerTestkit: PuppeteerUniTestkitFactory<SidebarDividerUniDriver>;
export const sidebarDividerTestkitFactory: PuppeteerUniTestkitFactory<SidebarDividerUniDriver>;

import { SidebarDividerNextUniDriver } from '../src/SidebarDividerNext/SidebarDividerNext.uni.driver';

export const SidebarDividerNextTestkit: PuppeteerUniTestkitFactory<SidebarDividerNextUniDriver>;
export const sidebarDividerNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarDividerNextUniDriver>;

import { SidebarHeaderUniDriver } from '../src/SidebarHeader/SidebarHeader.uni.driver';

export const SidebarHeaderTestkit: PuppeteerUniTestkitFactory<SidebarHeaderUniDriver>;
export const sidebarHeaderTestkitFactory: PuppeteerUniTestkitFactory<SidebarHeaderUniDriver>;

import { SidebarHeaderNextUniDriver } from '../src/SidebarHeaderNext/SidebarHeaderNext.uni.driver';

export const SidebarHeaderNextTestkit: PuppeteerUniTestkitFactory<SidebarHeaderNextUniDriver>;
export const sidebarHeaderNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarHeaderNextUniDriver>;

import { SidebarItemNextUniDriver } from '../src/SidebarItemNext/SidebarItemNext.uni.driver';

export const SidebarItemNextTestkit: PuppeteerUniTestkitFactory<SidebarItemNextUniDriver>;
export const sidebarItemNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarItemNextUniDriver>;

import { SidebarNextUniDriver } from '../src/SidebarNext/SidebarNext.uni.driver';

export const SidebarNextTestkit: PuppeteerUniTestkitFactory<SidebarNextUniDriver>;
export const sidebarNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarNextUniDriver>;

import { SidebarSectionItemUniDriver } from '../src/SidebarSectionItem/SidebarSectionItem.uni.driver';

export const SidebarSectionItemTestkit: PuppeteerUniTestkitFactory<SidebarSectionItemUniDriver>;
export const sidebarSectionItemTestkitFactory: PuppeteerUniTestkitFactory<SidebarSectionItemUniDriver>;

import { SidebarSectionTitleUniDriver } from '../src/SidebarSectionTitle/SidebarSectionTitle.uni.driver';

export const SidebarSectionTitleTestkit: PuppeteerUniTestkitFactory<SidebarSectionTitleUniDriver>;
export const sidebarSectionTitleTestkitFactory: PuppeteerUniTestkitFactory<SidebarSectionTitleUniDriver>;

import { SidebarSubMenuNextUniDriver } from '../src/SidebarSubMenuNext/SidebarSubMenuNext.uni.driver';

export const SidebarSubMenuNextTestkit: PuppeteerUniTestkitFactory<SidebarSubMenuNextUniDriver>;
export const sidebarSubMenuNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarSubMenuNextUniDriver>;

import { SidebarTitleItemNextUniDriver } from '../src/SidebarTitleItemNext/SidebarTitleItemNext.uni.driver';

export const SidebarTitleItemNextTestkit: PuppeteerUniTestkitFactory<SidebarTitleItemNextUniDriver>;
export const sidebarTitleItemNextTestkitFactory: PuppeteerUniTestkitFactory<SidebarTitleItemNextUniDriver>;

import { SkeletonUniDriver } from '../src/Skeleton/Skeleton.uni.driver';

export const SkeletonTestkit: PuppeteerUniTestkitFactory<SkeletonUniDriver>;
export const skeletonTestkitFactory: PuppeteerUniTestkitFactory<SkeletonUniDriver>;

import { SkeletonCircleUniDriver } from '../src/SkeletonCircle/SkeletonCircle.uni.driver';

export const SkeletonCircleTestkit: PuppeteerUniTestkitFactory<SkeletonCircleUniDriver>;
export const skeletonCircleTestkitFactory: PuppeteerUniTestkitFactory<SkeletonCircleUniDriver>;

import { SkeletonGroupUniDriver } from '../src/SkeletonGroup/SkeletonGroup.uni.driver';

export const SkeletonGroupTestkit: PuppeteerUniTestkitFactory<SkeletonGroupUniDriver>;
export const skeletonGroupTestkitFactory: PuppeteerUniTestkitFactory<SkeletonGroupUniDriver>;

import { SkeletonLineUniDriver } from '../src/SkeletonLine/SkeletonLine.uni.driver';

export const SkeletonLineTestkit: PuppeteerUniTestkitFactory<SkeletonLineUniDriver>;
export const skeletonLineTestkitFactory: PuppeteerUniTestkitFactory<SkeletonLineUniDriver>;

import { SkeletonRectangleUniDriver } from '../src/SkeletonRectangle/SkeletonRectangle.uni.driver';

export const SkeletonRectangleTestkit: PuppeteerUniTestkitFactory<SkeletonRectangleUniDriver>;
export const skeletonRectangleTestkitFactory: PuppeteerUniTestkitFactory<SkeletonRectangleUniDriver>;

import { SliderUniDriver } from '../src/Slider/Slider.uni.driver';

export const SliderTestkit: PuppeteerUniTestkitFactory<SliderUniDriver>;
export const sliderTestkitFactory: PuppeteerUniTestkitFactory<SliderUniDriver>;

import { SocialButtonUniDriver } from '../src/SocialButton/SocialButton.uni.driver';

export const SocialButtonTestkit: PuppeteerUniTestkitFactory<SocialButtonUniDriver>;
export const socialButtonTestkitFactory: PuppeteerUniTestkitFactory<SocialButtonUniDriver>;

import { SocialPostPreviewUniDriver } from '../src/SocialPostPreview/SocialPostPreview.uni.driver';

export const SocialPostPreviewTestkit: PuppeteerUniTestkitFactory<SocialPostPreviewUniDriver>;
export const socialPostPreviewTestkitFactory: PuppeteerUniTestkitFactory<SocialPostPreviewUniDriver>;

import { SocialPreviewUniDriver } from '../src/SocialPreview/SocialPreview.uni.driver';

export const SocialPreviewTestkit: PuppeteerUniTestkitFactory<SocialPreviewUniDriver>;
export const socialPreviewTestkitFactory: PuppeteerUniTestkitFactory<SocialPreviewUniDriver>;

import { SortableGridBaseUniDriver } from '../src/SortableGridBase/SortableGridBase.uni.driver';

export const SortableGridBaseTestkit: PuppeteerUniTestkitFactory<SortableGridBaseUniDriver>;
export const sortableGridBaseTestkitFactory: PuppeteerUniTestkitFactory<SortableGridBaseUniDriver>;

import { SortableListBaseUniDriver } from '../src/SortableListBase/SortableListBase.uni.driver';

export const SortableListBaseTestkit: PuppeteerUniTestkitFactory<SortableListBaseUniDriver>;
export const sortableListBaseTestkitFactory: PuppeteerUniTestkitFactory<SortableListBaseUniDriver>;

import { SparklineChartUniDriver } from '../src/SparklineChart/SparklineChart.uni.driver';

export const SparklineChartTestkit: PuppeteerUniTestkitFactory<SparklineChartUniDriver>;
export const sparklineChartTestkitFactory: PuppeteerUniTestkitFactory<SparklineChartUniDriver>;

import { StackedBarChartUniDriver } from '../src/StackedBarChart/StackedBarChart.uni.driver';

export const StackedBarChartTestkit: PuppeteerUniTestkitFactory<StackedBarChartUniDriver>;
export const stackedBarChartTestkitFactory: PuppeteerUniTestkitFactory<StackedBarChartUniDriver>;

import { StarsRatingBarUniDriver } from '../src/StarsRatingBar/StarsRatingBar.uni.driver';

export const StarsRatingBarTestkit: PuppeteerUniTestkitFactory<StarsRatingBarUniDriver>;
export const starsRatingBarTestkitFactory: PuppeteerUniTestkitFactory<StarsRatingBarUniDriver>;

import { StatisticsWidgetUniDriver } from '../src/StatisticsWidget/StatisticsWidget.uni.driver';

export const StatisticsWidgetTestkit: PuppeteerUniTestkitFactory<StatisticsWidgetUniDriver>;
export const statisticsWidgetTestkitFactory: PuppeteerUniTestkitFactory<StatisticsWidgetUniDriver>;

import { StatusIndicatorUniDriver } from '../src/StatusIndicator/StatusIndicator.uni.driver';

export const StatusIndicatorTestkit: PuppeteerUniTestkitFactory<StatusIndicatorUniDriver>;
export const statusIndicatorTestkitFactory: PuppeteerUniTestkitFactory<StatusIndicatorUniDriver>;

import { StepperUniDriver } from '../src/Stepper/Stepper.uni.driver';

export const StepperTestkit: PuppeteerUniTestkitFactory<StepperUniDriver>;
export const stepperTestkitFactory: PuppeteerUniTestkitFactory<StepperUniDriver>;

import { SwatchesUniDriver } from '../src/Swatches/Swatches.uni.driver';

export const SwatchesTestkit: PuppeteerUniTestkitFactory<SwatchesUniDriver>;
export const swatchesTestkitFactory: PuppeteerUniTestkitFactory<SwatchesUniDriver>;

import { TableUniDriver } from '../src/Table/Table.uni.driver';

export const TableTestkit: PuppeteerUniTestkitFactory<TableUniDriver>;
export const tableTestkitFactory: PuppeteerUniTestkitFactory<TableUniDriver>;

import { TableActionCellUniDriver } from '../src/TableActionCell/TableActionCell.uni.driver';

export const TableActionCellTestkit: PuppeteerUniTestkitFactory<TableActionCellUniDriver>;
export const tableActionCellTestkitFactory: PuppeteerUniTestkitFactory<TableActionCellUniDriver>;

import { TableListHeaderUniDriver } from '../src/TableListHeader/TableListHeader.uni.driver';

export const TableListHeaderTestkit: PuppeteerUniTestkitFactory<TableListHeaderUniDriver>;
export const tableListHeaderTestkitFactory: PuppeteerUniTestkitFactory<TableListHeaderUniDriver>;

import { TableListItemUniDriver } from '../src/TableListItem/TableListItem.uni.driver';

export const TableListItemTestkit: PuppeteerUniTestkitFactory<TableListItemUniDriver>;
export const tableListItemTestkitFactory: PuppeteerUniTestkitFactory<TableListItemUniDriver>;

import { TabsUniDriver } from '../src/Tabs/Tabs.uni.driver';

export const TabsTestkit: PuppeteerUniTestkitFactory<TabsUniDriver>;
export const tabsTestkitFactory: PuppeteerUniTestkitFactory<TabsUniDriver>;

import { TagUniDriver } from '../src/Tag/Tag.uni.driver';

export const TagTestkit: PuppeteerUniTestkitFactory<TagUniDriver>;
export const tagTestkitFactory: PuppeteerUniTestkitFactory<TagUniDriver>;

import { TagListUniDriver } from '../src/TagList/TagList.uni.driver';

export const TagListTestkit: PuppeteerUniTestkitFactory<TagListUniDriver>;
export const tagListTestkitFactory: PuppeteerUniTestkitFactory<TagListUniDriver>;

import { TestimonialListUniDriver } from '../src/TestimonialList/TestimonialList.uni.driver';

export const TestimonialListTestkit: PuppeteerUniTestkitFactory<TestimonialListUniDriver>;
export const testimonialListTestkitFactory: PuppeteerUniTestkitFactory<TestimonialListUniDriver>;

import { TextUniDriver } from '../src/Text/Text.uni.driver';
import { TextPuppeteerDriver } from '../src/Text/Text.puppeteer.driver';
export const TextTestkit: PuppeteerUniTestkitFactory<TextUniDriver>;
export const textTestkitFactory: PuppeteerTestkitFactory<TextPuppeteerDriver>;

import { TextButtonUniDriver } from '../src/TextButton/TextButton.uni.driver';

export const TextButtonTestkit: PuppeteerUniTestkitFactory<TextButtonUniDriver>;
export const textButtonTestkitFactory: PuppeteerUniTestkitFactory<TextButtonUniDriver>;

import { ThumbnailUniDriver } from '../src/Thumbnail/Thumbnail.uni.driver';

export const ThumbnailTestkit: PuppeteerUniTestkitFactory<ThumbnailUniDriver>;
export const thumbnailTestkitFactory: PuppeteerUniTestkitFactory<ThumbnailUniDriver>;

import { TimeInputUniDriver } from '../src/TimeInput/TimeInput.uni.driver';

export const TimeInputTestkit: PuppeteerUniTestkitFactory<TimeInputUniDriver>;
export const timeInputTestkitFactory: PuppeteerUniTestkitFactory<TimeInputUniDriver>;

import { TimeTableUniDriver } from '../src/TimeTable/TimeTable.uni.driver';

export const TimeTableTestkit: PuppeteerUniTestkitFactory<TimeTableUniDriver>;
export const timeTableTestkitFactory: PuppeteerUniTestkitFactory<TimeTableUniDriver>;

import { TimelineUniDriver } from '../src/Timeline/Timeline.uni.driver';

export const TimelineTestkit: PuppeteerUniTestkitFactory<TimelineUniDriver>;
export const timelineTestkitFactory: PuppeteerUniTestkitFactory<TimelineUniDriver>;

import { ToastUniDriver } from '../src/Toast/Toast.uni.driver';

export const ToastTestkit: PuppeteerUniTestkitFactory<ToastUniDriver>;
export const toastTestkitFactory: PuppeteerUniTestkitFactory<ToastUniDriver>;

import { ToggleButtonUniDriver } from '../src/ToggleButton/ToggleButton.uni.driver';

export const ToggleButtonTestkit: PuppeteerUniTestkitFactory<ToggleButtonUniDriver>;
export const toggleButtonTestkitFactory: PuppeteerUniTestkitFactory<ToggleButtonUniDriver>;

import { ToggleSwitchUniDriver } from '../src/ToggleSwitch/ToggleSwitch.uni.driver';

export const ToggleSwitchTestkit: PuppeteerUniTestkitFactory<ToggleSwitchUniDriver>;
export const toggleSwitchTestkitFactory: PuppeteerUniTestkitFactory<ToggleSwitchUniDriver>;

import { TooltipUniDriver } from '../src/Tooltip/Tooltip.uni.driver';

export const TooltipTestkit: PuppeteerUniTestkitFactory<TooltipUniDriver>;
export const tooltipTestkitFactory: PuppeteerUniTestkitFactory<TooltipUniDriver>;

import { TransitionUniDriver } from '../src/Transition/Transition.uni.driver';

export const TransitionTestkit: PuppeteerUniTestkitFactory<TransitionUniDriver>;
export const transitionTestkitFactory: PuppeteerUniTestkitFactory<TransitionUniDriver>;

import { TrendIndicatorUniDriver } from '../src/TrendIndicator/TrendIndicator.uni.driver';

export const TrendIndicatorTestkit: PuppeteerUniTestkitFactory<TrendIndicatorUniDriver>;
export const trendIndicatorTestkitFactory: PuppeteerUniTestkitFactory<TrendIndicatorUniDriver>;

import { VariableInputUniDriver } from '../src/VariableInput/VariableInput.uni.driver';

export const VariableInputTestkit: PuppeteerUniTestkitFactory<VariableInputUniDriver>;
export const variableInputTestkitFactory: PuppeteerUniTestkitFactory<VariableInputUniDriver>;

import { VerticalTabsUniDriver } from '../src/VerticalTabs/VerticalTabs.uni.driver';

export const VerticalTabsTestkit: PuppeteerUniTestkitFactory<VerticalTabsUniDriver>;
export const verticalTabsTestkitFactory: PuppeteerUniTestkitFactory<VerticalTabsUniDriver>;

import { VerticalTabsItemUniDriver } from '../src/VerticalTabsItem/VerticalTabsItem.uni.driver';

export const VerticalTabsItemTestkit: PuppeteerUniTestkitFactory<VerticalTabsItemUniDriver>;
export const verticalTabsItemTestkitFactory: PuppeteerUniTestkitFactory<VerticalTabsItemUniDriver>;

import { WixDesignSystemProviderUniDriver } from '../src/WixDesignSystemProvider/WixDesignSystemProvider.uni.driver';

export const WixDesignSystemProviderTestkit: PuppeteerUniTestkitFactory<WixDesignSystemProviderUniDriver>;
export const wixDesignSystemProviderTestkitFactory: PuppeteerUniTestkitFactory<WixDesignSystemProviderUniDriver>;

import { WixStyleReactProviderUniDriver } from '../src/WixStyleReactProvider/WixStyleReactProvider.uni.driver';

export const WixStyleReactProviderTestkit: PuppeteerUniTestkitFactory<WixStyleReactProviderUniDriver>;
export const wixStyleReactProviderTestkitFactory: PuppeteerUniTestkitFactory<WixStyleReactProviderUniDriver>;

import { CardHeaderUniDriver } from '../src/Card/Header/Header.uni.driver';

export const CardHeaderTestkit: PuppeteerUniTestkitFactory<CardHeaderUniDriver>;
export const cardHeaderTestkitFactory: PuppeteerUniTestkitFactory<CardHeaderUniDriver>;

import { EditableRowUniDriver } from '../src/EditableSelector/EditableRow/EditableRow.uni.driver';

export const EditableRowTestkit: PuppeteerUniTestkitFactory<EditableRowUniDriver>;
export const editableRowTestkitFactory: PuppeteerUniTestkitFactory<EditableRowUniDriver>;

import { CardSubheaderUniDriver } from '../src/Card/Subheader/Subheader.uni.driver';

export const CardSubheaderTestkit: PuppeteerUniTestkitFactory<CardSubheaderUniDriver>;
export const cardSubheaderTestkitFactory: PuppeteerUniTestkitFactory<CardSubheaderUniDriver>;

import { CardContentUniDriver } from '../src/Card/Content/Content.uni.driver';

export const CardContentTestkit: PuppeteerUniTestkitFactory<CardContentUniDriver>;
export const cardContentTestkitFactory: PuppeteerUniTestkitFactory<CardContentUniDriver>;



