export default AddressInput;
/** AddressInput */
declare class AddressInput extends React.PureComponent<any, any, any> {
    constructor(props: any);
    state: {
        inputValue: any;
        isDropdownOpen: boolean;
    };
    innerRef: React.RefObject<any>;
    _onChange: (event: any) => void;
    _onSelect: (option: any) => void;
    _onClear: () => void;
    _getInputValue: () => any;
    _getIsLoading: () => boolean;
    _getStatus: () => any;
    _setDropdownOpen: () => void;
    _setDropdownClosed: () => void;
    _renderLoadingOption: () => {
        id: string;
        disabled: boolean;
        value: () => React.JSX.Element;
    };
    _renderNoResultsOption: () => {
        id: string;
        disabled: boolean;
        overrideOptionStyle: boolean;
        value: any;
    };
    _renderOptions: () => any;
    render(): React.JSX.Element;
    /**
     * Sets focus on the input element
     * @param {FocusOptions} options
     */
    focus(): void;
}
declare namespace AddressInput {
    let displayName: string;
    namespace propTypes {
        let dataHook: PropTypes.Requireable<string>;
        let className: PropTypes.Requireable<string>;
        let clearButton: PropTypes.Requireable<boolean>;
        let initialValue: PropTypes.Requireable<string>;
        let value: PropTypes.Requireable<string>;
        let disabled: PropTypes.Requireable<boolean>;
        let debounceDuration: PropTypes.Requireable<number>;
        let onSelect: PropTypes.Requireable<(...args: any[]) => any>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let options: PropTypes.Requireable<any[]>;
        let onClear: PropTypes.Requireable<(...args: any[]) => any>;
        let onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        let onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        let autoSelect: PropTypes.Requireable<boolean>;
        let onManuallyInput: PropTypes.Requireable<(...args: any[]) => any>;
        let status: PropTypes.Requireable<string>;
        let statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let border: PropTypes.Requireable<string>;
        let size: PropTypes.Requireable<string>;
        let placeholder: PropTypes.Requireable<string>;
        let noResultsText: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        let popoverProps: PropTypes.Requireable<PropTypes.InferProps<{
            appendTo: PropTypes.Requireable<string>;
            maxWidth: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
            minWidth: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
            flip: PropTypes.Requireable<boolean>;
            fixed: PropTypes.Requireable<boolean>;
            placement: PropTypes.Requireable<string>;
            dynamicWidth: PropTypes.Requireable<boolean>;
        }>>;
    }
    namespace defaultProps {
        let clearButton_1: boolean;
        export { clearButton_1 as clearButton };
        let debounceDuration_1: number;
        export { debounceDuration_1 as debounceDuration };
        let border_1: string;
        export { border_1 as border };
    }
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=AddressInput.d.ts.map