import React from 'react';
import PropTypes from 'prop-types';
import { AddressInputItemProps, AddressInputItemBuilderProps } from './AddressInputItem.types';
import { DropdownLayoutValueOption } from '../DropdownLayout';
/** This component is used to display an address item mainly in <AddressInput/> component. */
declare class AddressInputItem extends React.PureComponent<AddressInputItemProps> {
    static displayName: string;
    static defaultProps: {
        optionLayout: string;
        prefix: React.JSX.Element;
    };
    static propTypes: {
        dataHook: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
        mainLabel: PropTypes.Requireable<string>;
        secondaryLabel: PropTypes.Requireable<string>;
        optionLayout: PropTypes.Requireable<string>;
        prefix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        selected: PropTypes.Requireable<boolean>;
        disabled: PropTypes.Requireable<boolean>;
        highlighted: PropTypes.Requireable<boolean>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
    };
    render(): React.JSX.Element;
}
export declare const addressInputItemBuilder: ({ id, className, prefix, mainLabel, secondaryLabel, suffix, disabled, dataHook, optionLayout, onClick, displayLabel, }: AddressInputItemBuilderProps) => DropdownLayoutValueOption;
export default AddressInputItem;
//# sourceMappingURL=AddressInputItem.d.ts.map