export default AutoCompleteWithLabel;
declare class AutoCompleteWithLabel extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Sets a default value for those who want to use this component un-controlled. */
        dataHook: PropTypes.Requireable<string>;
        /** Defines a value label to show inside of a field. */
        label: PropTypes.Validator<string>;
        /** Specify an array of options to display in the dropdown list. */
        options: PropTypes.Validator<any[]>;
        /** Pass a component you want to show as the suffix of the input, e.g., text string, icon. */
        suffix: PropTypes.Requireable<(PropTypes.ReactElementLike | null | undefined)[]>;
        /** Specify the status of a field. */
        status: PropTypes.Requireable<string>;
        /** Defines the message to display on status icon hover. If not given or empty there will be no tooltip. */
        statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Defines a standard input onFocus callback. */
        onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        /** Defines a standard input onBlur callback */
        onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        /** Defines a standard input onChange callback. */
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        /** Reference element data when a form is submitted. */
        name: PropTypes.Requireable<string>;
        /** Specifies the type of `<input/>` element to display. Default is text string. */
        type: PropTypes.Requireable<string>;
        /** Define a string that labels the current element in case where a text label is not visible on the screen. */
        ariaLabel: PropTypes.Requireable<string>;
        /** Focus the element on mount (standard React input autoFocus). */
        autoFocus: PropTypes.Requireable<boolean>;
        /** Sets the value of native autocomplete attribute (check the [HTML spec](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#attr-fe-autocomplete) for possible values  */
        autocomplete: PropTypes.Requireable<string>;
        /** Specifies whether input should be disabled or not. */
        disabled: PropTypes.Requireable<boolean>;
        /** Specifies a CSS class name to be appended to the component’s root element. */
        className: PropTypes.Requireable<string>;
        /** Sets the maximum number of characters that can be entered into a field. */
        maxLength: PropTypes.Requireable<number>;
        /** Sets a placeholder message to display. */
        placeholder: PropTypes.Requireable<string>;
        /** Defines a callback function which is called whenever user selects a different option in the list. */
        onSelect: PropTypes.Requireable<(...args: any[]) => any>;
        /** Indicates whether to render using the native select element */
        native: PropTypes.Requireable<boolean>;
        /** Value of rendered child input */
        value: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        /** Sets the maximum height of the dropdownLayout in pixels. */
        maxHeightPixels: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
    };
    static defaultProps: any;
    constructor(props: any);
    state: {
        value: any;
        isEditing: boolean;
    };
    onSelect: (option: any) => void;
    onChange: (event: any) => void;
    _isInputControlled: () => boolean;
    render(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=AutoCompleteWithLabel.d.ts.map