import { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
declare const cardGalleryItemDriverFactory: (base: UniDriver, body: UniDriver) => {
    /**
     * Gets the cards title.
     * @returns {Promise<string | null>}
     */
    getTitle: () => Promise<string | null>;
    /**
     * Gets the badge node element.
     * @returns {Promise<any>}
     */
    getBadge: () => Promise<any>;
    /**
     * Gets the cards subtitle.
     * @returns {Promise<string | null>}
     */
    getSubtitle: () => Promise<string | null>;
    /**
     * Gets the background image URL.
     * @returns {Promise<string | null>}
     */
    getBackgroundImageUrl: () => Promise<string | null>;
    /**
     * Clicks on the primary action.
     * @returns {Promise<void>}
     */
    click: () => Promise<void>;
    /**
     * Clicks on the footer.
     * @returns {Promise<void>}
     */
    clickFooter: () => Promise<void>;
    /**
     * Gets the primary action label.
     * @returns {Promise<string>}
     */
    getPrimaryActionLabel: () => Promise<string>;
    /**
     * Checks whether the primary action is clickable.
     * @returns {Promise<boolean>}
     */
    isPrimaryActionDisabled: () => Promise<any>;
    /**
     * Clicks on the primary action button.
     * @returns {Promise<void>}
     */
    clickOnPrimaryAction: () => Promise<void>;
    /**
     * Gets the secondary action label.
     * @returns {Promise<string>}
     */
    getSecondaryActionLabel: () => Promise<string>;
    /**
     * Clicks on the secondary action.
     * @returns {Promise<void>}
     */
    clickOnSecondaryAction: () => Promise<void>;
    /**
     * Gets the the settingsMenu node.
     * @returns {Promise<node>}
     */
    getSettingsMenu: () => Promise<any>;
    /**
     * Gets the background image element.
     * @returns {Promise<any>}
     */
    getBackgroundImageNode: () => Promise<unknown>;
    /**
     * Hovers the component.
     * @returns {Promise<void>}
     */
    hover: () => Promise<void>;
    /**
     * Indicates drag handle exists
     */
    dragHandleExists: () => Promise<boolean>;
    clickDragHandle: () => Promise<void>;
    hoverDragHandle: () => Promise<void>;
    isDragHandleTooltipEnabled: () => Promise<boolean>;
    getDragHandleTooltipContent: () => Promise<string | null>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
};
export type CardGalleryItemUniDriver = ReturnType<typeof cardGalleryItemDriverFactory>;
export default cardGalleryItemDriverFactory;
//# sourceMappingURL=CardGalleryItem.uni.driver.d.ts.map