export default ColorInput;
declare class ColorInput extends React.Component<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Defines placeholder text to display on an empty input */
        placeholder: PropTypes.Requireable<string>;
        /** Specifies whether the input should be disabled */
        disabled: PropTypes.Requireable<boolean>;
        /** Specifies the status of a field */
        status: PropTypes.Requireable<string>;
        /** Defines the message to display on status icon hover. If not given or empty, there will be no tooltip. */
        statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Controls input size */
        size: PropTypes.Requireable<string>;
        /** Defines input value */
        value: PropTypes.Validator<string>;
        /** Returns confirmed value */
        onConfirm: PropTypes.Requireable<(...args: any[]) => any>;
        /** Returns last confirmed value from `value` prop */
        onCancel: PropTypes.Requireable<(...args: any[]) => any>;
        /** Returns changed value of input or color picker */
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        /** Defines child items to render inside of a component. Accepts any kind of content. It receives the `changeColor` function to control <ColorInput/> value. */
        colorPickerChildren: PropTypes.Requireable<NonNullable<((...args: any[]) => any) | PropTypes.ReactNodeLike>>;
        /** Defines a callback handler with color HEX string. Handler is called whenever the `Add Color` button is pressed. */
        onAddColor: PropTypes.Requireable<(...args: any[]) => any>;
        /** Defines content to show in add button tooltip. Does not appear if `onAdd` is not passed. */
        addTooltipContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Allows to pass popover props. See <Popover/> API for a full list. */
        popoverProps: PropTypes.Requireable<object>;
    };
    static defaultProps: {
        placeholder: string;
        size: string;
        onChange: () => void;
        onConfirm: () => void;
        onCancel: () => void;
        popoverProps: {};
        value: string;
    };
    static getDerivedStateFromProps(props: any, state: any): {
        value: string;
    } | {
        value?: undefined;
    };
    constructor(props: any);
    state: {
        active: boolean;
        previous: any;
        value: string;
    };
    _renderPrefix: () => React.JSX.Element | undefined;
    _renderSuffix: () => React.JSX.Element;
    _onChange: (evt: any) => void;
    _onPickerChange: (value: any) => void;
    _onFocus: () => void;
    _keyDown: (e: any) => void;
    /**
     * clicks the input element
     * @returns {Void}
     */
    click: () => void;
    /**
     * sets the picked color
     * @returns {Void}
     */
    confirm: () => void;
    /**
     * sets the previous color
     * @returns {Void}
     */
    cancel: () => void;
    render(): React.JSX.Element;
    input: Input | null | undefined;
}
import React from 'react';
import Input from '../Input';
import PropTypes from 'prop-types';
//# sourceMappingURL=ColorInput.d.ts.map