export namespace defaultEmptyStateProps {
    let theme: string;
    let image: null;
    let children: null;
    let align: string;
}
export default EmptyState;
/**
 * Representing a state of an empty page, section, table, etc.
 */
declare function EmptyState({ theme, image, children, align, title, subtitle, classNames: classNamesProp, className, dataHook, }: {
    theme?: string | undefined;
    image?: null | undefined;
    children?: null | undefined;
    align?: string | undefined;
    title: any;
    subtitle: any;
    classNames: any;
    className: any;
    dataHook: any;
}): React.JSX.Element;
declare namespace EmptyState {
    let displayName: string;
    namespace propTypes {
        let theme_1: PropTypes.Requireable<string>;
        export { theme_1 as theme };
        export let title: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        export let subtitle: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        let image_1: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        export { image_1 as image };
        export let classNames: PropTypes.Requireable<PropTypes.InferProps<{
            imageContainer: PropTypes.Requireable<string>;
        }>>;
        export let className: PropTypes.Requireable<string>;
        let children_1: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        export { children_1 as children };
        export let dataHook: PropTypes.Requireable<string>;
        let align_1: PropTypes.Requireable<string>;
        export { align_1 as align };
    }
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=EmptyState.d.ts.map