import { BaseDriver, DriverFactory } from '@wix/wix-ui-test-utils/driver-factory';
export interface LinearProgressBarCoreDriver extends BaseDriver {
    /** Get the width of the foreground bar (the progress) */
    getWidth(): string;
    /** Returns boolean that indicates if the success icon exists */
    isSuccessIconDisplayed(): boolean;
    /** Returns boolean that indicates if the error icon exists */
    isErrorIconDisplayed(): boolean;
    /** Returns boolean that indicates if the progress percentages text exists */
    isPercentagesProgressDisplayed(): boolean;
    /** Returns boolean that indicates if the prefix indication exists */
    hasPrefixIndication(): boolean;
    /** Returns boolean that indicates if the custom suffix indication exists */
    hasSuffixIndication(): boolean;
    /** Get the suffix indication's text */
    getSuffixIndicationText(): string;
    /** Get the prefix indication aria-hidden value */
    hasPrefixAriaHidden(): boolean;
    /** Get the progress indication aria-hidden value */
    hasProgressIndicatorAriaHidden(): boolean;
    /** Returns aria-label prop */
    getAriaLabel(): string;
    /** Get the progress percentages value */
    getValue(): string;
    /** Get the progress numeric value */
    getNumericValue(): number;
    /** Returns true if has progress completed (value is 100) */
    isCompleted(): boolean;
    /** Returns true if has error */
    hasError(): boolean;
    /** Returns min value prop */
    getMinValue(): number;
    /** Returns max value prop */
    getMaxValue(): number;
    /** Returns aria-valuenow prop */
    getAriaValueNow(): number;
    /** Returns aria-valuemax prop */
    getAriaValueMax(): number;
    /** Returns aria-valuemin prop */
    getAriaValueMin(): number;
    /** Returns role html attribute */
    getRoleAttribute(): string;
    /** Returns aria-valuetext prop */
    getAriaValueText(): string;
    /** Clicks the component */
    click(): void;
}
export declare const linearProgressBarDriverFactory: DriverFactory<LinearProgressBarCoreDriver>;
//# sourceMappingURL=LinearProgressBarCore.driver.d.ts.map