export namespace SIZES {
    let small: string;
    let medium: string;
}
export default ListItemSelect;
export function listItemSelectBuilder({ id, className, checkbox, prefix, title, label, subtitle, suffix, disabled, size, ellipsis, dataHook, tooltipProps, }: {
    id: any;
    className: any;
    checkbox: any;
    prefix: any;
    title: any;
    label: any;
    subtitle: any;
    suffix: any;
    disabled: any;
    size: any;
    ellipsis: any;
    dataHook: any;
    tooltipProps: any;
}): {
    id: any;
    disabled: any;
    overrideOptionStyle: boolean;
    label: any;
    value: ({ selected, hovered, ...rest }: {
        [x: string]: any;
        selected: any;
        hovered: any;
    }) => React.JSX.Element;
};
/** ListItemSelect description */
declare class ListItemSelect extends React.PureComponent<any, any, any> {
    static displayName: string;
    static propTypes: {
        /** Applied as data-hook HTML attribute that can be used in the tests */
        dataHook: PropTypes.Requireable<string>;
        /** A css class to be applied to the component's root element */
        className: PropTypes.Requireable<string>;
        /** If true, a checkbox will be shown */
        checkbox: PropTypes.Requireable<boolean>;
        /** Any prefix */
        prefix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Title of the list item */
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Text of the list item subtitle */
        subtitle: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** Any suffix */
        suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /** If true, the item is selected */
        selected: PropTypes.Requireable<boolean>;
        /** If true, the item is highlighted */
        highlighted: PropTypes.Requireable<boolean>;
        /** If true, the item is disabled */
        disabled: PropTypes.Requireable<boolean>;
        /** Allows to pass all common tooltip props.
         * @linkTypeTo components-overlays--tooltip
         * @setTypeName TooltipCommonProps
         */
        tooltipProps: PropTypes.Requireable<PropTypes.InferProps<any>>;
        /** Callback function triggered when list item is clicked */
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** Changing text size */
        size: PropTypes.Requireable<string>;
        /** If true, long text won't break into more than one line and will be terminated with an ellipsis */
        ellipsis: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        checkbox: boolean;
        selected: boolean;
        highlighted: boolean;
        ellipsis: boolean;
        size: string;
        dataHook: string;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    render(): React.JSX.Element;
    _renderTitle(textProps: any): React.JSX.Element;
    _renderContent(): React.JSX.Element;
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=ListItemSelect.d.ts.map