export default Page;
declare class Page extends React.PureComponent<any, any, any> {
    static defaultProps: {
        minWidth: number;
        maxWidth: number;
        scrollProps: {};
    };
    constructor(props: any);
    scrollableContainerRef: React.RefObject<any>;
    _handleScroll(e: any): void;
    _handleWidthResize(): void;
    _handleWindowResize(): void;
    _calculateComponentsHeights(): void;
    state: {
        headerContainerHeight: number;
        headerWrapperHeight: number;
        tailHeight: number;
        footerHeight: number;
        minimized: boolean;
    };
    componentDidMount(): void;
    contentResizeListener: ResizeSensor | undefined;
    timerId: NodeJS.Timeout | undefined;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    _getNamedChildren(): {};
    _getScrollContainer(): any;
    _getMinimizedHeaderWrapperHeight(): number;
    _getMinimizationDiff(): number | null;
    _safeGetChildren(element: any): any;
    _getPageDimensionsStyle(): {
        maxWidth: string;
        paddingLeft: string;
        paddingRight: string;
    } | null;
    _hasBackgroundImage(): boolean;
    _hasGradientClassName(): boolean;
    _renderContentHorizontalLayout(props: any): React.JSX.Element;
    _renderHeader(): any;
    headerWrapperRef: HTMLDivElement | null | undefined;
    _renderHeaderContainer(): React.JSX.Element;
    headerContainerRef: HTMLDivElement | null | undefined;
    _renderScrollableContainer(): React.JSX.Element;
    _hasTail(): boolean;
    _hasHeader(): boolean;
    _renderScrollableBackground(): React.JSX.Element | undefined;
    _renderTail(): any;
    pageHeaderTailRef: HTMLDivElement | null | undefined;
    _renderContentContainer(): React.JSX.Element;
    _renderFixedFooter: () => React.JSX.Element | undefined;
    footerWrapperRef: HTMLDivElement | null | undefined;
    render(): React.JSX.Element;
    pageRef: HTMLDivElement | null | undefined;
    /**
     * Scrolls the page to a particular set of coordinates
     * @param {ScrollToOptions} scrollTo { left: number, top: number, behavior: 'smooth' | 'auto' }
     */
    scrollTo(scrollTo: ScrollToOptions): void;
}
declare namespace Page {
    export let displayName: string;
    export { PageHeader as Header };
    export { PageSection as Section };
    export { Content };
    export { FixedContent };
    export { Tail };
    export { FixedFooter };
    export { PageSticky as Sticky };
    export { PageFooter as Footer };
    export namespace propTypes {
        let dataHook: PropTypes.Requireable<string>;
        let backgroundImageUrl: PropTypes.Requireable<string>;
        let maxWidth: PropTypes.Requireable<number>;
        let minWidth: PropTypes.Requireable<number>;
        let horizontalScroll: PropTypes.Requireable<boolean>;
        let height: PropTypes.Requireable<string>;
        let sidePadding: PropTypes.Requireable<number>;
        let className: PropTypes.Requireable<string>;
        let gradientClassName: PropTypes.Requireable<string>;
        let scrollableContentRef: PropTypes.Requireable<(...args: any[]) => any>;
        let scrollProps: PropTypes.Requireable<PropTypes.InferProps<{
            onScrollAreaChanged: React.Validator<((scrollChangedData: import("../common/ScrollableContainer").ScrollAreaData) => void) | null | undefined> | undefined;
            onScrollChanged: React.Validator<((target: HTMLElement) => void) | null | undefined> | undefined;
        }>>;
        let children: PropTypes.Validator<any[]>;
        let zIndex: PropTypes.Requireable<number>;
    }
}
import React from 'react';
import { ResizeSensor } from 'css-element-queries';
import PageHeader from '../PageHeader';
import PageSection from '../PageSection';
import Content from './Content';
declare function FixedContent(props: any): any;
declare namespace FixedContent {
    let displayName_1: string;
    export { displayName_1 as displayName };
    export namespace propTypes_1 {
        let children_1: PropTypes.Validator<PropTypes.ReactElementLike>;
        export { children_1 as children };
    }
    export { propTypes_1 as propTypes };
}
import Tail from './Tail';
import FixedFooter from './FixedFooter';
import { PageSticky } from './PageSticky';
import PageFooter from '../PageFooter';
import PropTypes from 'prop-types';
//# sourceMappingURL=Page.d.ts.map