export default RadioGroup;
/**
 * component for easy radio group creation.
 *
 * similar to HTML `<input type="radio"/>` except you don't need to handle `name` or click handlers
 */
declare class RadioGroup extends React.PureComponent<any, any, any> {
    constructor(props: any);
    constructor(props: any, context: any);
    _getSpacing(index: any): {
        marginTop: any;
        marginInlineStart?: undefined;
    } | {
        marginInlineStart: any;
        marginTop?: undefined;
    } | {
        marginTop?: undefined;
        marginInlineStart?: undefined;
    };
    render(): React.JSX.Element;
}
declare namespace RadioGroup {
    export namespace propTypes {
        let dataHook: PropTypes.Requireable<string>;
        let className: PropTypes.Requireable<string>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let value: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        let disabledRadios: PropTypes.Requireable<(NonNullable<string | number | null | undefined> | null | undefined)[]>;
        let vAlign: PropTypes.Requireable<string>;
        let disabled: PropTypes.Requireable<boolean>;
        let display: PropTypes.Requireable<string>;
        let selectionArea: PropTypes.Requireable<string>;
        let selectionAreaSkin: PropTypes.Requireable<string>;
        let selectionAreaPadding: PropTypes.Requireable<string>;
        let children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let spacing: PropTypes.Requireable<string>;
        let name: PropTypes.Requireable<string>;
        let fullWidth: PropTypes.Requireable<boolean>;
    }
    export namespace defaultProps {
        let disabledRadios_1: never[];
        export { disabledRadios_1 as disabledRadios };
        export function onChange_1(): void;
        export { onChange_1 as onChange };
        let value_1: string;
        export { value_1 as value };
        let vAlign_1: string;
        export { vAlign_1 as vAlign };
        let display_1: string;
        export { display_1 as display };
        let selectionArea_1: string;
        export { selectionArea_1 as selectionArea };
        let selectionAreaSkin_1: string;
        export { selectionAreaSkin_1 as selectionAreaSkin };
        let fullWidth_1: boolean;
        export { fullWidth_1 as fullWidth };
    }
    export { Radio };
    export let displayName: string;
}
import React from 'react';
import PropTypes from 'prop-types';
import Radio from '../Radio/Radio';
//# sourceMappingURL=RadioGroup.d.ts.map