export function sidebarItemButtonNextDriverFactory(base: any, body: any): {
    /**
     * Returns if the sidebar item is selected
     * @returns {Promise<boolean>}
     */
    isSelected: () => Promise<boolean>;
    /**
     * Returns if the sidebar item is disabled
     * @returns {Promise<boolean>}
     */
    isDisabled: () => Promise<boolean>;
    /**
     * Returns if a suffix exists
     * @returns {Promise<boolean>}
     */
    suffixExists: () => Promise<boolean>;
    /**
     * Returns count of suffix items
     * @returns {Promise<number>}
     */
    getSuffixCount: () => Promise<number>;
    /**
     * Returns if a prefix exists
     * @returns {Promise<boolean>}
     */
    prefixExists: () => Promise<boolean>;
    /**
     * Returns the skin
     * @returns {Promise<string>}
     */
    getSkin: () => Promise<string>;
    /**
     * Returns the displayed text
     * @returns {Promise<string>}
     * */
    getText: () => Promise<string>;
    exists: () => Promise<boolean>;
    element: () => Promise<any>;
    click: () => Promise<void>;
};
//# sourceMappingURL=SidebarItemButtonNext.uni.driver.d.ts.map