import React from 'react';
type SidebarSkin = 'dark' | 'light' | 'neutral';
type SidebarNextProps = {
    /** The dataHook of the Sidebar */
    dataHook?: string;
    /** The classes of the Sidebar */
    className?: string;
    /** Sidebar menu children */
    children?: React.ReactNode;
    /** Sets the skin of the Sidebar */
    skin?: SidebarSkin;
    /** Renders header element */
    header?: React.ReactNode;
    /** Renders footer element */
    footer?: React.ReactNode;
    /** Controls if the sidebar is shown or hidden, using an animation to switch between the two */
    hidden?: boolean;
    /** The selected item key */
    selectedKey?: string;
    /** Control whether the sidebar displays a loading animation, true by default */
    isLoading?: boolean;
    /** Define a string that labels the current element in case where a text label is not visible on the screen */
    ariaLabel?: string;
    /**  Defines the width */
    width?: string | number;
    /**  Enables minimized mode */
    minimized?: boolean;
    /**  Enables toggle button */
    enableMinimizeToggle?: boolean;
    /**  Defines the tooltip content of minimization toggle. */
    minimizeToggleTooltip?: string;
    /**  Defines a callback function which is called every time a minimize toggle button is clicked. */
    onMinimizeToggleClick?: () => void;
    /**  Defines the z-index of the sidebar. */
    zIndex?: number;
};
export declare const SidebarNext: React.NamedExoticComponent<SidebarNextProps>;
export {};
//# sourceMappingURL=SidebarNextNext.d.ts.map