import { BaseUniDriver } from '@wix/wix-ui-test-utils/base-driver';
import { UniDriver } from '@wix/wix-ui-test-utils/unidriver';
export interface ToggleSwitchCoreUniDriver extends BaseUniDriver {
    /** Triggers change */
    click(): Promise<void>;
    /** Returns a boolean indicating if the toggleSwitch is checked */
    isChecked(): Promise<boolean>;
    /** Returns a boolean indicating if the toggleSwitch is disabled */
    isDisabled(): Promise<boolean>;
    /** Returns the toggle icon inside the knob */
    getKnobIcon(): Promise<object>;
    /** Returns whether the toggle has an icon */
    hasKnobIcon(): Promise<boolean>;
    /** Returns the id of the input */
    getId(): Promise<string>;
    /** Returns the tab index */
    getTabIndex(): Promise<number>;
    /** Returns the computed styles object of the root component */
    getRootStyles(): Promise<object>;
    /** Returns the computed styles object of the track */
    getTrackStyles(): Promise<object>;
    /** Returns the computed styles object of the knob */
    getKnobStyles(): Promise<object>;
    /** Returns the computed styles object of the knob icon */
    getKnobIconStyles(): Promise<object>;
}
export declare const toggleSwitchUniDriverFactory: (base: UniDriver) => ToggleSwitchCoreUniDriver;
//# sourceMappingURL=ToggleSwitchCore.uni.driver.d.ts.map