import { CSSProperties } from 'react';
type StyleMap = {
    [name: string]: string;
};
export type TransitionType = 'fadeIn' | 'moveIn' | 'expand' | 'scaleUp' | 'fadeOut' | 'moveOut' | 'collapse' | 'scaleDown';
export type TransitionStatusType = {
    entering?: CSSProperties;
    entered?: CSSProperties;
    exiting?: CSSProperties;
    exited?: CSSProperties;
    unmounted?: CSSProperties;
};
export type TransitionStyles = {
    move: TransitionStatusType;
    fade: TransitionStatusType;
    scale: TransitionStatusType;
    toggle: TransitionStatusType;
};
export declare const dataHooks: {
    fadeStyles: string;
    moveStyles: string;
    toggleStyles: string;
    scaleStyles: string;
    transition: string;
};
export declare const easingMap: StyleMap;
export declare const timingMap: {
    [name: string]: number;
};
export {};
//# sourceMappingURL=constants.d.ts.map