export default VariableInput;
/** Input with variables as tags */
declare class VariableInput extends React.PureComponent<any, any, any> {
    static contextType: React.Context<{
        status?: import("..").StatusType | null;
        ariaLabelledBy?: string | null;
        ariaDescribedBy?: string | null;
    }>;
    constructor(props: any);
    state: {
        editorState: any;
    };
    componentDidMount(): void;
    editorRef: React.RefObject<any> | undefined;
    render(): React.JSX.Element;
    _handlePastedText: (text: any, html: any, editorState: any) => boolean;
    _isEmpty: () => boolean;
    _inputToTagSize: (inputSize: any) => any;
    _toString: () => any;
    _onBlur: () => void;
    _onFocus: () => void;
    _onSubmit: () => void;
    _onChange: () => void;
    _onEditorChange: (editorState: any) => void;
    _setEditorState: (editorState: any, onStateChanged?: () => void) => void;
    _stringToContentState: (str: any) => any;
    _setStringValue: (str: any, afterUpdated?: () => void) => void;
    /** Set value to display in the input */
    setValue: (value: any) => void;
    /** Insert variable at the input cursor position */
    insertVariable: (value: any) => void;
}
declare namespace VariableInput {
    let displayName: string;
    namespace propTypes {
        let className: PropTypes.Requireable<string>;
        let dataHook: PropTypes.Requireable<string>;
        let disabled: PropTypes.Requireable<boolean>;
        let readOnly: PropTypes.Requireable<boolean>;
        let initialValue: PropTypes.Requireable<string>;
        let multiline: PropTypes.Requireable<boolean>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let onSubmit: PropTypes.Requireable<(...args: any[]) => any>;
        let onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        let onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        let status: PropTypes.Requireable<string>;
        let statusMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let placeholder: PropTypes.Requireable<string>;
        let rows: PropTypes.Requireable<number>;
        let size: PropTypes.Requireable<string>;
        let variableParser: PropTypes.Requireable<(...args: any[]) => any>;
        let variableTagPropsParser: PropTypes.Requireable<(...args: any[]) => any>;
        let variableTemplate: PropTypes.Requireable<PropTypes.InferProps<{
            prefix: PropTypes.Requireable<string>;
            suffix: PropTypes.Requireable<string>;
        }>>;
    }
    namespace defaultProps {
        let initialValue_1: string;
        export { initialValue_1 as initialValue };
        let multiline_1: boolean;
        export { multiline_1 as multiline };
        let rows_1: number;
        export { rows_1 as rows };
        let size_1: string;
        export { size_1 as size };
        export function variableParser_1(): void;
        export { variableParser_1 as variableParser };
        export function variableTagPropsParser_1(): {};
        export { variableTagPropsParser_1 as variableTagPropsParser };
        export namespace variableTemplate_1 {
            let prefix: string;
            let suffix: string;
        }
        export { variableTemplate_1 as variableTemplate };
    }
}
import React from 'react';
import PropTypes from 'prop-types';
//# sourceMappingURL=VariableInput.d.ts.map