export function capitalizeFirstLetter(str: any): any;
export namespace locales {
    let ar: string;
    let bg: string;
    let cs: string;
    let da: string;
    let de: string;
    let el: string;
    let en: string;
    let es: string;
    let fi: string;
    let fr: string;
    let he: string;
    let hi: string;
    let hu: string;
    let id: string;
    let it: string;
    let ja: string;
    let ko: string;
    let lt: string;
    let ms: string;
    let nl: string;
    let no: string;
    let pl: string;
    let pt: string;
    let ro: string;
    let ru: string;
    let sv: string;
    let th: string;
    let tl: string;
    let tr: string;
    let uk: string;
    let vi: string;
    let zh: string;
}
export const MONTHS_INDEXES: number[];
export const CAPITALIZED_MONTH_LANGUAGES: string[];
export namespace WEEKDAY_NARROW_FORMAT_LOCALES {
    let ar_1: string;
    export { ar_1 as ar };
    let el_1: string;
    export { el_1 as el };
    let he_1: string;
    export { he_1 as he };
    export let lv: string;
    let pl_1: string;
    export { pl_1 as pl };
    let vi_1: string;
    export { vi_1 as vi };
    let zh_1: string;
    export { zh_1 as zh };
}
export namespace FIRST_WEEKDAY {
    let vi_2: number;
    export { vi_2 as vi };
}
export function capitalizeMonth(month: any, locale: any): any;
declare function _default(locale: any, firstDayOfWeek: any): {
    /**
     * This method is required by the ReactDayPicker LocaleUtils API but is not really used since we are using our own CaptionElement - DatePickerHead component.
     *
     * Return the string used to format the month’s title for the given month. e.g ‘December 2021’
     * @param date - a given date
     * @returns {string} - the month title
     */
    formatMonthTitle: (date: any) => string;
    /**
     * Return the string used to format the month and year title for the given date. e.g ‘December 2021’
     * @param date - a given date
     * @returns {string} - the month and year
     */
    formatMonthAndYear: (date: any) => string;
    /**
     * Return the string used to format the months range for the given dates. E.g ‘Dec - Jan 2022’
     * @param firstDate - first date in the range
     * @param secondDate - last date in the range
     * @returns {string} - the months range for the given dates
     */
    formatMonthsRange: (firstDate: any, secondDate: any) => string;
    /**
     * Return the string used to render the weekday’s short name, e.g. ‘Mon’ for Monday.
     * @param index: number - a weekday index, from 0 to 6 (Sunday to Saturday)
     * @returns {string} - a weekday in short format
     */
    formatWeekdayShort: (index: any) => string;
    /**
     * Return the string used to render the weekday’s long name (starting from 0 as Sunday). e.g. ‘Monday’.
     * @param index: number - a weekday index, from 0 to 6 (Sunday to Saturday)
     * @returns {string} - a weekday in long format
     */
    formatWeekdayLong: (index: any) => string;
    /**
     * Format the string used as aria-label for the given day.
     * @param date: Date - a given day
     * @returns {string} - formatted string that is used as aria-label for the given day
     */
    formatDay: (date: any) => string;
    /**
     * Return an array with the twelve months for the given locale
     * @returns {String[]} - an array with all the translated months strings
     */
    getMonths: () => string[];
    /**
     * Return the first day of week. Currently the default value is 1 which means Monday.
     * @returns {*|number} - a number between 0 to 6 (Sunday to Saturday) which represent the week day
     */
    getFirstDayOfWeek: () => any | number;
    /**
     * Return the string used to format the year for the given date. E.g ‘2023年’
     *  @param date - a given date
     *  @returns {string} - the string of the given date
     * */
    formatYear: (date: any) => string;
};
export default _default;
//# sourceMappingURL=LocaleUtils.d.ts.map