const execa = require('execa');
const path = require('path');

module.exports = () => {
  const customGenerator = path.resolve(__dirname, 'utils', 'generator.ts');
  const TS_NODE_PROJECT = path.resolve(__dirname, 'utils', 'tsconfig.json');

  const exportStyleSheetsESEntry = execa.command(
    `stc --srcDir=dist/es/src --require=ts-node/register --indexFile=index.es.st.css  --customGenerator=${customGenerator}`,
    {
      env: {
        TS_NODE_PROJECT,
      },
    },
  );

  const exportStyleSheetsCJSEntry = execa.command(
    `stc --srcDir=dist/src --require=ts-node/register --indexFile=index.st.css  --customGenerator=${customGenerator}`,
    {
      env: {
        TS_NODE_PROJECT,
      },
    },
  );

  return Promise.all([exportStyleSheetsESEntry, exportStyleSheetsCJSEntry]);
};
